/* $Header: /home/xplore/cvs/xpl4gr/cast.C,v 1.3 2002/08/16 12:31:39 sigbert Exp $ */

#include "xarray.hpp"

XplArray<double> cast (const XplArray<int> &x)
{ XplArray<double> ret(x.getdim());
  long i, n = x.size();
  for (i=0; i<n ; i++)
    ret[i] = (double) x[i];
  return (ret);
}

XplArray<double> cast (const XplArray<long> &x)
{ XplArray<double> ret(x.getdim());
  long i, n = x.size();
  for (i=0; i<n ; i++)
    ret[i] = (double) x[i];
  return (ret);
}

XplArray<long> cast (const XplArray<double> &x)
{ XplArray<long> ret(x.getdim());
  long i, n = x.size();
  for (i=0; i<n ; i++)
    ret[i] = (long) x[i];
  return (ret);
}


#ifdef __BORLANDC__
 XplArray<double> cast (const XplInteger<long> x)
 { XplArray<double> ret(x.getdim());
   long i, n = x.size();
   for (i=0; i<n ; i++)
     ret[i] = (double) x[i];
   return (ret);
 }

 XplArray<double> cast (const XplInteger<int> x)
 { XplArray<double> ret(x.getdim());
   long i, n = x.size();
   for (i=0; i<n ; i++)
     ret[i] = (double) x[i];
   return (ret);
 }
#endif




