/* $Header: /home/xplore/cvs/xpl4gr/eispack.h,v 1.3 2002/08/16 12:31:42 sigbert Exp $ */

#include "f2c.h"

int cdiv_(doublereal *ar, doublereal *ai, doublereal *br, doublereal *bi,
 doublereal *cr, doublereal *ci);

int csroot_(doublereal *xr, doublereal *xi, doublereal *yr, doublereal *yi);

doublereal epslon_(doublereal *x);

doublereal pythag_(doublereal *a, doublereal *b);

int bakvec_(integer *nm, integer *n, doublereal *t, doublereal *e, 

integer *m, doublereal *z, integer *ierr);

int balanc_(integer *nm, integer *n, doublereal *a, integer *low, 

integer *igh, doublereal *scale);

int balbak_(integer *nm, integer *n, integer *low, integer *igh, 

doublereal *scale, integer *m, doublereal *z);

int bandr_(integer *nm, integer *n, integer *mb, doublereal *a, 

doublereal *d, doublereal *e, doublereal *e2, logical *matz, doublereal *z);

int bandv_(integer *nm, integer *n, integer *mbw, doublereal *a, 

doublereal *e21, integer *m, doublereal *w, doublereal *z, integer *ierr, 

integer *nv, doublereal *rv, doublereal *rv6);

int bisect_(integer *n, doublereal *eps1, doublereal *d, doublereal *e, 

doublereal *e2, doublereal *lb, doublereal *ub, integer *mm, integer *m, 
doublereal *w, integer *ind, integer *ierr, doublereal *rv4, doublereal *rv5);

int bqr_(integer *nm, integer *n, integer *mb, doublereal *a, doublereal *t,

 doublereal *r, integer *ierr, integer *nv, doublereal *rv);

int cbabk2_(integer *nm, integer *n, integer *low, integer *igh, 

doublereal *scale, integer *m, doublereal *zr, doublereal *zi);

int cbal_(integer *nm, integer *n, doublereal *ar, doublereal *ai, 
integer *low, integer *igh, doublereal *scale);

int cg_(integer *nm, integer *n, doublereal *ar, doublereal *ai, 
doublereal *wr, doublereal *wi, integer *matz, doublereal *zr, 
doublereal *zi, doublereal *fv1, doublereal *fv2, doublereal *fv3, 
integer *ierr);

int ch_(integer *nm, integer *n, doublereal *ar, doublereal *ai, 
doublereal *w, integer *matz, doublereal *zr, doublereal *zi, 
doublereal *fv1, doublereal *fv2, doublereal *fm1, integer *ierr);

int cinvit_(integer *nm, integer *n, doublereal *ar, doublereal *ai, 
doublereal *wr, doublereal *wi, logical *select, integer *mm, integer *m, 
doublereal *zr, doublereal *zi, integer *ierr, doublereal *rm1, 
doublereal *rm2, doublereal *rv1, doublereal *rv2);

int combak_(integer *nm, integer *low, integer *igh, doublereal *ar, 
doublereal *ai, integer *int__, integer *m, doublereal *zr, doublereal *zi);

int comhes_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *ar, doublereal *ai, integer *int__);

int comlr_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *hr, doublereal *hi, doublereal *wr, doublereal *wi, integer *ierr);

int comlr2_(integer *nm, integer *n, integer *low, integer *igh, 
integer *int__, doublereal *hr, doublereal *hi, doublereal *wr, 
doublereal *wi, doublereal *zr, doublereal *zi, integer *ierr);

int comqr_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *hr, doublereal *hi, doublereal *wr, doublereal *wi, integer *ierr);

int comqr2_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *ortr, doublereal *orti, doublereal *hr, doublereal *hi, 
doublereal *wr, doublereal *wi, doublereal *zr, doublereal *zi, integer *ierr);

int cortb_(integer *nm, integer *low, integer *igh, doublereal *ar, 
doublereal *ai, doublereal *ortr, doublereal *orti, integer *m, 
doublereal *zr, doublereal *zi);

int corth_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *ar, doublereal *ai, doublereal *ortr, doublereal *orti);

int elmbak_(integer *nm, integer *low, integer *igh, doublereal *a, 
integer *int__, integer *m, doublereal *z);

int elmhes_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *a, integer *int__);

int eltran_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *a, integer *int__, doublereal *z);

int figi_(integer *nm, integer *n, doublereal *t, doublereal *d, 
doublereal *e, doublereal *e2, integer *ierr);

int figi2_(integer *nm, integer *n, doublereal *t, doublereal *d, 
doublereal *e, doublereal *z, integer *ierr);

int hqr_(integer *nm, integer *n, integer *low, integer *igh, doublereal *h, 
doublereal *wr, doublereal *wi, integer *ierr);

int hqr2_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *h, doublereal *wr, doublereal *wi, doublereal *z, integer *ierr);

int htrib3_(integer *nm, integer *n, doublereal *a, doublereal *tau, 
integer *m, doublereal *zr, doublereal *zi);

int htribk_(integer *nm, integer *n, doublereal *ar, doublereal *ai, 
doublereal *tau, integer *m, doublereal *zr, doublereal *zi);

int htrid3_(integer *nm, integer *n, doublereal *a, doublereal *d, 
doublereal *e, doublereal *e2, doublereal *tau);

int htridi_(integer *nm, integer *n, doublereal *ar, doublereal *ai, 
doublereal *d, doublereal *e, doublereal *e2, doublereal *tau);

int imtql1_(integer *n, doublereal *d, doublereal *e, integer *ierr);

int imtql2_(integer *nm, integer *n, doublereal *d, doublereal *e, 
doublereal *z, integer *ierr);

int imtqlv_(integer *n, doublereal *d, doublereal *e, doublereal *e2, 
doublereal *w, integer *ind, integer *ierr, doublereal *rv1);

int invit_(integer *nm, integer *n, doublereal *a, doublereal *wr, 
doublereal *wi, logical *select, integer *mm, integer *m, doublereal *z, 
integer *ierr, doublereal *rm1, doublereal *rv1, doublereal *rv2);

int minfit_(integer *nm, integer *m, integer *n, doublereal *a, 
doublereal *w, integer *ip, doublereal *b, integer *ierr, doublereal *rv1);

int ortbak_(integer *nm, integer *low, integer *igh, doublereal *a, 
doublereal *ort, integer *m, doublereal *z);

int orthes_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *a, doublereal *ort);

int ortran_(integer *nm, integer *n, integer *low, integer *igh, 
doublereal *a, doublereal *ort, doublereal *z);

int qzhes_(integer *nm, integer *n, doublereal *a, doublereal *b, 
logical *matz, doublereal *z);

int qzit_(integer *nm, integer *n, doublereal *a, doublereal *b, 
doublereal *eps1, logical *matz, doublereal *z, integer *ierr);

int qzval_(integer *nm, integer *n, doublereal *a, doublereal *b, 
doublereal *alfr, doublereal *alfi, doublereal *beta, logical *matz, 
doublereal *z);

int qzvec_(integer *nm, integer *n, doublereal *a, doublereal *b, 
doublereal *alfr, doublereal *alfi, doublereal *beta, doublereal *z);

int ratqr_(integer *n, doublereal *eps1, doublereal *d, doublereal *e, 
doublereal *e2, integer *m, doublereal *w, integer *ind, doublereal *bd, 
logical *type, integer *idef, integer *ierr);

int rebak_(integer *nm, integer *n, doublereal *b, doublereal *dl, 
integer *m, doublereal *z);

int rebakb_(integer *nm, integer *n, doublereal *b, doublereal *dl, 
integer *m, doublereal *z);

int reduc_(integer *nm, integer *n, doublereal *a, doublereal *b, 
doublereal *dl, integer *ierr);

int reduc2_(integer *nm, integer *n, doublereal *a, doublereal *b, 
doublereal *dl, integer *ierr);

int rg_(integer *nm, integer *n, doublereal *a, doublereal *wr, 
doublereal *wi, integer *matz, doublereal *z, integer *iv1, doublereal *fv1, 
integer *ierr);

int rgg_(integer *nm, integer *n, doublereal *a, doublereal *b, 
doublereal *alfr, doublereal *alfi, doublereal *beta, integer *matz, 
doublereal *z, integer *ierr);

int rs_(integer *nm, integer *n, doublereal *a, doublereal *w, 
integer *matz, doublereal *z, doublereal *fv1, doublereal *fv2, integer *ierr);

int rsb_(integer *nm, integer *n, integer *mb, doublereal *a, doublereal *w, 
integer *matz, doublereal *z, doublereal *fv1, doublereal *fv2, integer *ierr);

int rsg_(integer *nm, integer *n, doublereal *a, doublereal *b, 
doublereal *w, integer *matz, doublereal *z, doublereal *fv1, doublereal *fv2,
integer *ierr);

int rsgab_(integer *nm, integer *n, doublereal *a, doublereal *b, 
doublereal *w, integer *matz, doublereal *z, doublereal *fv1, doublereal *fv2,
integer *ierr);

int rsgba_(integer *nm, integer *n, doublereal *a, doublereal *b, 
doublereal *w, integer *matz, doublereal *z, doublereal *fv1, doublereal *fv2,
integer *ierr);

int rsm_(integer *nm, integer *n, doublereal *a, doublereal *w, 
integer *m, doublereal *z, doublereal *fwork, integer *iwork, integer *ierr);

int rsp_(integer *nm, integer *n, integer *nv, doublereal *a, 
doublereal *w, integer *matz, doublereal *z, doublereal *fv1, doublereal *fv2,
integer *ierr);

int rst_(integer *nm, integer *n, doublereal *w, doublereal *e, 
integer *matz, doublereal *z, integer *ierr);

int rt_(integer *nm, integer *n, doublereal *a, doublereal *w, 
integer *matz, doublereal *z, doublereal *fv1, integer *ierr);

int svd_(integer *nm, integer *m, integer *n, doublereal *a, 
doublereal *w, logical *matu, doublereal *u, logical *matv, doublereal *v,
integer *ierr, doublereal *rv1);

int tinvit_(integer *nm, integer *n, doublereal *d, doublereal *e, 
doublereal *e2, integer *m, doublereal *w, integer *ind, doublereal *z,
integer *ierr, doublereal *rv1, doublereal *rv2, doublereal *rv3,
doublereal *rv4, doublereal *rv6);

int tql1_(integer *n, doublereal *d, doublereal *e, integer *ierr);

int tql2_(integer *nm, integer *n, doublereal *d, doublereal *e, 
doublereal *z, integer *ierr);

int tqlrat_(integer *n, doublereal *d, doublereal *e2, integer *ierr);

int trbak1_(integer *nm, integer *n, doublereal *a, doublereal *e, 
integer *m, doublereal *z);

int trbak3_(integer *nm, integer *n, integer *nv, doublereal *a, 
integer *m, doublereal *z);

int tred1_(integer *nm, integer *n, doublereal *a, doublereal *d, 
doublereal *e, doublereal *e2);

int tred2_(integer *nm, integer *n, doublereal *a, doublereal *d, 
doublereal *e, doublereal *z);

int tred3_(integer *n, integer *nv, doublereal *a, doublereal *d, 
doublereal *e, doublereal *e2);

int tridib_(integer *n, doublereal *eps1, doublereal *d, doublereal *e, 
doublereal *e2, doublereal *lb, doublereal *ub, integer *m11, integer *m,
doublereal *w, integer *ind, integer *ierr, doublereal *rv4, doublereal *rv5);

int tsturm_(integer *nm, integer *n, doublereal *eps1, doublereal *d, 
doublereal *e, doublereal *e2, doublereal *lb, doublereal *ub, integer *mm,
integer *m, doublereal *w, doublereal *z, integer *ierr, doublereal *rv1,
doublereal *rv2, doublereal *rv3, doublereal *rv4, doublereal *rv5,
doublereal *rv6);
