/* $Header: /home/xplore/cvs/xpl4gr/globlist.h,v 1.3 2002/08/16 12:31:43 sigbert Exp $ */

// GlobalList Klasse

// TTK 10.10.94 - 1.6.98


#ifndef _GLOBLIST_H_
#define _GLOBLIST_H_

#include "xplpp.h"
#include "liste.h"

class	GlobalList {
  public:  GlobalList  (Vector<TokenElement>* );
	   GlobalList  ();
	   ~GlobalList ()           {
#ifdef TTKDEBUG
  if (ttkdebug)
    cerr << "Glbl:\tdestruct\t" << this << '\t' << endl;
#endif
                                      delete tokenlist;  }
	   void Clear             ();
	   void DeleteElements    ();
	   void RemoveTokenList   ();
	   void PrintCurrentToken ();
	   long CurrentLine       ();
	   void GetCurrentToken   (char text[]);

	   long Pos     ()       const  { return (pos);  }
	   void SetPos  (long p)        { pos = p;       }
	   long Jump    ()       const  { return (jump); }
	   void SetJump (long j)        { jump = j;      }

	   TokenElement&        Next         ()
	     { return ((*tokenlist)[(int) pos++]);       }
	   GlobalList&          operator=    (const GlobalList&);
	   Vector<TokenElement>*	GetTokenList () const
	     { return (tokenlist); }
	   void SetTokenList (Vector<TokenElement>* t)
             { delete tokenlist;
               tokenlist = t;    }

 private:  long		         pos, jump;
	   Vector<TokenElement>  *tokenlist;
};

#endif
