/* $Header: /home/xplore/cvs/xpl4gr/initsws.C,v 1.4 2002/10/31 18:26:26 cizek Exp $ */

//SWS 16.09
// Erweiterung of SWS_Interpreter
//  SWS 26.2.95

#pragma implementation "liste.h"

#include <math.h>
#include <new.h>
#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif
#include <signal.h>

#include "liste.h"
#include "init.h"
#include "function.h"
#include "macro.h"
#include "xplfun.h"
#include "xplfun2.h"
#include "xplfun3.h"
#include "xplbasefun.h"
#include "plot.h"
#include "initsws.h"

extern XplObject* DisplayType(Liste<XplObject*> *argl);
extern XplObject* SetGrOptions(Liste<XplObject*> *argl);
extern XplObject* GetGrOptions(Liste<XplObject*> *argl);

extern XplObject* createDisplay(Liste<XplObject*> *argl);
extern XplObject* Show(Liste<XplObject*> *argl);
extern XplObject* getDataFromPlot(Liste<XplObject*> *argl);
extern XplObject* SetXplPointsMask(Liste<XplObject*> *argl);
extern XplObject* AxesOn(Liste<XplObject*> *argl);
extern XplObject* AxesOff(Liste<XplObject*> *argl);

extern XplObject* AddButton(Liste<XplObject*> *argl);
//extern XplObject* XYMouse(Liste<XplObject*> *argl);

extern XplObject* Add2MCL(Liste<XplObject*> *argl);

extern XplObject* SetMode(Liste<XplObject*> *argl);
/*******************************************************
setmode becomes 3 arguments to identify a plot and 1 for plot_mode.
setmode set click_drag_function of plot to zoom(0) or brush(1) or nothing
Only for graphics!
*******************************************************/

extern XplObject* CreateColorPalette(Liste<XplObject*> *argl);
extern XplObject* ColorTest(Liste<XplObject*> *argl);
extern XplObject* FreeColor(Liste<XplObject*> *argl);

extern XplObject* SetText(Liste<XplObject*> *argl);

extern XplObject* DeleteButton(Liste<XplObject*> *argl);

extern XplObject* SetBrushFunction(Liste<XplObject*> *argl);

#ifdef _RPCXGOBI_

extern XplObject* XGobiStart(Liste<XplObject*> *argl);

extern XplObject* XGobiSetData(Liste<XplObject*> *argl);

extern XplObject* XGobiStop(Liste<XplObject*> *argl);

extern XplObject* RPCBrush(Liste<XplObject*> *argl);

extern XplObject* StartServer(Liste<XplObject*> *argl);

extern XplObject* StopServer(Liste<XplObject*> *argl);

extern XplObject* StartClient(Liste<XplObject*> *argl);

extern XplObject* StopClient(Liste<XplObject*> *argl);

extern XplObject* StartTimer(Liste<XplObject*> *argl);

extern XplObject* StopTimer(Liste<XplObject*> *argl);

extern XplObject* SendRequest(Liste<XplObject*> *argl);

extern XplObject* SystemCall(Liste<XplObject*> *argl);

#endif


extern XplObject* Flush(Liste<XplObject*> *argl);

#ifdef _SWETEST_

extern XplObject* ReadCon(Liste<XplObject*> *argl);
extern XplObject* GetMouse(Liste<XplObject*> *argl);

extern XplObject* LocalPolynom(Liste<XplObject*> *argl);
/*	1. arg is x-variable(design) with n rows and d columns
	2. arg is y-variable with n rows
	3. arg is a vector(bandwidth)  with d columns
	4. arg is:
		1 for linear
		2 for quadratic
		3 for quadratic without mixed terms
*/

#endif

extern XplObject* ReadValue(Liste<XplObject*> *argl);
/*	1. arg. is a XplChar with 1 column and n rows;
	2. arg. is a XplDouble with 1 column and n rows for default values

	xc="x=" | "y=" | "z="
	xd= 1 | 2 | 3
	xd=readvalue(xc, xd)
*/

// PC 20011006
#if defined(__BORLANDC__)
extern XplObject* SlideValue(Liste<XplObject*> *argl);
/*	1. arg. is a XplChar with 1 column and n rows;
	2. arg. is a XplDouble with 1 column and n rows for default values

	xc="x=" | "y=" | "z="
	xd= 1 | 2 | 3
   min = 0 | 0 | 0
   max = 10 | 10 | 10
	xd=slidevalue(xc, xd, min, max)
*/
#endif

extern XplObject* SelectItem(Liste<XplObject*> *argl);
/*	1. arg. is a XplChar with 1 column and  rows;
	2. arg. is a XplDouble with 1 column and n rows for default values
	
	xc="Select bandwith please:"
	bw=0.05 | 0.1 | 0.15
	bw=selectvalue(xc, bw)

*/

extern XplObject* SetXplLinesMask(Liste<XplObject*> *argl);
/*	z.b connect all points of a dataset:

	setmaskl(data, (1:rows(data))', color, outfit, thickness)
	color: 0=black, 1=blue, ..., max 7
*/


extern XplObject* SetFractions(Liste <XplObject*> *argl);
/* 3 argumente, 1. ist ein display,
	2. und 3. :	beide Matrizen, 
		(1, anzahl der zeilen), 
		(1, anzahl der spalten)
*/

extern XplObject* SetXAxis(Liste <XplObject*> *argl);
/*	Mindestens: 	Display
			Zeile
			Spalte
			X-Minimum
			Y-Maximum
	Optional:	origin
			major
			minor
			m
			k
*/
extern XplObject* SetYAxis(Liste <XplObject*> *argl);
/*	Mindestens: 	Display
			Zeile
			Spalte
			X-Minimum
			Y-Maximum
	Optional:	origin
			major
			minor
			m
			k
*/

extern XplObject* SetHeadline(Liste <XplObject*> *argl);
/*			Display
			Zeile
			Spalte
			XplChar
*/

extern XplObject* GetMask(Liste<XplObject*> *argl);
/*******************************************************
3 args for plot, 1 for data
*******************************************************/

extern XplObject* AddData(Liste<XplObject*> *argl);
/*******************************************************
DeleteData bekomes 3 args for aplot
	and 1... for data
*******************************************************/

extern XplObject* DeleteData(Liste<XplObject*> *argl);
/*******************************************************
DeleteData bekomes 3 args for aplot
	and 1 for data_number=1,....
*******************************************************/

extern XplObject* setdatacolor(Liste<XplObject*> *argl);
/*******************************************************
setdatacolor becomes 3 (for a part of it) args 
	and 1 for data_number(1...data_count) 
	and 1 for color (1 ...8)
*******************************************************/

extern XplObject* setpointscolor(Liste<XplObject*> *argl);
/*******************************************************
setpointcolor becomes 3 (for a part of it) args 
	and 1 for data_number(1...data_count) 
	and 1 for index_vector of points
	and 1 for color (1 ...8)
*******************************************************/

extern XplObject* setdataoutfit(Liste<XplObject*> *argl);
/*******************************************************
setdataoutfit becomes 3 (for a part of it) args 
	and 1 for data_number(1...data_count) 
	and 1 for outfit (POINT, KREIS, NOPOINT, FILLKREIS, DIFF)
*******************************************************/

extern XplObject* setpointsoutfit(Liste<XplObject*> *argl);
/*******************************************************
setpointoutfit becomes 3 (for a part of it) args 
	and 1 for data_number(1...data_count) 
	and 1 for index_vector of points
	and 1 for outfit (POINT, KREIS, NOPOINT, FILLKREIS, DIFF)
*******************************************************/
extern XplObject* setdatasize(Liste<XplObject*> *argl);
/*******************************************************
setdataoutfit becomes 3 (for a part of it) args 
	and 1 for data_number(1...data_count) 
	and 1 for outfit (POINT, KREIS, NOPOINT, FILLKREIS, DIFF)
*******************************************************/

extern XplObject* setpointssize(Liste<XplObject*> *argl);
/*******************************************************
setpointoutfit becomes 3 (for a part of it) args 
	and 1 for data_number(1...data_count) 
	and 1 for index_vector of points
	and 1 for outfit (POINT, KREIS, NOPOINT, FILLKREIS, DIFF)
*******************************************************/

extern XplObject* setdatasymbol(Liste<XplObject*> *argl);
/*******************************************************
setdataoutfit becomes 3 (for a part of it) args 
	and 1 for data_number(1...data_count) 
	and 1 for outfit (POINT, KREIS, NOPOINT, FILLKREIS, DIFF)
*******************************************************/

extern XplObject* setpointssymbol(Liste<XplObject*> *argl);
/*******************************************************
setpointoutfit becomes 3 (for a part of it) args 
	and 1 for data_number(1...data_count) 
	and 1 for index_vector of points
	and 1 for outfit (POINT, KREIS, NOPOINT, FILLKREIS, DIFF)
*******************************************************/

extern XplObject* connect(Liste<XplObject*> *argl);
/*******************************************************
connect becomes 3 (for a part of it) args 
	and 1 for data_number(1...data_count).
*******************************************************/

extern XplObject* swsprint(Liste<XplObject*> *argl);
/*******************************************************
swsprint becomes 	1 (for a whole display to "subdn.ps") or 
			2 (for a whole display to (*argl)[1]) or
			3 (for a part of it to "subdn.ps") or
			4 (for a part of it to (*argl)[3]) 
				args.
A ps-file will be created. Ps-size is equal to real size.
*******************************************************/

extern XplObject* setsize(Liste<XplObject*> *argl);
/*******************************************************
setsize (int wi, int he) sets width and height for all later created 
displays to wi and he. The ps-size will be set too.
if display (third optional argument) is supplied, it applies
to that display
*******************************************************/
extern XplObject* setpos(Liste<XplObject*> *argl);
/* without parameters return defaults, otherwise position and size of display */
extern XplObject* getsize(Liste<XplObject*> *argl);
extern XplObject* getpos(Liste<XplObject*> *argl);

#ifdef _SWETEST_


extern XplObject* getbrushed(Liste<XplObject*> *argl);
/*******************************************************
getbrushed becomes 3 arguments to identify a plot and returns a mask-vector.
Only for graphics!
*******************************************************/

extern XplObject* setbrushed(Liste<XplObject*> *argl);
/*******************************************************
setbrushed becomes 3 arguments to identify a plot and 1 for a mask-vector.
Only for graphics!
*******************************************************/

extern XplObject* dialogbox(Liste<XplObject*> *argl);
/*******************************************************
????????????????
*******************************************************/
/*******************************************************
????????????????
*******************************************************/

#endif

extern XplObject* colordialogbox(Liste<XplObject*> *argl);

void InstallGraphicsFunctions  ()
{	
#if defined (_GRAPHICS_)
	InitShellOnly(0, NULL);
#endif
 	InitColorList();
	InitSymbolList();

#ifdef _RPCXGOBI_
	funList->haengeAn(new Function ("rpcstartserver", StartServer));
	funList->haengeAn(new Function ("rpcstopserver", StopServer));
	funList->haengeAn(new Function ("rpcstartclient", StartClient));
	funList->haengeAn(new Function ("rpcstopclient", StopClient));
	funList->haengeAn(new Function ("rpcstarttimer", StartTimer));
	funList->haengeAn(new Function ("rpcstoptimer", StopTimer));
	funList->haengeAn(new Function ("rpcsendrequest", SendRequest));
 	funList->haengeAn(new Function ("rpclink", RPCBrush));
	funList->haengeAn(new Function ("systemcall", SystemCall));
	funList->haengeAn(new Function ("colordialogbox", colordialogbox));
#endif

#ifdef _SWETEST_
	funList->haengeAn(new Function ("readcon", ReadCon));
	funList->haengeAn(new Function ("getmouse", GetMouse));

	funList->haengeAn(new Function ("getbrushed", getbrushed));
	funList->haengeAn(new Function ("dialogbox", dialogbox));
#endif

#if defined (PSGEN) || defined (_GRAPHICS_) || defined (__BORLANDC__)
	funList->haengeAn(new Function ("setxaxis", SetXAxis));
	funList->haengeAn(new Function ("setyaxis", SetYAxis));
	funList->haengeAn(new Function ("setheadline", SetHeadline));
#endif
#if defined (_GRAPHICS_)

	funList->haengeAn(new Function ("testcolor", ColorTest));
	funList->haengeAn(new Function ("readevent", Flush));
#endif

#if defined (PSGEN) || defined (_GRAPHICS_) || defined (__BORLANDC__)
	funList->haengeAn(new Function ("displaytype", DisplayType));
	funList->haengeAn(new Function ("freecolor", FreeColor));
	funList->haengeAn(new Function ("createcolor", CreateColorPalette));
	funList->haengeAn(new Function ("setgopt", SetGrOptions));
	funList->haengeAn(new Function ("getgopt", GetGrOptions));

	funList->haengeAn(new Function ("createdisplay", createDisplay));
	funList->haengeAn(new Function ("show", Show));
	funList->haengeAn(new Function ("getdata", getDataFromPlot));
	funList->haengeAn(new Function ("axeson", AxesOn));
	funList->haengeAn(new Function ("axesoff", AxesOff));
//	funList->haengeAn(new Function ("getmask", GetMask));
	funList->haengeAn(new Function ("setmaskp", SetXplPointsMask));
	funList->haengeAn(new Function ("setmaskt", SetText));
	funList->haengeAn(new Function ("setmaskl", SetXplLinesMask));
//#ifndef __BORLANDC__
	funList->haengeAn(new Function ("print", swsprint));
//#endif
	//funList->haengeAn(new Function ("setsize", setsize));
        //PC 20021031
	funList->haengeAn(new Function ("setsize", setsize, FALSE));
	funList->haengeAn(new Function ("setposition", setpos, FALSE));
	funList->haengeAn(new Function ("getsize", getsize));
	funList->haengeAn(new Function ("getposition", getpos));
	funList->haengeAn(new Function ("deletedata", DeleteData));
	funList->haengeAn(new Function ("adddata", AddData));
	funList->haengeAn(new Function ("setfractions", SetFractions));
#endif

#if defined (_GRAPHICS_) || defined (__BORLANDC__)            //SWS 16.09
	funList->haengeAn(new Function ("readvalue", ReadValue));
	funList->haengeAn(new Function ("selectitem", SelectItem));
#if defined (__BORLANDC__)
	funList->haengeAn(new Function ("slidevalue", SlideValue));	// PC 20011006
#endif
	funList->haengeAn(new Function ("addbutton", AddButton));
#endif
#if defined (_GRAPHICS_)  || defined (__BORLANDC__)
	funList->haengeAn(new Function ("link", Add2MCL));
	funList->haengeAn(new Function ("setmode", SetMode));
	//funList->haengeAn(new Function ("deletebutton", DeleteButton));
//	funList->haengeAn(new Function ("setbrushfunc", SetBrushFunction));
#endif
//	funList->haengeAn(new Function ("connect", connect));
//	funList->haengeAn(new Function ("setdatacolor", setdatacolor));
//	funList->haengeAn(new Function ("setpointscolor", setpointscolor));
//	funList->haengeAn(new Function ("setdataoutfit", setdataoutfit));
//	funList->haengeAn(new Function ("setpointsoutfit", setpointsoutfit));
//	funList->haengeAn(new Function ("setdatasize", setdatasize));
//	funList->haengeAn(new Function ("setpointssize", setpointssize));
//	funList->haengeAn(new Function ("setdatasymbol", setdatasymbol));
//	funList->haengeAn(new Function ("setpointssymbol", setpointssymbol));

}


