/* $Header: /home/xplore/cvs/xpl4gr/insym.C,v 1.3 2002/08/16 12:31:44 sigbert Exp $ */

#ifdef __BORLANDC__
#include "wplot.h"
#include "wdisp.h"
#include "color.h"
#include "xplwin.h"
#endif
 
#include <sys/types.h>
#include <time.h>

#include "function.h"
#include "macro.h"

#include "main.h"
#include "color.h"
#include "display.h"
#include "plot.h"

#include "xplio.h"
#include "xchar.hpp"


#define SYMBOL_COUNT 16
#define SIZE_COUNT 16

#ifdef _UNIX_
char * all_bitmaps[(SYMBOL_COUNT-1)][(SIZE_COUNT-1)];
#endif
#ifdef __BORLANDC__
TMemoryDC *alldcs[(SYMBOL_COUNT-1)][(SIZE_COUNT-1)];
#endif

/* extra 16 for RECTANGLE	*/
#include "bm1all.h"

/* extra 16 for CIRCLE:	*/
#include "bm2all.h"

/* extra 16 for RECTANGLE:	*/
#include "bm3all.h"

/* extra 16 for CROSS:	*/
#include "bm4all.h"

/* extra 16 for XSYM:	*/
#include "bm5all.h"

/* extra 16 for RHOMBUS:	*/
#include "bm6all.h"

/* extra 16 for RHOMBUS:	*/
#include "bm7all.h"

/* extra 16 for GRID:	*/
#include "bm8all.h"

/* extra 16 for GRIDRHOMBUS:	*/
#include "bm9all.h"

/* extra 16 for FILLED_RHOMBUS:	*/
#include "bm10all.h"

/* extra 16 for FILLEDRECTANGLE	*/
#include "bm11all.h"

/* extra 16 for FILLEDCIRCLE:	*/
#include "bm12all.h"

/* extra 16 for FILLEDTRIANGLE:	*/
#include "bm13all.h"

/* extra 16 for QUESTUON	*/
#include "bm14all.h"

/*----------------BITMAPS_DEFINES::----------------------------*/

#ifdef __BORLANDC__
WORD * all_bitmaps[(SYMBOL_COUNT-1)][(SIZE_COUNT-1)];
#endif

void InitBit(void)
{
#if defined  (__BORLANDC__) || defined (_UNIX_)

	// RECTANGLE;
//#ifdef _UNIX_
	all_bitmaps[0][0]=bm1_1;
	all_bitmaps[0][1]=bm1_2;
	all_bitmaps[0][2]=bm1_3;
	all_bitmaps[0][3]=bm1_4;
		all_bitmaps[0][4]=bm1_5;
		all_bitmaps[0][5]=bm1_6;
		all_bitmaps[0][6]=bm1_7;
		all_bitmaps[0][7]=bm1_8;
		all_bitmaps[0][8]=bm1_9;
		all_bitmaps[0][9]=bm1_10;
		all_bitmaps[0][10]=bm1_11;
		all_bitmaps[0][11]=bm1_12;
		all_bitmaps[0][12]=bm1_13;
		all_bitmaps[0][13]=bm1_14;
		all_bitmaps[0][14]=bm1_15;

	// CIRCLE
	all_bitmaps[1][0]=bm2_1;
	all_bitmaps[1][1]=bm2_2;
	all_bitmaps[1][2]=bm2_3;
	all_bitmaps[1][3]=bm2_4;
		all_bitmaps[1][4]=bm2_5;
		all_bitmaps[1][5]=bm2_6;
   	all_bitmaps[1][6]=bm2_7;
   	all_bitmaps[1][7]=bm2_8;
		all_bitmaps[1][8]=bm2_9;
		all_bitmaps[1][9]=bm2_10;
		all_bitmaps[1][10]=bm2_11;
		all_bitmaps[1][11]=bm2_12;
   	all_bitmaps[1][12]=bm2_13;
   	all_bitmaps[1][13]=bm2_14;
		all_bitmaps[1][14]=bm2_15;

	//TRIANGLE
	all_bitmaps[2][0]=bm3_1;
	all_bitmaps[2][1]=bm3_2;
	all_bitmaps[2][2]=bm3_3;
	all_bitmaps[2][3]=bm3_4;
   	all_bitmaps[2][4]=bm3_5;
		all_bitmaps[2][5]=bm3_6;
		all_bitmaps[2][6]=bm3_7;
		all_bitmaps[2][7]=bm3_8;
   	all_bitmaps[2][8]=bm3_9;
		all_bitmaps[2][9]=bm3_10;
   	all_bitmaps[2][10]=bm3_11;
		all_bitmaps[2][11]=bm3_12;
		all_bitmaps[2][12]=bm3_13;
		all_bitmaps[2][13]=bm3_14;
		all_bitmaps[2][14]=bm3_15;

	//XSYM
	all_bitmaps[3][0]=bm5_1;
	all_bitmaps[3][1]=bm5_2;
	all_bitmaps[3][2]=bm5_3;
	all_bitmaps[3][3]=bm5_4;
   	all_bitmaps[3][4]=bm5_5;
   	all_bitmaps[3][5]=bm5_6;
   	all_bitmaps[3][6]=bm5_7;
		all_bitmaps[3][7]=bm5_8;
   	all_bitmaps[3][8]=bm5_9;
		all_bitmaps[3][9]=bm5_10;
		all_bitmaps[3][10]=bm5_11;
   	all_bitmaps[3][11]=bm5_12;
		all_bitmaps[3][12]=bm5_13;
   	all_bitmaps[3][13]=bm5_14;
		all_bitmaps[3][14]=bm5_15;

	//RHOMBUS
	all_bitmaps[4][0]=bm6_1;
	all_bitmaps[4][1]=bm6_2;
	all_bitmaps[4][2]=bm6_3;
	all_bitmaps[4][3]=bm6_4;
		all_bitmaps[4][4]=bm6_5;
		all_bitmaps[4][5]=bm6_6;
		all_bitmaps[4][6]=bm6_7;
		all_bitmaps[4][7]=bm6_8;
		all_bitmaps[4][8]=bm6_9;
   	all_bitmaps[4][9]=bm6_10;
		all_bitmaps[4][10]=bm6_11;
   	all_bitmaps[4][11]=bm6_12;
		all_bitmaps[4][12]=bm6_13;
		all_bitmaps[4][13]=bm6_14;
		all_bitmaps[4][14]=bm6_15;

	//FILLRECT
	all_bitmaps[5][0]=bm12_1;
	all_bitmaps[5][1]=bm12_2;
	all_bitmaps[5][2]=bm12_3;
	all_bitmaps[5][3]=bm12_4;
   	all_bitmaps[5][4]=bm12_5;
   	all_bitmaps[5][5]=bm12_6;
		all_bitmaps[5][6]=bm12_7;
   	all_bitmaps[5][7]=bm12_8;
		all_bitmaps[5][8]=bm12_9;
		all_bitmaps[5][9]=bm12_10;
   	all_bitmaps[5][10]=bm12_11;
   	all_bitmaps[5][11]=bm12_12;
   	all_bitmaps[5][12]=bm12_13;
		all_bitmaps[5][13]=bm12_14;
		all_bitmaps[5][14]=bm12_15;

	//FILLCIRCLE
	all_bitmaps[6][0]=bm11_1;
	all_bitmaps[6][1]=bm11_2;
	all_bitmaps[6][2]=bm11_3;
	all_bitmaps[6][3]=bm11_4;
		all_bitmaps[6][4]=bm11_5;
		all_bitmaps[6][5]=bm11_6;
   	all_bitmaps[6][6]=bm11_7;
		all_bitmaps[6][7]=bm11_8;
   	all_bitmaps[6][8]=bm11_9;
		all_bitmaps[6][9]=bm11_10;
   	all_bitmaps[6][10]=bm11_11;
		all_bitmaps[6][11]=bm11_12;
		all_bitmaps[6][12]=bm11_13;
		all_bitmaps[6][13]=bm11_14;
		all_bitmaps[6][14]=bm11_15;

	//FILLED_RHOMBUS
	all_bitmaps[7][0]=bm10_1;
	all_bitmaps[7][1]=bm10_2;
	all_bitmaps[7][2]=bm10_3;
	all_bitmaps[7][3]=bm10_4;
   	all_bitmaps[7][4]=bm10_5;
		all_bitmaps[7][5]=bm10_6;
   	all_bitmaps[7][6]=bm10_7;
		all_bitmaps[7][7]=bm10_8;
		all_bitmaps[7][8]=bm10_9;
		all_bitmaps[7][9]=bm10_10;
   	all_bitmaps[7][10]=bm10_11;
		all_bitmaps[7][11]=bm10_12;
		all_bitmaps[7][12]=bm10_13;
		all_bitmaps[7][13]=bm10_14;
		all_bitmaps[7][14]=bm10_15;

	//FILLTRIANGLE

	all_bitmaps[8][0]=bm13_1;
	all_bitmaps[8][1]=bm13_2;
	all_bitmaps[8][2]=bm13_3;
	all_bitmaps[8][3]=bm13_4;
   	all_bitmaps[8][4]=bm13_5;
		all_bitmaps[8][5]=bm13_6;
   	all_bitmaps[8][6]=bm13_7;
		all_bitmaps[8][7]=bm13_8;
   	all_bitmaps[8][8]=bm13_9;
		all_bitmaps[8][9]=bm13_10;
		all_bitmaps[8][10]=bm13_11;
		all_bitmaps[8][11]=bm13_12;
		all_bitmaps[8][12]=bm13_13;
   	all_bitmaps[8][13]=bm13_14;
   	all_bitmaps[8][14]=bm13_15;

	// CROSS
	all_bitmaps[9][0]=bm4_1;
	all_bitmaps[9][1]=bm4_2;
	all_bitmaps[9][2]=bm4_3;
	all_bitmaps[9][3]=bm4_4;
		all_bitmaps[9][4]=bm4_5;
		all_bitmaps[9][5]=bm4_6;
		all_bitmaps[9][6]=bm4_7;
   	all_bitmaps[9][7]=bm4_8;
		all_bitmaps[9][8]=bm4_9;
   	all_bitmaps[9][9]=bm4_10;
		all_bitmaps[9][10]=bm4_11;
		all_bitmaps[9][11]=bm4_12;
   	all_bitmaps[9][12]=bm4_13;
		all_bitmaps[9][13]=bm4_14;
		all_bitmaps[9][14]=bm4_15;

	//STAR
	all_bitmaps[10][0]=bm7_1;
	all_bitmaps[10][1]=bm7_2;
	all_bitmaps[10][2]=bm7_3;
	all_bitmaps[10][3]=bm7_4;
		all_bitmaps[10][4]=bm7_5;
   	all_bitmaps[10][5]=bm7_6;
		all_bitmaps[10][6]=bm7_7;
   	all_bitmaps[10][7]=bm7_8;
		all_bitmaps[10][8]=bm7_9;
		all_bitmaps[10][9]=bm7_10;
		all_bitmaps[10][10]=bm7_11;
		all_bitmaps[10][11]=bm7_12;
   	all_bitmaps[10][12]=bm7_13;
   	all_bitmaps[10][13]=bm7_14;
		all_bitmaps[10][14]=bm7_15;

	//GRID
	all_bitmaps[11][0]=bm8_1;
	all_bitmaps[11][1]=bm8_2;
	all_bitmaps[11][2]=bm8_3;
	all_bitmaps[11][3]=bm8_4;
		all_bitmaps[11][4]=bm8_5;
		all_bitmaps[11][5]=bm8_6;
   	all_bitmaps[11][6]=bm8_7;
   	all_bitmaps[11][7]=bm8_8;
		all_bitmaps[11][8]=bm8_9;
		all_bitmaps[11][9]=bm8_10;
		all_bitmaps[11][10]=bm8_11;
   	all_bitmaps[11][11]=bm8_12;
		all_bitmaps[11][12]=bm8_13;
		all_bitmaps[11][13]=bm8_14;
   	all_bitmaps[11][14]=bm8_15;

	//GRID_RHOMBUS
	all_bitmaps[12][0]=bm9_1;
	all_bitmaps[12][1]=bm9_2;
	all_bitmaps[12][2]=bm9_3;
	all_bitmaps[12][3]=bm9_4;
   	all_bitmaps[12][4]=bm9_5;
		all_bitmaps[12][5]=bm9_6;
   	all_bitmaps[12][6]=bm9_7;
		all_bitmaps[12][7]=bm9_8;
		all_bitmaps[12][8]=bm9_9;
		all_bitmaps[12][9]=bm9_10;
		all_bitmaps[12][10]=bm9_11;
		all_bitmaps[12][11]=bm9_12;
   	all_bitmaps[12][12]=bm9_13;
		all_bitmaps[12][13]=bm9_14;
		all_bitmaps[12][14]=bm9_15;

/*	//DEFAULT CIRCLE
	
	all_bitmaps[13][0]=bm2_1;
	all_bitmaps[13][1]=bm2_2;
	all_bitmaps[13][2]=bm2_3;
	all_bitmaps[13][3]=bm2_4;
   	all_bitmaps[13][4]=bm2_5;
   	all_bitmaps[13][5]=bm2_6;
   	all_bitmaps[13][6]=bm2_7;
		all_bitmaps[13][7]=bm2_8;
		all_bitmaps[13][8]=bm2_9;
   	all_bitmaps[13][9]=bm2_10;
		all_bitmaps[13][10]=bm2_11;
		all_bitmaps[13][11]=bm2_12;
		all_bitmaps[13][12]=bm2_13;
		all_bitmaps[13][13]=bm2_14;
		all_bitmaps[13][14]=bm2_15;
*/
	//QUESTION

	all_bitmaps[13][0]=bm14_1;
	all_bitmaps[13][1]=bm14_2;
	all_bitmaps[13][2]=bm12_3;
	all_bitmaps[13][3]=bm14_4;
		all_bitmaps[13][4]=bm14_5;
		all_bitmaps[13][5]=bm14_6;
		all_bitmaps[13][6]=bm14_7;
		all_bitmaps[13][7]=bm14_8;
   	all_bitmaps[13][8]=bm14_9;
		all_bitmaps[13][9]=bm14_10;
		all_bitmaps[13][10]=bm14_11;
		all_bitmaps[13][11]=bm14_12;
		all_bitmaps[13][12]=bm14_13;
		all_bitmaps[13][13]=bm14_14;
		all_bitmaps[13][14]=bm14_15;
#endif
}

#define SYMBOL_SIZE 8

#define TO_LOAD_FIRST 14

/*		ENDE 	BIT	MAP	DEFINITION	*********/

Liste <XplSymbol *> all_symbols;

#ifdef _UNIX_
extern "C" BS_Glob_Variable bs_glob_variable;
#endif


int InitSymbolList()
{
#ifdef _UNIX_
	Display *dis;
	dis=XtDisplay(bs_glob_variable.main_shell);
#endif
	int i, j, symbol_number;
	XplSymbol * new_sym;

	InitBit();
	//cout<<"Die Bitmaps werden geladen..."<<endl;

#ifdef _UNIX_
	char *data;
#endif
/*
// erst fuer 8- maps!

	for (i=0; i<TO_LOAD_FIRST; i++)
	{  	 new_sym=new XplSymbol;
#ifdef _UNIX_
			data=all_bitmaps[i][7];
		if ((new_sym->pixy=XCreateBitmapFromData(
			dis, RootWindow(dis,DefaultScreen(dis)),
			data, SYMBOL_SIZE, SYMBOL_SIZE))==False)
		{
#ifdef _BLABLA_
	cout<<i<<" bitmap_error!"<<endl;
#endif
			exit(1);
		}
#endif
#ifdef __BORLANDC__
	TBitmap tbm(SYMBOL_SIZE, SYMBOL_SIZE, 1, 1, all_bitmaps[i][7]);
	alldcs[i][7]=new TMemoryDC(tbm);
#endif

//		cout<<"id for "<<all_symbols.laenge()<<
//			" is "<<new_sym->pixy<<endl;
		new_sym->symbol=i+2;
		new_sym->size=SYMBOL_SIZE;
		all_symbols.haengeAn(new_sym);
	}
*/

	for (i=2; i<SYMBOL_COUNT; i++)
	for (j=1; j<SIZE_COUNT; j++)
 //	if (j!=8)	//schon gemacht!
	{	symbol_number=i;
		new_sym=new XplSymbol;
//		cout<<"i="<<i<<", J="<<j<<endl;
#ifdef _UNIX_
		if ((new_sym->pixy=XCreateBitmapFromData(
			dis, RootWindow(dis,DefaultScreen(dis)),
			all_bitmaps[i-2][j-1], j, j))==False)
		{
#ifdef _BLABLA_
	cout<<i<<" bitmap_error!"<<endl;
#endif
			exit(1);
		}
#endif
#ifdef __BORLANDC__

	if (j<=8)
	{ /* for (int k=0; k<j; k++)
	  { char c, *ctmp = (char *) (&(all_bitmaps[i-2][j-1][k]));
		 c = ctmp[0];
		 ctmp[0] = ctmp[1];
		 ctmp[1] = c;
	  }
	  */
	}
 /*	TBitmap tbm(j, j, 1, 1, (j<=8 ? all_bitmaps[i-2][j-1] : NULL) );
	alldcs[i-2][j-1]=new TMemoryDC(tbm);
 */
	if (j<=8)
	{	TBitmap tbm(8, j, 1, 1, all_bitmaps[i-2][j-1] );
		TMemoryDC curr(tbm);
      TBitmap tbc(j, j);
		alldcs[i-2][j-1]=new TMemoryDC(tbc);
 //		alldcs[i-2][j-1]->BitBlt(0, 0, j, j, curr, 8-j, 0, SRCCOPY);
		alldcs[i-2][j-1]->BitBlt(0, 0, j, j, curr, 8-j, 0, SRCPAINT);
	}
	else
	{  alldcs[i-2][j-1]=NULL;
	/*
		TBitmap tbm(16, 16, 1, 1, all_bitmaps[i-2][j-1] );
		TMemoryDC curr(tbm);
		alldcs[i-2][j-1]=new TMemoryDC(TBitmap(j, j));
		alldcs[i-2][j-1]->BitBlt(0, 0, j, j, curr, 0, 0, SRCCOPY);
		*/	 //	alldcs[i-2][j-1]->SetBkColor(TColor(256, 256, 256));
	}
#endif
//		cout<<"id for "<<all_symbols.laenge()<<
//			" is "<<new_sym->pixy<<endl;
		new_sym->symbol=symbol_number;
		new_sym->size=j;
/*
#ifdef _BLABLA_
		if (i-2==13)
			cout<<"ASK! "<<all_symbols.laenge()<<endl;
#endif
*/
		all_symbols.haengeAn(new_sym);

	}



/*	int all=all_symbols.laenge();
	for (i=0; i<all; i++)
		cout<<i+1<<". Bitmap: symbol="<<all_symbols[i]->symbol
		<<", size="<<all_symbols[i]->size<<endl;
 */

	return(0);
}



