/* $Header: /home/xplore/cvs/xpl4gr/qr.C,v 1.3 2002/08/16 12:31:48 sigbert Exp $ */

#include <stdlib.h>
#include <math.h>
#include <iostream.h>
#include "xplqr.C"

double **matrix(long nrow, long ncol)

{
	long i;
	double **m;

  
	m = new double*[nrow];
    
	for(i=0;i<nrow;i++)
	{
		m[i]=new double[ncol];
	}
   
	return m;
}
void  delete_matrix(double **m, long nrow)
{
 long i;
 for(i=0;i<nrow;i++)
 {
	delete[] m[i];
 }
 delete[] m;
}
 
void mult(double **A, double **B, double **C,
         long nrowA, long ncolA,
         long ncolB){

int i,k,l;
double sum;
for(k=0; k < ncolB; k++)
  for(i=0; i < nrowA; i++){
    sum = 0.0;
    for(l=0; l< ncolA; l++) 
       sum =sum+ A[i][l]*B[l][k];
    C[i][k] =sum;
  }
}
#define RRANGE 32768.0
# define pi 3.1415926

double rnd(void)
{
  return rand()/(RRANGE);
}
double gauss(void)
{
  return sqrt(-2.0*log(rnd()))*cos(2*pi*rnd());
}
void main(void)
{
  int nrow=10;
  int ncol=54;
  double **m;
  double *x;
  int i, k;
m=matrix(nrow,ncol);
double **Q;
double **R;
double *r, *q;
r=new double[nrow*ncol];
Q=matrix(nrow,nrow);
q=new double[nrow*nrow];
R=matrix(nrow,ncol);
x= new double[nrow*ncol];
  long *jpvt;
  jpvt = new long[ncol];

for(i=0; i < nrow; i++)
  for(k=0; k < ncol; k++)
     m[i][k]=rnd();
  
   
cout << "matrix m\n";
for(i=0; i < nrow; i++){
  for(k=0; k < ncol; k++)
        cout<< m[i][k]<<"      ";
 cout<<"\n";}

matrix_vector(m,nrow,ncol,x);
int job=0;
double *qraux;
qraux = new double[ncol];
for(i=0;i<1000;i++){ 
sqrdc_(x, 
       nrow, 
       nrow, 
       ncol,
       qraux, 
       jpvt,  
       job);
//for(k=0;k<nrow;k++)
// cout << qraux[k]<< "\n";
vector_matrix(x,nrow,ncol,m);
qrR(x,nrow,ncol,r);
vector_matrix(r,nrow,ncol,R);
qrQ(x,qraux,nrow,ncol,q,0.0000001);
vector_matrix(q,nrow,nrow,Q);
mult(Q,R,m,nrow,nrow,ncol);
cout <<i<<"\n";}
cout << "decomposed matrix \n";

for(i=0; i < nrow; i++){
  for(k=0; k < ncol; k++)
        cout<< m[i][k]<<"      "; 
 cout<<"\n";}
}











