/* $Header: /home/xplore/cvs/xpl4gr/selitem.cpp,v 1.4 2003/05/23 16:27:01 cizek Exp $ */



#include "liste.h"

#include "xplwinap.h"

#include "function.h"

#include "macro.h"

#include "xplmat.h"



#include "object.h"

#include "wdisp.h"

#include "xplwin.h"

#include "selitem.h"



#include "xplore_strings.h"



extern bool closeall;

extern bool isrunning;

extern TApplication *myapp;



int six=40;

int siy=40;

int rvx=40;

int rvy=40;





extern TWindow *GrossVater;

char * SetTempDir()

{    Strp *strings = new Strp;

      strings[0]=strdup("Where is Your TEMP?");

		Strp *defs = new Strp;

      defs[0]=strdup("C:\\Temp");

      Strp *result= new Strp;

      result[0]=strdup("C:\\Temp");



      TReadValue trv(TXploreClient::Client, "Temp", strings, defs, 1, result);

	   if (trv.Execute()==IDOK)

   	   return(result[0]);

      else

        exit(1);

}





//************************************************************

//         ReadValue

//************************************************************



XplObject* ReadValue(Liste<XplObject*> *argl) {



	int i;

	char *str;

	float f;



	if (argl->laenge()!=2)

	{	globalError.Set (ERR_INTERN, "Error by readval: two args are wanted");

		return(NULL);

	}





	if (! ((*argl)[0]->Type()==O_XPLCHAR))

	{	globalError.Set (ERR_INTERN, "Error by readval: first parameter must be a XplChar!");

		return(NULL);

	}



	if (! ((*argl)[1]->Type()==O_XPLDOUBLE) && ! ((*argl)[1]->Type()==O_XPLCHAR))

	{	globalError.Set (ERR_INTERN,

	"Error by readval: second parameter must be a XplDouble or a XplChar!");

		return(NULL);

	}



	XplChar * xplc=(*argl)[0]->DefaultComponent()->Content().xplchar;



	int z;

	XplDouble *xd=NULL;

	XplChar *xc=NULL;



	if ((*argl)[1]->Type()==O_XPLDOUBLE )

	{	xd=(*argl)[1]->DefaultXplDouble();

		z= xd->dimension(0);

	}

	else

	{	xc=(*argl)[1]->DefaultComponent()->Content().xplchar;

		z= xc->dimension(0);

	}

	if ( xplc->dimension(0)!=z)

	{	globalError.Set (ERR_INTERN,

			"Error by readval: args have different dimensions!");

		return(NULL);

	}



	Strp *strings = new Strp[z];

	for (i=0; i<z; i++)

		strings[i] =(*xplc)(i).tostr();



	//float * defv = NULL;

	Strp *defs = new Strp[z];



	for (i=0; i<z; i++)

	if (xd!=NULL)

	{	defs[i] = new char [256];

  //		sprintf(defs[i], " %lf ", (*xd)(i));

		sprintf(defs[i], "%g", (*xd)(i));

  	}

	else

		defs[i]= (*xc)(i).tostr();



	Strp* result = new Strp [z];

	for (i=0; i<z; i++)

			result[i]=strdup(defs[i]);



	TReadValue rv(TXploreClient::Client, XMSG_READVALUE_DIALOGTITLE_STR,

					strings, defs, z, result);

	//rv.Execute();

    rv.Create();

    rv.ShowWindow(SW_SHOW);

    MSG msg;

    while (!closeall && GetMessage(&msg, NULL, 0, 0) && isrunning)

    {	TranslateMessage(&msg);

    //cout<<"number="<<msg.message<<endl;

    	DispatchMessage(&msg);

    }

    if (closeall)

    {	//si->CmOk();

    	isrunning=false;

      DispatchMessage(&msg);

    }



	XplDouble resd(z);

	XplChar resc(z);

	float fl;

	for (i=0; i<z; i++)

	if (xd!=NULL)

	{

   //if (sscanf(result[i], "%f", &fl)!=1)     // nicht lf !

	  if (sscanf(result[i], "%g", &fl)!=1)     // nicht lf !

     	{	globalError.Set (ERR_INTERN,

				"it is not a double!");

			cout<<" it is not double: "<<result[i]<<endl;

			for (i=0; i<z; i++)

			{	delete  strings[i];

				delete defs[i];

				delete result[i];

			}

			delete[] strings;

			delete[] defs;

			delete[] result;

			return(NULL);

		}

//		cout<<"fl="<<fl<<endl;

		resd(i)=fl;

	}

	else

			resc(i) = strdup(result[i]);







  for (i=0; i<z; i++)

  {	delete  strings[i];

		delete defs[i];

		delete result[i];

  }

  delete[] strings;

  delete[] defs;

  delete[] result;



	if (xd!=NULL)

	  return (new XplObject (new XplDouble(resd), "readvalue"));

	else

		return (new XplObject (new XplChar(resc), "readvalue"));



}



DEFINE_RESPONSE_TABLE1(TReadValue, TDialog)

		EV_COMMAND (IDOK, CmOk),

END_RESPONSE_TABLE;



#define ROWHEIGHT 25

#define CHARWIDTH 10

#define MIN_LENGTH 8



TReadValue::TReadValue(TXploreClient *parent, const char far* title,

						Strp *strs, Strp *defs, int dim, Strp *result)

						: TDialog(parent, "READVALUE"),

						 Strs(strs), Defs(defs), Result(result), Dim(dim)

{

		SetCaption(title);

		int i; int delta = 0; int deltav=0;

		for (i=0; i<dim; i++) {

		{	delta = (strlen(Strs[i]) > delta) ? strlen(Strs[i])  : delta;

			deltav = (strlen(defs[i]) > deltav) ? strlen(defs[i])  : deltav;		}

		}

	  //	if (delta<MIN_LENGTH)

     // 	delta=MIN_LENGTH;

		if (deltav<MIN_LENGTH)

      	deltav=MIN_LENGTH;

      delta *= CHARWIDTH;

		deltav *= CHARWIDTH;



		items = new TSArray<TStatic *>(dim);

		values = new TSArray<TEdit *>(dim);

		TStatic *s1; TEdit *s2;



		//char str[100];

		for (i=0; i<dim; i++) {

			s1 = new TStatic(this, -1, strs[i],  20, 20 + i*ROWHEIGHT, delta, ROWHEIGHT-5, 256);

			//gcvt(defv[i], 30, str);

			//sprintf(str, "%g", defv[i]);

	//		s2 = new TEdit(this, -1, defs[i],  30 + delta, 20 + i*20, 60, 15, 15);

			s2 = new TEdit(this, -1, defs[i],  30 + delta, 20 + i*ROWHEIGHT, deltav+7, ROWHEIGHT-5, 256);

			(*items)[i]=s1;

			(*values)[i]=s2;

	  }

	  winHi = dim*ROWHEIGHT + 50;

//	  winLen = 120 + delta;

	  winLen = 60 + delta+deltav;

	  bt = new TButton(this, IDOK, "OK", winLen/2 - 40, winHi - 20, 80, 20,true);

}

TReadValue::~TReadValue()

{





}







void

TReadValue::SetupWindow() {

	TDialog::SetupWindow();



   	int i;

	  for (i=0; i<Dim; i++) {

		(*items)[i]->Create();

		(*values)[i]->Create();

	  }

		bt->Create();

      isrunning=true;

	TRect cr1, cr2;

   GetWindowRect(cr1);

   cr2.SetWH( rvx, rvy, cr1.Width(),  cr1.Height());



//   MoveWindow(40, 40, winLen, winHi + 40 , TRUE);

	 MoveWindow(cr2.Left(), cr2.Top(), winLen,  winHi+40, TRUE);

}



void

TReadValue::EvSize(UINT sizeType, TSize& size)

{

  TDialog::EvSize(sizeType, size);

  Invalidate(TRUE);

}



void TReadValue::CmOk() {

	char str[100];

	int i;

		for (i=0; i<Dim; i++)

		{

			(*values)[i]->GetText(str, 100);

			 delete Result[i];

			 Result[i]=strdup(str);

			 //sscanf(str, "%g", & (Result[i]));

			 //Result[i] = atof(str);

		}

   isrunning=false;

   TRect cr;

   GetWindowRect(cr);

   rvx=cr.Left();

   rvy=cr.Top();

	TDialog::CmOk();

}



//**************************************************************

//                      SelectItem

//**************************************************************



XplObject* SelectItem(Liste<XplObject*> *argl) {



	int i, k, dim;

	char *str, *valstr;;

	float f;

	XplChar * xplv;

	XplDouble * xd;

	XplChar * xplc;

	bool ssingle = false;



	int count=(argl->laenge())/2;

	int all_count=0;



	// "single" als letzte parameter?

	if (argl->laenge()>2*count)

	{	if (! ((*argl)[2*count]->Type()==O_XPLCHAR))

		{	globalError.Set (ERR_INTERN, "Error by selectval: last parameter must be a XplChar!");

			return(NULL);

		}

		xplc=(*argl)[2*count]->DefaultComponent()->Content().xplchar;

		str=(*xplc)(0).tostr();

		if (!strcmp(str, "single"))

		{	//cout<<"!strcmp(xplc, single)"<<endl;

			ssingle=true;

		}

	}

	if (argl->laenge()<2)

	{	globalError.Set (ERR_INTERN, "Error by selectval: min. two args are wanted");

		return(NULL);

	}



	for (k=0; k<count; k++)

	{	if (! ((*argl)[2*k]->Type()==O_XPLCHAR))

		{	globalError.Set (ERR_INTERN, "Error by selectval: first parameter must be a XplChar!");

			return(NULL);

		}



		if (! ((*argl)[2*k+1]->Type()==O_XPLDOUBLE ||

	 	(*argl)[2*k+1]->Type()==O_XPLCHAR) )

		{	globalError.Set (ERR_INTERN, "Error by selectval: second parameter must be a XplDouble or XplChar!");

			return(NULL);

		}





		xplc=(*argl)[2*k]->DefaultComponent()->Content().xplchar;

		str=(*xplc)(0).tostr();	//OK!

		delete str;



		if ((*argl)[1+2*k]->Type()==O_XPLDOUBLE)

		{	xd=(*argl)[1+2*k]->DefaultXplDouble();

			dim=xd->dimension(0);

			for (i=0; i<dim; i++)

			{	f=(*xd)(i);

		  //		cout<<"xd="<<f<<endl;

			}

		}

		else

		{	xplv=(*argl)[1+2*k]->DefaultComponent()->Content().xplchar;

			dim=xplv->dimension(0);

			for (i=0; i<dim; i++)

			{	valstr=(*xplv)(i).tostr();

  				delete valstr;

			}

		}

		all_count+=dim;

	}

	char *st, fstr[256];

	Strp *strings = new Strp[all_count+k];

  	int z=0;

	//cout<<count<<endl;

	for (k=0; k<count; k++)

	{

   	xplc=(*argl)[2*k]->DefaultComponent()->Content().xplchar;

		st=(*xplc)(0).tostr();	//OK!

		strings[z++] = strdup(st);

		delete st;





		if ((*argl)[1+2*k]->Type()==O_XPLDOUBLE)

		{	xd=(*argl)[1+2*k]->DefaultXplDouble();

			dim=xd->dimension(0);

			for (i=0; i<dim; i++)

			{	sprintf(fstr, "%g", (*xd)[i]);

				strings[z++] = strdup(fstr);

			//	cout<<fstr<<endl;

			}

		}

		else

		{	xplv=(*argl)[1+2*k]->DefaultComponent()->

					Content().xplchar;

			dim=xplv->dimension(0);

			for (i=0; i<dim; i++)

			{	st=(*xplv)(i).tostr();	//OK!

				sprintf(fstr, "%s", st);

				strings[z++] = strdup(st);

				delete st;

			}

		}

	}



	 Strp *strs = new Strp[z-1];



	 for (i=1; i<z; i++)

	 {	//cout<<strings[i]<<endl;

		strs[i-1] = strdup(strings[i]);

	 }

	 int* result = new int[z-1];



	 TSelItem *si=new TSelItem(TXploreClient::Client, strings[0],

					strs, z-1, result, ssingle);

    si->Create();

   HFONT tfont=(HFONT) GetStockObject(SYSTEM_FIXED_FONT);

   si->SetWindowFont(tfont, FALSE);

     si->ShowWindow(SW_SHOW);



    //si.Execute();



   /*

    while (si->isrunning)

    {	for (i=0; i<100000; i++);

      	log(i)+log(log(i));

    cout<<"uhu"<<endl;

    }

    */

    MSG msg;

    while (!closeall && GetMessage(&msg, NULL, 0, 0) && isrunning)

    {	TranslateMessage(&msg);

    //cout<<"number="<<msg.message<<endl;

    	DispatchMessage(&msg);

    }

    if (closeall)

    {	//si->CmOk();

    	delete si;

    	isrunning=false;

      DispatchMessage(&msg);

    }



  XplDouble *r = new XplDouble (z-1);



  for (i=0; i<z-1; i++)

    {

		(*r)(i) = result[i];

    }



  delete[] strs;

  delete[] strings;

  delete[] result;





  return (new XplObject (r, "selectitem"));





}



DEFINE_RESPONSE_TABLE1(TSelItem, TDialog)

  EV_LBN_SELCHANGE(IDC_LISTBOX1,    EvLBNSelChange),

  EV_COMMAND (IDOK, CmOk),

END_RESPONSE_TABLE;



TSelItem::TSelItem(TXploreClient *parent, const char far* title,

						Strp *strs, int dim, int *result, bool ss)

                  : TDialog(parent, "SELECTITEM"),

                    Strs(strs), Result(result), Dim(dim)

{



  ListBox = new TListBox(this, IDC_LISTBOX1);

  ListBox->Attr.Style;



  SetCaption(title);

  isrunning=true;

  single=ss;

}

TSelItem::~TSelItem()

{



}







void

TSelItem::SetupWindow() {

	TDialog::SetupWindow();





  	  ListBox->Create();

     ListBox->SetFocus();



     for (int i=0; i<Dim; i++) {

		  ListBox->AddString(Strs[i]);

        Result[i] = 0;

     }

   TRect cr;

   GetWindowRect(cr);

//   MoveWindow(40, 40, winLen, winHi + 40 , TRUE);

	 MoveWindow(six, siy, cr.Width(),  cr.Height(), TRUE);

}



void

TSelItem::EvSize(UINT sizeType, TSize& size)

{

  TDialog::EvSize(sizeType, size);

  Invalidate(TRUE);

}



void TSelItem::EvLBNSelChange() {

	int *sels = new int[Dim];

   int count = ListBox->GetSelIndexes(sels, Dim);



   for (int i=0; i<Dim; i++) Result[i] = 0;

   for (int i=0; i<count; i++) Result[sels[i]] = 1;

   if (single)

      TSelItem::CmOk();





}

void TSelItem::CmOk()

{

//cout<<"hurra"<<endl;

   TRect cr;

   GetWindowRect(cr);

   six=cr.Left();

   siy=cr.Top();

   isrunning=false;

	TDialog::CmOk();

}





//**************************************************************

//                      slideValue

//**************************************************************

// PC 20011005



XplObject* SlideValue(Liste<XplObject*> *argl) {



	int i;

	char *str;

	float f;



	if (argl->laenge()!=4)

	{	globalError.Set (ERR_INTERN, "Error by readval: two args are wanted");

		return(NULL);

	}





	if (! ((*argl)[0]->Type()==O_XPLCHAR))

	{	globalError.Set (ERR_INTERN, "Error by readval: first parameter must be a XplChar!");

		return(NULL);

	}



	if (! ((*argl)[1]->Type()==O_XPLDOUBLE) )

	{	globalError.Set (ERR_INTERN,

	"Error by readval: second parameter must be a XplDouble or a XplChar!");

		return(NULL);

	}



  	if (! ((*argl)[2]->Type()==O_XPLDOUBLE) )

	{	globalError.Set (ERR_INTERN,

	"Error by readval: second parameter must be a XplDouble or a XplChar!");

		return(NULL);

	}



  	if (! ((*argl)[3]->Type()==O_XPLDOUBLE) )

	{	globalError.Set (ERR_INTERN,

	"Error by readval: second parameter must be a XplDouble or a XplChar!");

		return(NULL);

	}



	XplChar * xplc=(*argl)[0]->DefaultComponent()->Content().xplchar;



	int z;

	XplDouble *xd=NULL;

	XplDouble *xmin=NULL;

	XplDouble *xmax=NULL;

	XplChar *xc=NULL;



//	if ((*argl)[1]->Type()==O_XPLDOUBLE )

	{

      xd=(*argl)[1]->DefaultXplDouble();

		z= xd->dimension(0);

	}

	if ( xplc->dimension(0)!=z)

	{	globalError.Set (ERR_INTERN,

			"Error by readval: args have different dimensions!");

		return(NULL);

	}

	{

      xmin=(*argl)[2]->DefaultXplDouble();

	}

	{

      xmax=(*argl)[3]->DefaultXplDouble();

	}



	Strp *strings = new Strp[z];

	for (i=0; i<z; i++)

		strings[i] =(*xplc)(i).tostr();



	//float * defv = NULL;

	double *defs = new double[z];

	double *mins = new double[z];

	double *maxs = new double[z];

	for (i=0; i<z; i++)

   {

		defs[i]= (*xd)(i);

		mins[i]= (*xmin)(i);

		maxs[i]= (*xmax)(i);

   }



	double *results = new double[z];

	for (i=0; i<z; i++)

			results[i]=defs[i];



	TSlideValue sv(TXploreClient::Client, "Slide Value",

					strings, defs, mins, maxs, z, 0, results);

	//rv.Execute();

    sv.Create();

    sv.ShowWindow(SW_SHOW);

    MSG msg;

    while (!closeall && GetMessage(&msg, NULL, 0, 0) && isrunning)

    {	TranslateMessage(&msg);

    //cout<<"number="<<msg.message<<endl;

    	DispatchMessage(&msg);

    }

    if (closeall)

    {	//si->CmOk();

    	isrunning=false;

      DispatchMessage(&msg);

    }



	XplDouble resd(z);

	for (i=0; i<z; i++)

		resd(i) = results[i];



  for (i=0; i<z; i++)

  {	delete strings[i];

  }

  delete[] strings;

  delete[] defs;

  delete[] mins;

  delete[] maxs;

  delete[] results;



  return (new XplObject (new XplDouble(resd), "readvalue"));

}



#define ROWHEIGHT 30

#define CHARWIDTH 10

#define MIN_LENGTH 8

#define SLIDE_VALUE_LENGTH (9*CHARWIDTH)

#define SLIDE_LENGTH 300

#define SLIDE_DIVISION 1000	// ticks are DIVISION / 10

#define SLIDER_IDS	21100

#define DESCRIPTOR_IDS 21200

#define SLIDEVALUE_IDS 21300





DEFINE_RESPONSE_TABLE1(TSlideValue, TDialog)

		EV_COMMAND (IDOK, CmOk),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+0, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+1, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+2, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+3, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+4, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+5, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+6, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+7, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+8, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+9, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+10, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+11, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+12, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+13, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+14, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+15, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+16, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+17, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+18, UpdateInfoValues),

      EV_CHILD_NOTIFY_ALL_CODES(SLIDER_IDS+19, UpdateInfoValues),

END_RESPONSE_TABLE;



TSlideValue::TSlideValue(TXploreClient *parent, const char far* title,

						Strp *strs, double *defs, double *mins, double * maxs,

                  int dim, int interactive, double *results)

						: TDialog(parent, "SLIDEVALUE"),

						 Strs(strs), Defs(defs), Mins(mins), Maxs(maxs),

                   Results(results), Dim(dim), Interactive(interactive)

{

		SetCaption(title);

		int i;

      int delta = 0;

      int deltav=0;



		for (i=0; i<dim; i++) {

		{	delta = (strlen(Strs[i]) > delta) ? strlen(Strs[i])  : delta;

//			deltav = (strlen(defs[i]) > deltav) ? strlen(defs[i])  : deltav;

      }

		}



	  //	if (delta<MIN_LENGTH)

     // 	delta=MIN_LENGTH;

		if (deltav<MIN_LENGTH)

      	deltav=MIN_LENGTH;

      delta *= CHARWIDTH;

		deltav = SLIDE_LENGTH;



		items = new TSArray<TStatic *>(dim);

      actvals = new TSArray<TStatic *>(dim);

		values = new TSArray<THSlider *>(dim);

		TStatic *s1, *s3; THSlider *s2;



		//char str[100];

		for (i=0; i<dim; i++) {

			s1 = new TStatic(this, DESCRIPTOR_IDS + i, strs[i], 20, 20 + i*ROWHEIGHT, delta, ROWHEIGHT-5, 256);

			//gcvt(defv[i], 30, str);

			//sprintf(str, "%g", defv[i]);

	//		s2 = new TEdit(this, -1, defs[i],  30 + delta, 20 + i*20, 60, 15, 15);

			s2 = new THSlider(this, SLIDER_IDS + i, 30 + delta, 20 + i*ROWHEIGHT, deltav, ROWHEIGHT - 5);

// done in SetupWindow         s2->SetRange(0,SLIDE_DIVISION);

// done in SetupWindow         s2->SetPosition((int) (SLIDE_DIVISION * (defs[i] - mins[i]) / (maxs[i] - mins[i])));



			s3 = new TStatic(this, SLIDEVALUE_IDS + i, "", 40 + delta + deltav, 20 + i*ROWHEIGHT, SLIDE_VALUE_LENGTH + CHARWIDTH, ROWHEIGHT-5, 64);



			(*items)[i]=s1;

         (*actvals)[i]=s3;

			(*values)[i]=s2;

	  }

	  winHi = dim*ROWHEIGHT + 50;

//	  winLen = 120 + delta;

	  winLen = 80 + delta + deltav + SLIDE_VALUE_LENGTH;

	  bt = new TButton(this, IDOK, "OK", winLen/2 - 40, winHi - 20, 80, 20,true);

}



TSlideValue::~TSlideValue()

{

}







void

TSlideValue::SetupWindow() {

	TDialog::SetupWindow();



   	int i;

	  for (i=0; i<Dim; i++) {

		(*items)[i]->Create();

      (*actvals)[i]->Create();

		(*values)[i]->Create();

	  }



   bt->Create();

   isrunning=true;

	TRect cr1, cr2;

   GetWindowRect(cr1);

   cr2.SetWH( rvx, rvy, cr1.Width(),  cr1.Height());



//   MoveWindow(40, 40, winLen, winHi + 40 , TRUE);

	 MoveWindow(cr2.Left(), cr2.Top(), winLen,  winHi+40, TRUE);



    THSlider *s;



  for (i=0; i<Dim; i++)

  {

		s = (*values)[i];

      s->SetRange(0,SLIDE_DIVISION);

      s->SetPosition((int) (SLIDE_DIVISION * (Defs[i] - Mins[i]) / (Maxs[i] - Mins[i])));

  }

}



void

TSlideValue::EvSize(UINT sizeType, TSize& size)

{

  TDialog::EvSize(sizeType, size);

  Invalidate(TRUE);

}



void TSlideValue::CmOk()

{

   THSlider *s;

	char str[100];

	int i;

		for (i=0; i<Dim; i++)

		{

          s = (*values)[i];

			 Results[i] = ((double) s->GetPosition() / (double) SLIDE_DIVISION) *

          						(Maxs[i] - Mins[i]) + Mins[i] ;

		}

   isrunning=false;

   TRect cr;

   GetWindowRect(cr);

   rvx=cr.Left();

   rvy=cr.Top();

	TDialog::CmOk();

}



void TSlideValue::UpdateInfoValues(UINT id)

{

      TStatic *t;

      THSlider *s;

      int i;

      char buf[32];



		for (i=0; i<Dim; i++)

      {

            t = (*actvals)[i];

            s = (*values)[i];

            sprintf(buf, "%8g", ((double) s->GetPosition() / (double) SLIDE_DIVISION) *

                						(Maxs[i] - Mins[i]) + Mins[i]);

            t->SetText(buf);

      }

}





