/* $Header: /home/xplore/cvs/xpl4gr/selitem.h,v 1.3 2002/08/16 12:31:49 sigbert Exp $ */

#ifndef _SELITEM_H_
#define _SELITEM_H_

//#include <owl\framewin.h>
#include <owl/slider.h>

#include "xplwinap.h"
//***************************************************

class TReadValue : public TDialog {
  public:
	 TReadValue(TXploreClient *parent, const char far* title,
		//alt:		 Strp *strs, float *Defv, int dim, float *result) ;
				 Strp *strs, Strp *defs, int dim, Strp *result) ;       //SWS

	 ~TReadValue();

	protected:
  void EvSize(uint sizeType, TSize& size);
 // void EvLBNSelChange();
  void SetupWindow();


  private:
  TXploreClient* Parent;
  TSArray<TStatic *> *items;
  TSArray<TEdit *> *values;
  TButton *bt;
  int winHi, winLen;
  Strp *Strs;
  Strp *Defs;
  int Dim;
  Strp *Result;
  void CmOk();
//  char Title[30];


  DECLARE_RESPONSE_TABLE(TReadValue);
};

class TSelItem : public TDialog {
  public:
	 TSelItem(TXploreClient *parent, const char far* title,
    			 Strp *strs, int dim, int *result, bool s) ;

	 ~TSelItem();
	protected:
  void EvSize(uint sizeType, TSize& size);
  void EvLBNSelChange();
  void SetupWindow();
  void CmOk();

  private:
  TXploreClient* Parent;
  TListBox*   ListBox;
  Strp *Strs;
  int Dim;
  int *Result;
  char Title[30];
  bool single;

  DECLARE_RESPONSE_TABLE(TSelItem);
};

// PC 20011005
class TSlideValue : public TDialog {
  public:
	 TSlideValue(TXploreClient *parent, const char far* title,
				 Strp *strs, double *defs, double *min, double * maxs,
             int dim, int interactive, double *results);

	 ~TSlideValue();

	protected:
  void EvSize(uint sizeType, TSize& size);
 // void EvLBNSelChange();
  void SetupWindow();
  void UpdateInfoValues(UINT id);


  private:
  TXploreClient* Parent;
  TSArray<TStatic *> *items;
  TSArray<TStatic *> *actvals;
  TSArray<THSlider *> *values;
  TButton *bt;
  int winHi, winLen;
  Strp *Strs;
  double *Defs;
  double *Mins;
  double *Maxs;
  double *Results;
  int Dim;
  int Interactive;
  void CmOk();

  DECLARE_RESPONSE_TABLE(TSlideValue);
};
#endif

