
/* setgopt definitions for xplore and java */

#define OPTNUM          27

#define TITLE_NUM 	   0
#define XLIM_NUM	      1
#define YLIM_NUM	      2
#define XORIGIN_NUM	   3
#define YORIGIN_NUM	   4
#define XMAJOR_NUM	   5
#define YMAJOR_NUM	   6
#define XLABEL_NUM	   7
#define YLABEL_NUM	   8
#define XVALUE_NUM	   9
#define YVALUE_NUM	   10
#define ROTPOINT_NUM	   11
#define ROTCOS_NUM	   12
#define SCAL_NUM	      13
#define TRANS_NUM	      14
#define XOFFSET_NUM	   15
#define YOFFSET_NUM	   16
#define BRUSHSIZE_NUM 	17
#define FSCAL_NUM	      18
#define BORDER_NUM      19
#define XAXIS_NUM       20
#define YAXIS_NUM       21
#define ZAXIS_NUM       22
#define FONTTYPE_NUM    23
#define DISPSIZE_NUM    24
#define DISPPOS_NUM     25
#define AXES_NUM    		26

/* extern char *options[OPTNUM]; defined in swefunc7.c */
/* extern long opt_type[OPTNUM]; defined in swefunc7.c */

static char *options[OPTNUM] = {
		 	"title", "xlim", "ylim", "xorigin", "yorigin",
			"xmajor", "ymajor", "xlabel", "ylabel", "xvalue",
			"yvalue", "rotpoint", "rotcos", "scal", "transl",
			"xoffset", "yoffset", "brushsize", "fscal", "border",
         "xaxis", "yaxis", "zaxis", "fonttype",
         "dispsize", "disppos", "axes"
         							 };

static long opt_type[OPTNUM]={
      O_XPLCHAR, O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE,
		O_XPLDOUBLE, O_XPLDOUBLE, O_XPLCHAR, O_XPLCHAR, O_XPLDOUBLE,
		O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE,
		O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE,
      O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE, O_XPLCHAR,
      O_XPLDOUBLE, O_XPLDOUBLE, O_XPLDOUBLE 
		};


