/* $Header: /home/xplore/cvs/xpl4gr/swefun2.C,v 1.4 2002/10/31 18:21:20 cizek Exp $ */

// Erweiterung of SWS_Interpreter
//  SWS 26.2.95

#pragma implementation "liste.h"

#include <math.h>
#include <new.h>
#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif
#include <signal.h>

#include "liste.h"
#include "init.h"
#include "function.h"
#include "macro.h"
// Last Cahnge SWS 10.9
#include "xplfun.h"
#include "xplfun2.h"
#include "xplfun3.h"
#include "xplbasefun.h"
#include "plot.h"

extern int xpldisplay_width, xpldisplay_height;
extern int xpldisplay_left, xpldisplay_top;  // PC 20021030
extern int ps_width, ps_height;
extern bool global_axis_on;


Plot *PlotRequested(Liste<XplObject*> *argl);
//#ifndef __BORLANDC__      // SWS
XplObject* swsprint(Liste<XplObject*> *argl)
{	XplDisplay *xpld;
	XplChar *xplc;
	char * fname;
	Plot *p;

	static int psnum=1;

	switch (argl->laenge())
	{	case 1:
		if ( ! ((*argl)[0]->Type()==O_DISPLAY) )
		{	globalError.Set (ERR_INTERN,
		"Error by print: 1. Argument must be a display!");
			return(NULL);
		}
		xpld=
			(*argl)[0]->DefaultComponent()->Content().display;
		xpld->Print();
		return(NULL);

		case 2:
		if ( ! ((*argl)[0]->Type()==O_DISPLAY) )
		{	globalError.Set (ERR_INTERN, 
		"Error by print: 1. Argument must be a display!");
			return(NULL);
		}
		xpld=
			(*argl)[0]->DefaultComponent()->Content().display;
		if ( ! ((*argl)[1]->Type()==O_XPLCHAR) )
		{	globalError.Set (ERR_INTERN,
		"Error by print: 2. Argument must be a string!");
			return(NULL);
		}
		xplc=(*argl)[1]->DefaultComponent()->Content().xplchar;
		fname=((*xplc)(0).tostr());	//OK!
		xpld->Print(fname);
		delete fname;
		return(NULL);
		
		case 3:
		p=PlotRequested(argl);
		if (p==NULL)
		{	globalError.Set (ERR_INTERN, "Error by swsprint! No such plot");
			return(NULL);
		}
		char ffn[16];
		sprintf(ffn, "plot%d", psnum);
		p->Print(ffn);
		psnum++;
		return(NULL);


		case 4:
		p=PlotRequested(argl);
		if (p==NULL)
		{	globalError.Set (ERR_INTERN, "Error by swsprint! No such plot");
			return(NULL);
		}
		if ( ! ((*argl)[3]->Type()==O_XPLCHAR) )
		{	globalError.Set (ERR_INTERN, 
		"Error by print: 4. Argument must be a string!");
			return(NULL);
		}
		xplc=(*argl)[3]->DefaultComponent()->Content().xplchar;
		fname=((*xplc)(0).tostr());	//OK!
		p->Print(fname);
		delete fname;
		return(NULL);
		

		default:
		{	globalError.Set (ERR_INTERN, 
			"Error by print: 1, 2 3 or 4 arguments wanted!");
		return(NULL);
		}
	}
	return (NULL);
}
//#endif //BORLANDC
XplObject* AxesOn(Liste<XplObject*> *argl)
{	global_axis_on=(0==0);
	return(NULL);
}

XplObject* AxesOff(Liste<XplObject*> *argl)
{	global_axis_on=(1==0);
	return(NULL);
}

/* PC 20021031: new setsize, setpos, getsize, getpos */
XplObject* setsize(Liste<XplObject*> *argl)
{	XplDouble *x, *y;
	if ((argl->laenge()!=2) && (argl->laenge()!=3))
	{	cerr<<"Error by setsize: 2 or 3 arguments wanted!"<<endl;
		return(NULL);
	}

	if (argl->laenge()==2)
   {
	  x=(*argl)[0]->DefaultXplDouble();
	  xpldisplay_width=(int)((*x)[0]);
     if (xpldisplay_width <= 0)
       xpldisplay_width = 1;

	  x=(*argl)[1]->DefaultXplDouble();
	  xpldisplay_height=(int)((*x)[0]);
     if (xpldisplay_height <= 0)
       xpldisplay_height = 1;
#ifdef _BLABLA_
	  cout<<"global: width="<<xpldisplay_width<<", height="<<
	      xpldisplay_height<<endl;
#endif
   }
   else
   {
     int xint, yint;
     if ((*argl)[2]->Type () != O_DISPLAY)
     {
		   globalError.Set (ERR_NUM, "setsize: third argument must be display");
	   	return (NULL);
	  }
     XplDisplay *xpld=(*argl)[2]->DefaultComponent()->Content().display;

     x=(*argl)[0]->DefaultXplDouble();
     xint = (int)((*x)[0]);
     if (xint <= 0) xint = 1;

	  y=(*argl)[1]->DefaultXplDouble();
     yint = (int)((*y)[0]);
     if (yint <= 0) yint = 1;

	  xpld->DoWinResize( xint, yint );

#ifdef _BLABLA_
	cout<<"width="<<xpldisplay_width<<", height="<<
		xpldisplay_height<<endl;
#endif
   }

	return(NULL);
}

/* original setsize 
XplObject* setsize(Liste<XplObject*> *argl)
{	XplDouble *x;
	if (argl->laenge()!=2)
	{	cerr<<"Error by setsize: 2 arguments wanted!"<<endl;
		return(NULL);
	}

	x=(*argl)[0]->DefaultXplDouble();
	xpldisplay_width=(int)((*x)[0]);

	x=(*argl)[1]->DefaultXplDouble();
	xpldisplay_height=(int)((*x)[0]);
#ifdef _BLABLA_
	cout<<"global: width="<<xpldisplay_width<<", height="<<
		xpldisplay_height<<endl;
#endif
	return(NULL);
}
*/

XplObject* getsize(Liste<XplObject*> *argl)
{
   XplDouble *res = new XplDouble(2);

	if ((argl->laenge()!=0) && (argl->laenge()!=1))
	{	cerr<<"Error by getsize: none or 1 argument wanted!"<<endl;
		return(NULL);
	}

	if (argl->laenge()==0)
   {
	  (*res)(0) = xpldisplay_width;
	  (*res)(1) = xpldisplay_height;
   }
   else
   {
     if ((*argl)[0]->Type () != O_DISPLAY)
     {
		   globalError.Set (ERR_NUM, "show: argument must be display");
	   	return (NULL);
	  }
     XplDisplay *xpld=(*argl)[0]->DefaultComponent()->Content().display;

	  (*res)(0) = xpld->GetWidth();
	  (*res)(1) = xpld->GetHeight();
   }

	return(new XplObject (res, "getsize"));
}

XplObject* setpos(Liste<XplObject*> *argl)
{	XplDouble *x, *y;
	if ((argl->laenge()!=2) && (argl->laenge()!=3))
	{	cerr<<"Error by setpos: 2 or 3 arguments wanted!"<<endl;
		return(NULL);
	}

	if (argl->laenge()==2)
   {
	  x=(*argl)[0]->DefaultXplDouble();
	  xpldisplay_left=(int)((*x)[0]);

	  x=(*argl)[1]->DefaultXplDouble();
	  xpldisplay_top=(int)((*x)[0]);
   }
   else
   {
     int xint, yint;

     if ((*argl)[2]->Type () != O_DISPLAY)
     {
		   globalError.Set (ERR_NUM, "getpos: third argument must be display");
	   	return (NULL);
	  }
     XplDisplay *xpld=(*argl)[2]->DefaultComponent()->Content().display;

     x=(*argl)[0]->DefaultXplDouble();
     xint = (int)((*x)[0]);
     if (xint <= 0) xint = 0;

	  y=(*argl)[1]->DefaultXplDouble();
     yint = (int)((*y)[0]);
     if (yint <= 0) yint = 0;

	  xpld->DoWinPosition( xint, yint );
   }

	return(NULL);
}

XplObject* getpos(Liste<XplObject*> *argl)
{
   XplDouble *res = new XplDouble(2);

	if ((argl->laenge()!=0) && (argl->laenge()!=1))
	{	cerr<<"Error by getpos: none or 1 argument wanted!"<<endl;
		return(NULL);
	}

	if (argl->laenge()==0)
   {
	  (*res)(0) = xpldisplay_left;
	  (*res)(1) = xpldisplay_top;
   }
   else
   {
     if ((*argl)[0]->Type () != O_DISPLAY)
     {
		   globalError.Set (ERR_NUM, "show: argument must be display");
	   	return (NULL);
	  }
     XplDisplay *xpld=(*argl)[0]->DefaultComponent()->Content().display;

	  (*res)(0) = xpld->GetWinLeft();
	  (*res)(1) = xpld->GetWinTop();
   }

	return(new XplObject (res, "getpos"));
}

 
#ifdef _GRAPHICS_

XplObject* SetMode(Liste<XplObject*> *argl)
{	if (argl->laenge()!=4)
	{	cerr<<"Error by setsize: 5 argumente erwartet!"<<endl;
		return(NULL);
	}

	Plot * p=PlotRequested(argl);
	if (p==NULL)
	{	globalError.Set (ERR_INTERN, "Error by setmode:no such element!");
		return(NULL);
	}
	XplDouble *x;
	x=(*argl)[3]->DefaultXplDouble();
	int mo=(int)((*x)[0]);
	switch(mo)
	{	case 0:	p->mouse_function[0]=ZOOM;
			p->mouse_function[2]=INDEX;
			p->pointer_function=PNOTHING;
#ifdef _BLABLA_
			cout<<"ZOOM!"<<endl;
#endif
			break;
		case 1: p->mouse_function[0]=SINGLE_BRUSH;
			p->pointer_function=PREPARE_BRUSH;
			p->mouse_function[2]=INDEX;
#ifdef _BLABLA_
			cout<<"SINGLE_BRUSH!"<<endl;
#endif
			break;
		case 2: p->mouse_function[0]=NOTHING;
			p->mouse_function[2]=NOTHING;
			p->pointer_function=PNOTHING;
#ifdef _BLABLA_
			cout<<"NOTHING!"<<endl;
#endif
			break;
		case 3: p->mouse_function[0]=SINGLE_ZOOM;
			p->pointer_function=PREPARE_ZOOM;
			p->mouse_function[2]=INDEX;
#ifdef _BLABLA_
			cout<<"SINGLE_BRUSH!"<<endl;
#endif
			break;		
		defaults: cerr<<"no such mode!"<<endl;
			break;
	}
	return(NULL);
}

XplObject* getbrushed(Liste<XplObject*> *argl)
{	cout<<"sorry"<<endl;	
	return(NULL);
}
XplObject* setbrushed(Liste<XplObject*> *argl)
{	cout<<"sorry"<<endl;	
	return(NULL);
}
#endif
Plot *PlotRequested(Liste<XplObject*> *argl)
{if ( ! ((*argl)[0]->Type()==O_DISPLAY) )
{	cerr<<"Error by ...: 1. Argument must be a display!"<<endl;
	return(NULL);
}
XplDisplay *xpld=(*argl)[0]->DefaultComponent()->Content().display;

if ( ! ((*argl)[1]->Type()==O_XPLDOUBLE) )
{	cerr<<"Error by ...: 2. Argument must be a XPLDOUBLE!"<<endl;
	return(NULL);
}
XplDouble *x=(*argl)[1]->DefaultXplDouble();
int i=(int)((*x)[0]);

if ( ! ((*argl)[2]->Type()==O_XPLDOUBLE) )
{	cerr<<"Error by ...: 3. Argument must be a XPLDOUBLE!"<<endl;
	return(NULL);
}
x=(*argl)[2]->DefaultXplDouble();
int j=(int)((*x)[0]);

SubDisplay * sd=xpld->GetElement(i, j);
if (sd==NULL || !(sd->WhatIs()==PLOT || sd->WhatIs()==UPLOT || sd->WhatIs()==WPLOT))
{cerr<<"Error by ...:no such element! i="<<i<<", j="<<j<<endl;
	return(NULL);
}
return( (Plot *)sd);
}
