/* $Header: /home/xplore/cvs/xpl4gr/swefun6.C,v 1.3 2002/08/16 12:31:51 sigbert Exp $ */

// Erweiterung of SWS_Interpreter
//  SWS 26.2.95

#pragma implementation "liste.h"

#include <math.h>
#include <new.h>
#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif
#include <signal.h>

#include "liste.h"
#include "init.h"
#include "function.h"
#include "macro.h"
#include "xplfun.h"
#include "xplfun2.h"
#include "xplfun3.h"
#include "xplbasefun.h"
#include "plot.h"
#ifdef _UNIX_
#include "uplot.h"
#endif

extern Plot * PlotRequested(Liste<XplObject*> *argl);

XplObject* SetHeadline(Liste<XplObject*> *argl)
{	if (argl->laenge()!=4)
	{	globalError.Set (ERR_INTERN, "4 args are wanted");
		return(NULL);
	}

	Plot *p=PlotRequested(argl);
	if (p==NULL)
	{	globalError.Set (ERR_INTERN, "No such a plot!");
		return(NULL);
	}
	if (! ((*argl)[3]->Type()==O_XPLCHAR) )
	{	globalError.Set (ERR_INTERN, "Error by setheadline: fourth parameter must be a XplChar!");
		return(NULL);
	}
	
	XplChar * xplc=(*argl)[3]->DefaultComponent()->Content().xplchar;
	char * head=(*xplc)(0).tostr();
	p->SetHeadline(head);
	delete head;
	p->head_on=(0==0);
	p->Refresh();
	return(NULL);
}

#ifdef _UNIX_
#include "motif.h"
#include <Xm/DialogS.h>
#include <Xm/BulletinB.h>
#include <Xm/ToggleB.h>
extern "C" BS_Glob_Variable bs_glob_variable;

struct 	MENUE_S	{	Widget dialog;		//zum popdown
			Widget bulboard;	//zum killen
			int count;		//wieviel zeilen
			XplMatrix *selstr;
			XplObject *wohin;
			Widget *text_w;
		};

bool ready;
	

XplObject* Flush(Liste<XplObject*> *argl)
{	int i=0;
	int event_mask=KeyPressMask|ButtonPressMask|ButtonReleaseMask;
	Boolean ready;
	XEvent event;

	if (argl->laenge()==0)
	{	while (XQLength(XtDisplay(bs_glob_variable.main_shell))>0)
			XtAppProcessEvent(bs_glob_variable.kontext, XtIMAll);
	
		return(NULL);
	}


	Window win;
	Widget wid;
	Wid_Data *wid_data;
	MyPoint xy;
	XplMatrix ma;
	Plot *p;
	int evk;
	
	switch(argl->laenge())
	{	case 1:
		evk=(int)(*((*argl)[0]->DefaultXplDouble()))(0);
		p=NULL;
		break;
		
		case 4:
		evk=(int)(*((*argl)[3]->DefaultXplDouble()))(0);
		p=PlotRequested(argl);
		break;
		
		default:
		globalError.Set (ERR_INTERN, "Error by readevent: wrong number of arguments!");
		return(NULL);
	}

	//XFlush(XtDisplay(bs_glob_variable.main_shell));
	//XSynchronize(XtDisplay(bs_glob_variable.main_shell), True);
	switch(evk)
	{	case 0:	event_mask=KeyPressMask;	break;
		case 1:	event_mask=ButtonPressMask;	break;
	}

	XplDouble *nx=new XplDouble(1);
  	XplObject *o;
	
	if (p!=NULL)
	{	wid=((UPlot *)p)->GetWidget();
		win=XtWindow(wid);
	}
	if (p==NULL)
	if (XCheckMaskEvent(XtDisplay(bs_glob_variable.main_shell), 
		 event_mask, &event))
		(*nx)(0)=1;
	else
	{	(*nx)(0)=0;
 		o  = new XplObject (nx, "uhu");
		return(o);
	}
	else
	if (XCheckTypedWindowEvent(XtDisplay(bs_glob_variable.main_shell), 
		 XtWindow(((UPlot *)p)->GetWidget()),
		   event_mask, &event))
		(*nx)(0)=1;
	else
	{	(*nx)(0)=0;
 		o  = new XplObject (nx, "uhu");
		return(o);
	}
	
 	
 	o  = new XplObject (nx, "uhu");
	
	int charcount;
	char buf[1], str[2];
	KeySym keysym;
	XComposeStatus compose;
	XplChar * xplc;
	XplDouble *xpld, *xplr, *xplm;
	str[1]=0;

	if (evk==0)
	{	charcount=XLookupString(&(event.xkey), buf, 1, &keysym,
			 &compose);
		xplc=new XplChar(1);
		str[0]=buf[0];
		(*xplc)(0)=str;
#ifdef _BLABLA_
	cout<<"key "<<buf[0]<<" or as a keysym "<<keysym<<endl;
#endif
		o->AppendComponent( new Component( new XplObject 
  			(xplc,"key")));
		xpld=new XplDouble(1);
		(*xpld)(0)=(int)keysym;
		o->AppendComponent( new Component( new XplObject 
  			(xpld,"keysym")));
	}
	else
	{	win=event.xbutton.window;
		wid=XtWindowToWidget(XtDisplay(bs_glob_variable.main_shell),
					win);
		xpld=new XplDouble(1);
		(*xpld)(0)=event.xbutton.button;
		o->AppendComponent( new Component( new XplObject 
  			(xpld,"button")));
		if (p!=NULL)
		{	xplm=new XplDouble(2);
				(*xplm)(0)=event.xbutton.x;
				(*xplm)(1)=event.xbutton.y;
			o->AppendComponent( new Component( 
					new XplObject (xplm,"xy")));
			//o->Print();
			xy.x=event.xbutton.x;
			xy.y=event.xbutton.y;
			if (p->GetDimension()==2)
			{	ma=p->GetOrigin(xy);
				xplr=new XplDouble(2);
					(*xplr)(0)=ma(0, 0);
					(*xplr)(1)=ma(0, 1);
				o->AppendComponent( new Component( 
					new XplObject (xplr,"xyreal")));
#ifdef _BLABLA_
	cout<<"xyreal: "<<ma(0, 0)<<", "<<ma(0, 1)<<endl;
#endif
			}
			ready=False;
			while (!ready)
			{	XMaskEvent(XtDisplay(
					bs_glob_variable.main_shell), 
		 			ButtonReleaseMask|ButtonMotionMask,
		 			 &event);
		 		if (event.type==ButtonRelease)
		 		ready=True;
		 	}
		 	while (XCheckMaskEvent(XtDisplay(
		 		bs_glob_variable.main_shell), 
		 		ButtonPressMask, &event))
		 	{
			ready=False;
			while (!ready)
			{	XMaskEvent(XtDisplay(
					bs_glob_variable.main_shell), 
		 			ButtonReleaseMask|ButtonMotionMask,
		 			 &event);
		 		if (event.type==ButtonRelease)
		 		ready=True;
		 	}
		 	}
		}
		
	
	}
	/*
	XFlush(XtDisplay(bs_glob_variable.main_shell));
	if ((*nx)(0)==1)
		XPutBackEvent(XtDisplay(bs_glob_variable.main_shell), &event);
	*/
 	
	return(o);
}

XplObject* GetMouse(Liste<XplObject*> *argl)
{	if (argl->laenge()!=3)
	{	globalError.Set (ERR_INTERN, "3 args are wanted");
		return(NULL);
	}

	Plot *p=PlotRequested(argl);
	if (p==NULL)
	{	globalError.Set (ERR_INTERN, "No such a plot!");
		return(NULL);
	}

	int event_mask=ButtonPressMask;;
	XEvent event;

	XplDouble *nx=new XplDouble(1);
	XplDouble *xpld, *xplm, *xplr;
	XplMatrix ma;
  	XplObject *o;
	o  = new XplObject (nx, "uhu");
	
	Window win;
	Widget wid;
	Wid_Data *wid_data;
	MyPoint xy;

	Boolean found=False;
	while (XCheckMaskEvent(XtDisplay(bs_glob_variable.main_shell), 
		 event_mask, &event) && (!found))
	{	cout<<XQLength(XtDisplay(bs_glob_variable.main_shell))<<
		" events "<<endl;
		win=event.xbutton.window;
		wid=XtWindowToWidget(XtDisplay(bs_glob_variable.main_shell),
					win);
	cout<<endl<<endl<<"button pressed by "<<XtName(wid)<<endl;
		if (!strcmp(XtName(wid), "plotdef"))
		{	cout<<"hier bin ich..."<<endl;
			XtVaGetValues(wid, XmNuserData, &wid_data, NULL);
			if ((Plot *)(wid_data->subdis)==p)
			{	found=True;
				xpld=new XplDouble(1);
				(*xpld)(0)=event.xbutton.button;
				o->AppendComponent( new Component( 
					new XplObject (xpld,"button")));
				xplm=new XplDouble(2);
				(*xplm)(0)=event.xbutton.x;
				(*xplm)(1)=event.xbutton.y;
				o->AppendComponent( new Component( 
					new XplObject (xplm,"xy")));
				xy.x=event.xbutton.x;
				xy.y=event.xbutton.y;
				ma=p->GetOrigin(xy);
				xplr=new XplDouble(2);
				(*xplr)(0)=ma(0, 0);
				(*xplr)(1)=ma(0, 1);
				o->AppendComponent( new Component( 
					new XplObject (xplr,"xyreal")));
				break;
			}
		}
	}
	
	if (found)
		(*nx)(0)=1;
	else
		(*nx)(0)=0;
  	
	return(o);
}

XplObject* ReadCon(Liste<XplObject*> *argl)
{	if (argl->laenge()!=0)
	{	globalError.Set (ERR_INTERN, "no args are wanted");
		return(NULL);
	}
	int i=0;
	XEvent event;
	XplDouble *nx=new XplDouble(1);

	if (! XCheckMaskEvent(XtDisplay(bs_glob_variable.main_shell), 
		 KeyPressMask, &event))
	{	cout<<i<<"Read Con: Nichts gefunden!"<<endl;
 		(*nx)(0)=-1;
 		XplObject *o  = new XplObject (nx, "uhu");
 		return(o);
 	}	
	
	cout<<i<<"Read Con: Gefunden!"<<endl;
	int charcount;
	char buf[1];
	KeySym keysym;
	XComposeStatus compose;
	
	charcount=XLookupString(&(event.xkey), buf, 1, &keysym, &compose);
	
 	(*nx)(0)=(int)(buf[0]);
 	
 	cout<<"CHAR="<<buf<<", INT="<<(int)(buf[0])<<endl;
 	
 	XplObject *o  = new XplObject (nx, "uhu");
	
	if (nx==0)
		globalError.Set (ERR_INTERN, "nx==0");
	
	return(o);
}


void selit_dismiss(Widget ok_b, XtPointer p1, XtPointer p2)
{	if (ready)
		return; //after OK....
	struct 	MENUE_S *ds=(struct MENUE_S*) p1;
	XplObject *o=ds->wohin;
	int i;
	for (i=0; i<(* (ds->selstr))(0, 0); i++)
		(*(o->DefaultXplDouble()))(i)=0;
	
	ready=True;
	//XtPopdown(ds->dialog);
	XtDestroyWidget(ds->bulboard);
	XFlush(XtDisplay(bs_glob_variable.main_shell));
	delete (ds->text_w);
	delete (ds->selstr);
	//delete ds;

	globalError.Set (ERR_INTERN, "Dismiss used  by selectitem");
//	globalError.ShowError();

}

void selectval_ok(Widget ok_b, XtPointer p1, XtPointer p2)
{	struct 	MENUE_S *ds=(struct MENUE_S*) p1;
	int i, k, kk;
	XplObject *o=ds->wohin;
	
	Boolean on;
	
	kk=0;
	for (i=0; i<(* (ds->selstr))(0, 0); i++)
	{	XtVaGetValues(ds->text_w[i], XmNset, &on, NULL);
		(*(o->DefaultXplDouble()))(i)=on ? 1 : 0;
		kk++;
	}	
	XplDouble * comp;
	char sss[16];
	for (k=1; k<ds->selstr->rows(); k++)
	{	comp=new XplDouble( (int)(* (ds->selstr))(k, 0) );
		for (i=0; i<(* (ds->selstr))(k, 0); i++)
		{	XtVaGetValues(ds->text_w[kk], XmNset, &on, NULL);
			(*comp)(i)=on ? 1 : 0;
			kk++;
		}	
		sprintf(sss, "s%d", k);
 		o->AppendComponent (new Component (new XplObject ( comp, sss)));
 	}
		
	ready=True;
	XtPopdown(ds->dialog);
	XtDestroyWidget(ds->bulboard);
	XFlush(XtDisplay(bs_glob_variable.main_shell));
	delete (ds->text_w);
	delete (ds->selstr);
	//delete ds;
}

XplObject* SelectItem(Liste<XplObject*> *argl)
{	static Widget d_dialog=NULL;

	int i, k, dim;
	char *str, *valstr;;
	double f;
	XplChar * xplv;
	XplDouble * xd;
	XplChar * xplc;
	Boolean single=False;
	
	int count=(argl->laenge())/2;
	int all_count=0;
	
	// "single" als letzte parameter?
	if (argl->laenge()>2*count)
	{	if (! ((*argl)[2*count]->Type()==O_XPLCHAR))
		{	globalError.Set (ERR_INTERN, "Error by selectval: last parameter must be a XplChar!");
			return(NULL);
		}
		xplc=(*argl)[2*count]->DefaultComponent()->Content().xplchar;
		str=(*xplc)(0).tostr();
		if (!strcmp(str, "single"))
		{	//cout<<"!strcmp(xplc, single)"<<endl;
			single=True;
		}
	}
	XFlush(XtDisplay(bs_glob_variable.main_shell));
	//XSynchronize(XtDisplay(bs_glob_variable.main_shell), True);
	if (argl->laenge()<2)
	{	globalError.Set (ERR_INTERN, "Error by selectval: min. two args are wanted");
		return(NULL);
	}
		
	for (k=0; k<count; k++)
	{	if (! ((*argl)[2*k]->Type()==O_XPLCHAR))
		{	globalError.Set (ERR_INTERN, "Error by selectval: first parameter must be a XplChar!");
			return(NULL);
		}

		if (! ((*argl)[2*k+1]->Type()==O_XPLDOUBLE ||
	 	(*argl)[2*k+1]->Type()==O_XPLCHAR) )
		{	globalError.Set (ERR_INTERN, "Error by selectval: second parameter must be a XplDouble or XplChar!");
			return(NULL);
		}

	
		xplc=(*argl)[2*k]->DefaultComponent()->Content().xplchar;	
		str=(*xplc)(0).tostr();	//OK!
#ifdef _BLABLA_
		cout<<"str="<<str<<endl;
#endif	
		delete str;
		
		if ((*argl)[1+2*k]->Type()==O_XPLDOUBLE)
		{	xd=(*argl)[1+2*k]->DefaultXplDouble();
			dim=xd->dimension(0);
			for (i=0; i<dim; i++)
			{	f=(*xd)(i);
#ifdef _BLABLA_
			cout<<"xd="<<f<<endl;	
#endif	
			}
		}
		else
		{	xplv=(*argl)[1+2*k]->DefaultComponent()->
					Content().xplchar;	
			dim=xplv->dimension(0);
			for (i=0; i<dim; i++)
			{	valstr=(*xplv)(i).tostr();	//OK!
#ifdef _BLABLA_
			cout<<"valstr="<<valstr<<endl;
#endif	
				delete valstr;
			}
		}
		all_count+=dim;
	}
	
	static struct MENUE_S *ds;
		
	Widget rc, b_b, rcccc;
	Widget lab, togb;
	XmString xms;
	char *st, fstr[256];
		
	if (d_dialog==NULL)
	{	d_dialog=XtVaCreatePopupShell("SelectItem",
			xmDialogShellWidgetClass, 
			bs_glob_variable.main_shell, (Arg *)NULL, 0);
		ds=(struct MENUE_S *)(new (struct MENUE_S));
		XtAddCallback(d_dialog, XmNpopdownCallback, selit_dismiss, 
			(XtPointer) ds);
	}
	b_b=XmCreateBulletinBoard(d_dialog, "b_b", (Arg *)NULL, 0);
	//	XtVaSetValues(b_b, 
	//		XmNdialogStyle, XmDIALOG_SYSTEM_MODAL, NULL);
	XtVaSetValues(b_b, 
		XmNdialogStyle, XmDIALOG_MODELESS, NULL);
		
	rcccc=XmCreateRowColumn(b_b, "rccc", (Arg *)NULL, 0);
	XtVaSetValues(rcccc, XmNorientation, XmVERTICAL, NULL);
	
  	ds->text_w=new Widget [all_count];
  	ds->dialog=d_dialog;
  	ds->bulboard=b_b;
  	ds->count=all_count;
  	ds->selstr=new XplMatrix(count, 1);
  	int z=0;

	for (k=0; k<count; k++)
	{	rc=XmCreateRowColumn(rcccc, "rc", (Arg *)NULL, 0);
		lab=XmCreateLabel(rc, "read_val_lab", (Arg *)NULL, 0);
		xplc=(*argl)[2*k]->DefaultComponent()->Content().xplchar;
		st=(*xplc)(0).tostr();	//OK!
		xms=XmStringCreateSimple(st);	
		delete st;
		XtVaSetValues(lab, XmNlabelString, xms, NULL);
		XmStringFree(xms);	//OK
		XtManageChild(lab);
	
		if ((*argl)[1+2*k]->Type()==O_XPLDOUBLE)
		{	xd=(*argl)[1+2*k]->DefaultXplDouble();
			dim=xd->dimension(0);
			for (i=0; i<dim; i++)
			{	sprintf(fstr, "%lf", (*xd)(i));
				togb=XmCreateToggleButton(rc, fstr, 
					(Arg *)NULL, 0);
				XtManageChild(togb);
				if (single)
				XtAddCallback(togb,  XmNvalueChangedCallback,
					selectval_ok, (XtPointer) ds);
				ds->text_w[z]=togb;
				z++;
			}
		}
		else
		{	xplv=(*argl)[1+2*k]->DefaultComponent()->
					Content().xplchar;	
			dim=xplv->dimension(0);
			for (i=0; i<dim; i++)
			{	st=(*xplv)(i).tostr();	//OK!
				sprintf(fstr, "%s", st);
				delete st;
				togb=XmCreateToggleButton(rc, fstr, 
					(Arg *)NULL, 0);
				if (single)
				XtAddCallback(togb,  XmNvalueChangedCallback,
					selectval_ok, (XtPointer) ds);
				XtManageChild(togb);
				ds->text_w[z]=togb;
				z++;
			}
		}
		XtManageChild(rc);
		(*(ds->selstr))(k, 0)=dim;
	}
	
	Widget ok=XmCreatePushButton(rcccc, "OK", (Arg *)NULL, 0);
	XtManageChild(ok);
	XtAddCallback(ok,  XmNactivateCallback, selectval_ok, 
			(XtPointer) ds);		
 
	XplDouble *nx=new XplDouble((int)(*(ds->selstr))(0, 0));
 	nx->fill(0.0);
 	XplObject *o  = new XplObject (nx, "uhu");

   	ds->wohin=o;

#ifdef _BLABLA_
	ds->selstr->out();
#endif
	XtManageChild(rcccc);
	XtManageChild(b_b);
	XtRealizeWidget(d_dialog);
	XtPopup(d_dialog, XtGrabNone);
	
	XFlush(XtDisplay(bs_glob_variable.main_shell));
	Dimension wi, he;
	XtVaGetValues(d_dialog, XmNwidth, &wi, XmNheight, &he, NULL);
#ifdef _BLABLA_
	cout<<" Dialog width="<<wi<<", he="<<he<<endl;
#endif
	if (wi<100 && he<100)
		XtVaSetValues(d_dialog, XmNwidth, 200, XmNheight, 100, NULL);
	ready=False;
	while (!ready)
		XtAppProcessEvent(XtWidgetToApplicationContext(d_dialog), 
			XtIMAll);
	
	
	
	return(o);
}

void readval_reset(Widget w, XtPointer p1, XtPointer p2)
{	struct 	MENUE_S *ds=(struct MENUE_S*) p1;
	Widget te;
	XplObject *o=ds->wohin;
	char st[16];
	double d;
	int i;

	for (i=0; i<ds->count; i++)
	{	te=ds->text_w[i];
		d=(* (o->DefaultXplDouble()) )(i);
		sprintf(st, "%lf", d);
		XmTextFieldSetString(te, st);
	}
}

void reval_dismiss(Widget ok_b, XtPointer p1, XtPointer p2)
{	if (ready)
		return; //after OK....
	struct 	MENUE_S *ds=(struct MENUE_S*) p1;
	XplObject *o=ds->wohin;
	int i;
	for (i=0; i<ds->count; i++)
		(*(o->DefaultXplDouble()))(i)=0;
	
	ready=True;
	//XtPopdown(ds->dialog);
	XtDestroyWidget(ds->bulboard);
	XFlush(XtDisplay(bs_glob_variable.main_shell));
	delete (ds->text_w);
	//delete ds;

	globalError.Set (ERR_INTERN, "Dismiss used  by readvalue");
	//	globalError.ShowError();

}

void readval_ok(Widget w, XtPointer p1, XtPointer p2)
{	struct 	MENUE_S *ds=(struct MENUE_S*) p1;
	Widget te;
	XplObject *o=ds->wohin;
	char *st;
	double d;
	char word[128];
	int i;

	for (i=0; i<ds->count; i++)
	{	te=ds->text_w[i];
		st=XmTextFieldGetString(te);
		if (o->Type()==O_XPLDOUBLE)
		{	if (! (sscanf(st, "%lf", &d)==1))
			{	globalError.Set (ERR_INTERN, 
				"it is not a double!");
				return;
			}
			(*(o->DefaultXplDouble()))(i)=(double)d;
		}
		if (o->Type()==O_XPLCHAR)
			(*(o->DefaultComponent()->Content().xplchar))(i)=
				xplstring(st);
		
		XtFree(st);
	}
	ready=True;
	XtPopdown(ds->dialog);
	XtDestroyWidget(ds->bulboard);
	XFlush(XtDisplay(bs_glob_variable.main_shell));
	delete (ds->text_w);
	//	delete ds;
}

XplObject* ReadValue(Liste<XplObject*> *argl)
{	static Widget d_dialog=NULL;

	int i;
	char *str;
	double f;
	XplChar *chvals=NULL;
	XplDouble *dvals=NULL;
	
	if (argl->laenge()!=2)
	{	globalError.Set (ERR_INTERN, "Error by readval: two args are wanted");
		return(NULL);
	}
		
	
	if (! ((*argl)[0]->Type()==O_XPLCHAR))
	{	globalError.Set (ERR_INTERN, "Error by readval: first parameter must be a XplChar!");
		return(NULL);
	}

	if (! 	((*argl)[1]->Type()==O_XPLDOUBLE ||
		 (*argl)[1]->Type()==O_XPLCHAR))
	{	globalError.Set (ERR_INTERN, "Error by readval: second parameter must be a XplDouble or a String");
		return(NULL);
	}

	XplChar * xplc=(*argl)[0]->DefaultComponent()->Content().xplchar;
	for (i=0; i<xplc->dimension(0); i++)
	{	str=(*xplc)(i).tostr();	//OK!
#ifdef _BLABLA_
		cout<<"str="<<str<<endl;
#endif	
		delete str;
	}

	if ((*argl)[1]->Type()==O_XPLDOUBLE)
	{	dvals=(*argl)[1]->DefaultXplDouble();
		if ((*argl)[0]->DefaultComponent()
			->Content().xplchar->dimension(0)!=
			dvals->dimension(0))
		{	globalError.Set (ERR_INTERN, 
		"Error by readval: args have different dimensions!");
			return(NULL);
		}
	}

	// ODER ...
	
	if ((*argl)[1]->Type()==O_XPLCHAR)
	{	chvals=(*argl)[1]->DefaultComponent()->Content().xplchar;	
		if ((*argl)[0]->DefaultComponent()->
			Content().xplchar->dimension(0)!=
			chvals->dimension(0))
		{	globalError.Set (ERR_INTERN, 
		"Error by readval: args have different dimensions!");
			return(NULL);
		}
	}

	static struct MENUE_S *ds;

	Widget ok, reset, rc, rc1, rc2, b_b;
	Widget lab, text;
	XmString xms;
	char *st, fstr[256];
		
	if (d_dialog==NULL)
	{	//	cout<<"erste readvalue..."<<endl;
		d_dialog=XtVaCreatePopupShell("ReadValue",
			xmDialogShellWidgetClass, 
			bs_glob_variable.main_shell, (Arg *)NULL, 0);
		ds=(struct MENUE_S *)(new (struct MENUE_S));
		XtAddCallback(d_dialog, XmNpopdownCallback, reval_dismiss, 
			(XtPointer) ds);
	}
	b_b=XmCreateBulletinBoard(d_dialog, "b_b", (Arg *)NULL, 0);
	rc=XmCreateRowColumn(b_b, "rc", (Arg *)NULL, 0);
	rc1=XmCreateRowColumn(rc, "rc", (Arg *)NULL, 0);
	rc2=XmCreateRowColumn(rc, "rc", (Arg *)NULL, 0);
	XtVaSetValues(rc2, XmNorientation, XmHORIZONTAL, NULL);
	//XtVaSetValues(b_b, 
	//	XmNdialogStyle, XmDIALOG_SYSTEM_MODAL, NULL);
	XtVaSetValues(b_b, 
		XmNdialogStyle, XmDIALOG_MODELESS, NULL);
	
  	ds->text_w=new Widget [xplc->dimension(0)];
  	ds->dialog=d_dialog;
  	ds->bulboard=b_b;
  	ds->count=xplc->dimension(0);
  	char *ts;

	for (i=0; i<xplc->dimension(0); i++)
	{	lab=XmCreateLabel(rc1, "read_val_lab", (Arg *)NULL, 0);
		text=XmCreateTextField(rc1, "read_val_text", (Arg *)NULL, 0);
		st=(*xplc)(i).tostr();	//OK!
		xms=XmStringCreateSimple(st);
		delete st;
		XtVaSetValues(lab, XmNlabelString, xms, NULL);
		XmStringFree(xms);	//OK
		if (dvals!=NULL)
			sprintf(fstr, "%lf", (*dvals)(i));
		if (chvals!=NULL)
		{	ts=(*chvals)(i).tostr();
			sprintf(fstr, "%s", ts);
			delete ts;
		}
		XmTextFieldSetString(text, fstr);

		XtManageChild(lab);
		XtManageChild(text);
		ds->text_w[i]=text;
	}
	
	XtAddCallback(text,  XmNactivateCallback, readval_ok, 
			(XtPointer) ds);					
	
	ok=XmCreatePushButton(rc2, "OK", (Arg *)NULL, 0);
	reset=XmCreatePushButton(rc2, "Reset", (Arg *)NULL, 0);
	
	XtAddCallback(ok,  XmNactivateCallback, readval_ok, 
			(XtPointer) ds);	
 	XtAddCallback(reset,  XmNactivateCallback, readval_reset, 
			(XtPointer) ds);	
 	
  	XplObject *o;
  	if (dvals!=NULL)
  		o  = new XplObject (new XplDouble(*dvals), "readvalue");
  	if (chvals!=NULL)
  		o  = new XplObject (new XplChar(*chvals), "readvalue");

   	ds->wohin=o;

#ifdef _BLABLA_
	o->Print();
#endif
	XtManageChild(ok);
	XtManageChild(rc1);
	XtManageChild(rc2);
	XtManageChild(rc);
	XtManageChild(b_b);
	//	XtManageChild(reset);
	XtRealizeWidget(d_dialog);
	XtPopup(d_dialog, XtGrabNone);
	
	ready=False;
	while (!ready)
		XtAppProcessEvent(XtWidgetToApplicationContext(d_dialog), 
			XtIMAll);
	
	
	
	return(o);
}

XplObject* AddButton(Liste<XplObject*> *argl)
{	Plot *p= PlotRequested(argl);
	if (p==NULL)
	{	globalError.Set (ERR_INTERN, "no such plot!");
		return(NULL);
	}
	
	if (! ((*argl)[3]->Type()==O_XPLCHAR))
	{	globalError.Set (ERR_INTERN, "Error by readval: fourth parameter must be a XplChar!");
		return(NULL);
	}

	if (! ((*argl)[4]->Type()==O_XPLCHAR))
	{	globalError.Set (ERR_INTERN, "Error by readval: fifth parameter must be a XplChar!");
		return(NULL);
	}
	char*b_n=(*(*argl)[3]->DefaultComponent()->
			Content().xplchar)(0).tostr();	//OK!
	char *b_f=(*(*argl)[4]->DefaultComponent()
			->Content().xplchar)(0).tostr();	//OK!
	p->AddButton(b_n, b_f);	
	delete b_n;
	delete b_f;	
	p->Refresh();
	return(NULL);
}	

XplObject* DeleteButton(Liste<XplObject*> *argl)
{	Plot *p= PlotRequested(argl);
	if (p==NULL)
	{	globalError.Set (ERR_INTERN, "no such plot!");
		return(NULL);
	}
	
	if (! ((*argl)[3]->Type()==O_XPLCHAR))
	{	globalError.Set (ERR_INTERN, "Error by deletebutton: fourth parameter must be a XplChar!");
		return(NULL);
	}

	char*b_n=(*(*argl)[3]->DefaultComponent()->
			Content().xplchar)(0).tostr();	//OK!
	p->DeleteButton(b_n);	
	delete b_n;
	p->Refresh();
	return(NULL);
}	

#endif	//end of GRAPHICS
