/* $Header: /home/xplore/cvs/xpl4gr/swefun9.C,v 1.3 2002/08/16 12:31:51 sigbert Exp $ */

#include <math.h>
#include <string.h>

#ifdef _UNIX_
#include "udisp.h"
#else
#ifdef __BORLANDC__
#include "xplore.h"
#include "wdisp.h"
#else
#include "display.h"
#endif
#endif

#include "object.h"
#include "function.h"
#include "xplfun.h"
#include "xplerror.h"
#include "init.h"
#include "ttkio.h"
#include "xplexec.h"

#include "text.h"
#include "plot.h"
#include "color.h"

XplObject* DisplayType(Liste<XplObject*> *argl)
{
 	if (argl->laenge () >1)
    	{
    	globalError.Set (ERR_ARGS, "DisplayType: Must be max. 1");
    	return (NULL);
    	}
    	if ((*argl)[0]->Type () != O_DISPLAY)
    	{
    	globalError.Set (ERR_ARGS, "DisplayType: Must be display");
    	return (NULL);
    	}
    	
	XplDisplay *disp = (*argl)[0]->DefaultComponent()->Content().display;
	int x=disp->GetRows();
	int y=disp->GetColumns();
	int i, j;
	SubDisplay *sd;
	SubType st;
	XplDouble xd(x, y);
	for (i=0; i<x; i++)
	for (j=0; j<y; j++)
	{	sd=disp->GetElement(i+1, j+1);
		st=sd->WhatIs();
		switch(st)
		{	case TEXT: case UTEXT: case JTEXT: case WTEXT:
				xd(i, j)=-1;
				break;
			case PLOT: case UPLOT: case WPLOT: case JPLOT:
					xd(i, j)=((Plot *)sd)->GetDataCount();
				break;
			default:
				xd(i, j)=-1;
				break;
		}
	}
return(new XplObject(new XplDouble(xd), "displaytype"));
}




#ifdef _UNIX_
extern  "C" void show_data_box(Widget def, XtPointer p1, XtPointer p2); 
char * data_name=NULL;
Boolean data_read_ready=True;
XplDouble *read_res;
extern Widget data_fsb;

XplObject* readFromFileSelectionBox (void)
{	XtPointer p1=NULL, p2=NULL;
  	Widget def=NULL;
  	if (data_name!=NULL)
  		delete data_name;
  	data_name=NULL;
  	read_res = new XplDouble(1);
  	show_data_box(def, p1, p2);
  	data_read_ready=False;
  	while (!data_read_ready)
		XtAppProcessEvent(XtWidgetToApplicationContext(data_fsb), 
			XtIMAll);	
  	if (read_res==NULL) //soll bei dem nicht gelungenen lesen passieren!
  	{	globalError.Set  (ERR_FILE, "readVar: ");
      		//	globalError.AppendText  (ERR_FILE, var_n);
      		return(NULL);
	}
  	return (new XplObject (read_res, "readVar"));
}
#endif


/*
XplObject* readVar (Liste<XplObject*> *argl)
{
  XplDouble  *res;
  const char *n;

  if (argl->laenge () != 1 && argl->laenge () != 0)
    {
    globalError.Set (ERR_ARGS, "readVar: Must be 1");
    return (NULL);
    }

  if (argl->laenge () == 1)
  {
  if ((*argl)[0]->DefaultComponent()->Type() == C_TEXT)
    {
#ifdef _XPLCDEF_
    n = (*(*argl)[0]->DefaultComponent()->Content().xplchar)(0).tocstr();
#else
    n = (*argl)[0]->DefaultComponent()->Content().text;
#endif

    res = new XplDouble(1);

#ifdef MATRIX
    if (ReadMatrix (n, *res) == 0)
      {
#else
    if (res->ReadASCIIXplArray (n) == 0)
      {
#endif
      globalError.Set  (ERR_FILE, "readVar: ");
      globalError.AppendText  (ERR_FILE, n);
      delete res;
      return (NULL);
      }
    }

  return (new XplObject (res, "readVar"));
  }
  // SWS : read without args
#ifdef _UNIX_
  XplObject *o;
  o = readFromFileSelectionBox ();
#endif
return(o); 
  
}
*/

