/* $Header: /home/xplore/cvs/xpl4gr/udisp.C,v 1.3 2002/08/16 12:31:52 sigbert Exp $ */

#ifdef _UNIX_

#include "main.h"
#include "udisp.h"
#include "uplot.h"
#include "utext.h"
#include "subdis.h"

#ifdef _GUIDO_
extern	int starttime;
extern	char *gformat;
extern char *gfname;
#endif

#define MENUE_HEIGHT 50

/*	Globale Variablen						*/

extern Colormap cmap;

extern "C"	
{	extern BS_Glob_Variable bs_glob_variable;
	void reshandler(Widget w, XtPointer p, XEvent *cbs, char *ch);
	void display_destroy(Widget w, XtPointer p, XtPointer p2);
}	//end of extern "C"


UDisplay::UDisplay(const UDisplay *old ):XplDisplay( old)
{
	type=UDISPLAY;
	// 	bis jetzt wurde dazugehoeriger XplDisplay mit PLOT oder TEXT
	//	gefuellt
		
#ifdef _BLABLA_
cout<<"UDisplay::UDisplay(UDisplay *old)"<<endl;
#endif
	Widget dis_shell, kiste_all;
	int w_x, w_y ;
	int i, j, all, k;
	
	dis_shell=XtCreatePopupShell(name, vendorShellWidgetClass,
			bs_glob_variable.main_shell, (Arg *)NULL, 0);
	XtVaSetValues(dis_shell, XmNx, x,
				XmNy, y,
				NULL);
	kiste_all=XtVaCreateWidget("kiste_all", xmFormWidgetClass,
			dis_shell, NULL);

	menu=XtVaCreateWidget("menu", xmFormWidgetClass, kiste_all, 
			XmNtopAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNheight, MENUE_HEIGHT,
			NULL);
	kiste=	XtVaCreateWidget("kiste", xmFormWidgetClass,
			kiste_all, XmNfractionBase, 100, 
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, menu,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNbottomAttachment, XmATTACH_FORM,
				XmNwidth, width, 
				XmNheight, height,		
			NULL);
	XtAddEventHandler(kiste, 
 		StructureNotifyMask ,
 				False, reshandler, (XtPointer) this);

//ein Platzhalter! Soll am meistens in hintergrund bleiben!
Widget	menu_temp, draw_temp;
	menu_temp=XtVaCreateManagedWidget("Menu_Temp", xmPushButtonWidgetClass,
	 		menu, 
			XmNbottomAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			//XmNwidth, width,
			//XmNheight, MENUE_HEIGHT,
			NULL);
	draw_temp=XtVaCreateManagedWidget("draw_temp", xmPushButtonWidgetClass,
			kiste, 
			XmNbottomAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			NULL);
//ende der Platzhalter!
	XtManageChild(menu);
	XtManageChild(kiste_all);
	XtManageChild(kiste);
	XtRealizeWidget(dis_shell);
	XtPopup(dis_shell, XtGrabNone);
	XSetWindowColormap(XtDisplay(dis_shell), 	//OK!
			XtWindow(dis_shell), cmap);	
	XtAddCallback(dis_shell, XmNdestroyCallback, display_destroy, 
			(XtPointer) this);
	Dimension ww, hh;
	XtVaGetValues(kiste, XmNwidth, &ww, XmNheight, &hh, NULL);	
#ifdef _BLABLA_
	cout<<"w="<<ww<<", h="<<hh<<endl;
#endif
	width=ww;
	height=hh;
	
	k=0;

	UPlot *up;
	Plot *plot;
	
	for (j=0; j<vertical.cols(); j++)
	for (i=0; i<horizontal.cols(); i++)
	{	plot=(Plot *)(content[k]);
		up=new UPlot(this, j+1, i+1, plot);
		delete content[k];	//old plot delete
		content[k]=up;
		k++;
	}
//	jetzt wird es ernst...
	
}

UDisplay::UDisplay(XplDouble hori, XplDouble veri):XplDisplay(hori, veri)
{	
	type=UDISPLAY;
		
#ifdef _BLABLA_
cout<<"UDisplay::UDisplay(XplDouble hori, XplDouble veri, SubType * was_drin)"<<endl;
#endif

	Widget dis_shell, kiste_all;
	int w_x, w_y ;
	int i, j, all, k;
	
	dis_shell=XtCreatePopupShell(name, vendorShellWidgetClass,
			bs_glob_variable.main_shell, (Arg *)NULL, 0);
	XtVaSetValues(dis_shell, XmNx, x,
				XmNy, y,
				NULL);
	kiste_all=XtVaCreateWidget("kiste_all", xmFormWidgetClass,
			dis_shell, NULL);

	menu=XtVaCreateWidget("menu", xmFormWidgetClass, kiste_all, 
			XmNtopAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNheight, MENUE_HEIGHT,
			XmNresizable, False,
			NULL);
	kiste=	XtVaCreateWidget("kiste", xmFormWidgetClass,
			kiste_all, XmNfractionBase, 100, 
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, menu,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNbottomAttachment, XmATTACH_FORM,
				XmNwidth, width, 
				XmNheight, height,		
			NULL);
	XtAddEventHandler(kiste, 
 		StructureNotifyMask ,
 				False, reshandler, (XtPointer) this);

//ein Platzhalter! Soll am meistens in hintergrund bleiben!
Widget	menu_temp, draw_temp;
	menu_temp=XtVaCreateManagedWidget("Menu_Temp", xmPushButtonWidgetClass,
	 		menu, 
			XmNbottomAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			//XmNwidth, width,
			//XmNheight, MENUE_HEIGHT,
			NULL);
	draw_temp=XtVaCreateManagedWidget("draw_temp", xmPushButtonWidgetClass,
			kiste, 
			XmNbottomAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			NULL);
//ende der Platzhalter!
	XtManageChild(menu);
	XtManageChild(kiste_all);
	XtManageChild(kiste);
	XtRealizeWidget(dis_shell);
	XtPopup(dis_shell, XtGrabNone);
	XSetWindowColormap(XtDisplay(dis_shell), 	//OK!
			XtWindow(dis_shell), cmap);	
	XtAddCallback(dis_shell, XmNdestroyCallback, display_destroy, 
			(XtPointer) this);
	Dimension ww, hh;
	XtVaGetValues(kiste, XmNwidth, &ww, XmNheight, &hh, NULL);	
#ifdef _BLABLA_
	cout<<"w="<<ww<<", h="<<hh<<endl;
#endif
	width=ww;
	height=hh;
	
	all=veri.dimension(1)*hori.dimension(1);
	for (i=0; i<all; i++)
		delete (Plot *)(content[i]);
	k=0;

	UPlot *up;
	
	XtVaGetValues(kiste, XmNwidth, &ww, XmNheight, &hh, NULL);	
#ifdef _BLABLA_
	cout<<"w="<<ww<<", h="<<hh<<endl;
#endif
	for (j=0; j<veri.dimension(1); j++)
	for (i=0; i<hori.dimension(1); i++)
	{	up=new UPlot(this, j+1, i+1);
		content[k]=up;
		k++;
	XtVaGetValues(kiste, XmNwidth, &ww, XmNheight, &hh, NULL);	
#ifdef _BLABLA_
	cout<<"w="<<ww<<", h="<<hh<<endl;
#endif
	}
		
	XtVaGetValues(kiste, XmNwidth, &ww, XmNheight, &hh, NULL);	
#ifdef _BLABLA_
	cout<<"w="<<ww<<", h="<<hh<<endl;
#endif

#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	char line[64];
	sprintf(line, "%s\t%d\t%d", "CREATED", veri.dimension(1), hori.dimension(1));
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
		

}

UDisplay::~UDisplay()	
{
#ifdef _BLABLA_ 
	cout<<"UDisplay::~UDisplay()"<<endl;
#endif

	XtPopdown(XtParent(XtParent(kiste)));
	int all, i, j, k;
	all=vertical.cols()*horizontal.cols();
	SubType st;
	for (i=0; i<all; i++)
	{	st=content[i]->WhatIs();
/*		switch(st)
		{	case UPLOT:	delete (UPlot *)(content[i]);
				break;
			case PLOT:   delete (Plot *)(content[i]);
				break;
			default:
				delete (content[i]);
				break;
		}		
*/	
#ifdef _BLABLA_
	cout<<"i="<<i<<endl;
#endif
		delete content[i];
#ifdef _BLABLA_
	cout<<"ok deleted "<<i<<endl;
#endif
	}
	
	XtRemoveCallback(XtParent(XtParent(kiste)), XmNdestroyCallback, 
		display_destroy, XtPointer(this));
	XtRemoveEventHandler(kiste, StructureNotifyMask, False, reshandler,
	 XtPointer(this));
	XtDestroyWidget(XtParent(XtParent(kiste)));

	k=0;

	Plot *up;
	
	for (j=0; j<vertical.cols(); j++)
	for (i=0; i<horizontal.cols(); i++)
	{	up=new Plot(this, j+1, i+1);
		content[k]=up;
		k++;
	}
	// jetzt darf der XplDisplay::~XplDisplay kommen!!!
	
}


void UDisplay::SetElement(const Liste <XplObject *> * data_list,
		int di_x, int di_y)
{	int rows, cols;
	rows=vertical.cols();
	cols=horizontal.cols();
	if (di_x<1 || di_y<1 || di_x>rows || di_y>cols )
	{	
		
		globalError.Set (ERR_INTERN, "ERROR by SetElement");
		globalError.ShowError();
		return;
	}
	int num, i, text_lines;
	
#ifdef _BLABLA_
	cout<<"By SetElement: Kinder: "<<endl;
	Widget * kinder;
	int kn;
	Dimension wi, he;
	
	XtVaGetValues(kiste, XmNchildren, &kinder, XmNnumChildren, &kn, 
		XmNwidth, &wi, XmNheight, &he, NULL);
	for (i=0; i<kn; i++)
		cout<<XtName(kinder[i])<<endl;
	cout<<"wi="<<wi<<", he="<<he<<endl;
#endif
	
	
/*	switch(sd->WhatIs())
	{	case UPLOT:	delete (UPlot *)(sd);
				break;
#ifndef __BORLANDC__ //LOOK!
		case UTEXT:	delete (VisText *)(sd);
				break;
#endif
		default:	delete sd;
				break;
	}
*/	
	delete content[cols*(di_x-1)+di_y-1];

	content[cols*(di_x-1)+di_y-1]=NULL;
	SubDisplay *p;

	p=NULL;
	
	if ( (*(*data_list)[0])[0]->Type ()== O_XPLDOUBLE ||
		(*data_list)[0]->GetComponent("data")!=NULL)
	{	p=new UPlot(data_list, this, di_x, di_y);
		((UPlot *)p)->Refresh();
	}
	
	if ( p==NULL && (*data_list)[0]->Type () == O_XPLCHAR)
	{	char *line, string[32555];
		string[0]=0;
		text_lines=(*data_list)[0]->DefaultComponent()
			->Content().xplchar->dimension(0) ;
		for (i=0; i<text_lines; i++)
		{	char *line=(*((*data_list)[0]->DefaultComponent()
			->Content().xplchar) )(i).tostr();	//OK!
			strcat(string, line);	
			delete line;
			strcat(string, "\n");
		}
#ifdef _BLABLA_
		cout<<string<<endl;
#endif
		p=new UText(string, this, di_x, di_y);
	}

	if (p==NULL)
	{	globalError.Set (ERR_INTERN, "Something is wrong by SetElement for UDisplay!");
		globalError.ShowError();
		p=new UPlot(this, di_x, di_y);
	}


#ifdef _BLABLA_
	cout<<"Nach SetElement: Kinder: "<<endl;
	
	XtVaGetValues(kiste, XmNchildren, &kinder, XmNnumChildren, &kn, 
		XmNwidth, &wi, XmNheight, &he, NULL);
	for (i=0; i<kn; i++)
	{	cout<<XtName(kinder[i])<<endl;
		XtVaGetValues(kinder[i], XmNwidth, &wi, XmNheight, &he, NULL);
		cout<<i<<". Plot: wi="<<wi<<", he="<<he<<endl;
	}
	XtVaGetValues(kiste, XmNwidth, &wi, XmNheight, &he, NULL);
	cout<<"Display: wi="<<wi<<", he="<<he<<endl;
#endif
	content[cols*(di_x-1)+di_y-1]=p;
		return;
}	

void UDisplay::SetName(const char * newname)
{	XplDisplay::SetName(newname);
	XtVaSetValues(XtParent(XtParent(kiste)), XmNtitle, newname, NULL);
	return;
}

/*
SubDisplay* UDisplay::GetElement(int di_x, int di_y) const
{	int rows, cols;
	rows=vertical.cols();
	cols=horizontal.cols();
	if (di_x<1 || di_y<1 || di_x>rows || di_y>cols )
	{

		globalError.Set (ERR_INTERN, "ERROR by GetElement");
		globalError.ShowError();
		return(NULL);
	}
	return(content[(di_x-1)*horizontal.cols()+di_y-1]);
}
*/



extern "C"
{
void reshandler(Widget w, XtPointer p, XEvent *cbs, char *ch)
{	UDisplay *di=(UDisplay *)p;
	Dimension wi, he;
	XtVaGetValues(w, XmNwidth, &wi, XmNheight, &he, NULL);
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	char line[64];
	char *na=di->GetName();
	sprintf(line, "%s\tRESIZE\t%d\t%d", na, wi, he);
	delete na;
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		line, "");
	fclose(gfile);
#endif

#ifdef _BLABLA_
	cout<<"DISPLAY_RESIZE with wi="<<wi<<", he="<<he<<endl;
#endif
	di->Resize(wi, he);
}
void display_destroy(Widget w, XtPointer p, XtPointer p2)
{	//cout<<"display_destroy!\n";
	UDisplay *di=(UDisplay *)p;
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];;
	ndis=di->GetName();
	sprintf(name, "%s", ndis);
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "QUIT");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
	int removed=RemoveDisplay (GetXplObject(di));
#ifdef _BLABLA_
	if (removed==TRUE)
		cout<<"removed=TRUE\n";
	else
		cout<<"removed=FALSE\n";
#endif
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
 
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "QUITED");
	fclose(gfile);
#endif
}
}	//end von "C"


#endif		//end of ifdef _UNIX_
