/* $Header: /home/xplore/cvs/xpl4gr/uplot.h,v 1.4 2003/05/23 16:42:12 cizek Exp $ */

#ifndef _UPLOT_H
#define _UPLOT_H

#ifdef _UNIX_

#include "plot.h"
#include "xplore_strings.h"

#define UFN_SERIF        XMSG_FONTMASK_SERIF
#define UFN_SANSSERIF    XMSG_FONTMASK_SANSSERIF
#define UFN_MONOSPACE    XMSG_FONTMASK_MONOSPACE


class UPlot:		public Plot
		{	Widget widgi;
			Widget menu;
public:	
	UPlot(const Liste <XplObject *> * data_list,
		XplDisplay* dixi=NULL, 
		const int di_x=1, const int di_y=1); 
		
	UPlot(XplDisplay* dixi=NULL, 
		const int di_x=1, const int di_y=1); 
	
	UPlot(XplDisplay* dixi, 
		const int di_x, const int di_y, const Plot *old);
	
	
/*-----------------------------------------------------------------------*/

	~UPlot()	;

/*-----------------------------------------------------------------------*/

	void AddButton(const char *, const char*);

	void DeleteButton(const char *);

/*-----------------------------------------------------------------------*/
/*----------Nicht mehr relevant fuer Parser------------------------------*/
/*-----------------------------------------------------------------------*/
	
	void InFocus();
	
	void Refresh() const;	//eigene fuer PLOT und TEXT

	void Replace(int ttop, int bbottom, int lleft, int rright);
	/* is needed by setfractions and Resize)	*/	
	
	void Resize(int wi, int he);	

	int redraw_points(int data_num, XplMatrix & only_these);
/* 	to use only after color_brush	!!!!!			*/
	
	int repaint_part(int part_x, int part_y, 
		int part_width, int part_height) const;

	Widget GetWidget() const;		

        const char *GetUnixFontName(void);
};
		

typedef struct 	{	SubDisplay *subdis;	
			
			Widget ret_button;	// reset button
			Widget ind_label;	//index
			//Widget dialog;		//dialog
			Widget data_menu;	//z.b. data_part 0 usw
			Widget contr_pan;	//control_panel
			Pixmap pixy;		//pixmap von der selber groesse
			GC bitmap_gc;
		}  	Wid_Data;
#endif

#endif

		
