/* $Header: /home/xplore/cvs/xpl4gr/wdisp.h,v 1.4 2002/10/31 18:25:07 cizek Exp $ */

#ifndef __WDISP__
#define __WDISP__
#include <owl\printer.h>
#include <owl\dc.h>
#include <owl\framewin.h>
#include <owl\mdichild.h>
#include <owl\chooseco.h>
#include <owl\profile.h>
#include "display.h"
#include "wplot.h"
#include "xplore.rh"
#include "xplore.h"

class WPlot;

//class WDisplay : public TWindow, public XplDisplay {
//class WDisplay : public TMDIChild, public XplDisplay {
class WDisplay : public TWindow, public XplDisplay{
 public:
  WDisplay(const WDisplay *);                            								// SVEN
  WDisplay(XplDouble hori, XplDouble veri);
  ~WDisplay();
  int isresized;
  int SelPlot;
  //TMDIChild *mdiChild;
  //TWindowDC *dc;
  WPlot ***plot;
  TChooseColorDialog::TData   ColorData;
  TPrinter * Printer;
  TMDIChild * child;

  TMDIChild * labelchild;

  void CmPaint();
  void CmUp();
  void CmDown();
  void CmLeft();
  void CmRight();
  void CmFilePrint();
 void CopyAsBitmap();	// PC 20020227
 void SaveAsBitmap();
 void SaveAsPostscript();
 void SaveAsGif();
 void CmDispToolTips();
 
  void DoWinResize(int width, int height); // PC 20021031
  void DoWinPosition(int left, int top);
  int GetWinWidth();
  int GetWinHeight();
  int GetWinTop();
  int GetWinLeft();


  void Paint(TDC& dc, bool erase, TRect& rect);
  void PaintDisplay(TWindowDC *dc, bool erase, TSize& size);
  void SetupWindow();
  void RefreshAll(int ax, int ay,int bx,int by,TDC *tdc=NULL);
  void CmChooseColor();
  void EvLButtonDown(UINT, TPoint&);
  void EvRButtonDown(UINT, TPoint&);// PC 20010420
  void EvLButtonUp(UINT, TPoint&);	// PC 20010418
  void EvMouseMove(uint, TPoint&);	// PC 20010418

  int MouseRotate(TPoint &lastpoint, TPoint &actpoint);	// PC 20010418
  int Ueberlappt(int ax,int ay,int bx,int by,int cx,int cy,int dx,int dy);
  static int doAll;  //paint or not the whole display
  virtual void SetElement(const Liste <XplObject *> * data_list,
										int di_x, int di_y);
  virtual void SetName(const char * newname);

  void EvSize(UINT sizeType, TSize& size);
  void EvDestroy();
  bool CanClose();
  DECLARE_RESPONSE_TABLE(WDisplay);

  private:

  int selI, selJ;     // the index of selected plot.
  bool tooltips;	// PC 20010420

};



#endif
