/* $Header: /home/xplore/cvs/xpl4gr/xinteger.C,v 1.3 2002/08/16 12:31:55 sigbert Exp $ */

#include "xinteger.hpp"

template <class T> T and (T l, T r)  
{ return (l && r); }

template int and (int l, int r);  
template long and (long l, long r);  

template <class T> T or  (T l, T r)  
{ return (l || r); }

template int or (int l, int r);  
template long or (long l, long r);  

  template <class T> XplInteger<T>::XplInteger (XplIndex newdim) : XplNumber<T>(newdim) 
  { }

  template <class T> XplInteger<T>::XplInteger (long d0, long d1, long d2, long d3, 
              long d4, long d5, long d6, long d7) : 
     XplNumber<T>(d0, d1, d2, d3, d4, d5, d6, d7) { };

  template <class T> XplInteger<T>::~XplInteger () 
  { }

  template <class T> XplInteger<T>::XplInteger (XplNumber<T> &x)  : XplNumber<T>(x)  
  { }

  template <class T> XplInteger<T>::XplInteger (const XplArray<T> &x)   : XplNumber<T>(x)  
  { }

/*
#ifndef __BORLANDC__
  template <class T> XplInteger<T>::XplInteger (XplInteger<T> *x) : XplNumber<T>(*x) 
  { }
#endif
*/

  template <class T> XplInteger<T>::XplInteger (XplInteger<T> & x)
  { dim = x.dim;
#ifndef MEMDEBUG
    ptr = new T[x.size()]; // malloc(x.size()*sizeof(T));
#else
    ptr = (T *) xmem.newptr (sizeof(T), x.size(), "XplInteger", "XplInteger", "ptr");
#endif
    memcpy (ptr, x.ptr, x.size()*sizeof(T));
  }  


  template <class T> XplInteger<T>& XplInteger<T>::operator= (const XplNumber<T>& x)		
  { assignment (x);
    return (*this);
  }

  template <class T>XplInteger<T>&  XplInteger<T>::operator= (const XplArray<T>& x)		
  { assignment (x);
    return (*this);
  }

  template <class T> XplInteger<T> XplInteger<T>::operator&&(XplInteger<T> &right)
  { return (tfunctt(right, and)); }

  template <class T> XplInteger<T> XplInteger<T>::operator||(XplInteger<T> &right)
  { return (tfunctt(right, or)); }

template class XplInteger<int>;
template class XplInteger<long>;
