/* $Header: /home/xplore/cvs/xpl4gr/xio.h,v 1.3 2002/08/16 12:31:56 sigbert Exp $ */

#ifndef XIO
#define XIO

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "global.h"
#include "xarray.hpp"
#include "xchar.hpp"
#include "xtime.hpp"


#define MAXINPUTLINE  2048

int WriteXHeader (FILE *f); 
int ReadXHeader (FILE *f); 
void *ReadXArray (FILE *f, long *type, int int_fmt = 401);
int ReadXplArray (const char *name, XplChar &rs, 
                  XplArray<double> &rd, XplArray<long> &rl,
                  XplArray<long> &colvec);
    

int ReadASCIIData (const char *name, const char *separator, XplChar *data, 
                   XplArray<long> *type, int check = 1, int multisep = 1,
                   XplArray<long> *selrows = NULL, XplArray<long> *selcols = NULL, 
                   XplArray<long> *rowconds = NULL, XplArray<long> *colconds = NULL);
               
#endif



