/* $Header: /home/xplore/cvs/xpl4gr/xmask.hpp,v 1.3 2002/08/16 12:31:56 sigbert Exp $ */

#ifndef XPLMASKARRAY
#define XPLMASKARRAY

#include "xarray.hpp"

class XplMask : public XplArray<xplmask>
{
  public:

  XplMask (const XplIndex newdim);
  XplMask (long d0, long d1=1 , long d2=1, long d3=1, long d4=1, long d5=1, long d6=1, long d7=1);
  XplMask (const XplArray<xplmask>& x);
  XplMask& operator= (const XplArray<xplmask>& x);
  long xpltypeof (void);
  int WriteXArray (FILE *f);
  void mdump (const char *fmt = NULL, Xplostream *stream = NULL, const char *varname=NULL,
              int pdim = 1);
  XplMask &operator= (const xplmask m);
  XplMask &fill (const xplmask from, const xplmask to);
  void setred (const XplArray<long> &x);
  void setgreen (const XplArray<long> &x);
  void setblue (const XplArray<long> &x);
  void setsymbol (const XplArray<long> &x);
  void setsize (const XplArray<long> &x);
  XplArray<long> getred (void) const;
  XplArray<long> getgreen (void) const;
  XplArray<long> getblue (void) const;
  XplArray<long> getsymbol (void) const;
  XplArray<long> getsize (void) const;
  XplArray<long> group (void) const;

};

#endif


