typedef union {
int		    Index;
double		    Real;
char                *Name;
class XplObject     *Obj;
class Variable      *Var;
class Function      *Fun;
class Macro         *Mac;
class MacroText	    *MacText;
Liste<Variable*>    *VarList;
Liste<XplObject*>   *ObjList;
Liste<const char*>  *CharList;
long		    Branch;
} YYSTYPE;
#define	VARIABLE	258
#define	CONSTVAR	259
#define	CONSTANT	260
#define	OP_PM	261
#define	OP_MD	262
#define	OP_TMD	263
#define	OP_P	264
#define	OP_REL	265
#define	OP_EQ	266
#define	OP_AND	267
#define	OP_OR	268
#define	OP_SEQ	269
#define	OP_CON	270
#define	SINGLE_OPN	271
#define	SINGLE_OPV	272
#define	DOT	273
#define	COMMENT	274
#define	COMBEGIN	275
#define	COMEND	276
#define	INTERRUPT	277
#define	ASSIGNBRACKET	278
#define	NEWSTRING	279
#define	STRCONST	280
#define	REFMAC	281
#define	MFCAND	282
#define	UNKNOWNINPUT	283
#define	FUNCTION	284
#define	MACRO	285
#define	XPROC	286
#define	IF	287
#define	ELSE	288
#define	ENDIF	289
#define	WHILE	290
#define	ENDO	291
#define	REPEAT	292
#define	UNTIL	293
#define	ENDP	294
#define	SWITCH	295
#define	CASE	296
#define	BREAK	297
#define	DEFAULT	298
#define	ENDSW	299
#define	NOP	300
#define	SIGN	301

