/* Localization strings for XploRe */

/* DO NOT CHANGE FORMATTING CHARACTERS IN STRINGS! (\n, \r, \t, %l, %s, %d, etc.) */



#ifndef XPLORE_STRINGS_H
#define XPLORE_STRINGS_H

/* Japanese version */

#ifdef JAPANESE

#define XPLORE_STRINGS_DEFINED

#define XMSG_OUTPUT_TITLE_DONE 1
/* Modified by D-TEC */
#define XMSG_OUTPUT_TITLE_DONE_STR " - I"
//#define XMSG_OUTPUT_TITLE_DONE_STR " - done"

#define XMSG_OUTPUT_WIN_CAPTION 2
/* Modified by D-TEC */
#define XMSG_OUTPUT_WIN_CAPTION_STR "oͳ޳"
//#define XMSG_OUTPUT_WIN_CAPTION_STR "Output"

#define XMSG_XPL_EDITOR_FILE_FILTER 3
/* Modified by D-TEC */
#define XMSG_XPL_EDITOR_FILE_FILTER_STR "XploRe گ ̧ (*.xpl)|*.xpl|ް ̧ (*.dat)|*.dat|ׂĂ̧ (*.*)|*.*|"
//#define XMSG_XPL_EDITOR_FILE_FILTER_STR "XploRe quantlet files (*.xpl)|*.xpl|Data files (*.dat)|*.dat|All files (*.*)|*.*|"

#define XMSG_NO_PRINTER_ACCESS 4
/* Modified by D-TEC */
#define XMSG_NO_PRINTER_ACCESS_STR "̫Ăɱł܂"
//#define XMSG_NO_PRINTER_ACCESS_STR "Unable to access default printer"

#define XMSG_NO_TEXT_TO_PRINT 5
/* Modified by D-TEC */
#define XMSG_NO_TEXT_TO_PRINT_STR "÷Ă܂I"
//#define XMSG_NO_TEXT_TO_PRINT_STR "No text to print!"

#define XMSG_NO_MEMORY_TO_PRINT 6
/* Modified by D-TEC */
#define XMSG_NO_MEMORY_TO_PRINT_STR "邽߂̏\ȃ܂I"
//#define XMSG_NO_MEMORY_TO_PRINT_STR "Not enough memory for printing!"

#define XMSG_TITLE_PRINT_WIN 7
/* Modified by D-TEC */
#define XMSG_TITLE_PRINT_WIN_STR "XploRe "
//#define XMSG_TITLE_PRINT_WIN_STR "XploRe Print"

#define XMSG_ERROR_CANNOT_WRITE_QUANTLET 8
/* Modified by D-TEC */
#define XMSG_ERROR_CANNOT_WRITE_QUANTLET_STR "گ ̧ق݂̏o܂"
//#define XMSG_ERROR_CANNOT_WRITE_QUANTLET_STR "Cannot write quantlet file"

#define XMSG_ERROR_NO_QUANTLET_NAME 9
/* Modified by D-TEC */
#define XMSG_ERROR_NO_QUANTLET_NAME_STR "گĖ܂"
//#define XMSG_ERROR_NO_QUANTLET_NAME_STR "No quantlet name found"

#define XMSG_ERROR_CANNOT_CREATE_HELP 10
/* Modified by D-TEC */
#define XMSG_ERROR_CANNOT_CREATE_HELP_STR "߼т쐬ł܂"
//#define XMSG_ERROR_CANNOT_CREATE_HELP_STR "Cannot create helpsystem"

#define XMSG_INCORRECT_QUANTLET_DEFINITION 11
/* Modified by D-TEC */
#define XMSG_INCORRECT_QUANTLET_DEFINITION_STR "sԍ%iɕ@IɊԈگĂ̒`܂:\n\n%s"
//#define XMSG_INCORRECT_QUANTLET_DEFINITION_STR "Found syntactically incorrect quantlet definition in line %i:\n\n%s"

#define XMSG_CLOSE_SELECT_ITEM 12
/* Modified by D-TEC */
#define XMSG_CLOSE_SELECT_ITEM_STR "ACȇIĂB"
//#define XMSG_CLOSE_SELECT_ITEM_STR "You must close selectitem"

#define XMSG_WANT_TO_QUIT 13
/* Modified by D-TEC */
#define XMSG_WANT_TO_QUIT_STR "I܂H"
//#define XMSG_WANT_TO_QUIT_STR "Do you really want to quit?"

#define XMSG_EDITOR_WIN_NAME 14
/* Modified by D-TEC */
#define XMSG_EDITOR_WIN_NAME_STR "ҏWF "
//#define XMSG_EDITOR_WIN_NAME_STR "Editor: "

#define XMSG_XPLLIB_EDITOR_FILE_FILTER 15
/* Modified by D-TEC */
#define XMSG_XPLLIB_EDITOR_FILE_FILTER_STR "XploRe گ ̧ (*.xpl)|*.xpl|XploRe ײ ̧ (*.lib)|*.lib|ް ̧ (*.dat)|*.dat|ׂĂ̧ (*.*)|*.*"
//#define XMSG_XPLLIB_EDITOR_FILE_FILTER_STR "XploRe quantlet files (*.xpl)|*.xpl|XploRe library files (*.lib)|*.lib|Data files (*.dat)|*.dat|All files (*.*)|*.*"

#define XMSG_CANNOT_OPEN_FILE 16
/* Modified by D-TEC */
#define XMSG_CANNOT_OPEN_FILE_STR "t@CJ܂"
//#define XMSG_CANNOT_OPEN_FILE_STR "Cannot open file"

#define XMSG_CANNOT_GET_FILESIZE 17
/* Modified by D-TEC */
#define XMSG_CANNOT_GET_FILESIZE_STR "̃t@CTCYɃANZXł܂"
//#define XMSG_CANNOT_GET_FILESIZE_STR "Cannot access filesize"

#define XMSG_FILE_TOO_LARGE 18
/* Modified by D-TEC */
#define XMSG_FILE_TOO_LARGE_STR "32KB傫ȃt@Cł"
//#define XMSG_FILE_TOO_LARGE_STR "File larger than 32KB"

#define XMSG_DATA_FILE_FILTER 19
/* Modified by D-TEC */
#define XMSG_DATA_FILE_FILTER_STR "ް ̧ (*.DAT)|*.DAT|ׂĂ̧ (*.*)|*.*"
//#define XMSG_DATA_FILE_FILTER_STR "Data file (*.DAT)|*.DAT|All files (*.*)|*.*"

#define XMSG_INPUT_WIN_CAPTION 20
/* Modified by D-TEC */
#define XMSG_INPUT_WIN_CAPTION_STR "ͳ޳"
//#define XMSG_INPUT_WIN_CAPTION_STR "Input"

#define XMSG_ABOUT_WIN_CAPTION 21
#define XMSG_ABOUT_WIN_CAPTION_STR "About"

#define XMSG_XPLORE_WIN_CAPTION 22
#define XMSG_XPLORE_WIN_CAPTION_STR "XploRe"

#define XMSG_CANNOT_OPEN_HELP_FILE 23
/* Modified by D-TEC */
#define XMSG_CANNOT_OPEN_HELP_FILE_STR "̧قJ܂B\t\n\n%s\n\nXPL4HELP̃pXmFĂB"
//#define XMSG_CANNOT_OPEN_HELP_FILE_STR "Cannot open help file\t\n\n%s\n\nPlease check XPL4HELP path !!"

#define XMSG_OBJECT_DBLCLK_NAME 24
/* Modified by D-TEC */
#define XMSG_OBJECT_DBLCLK_NAME_STR "޼ު %s"
//#define XMSG_OBJECT_DBLCLK_NAME_STR "Object %s"

#define XMSG_OBJECT_LIST_COMPONENTS 25
/* Modified by D-TEC */
#define XMSG_OBJECT_LIST_COMPONENTS_STR "߰Ă̈ꗗ:\r\n "
//#define XMSG_OBJECT_LIST_COMPONENTS_STR "a list with following components:\r\n "

#define XMSG_OBJECT_1MATRIX_LARGE 26
/* Modified by D-TEC */
#define XMSG_OBJECT_1MATRIX_LARGE_STR "\ɂ͑傫߂sł"
//#define XMSG_OBJECT_1MATRIX_LARGE_STR "Matrix is too large to view"

#define XMSG_OBJECT_2MATRIX_LARGE 27
/* Modified by D-TEC */
#define XMSG_OBJECT_2MATRIX_LARGE_STR "߂ "
//#define XMSG_OBJECT_2MATRIX_LARGE_STR "Only first "

#define XMSG_OBJECT_3MATRIX_LARGE 28
/* Modified by D-TEC */
#define XMSG_OBJECT_3MATRIX_LARGE_STR " s "
//#define XMSG_OBJECT_3MATRIX_LARGE_STR " rows and "

#define XMSG_OBJECT_4MATRIX_LARGE 29 
/* Modified by D-TEC */
#define XMSG_OBJECT_4MATRIX_LARGE_STR " \܂"
//#define XMSG_OBJECT_4MATRIX_LARGE_STR " columns are shown"

#define XMSG_OBJECT_TEXT_PLOT 30
/* Modified by D-TEC */
#define XMSG_OBJECT_TEXT_PLOT_STR " ÷"
//#define XMSG_OBJECT_TEXT_PLOT_STR " TEXT"

#define XMSG_OBJECT_PLOT_PLOT 31
/* Modified by D-TEC */
#define XMSG_OBJECT_PLOT_PLOT_STR " ۯ"
//#define XMSG_OBJECT_PLOT_PLOT_STR " PLOT"

#define XMSG_OBJECT_DEFAULT_PLOT 32
/* Modified by D-TEC */
#define XMSG_OBJECT_DEFAULT_PLOT_STR " ̫"
//#define XMSG_OBJECT_DEFAULT_PLOT_STR " DEFAULT"

#define XMSG_OBJECT_UNKNOWN 33
/* Modified by D-TEC */
#define XMSG_OBJECT_UNKNOWN_STR " ͕s߂ł"
//#define XMSG_OBJECT_UNKNOWN_STR " is an unknown type"

#define XMSG_1GLOBAL_ERROR_LINE 34
/* Modified by D-TEC */
#define XMSG_1GLOBAL_ERROR_LINE_STR "\n%s %ldsڂ\n%s"
//#define XMSG_1GLOBAL_ERROR_LINE_STR "\nin %s line: %ld\n%s"

#define XMSG_2GLOBAL_ERROR_LINE 35
/* Modified by D-TEC */
#define XMSG_2GLOBAL_ERROR_LINE_STR "\n%s sԍF %ld\n%s"
//#define XMSG_2GLOBAL_ERROR_LINE_STR "\n%s line: %ld\n%s"

#define XMSG_3GLOBAL_ERROR_LINE 36
/* Modified by D-TEC */
#define XMSG_3GLOBAL_ERROR_LINE_STR "\n%s %ldsڂ\n%s\n"
//#define XMSG_3GLOBAL_ERROR_LINE_STR "\nin %s line: %ld\n%s\n"

#define XMSG_4GLOBAL_ERROR_LINE 37
/* Modified by D-TEC */
#define XMSG_4GLOBAL_ERROR_LINE_STR "\n%s %ldsڂ\n"
//#define XMSG_4GLOBAL_ERROR_LINE_STR "\nin %s line: %ld\n"

#define XMSG_5GLOBAL_WARNING_LINE 38
/* Modified by D-TEC */
#define XMSG_5GLOBAL_WARNING_LINE_STR "\n%s sԍF %ld\n%s\n"
//#define XMSG_5GLOBAL_WARNING_LINE_STR "\n%s line: %ld\n%s\n"

#define XMSG_FREE_NOT_ALLOWED_INSIDE 39
/* Modified by D-TEC */
#define XMSG_FREE_NOT_ALLOWED_INSIDE_STR "free not allowed inside of procedures"

#define XMSG_NO_CONVERGENCE 40
/* Modified by D-TEC */
#define XMSG_NO_CONVERGENCE_STR "܂"
//#define XMSG_NO_CONVERGENCE_STR "No convergence"

#define XMSG_WARNING_IN_QUANTLET 41
/* Modified by D-TEC */
#define XMSG_WARNING_IN_QUANTLET_STR "گĂɌx"
//#define XMSG_WARNING_IN_QUANTLET_STR "Warning in quantlet"

#define XMSG_DYNAMIC_LIBRARY_OPENED_AGAIN 42
/* Modified by D-TEC */
#define XMSG_DYNAMIC_LIBRARY_OPENED_AGAIN_STR "޲Яײ؍ēx݂܂"
//#define XMSG_DYNAMIC_LIBRARY_OPENED_AGAIN_STR "dynamic library opened again"

#define XMSG_DYNAMIC_LIBRARY_NOT_FOUND 43
/* Modified by D-TEC */
#define XMSG_DYNAMIC_LIBRARY_NOT_FOUND_STR "޲Яײ؂܂"
//#define XMSG_DYNAMIC_LIBRARY_NOT_FOUND_STR "dynamic library not found"

#define XMSG_NO_OUTPUT_FILE_WAS_OPEN 44 
/* Modified by D-TEC */
#define XMSG_NO_OUTPUT_FILE_WAS_OPEN_STR "݂ꂽo̧ق܂"
//#define XMSG_NO_OUTPUT_FILE_WAS_OPEN_STR "no output file was open"

#define XMSG_IGNORE_SELECTION_DIMENSION_BY 45
/* Modified by D-TEC */
#define XMSG_IGNORE_SELECTION_DIMENSION_BY_STR "[]őIꂽ܂"
//#define XMSG_IGNORE_SELECTION_DIMENSION_BY_STR "ignore selection dimension by []"

#define XMSG_INVALID_CHARACTER 46
/* Modified by D-TEC */
#define XMSG_INVALID_CHARACTER_STR "sȕ"
//#define XMSG_INVALID_CHARACTER_STR "Invalid character"

#define XMSG_WRONG_NUMBER_OF_ARGUMENTS 47
/* Modified by D-TEC */
#define XMSG_WRONG_NUMBER_OF_ARGUMENTS_STR "̐ԈĂ܂"
//#define XMSG_WRONG_NUMBER_OF_ARGUMENTS_STR "Wrong number of arguments"

#define XMSG_WRONG_DIMENSION 48
/* Modified by D-TEC */
#define XMSG_WRONG_DIMENSION_STR "ԈĂ܂"
//#define XMSG_WRONG_DIMENSION_STR "Wrong dimension"

#define XMSG_CAN_NOT_OPEN_FILE 49
/* Modified by D-TEC */
#define XMSG_CAN_NOT_OPEN_FILE_STR "t@CJ܂"
//#define XMSG_CAN_NOT_OPEN_FILE_STR "Can not open file"

#define XMSG_CAN_NOT_FIND_OBJECT 50
/* Modified by D-TEC */
#define XMSG_CAN_NOT_FIND_OBJECT_STR "޼ުĂ܂"
//#define XMSG_CAN_NOT_FIND_OBJECT_STR "Can not find object"

#define XMSG_CAN_NOT_FIND_QUANTLET 51
/* Modified by D-TEC */
#define XMSG_CAN_NOT_FIND_QUANTLET_STR "گĂ܂"
//#define XMSG_CAN_NOT_FIND_QUANTLET_STR "Can not find quantlet"

#define XMSG_WRONG_VALUE 52
/* Modified by D-TEC */
#define XMSG_WRONG_VALUE_STR "Ԉlł"
//#define XMSG_WRONG_VALUE_STR "Wrong value"

#define XMSG_EMPTY_OBJECT_ 53
/* Modified by D-TEC */
#define XMSG_EMPTY_OBJECT__STR "̵޼ު "
//#define XMSG_EMPTY_OBJECT__STR "Empty Object "

#define XMSG_WRONG_ARGUMENT_TYPE 54
/* Modified by D-TEC */
#define XMSG_WRONG_ARGUMENT_TYPE_STR "߂sł"
//#define XMSG_WRONG_ARGUMENT_TYPE_STR "Wrong argument type"

#define XMSG_WRONG_1ARGUMENT_TYPE 55
/* Modified by D-TEC */
#define XMSG_WRONG_1ARGUMENT_TYPE_STR "߂sł\nlł܂"
//#define XMSG_WRONG_1ARGUMENT_TYPE_STR "Wrong argument type\nMust be numeric"

#define XMSG_WRONG_2ARGUMENT_TYPE 56
/* Modified by D-TEC */
#define XMSG_WRONG_2ARGUMENT_TYPE_STR "߂sł\n÷Ăł܂"
//#define XMSG_WRONG_2ARGUMENT_TYPE_STR "Wrong argument type\nMust be text"

#define XMSG_WRONG_3ARGUMENT_TYPE 57
/* Modified by D-TEC */
#define XMSG_WRONG_3ARGUMENT_TYPE_STR "߂sł\n ۯĂł܂"
//#define XMSG_WRONG_3ARGUMENT_TYPE_STR "Wrong argument type\n Must be plot"

#define XMSG_WRONG_4ARGUMENT_TYPE 58
/* Modified by D-TEC */
#define XMSG_WRONG_4ARGUMENT_TYPE_STR "߂sł\n Ͻł܂"
//#define XMSG_WRONG_4ARGUMENT_TYPE_STR "Wrong argument type\n Must be mask"

#define XMSG_WRONG_5ARGUMENT_TYPE 59
/* Modified by D-TEC */
#define XMSG_WRONG_5ARGUMENT_TYPE_STR "߂sł\n Ԃł܂"
//#define XMSG_WRONG_5ARGUMENT_TYPE_STR "Wrong argument type\n Must be time"

#define XMSG_UNKNOWN_VARIABLE 60
/* Modified by D-TEC */
#define XMSG_UNKNOWN_VARIABLE_STR "sȕϐł"
//#define XMSG_UNKNOWN_VARIABLE_STR "Unknown variable"

#define XMSG_UNKNOWN_FUNCTION 61
/* Modified by D-TEC */
#define XMSG_UNKNOWN_FUNCTION_STR "sȋ@\ł"
//#define XMSG_UNKNOWN_FUNCTION_STR "Unknown function"

#define XMSG_SYNTAX_ERROR 62
/* Modified by D-TEC */
#define XMSG_SYNTAX_ERROR_STR "@G["
//#define XMSG_SYNTAX_ERROR_STR "Syntax Error"

#define XMSG_ERROR_IN_ASSIGNMENT 63
/* Modified by D-TEC */
#define XMSG_ERROR_IN_ASSIGNMENT_STR "wɴװ܂"
//#define XMSG_ERROR_IN_ASSIGNMENT_STR "Error in assignment"

#define XMSG_ERROR_IN_SELECTION 64
/* Modified by D-TEC */
#define XMSG_ERROR_IN_SELECTION_STR "IɌ肪܂"
//#define XMSG_ERROR_IN_SELECTION_STR "Error in selection"

#define XMSG_COMPONENT_NOT_FOUND 65
/* Modified by D-TEC */
#define XMSG_COMPONENT_NOT_FOUND_STR "߰Ă܂"
//#define XMSG_COMPONENT_NOT_FOUND_STR "Component not found"

#define XMSG_VARIABLE_END_WITH_ 66
/* Modified by D-TEC */
#define XMSG_VARIABLE_END_WITH__STR "ϐ . ŏIĂ܂"
//#define XMSG_VARIABLE_END_WITH__STR "Variable end with ."

#define XMSG_UNKNOWN_REFERENCE 67
/* Modified by D-TEC */
#define XMSG_UNKNOWN_REFERENCE_STR "sȎQƂł"
//#define XMSG_UNKNOWN_REFERENCE_STR "Unknown reference"

#define XMSG_WRONG_NUM_OF_ARGS 68
/* Modified by D-TEC */
#define XMSG_WRONG_NUM_OF_ARGS_STR "̐ԈĂ܂"
//#define XMSG_WRONG_NUM_OF_ARGS_STR "Wrong number of arguments"

#define XMSG_MISSING_RETURN_ARGUMENT 69
/* Modified by D-TEC */
#define XMSG_MISSING_RETURN_ARGUMENT_STR "߂l܂"
//#define XMSG_MISSING_RETURN_ARGUMENT_STR "Missing return argument"

#define XMSG_INTERNAL_ERROR 70
/* Modified by D-TEC */
#define XMSG_INTERNAL_ERROR_STR "װ"
//#define XMSG_INTERNAL_ERROR_STR "Internal Error"

#define XMSG_RUNTIME_ERROR 71
/* Modified by D-TEC */
#define XMSG_RUNTIME_ERROR_STR " װ"
//#define XMSG_RUNTIME_ERROR_STR "Runtime Error"

#define XMSG_NO_HELP_FOR_ 72
/* Modified by D-TEC */
#define XMSG_NO_HELP_FOR__STR "߂܂: "
//#define XMSG_NO_HELP_FOR__STR "No help for "

#define XMSG_INPUT_PARAMETER_ERROR 73
/* Modified by D-TEC */
#define XMSG_INPUT_PARAMETER_ERROR_STR "Ұ װ"
//#define XMSG_INPUT_PARAMETER_ERROR_STR "Input Parameter Error"

#define XMSG_OUTPUT_PARAMETER_ERROR 74
/* Modified by D-TEC */
#define XMSG_OUTPUT_PARAMETER_ERROR_STR "oҰ װ"
//#define XMSG_OUTPUT_PARAMETER_ERROR_STR "Output Parameter Error"

#define XMSG_EQUAL_NAME_FOR_IO 75
/* Modified by D-TEC */
#define XMSG_EQUAL_NAME_FOR_IO_STR "I/O Ұ̖Oł"
//#define XMSG_EQUAL_NAME_FOR_IO_STR "Equal name for I/O parameter"

#define XMSG_TYPE_MISMATCH 76
/* Modified by D-TEC */
#define XMSG_TYPE_MISMATCH_STR "߂Ă܂"
//#define XMSG_TYPE_MISMATCH_STR "Type mismatch"

#define XMSG_ERROR_IN_NELMIN 77
/* Modified by D-TEC */
#define XMSG_ERROR_IN_NELMIN_STR "Nelminɴװ"
//#define XMSG_ERROR_IN_NELMIN_STR "Error in Nelmin"

#define XMSG_ERROR_IN_GENAR 78
/* Modified by D-TEC */
#define XMSG_ERROR_IN_GENAR_STR "Genarɴװ"
//#define XMSG_ERROR_IN_GENAR_STR "Error in Genar"

#define XMSG_CANT_LOAD_DLL 79
/* Modified by D-TEC */
#define XMSG_CANT_LOAD_DLL_STR "DLL۰ނł܂"
//#define XMSG_CANT_LOAD_DLL_STR "Can't load DLL"

#define XMSG_CLOSING_DLL 80
/* Modified by D-TEC */
#define XMSG_CLOSING_DLL_STR "DLL܂"
//#define XMSG_CLOSING_DLL_STR "closing DLL"

#define XMSG_CANT_LOAD_SYMBOL 81
/* Modified by D-TEC */
#define XMSG_CANT_LOAD_SYMBOL_STR "ق۰ނł܂"
//#define XMSG_CANT_LOAD_SYMBOL_STR "Can't load symbol"

#define XMSG_ERROR_IN_SIMPSON 82
/* Modified by D-TEC */
#define XMSG_ERROR_IN_SIMPSON_STR "Simpsonɴװ"
//#define XMSG_ERROR_IN_SIMPSON_STR "Error in Simpson"

#define XMSG_ERROR_IN_LOCPOL 83
/* Modified by D-TEC */
#define XMSG_ERROR_IN_LOCPOL_STR "LocPolɴװ"
//#define XMSG_ERROR_IN_LOCPOL_STR "Error in LocPol"

#define XMSG_ERROR_IN_QUANTLET__ 84
/* Modified by D-TEC */
#define XMSG_ERROR_IN_QUANTLET___STR "گĂɴװ  "
//#define XMSG_ERROR_IN_QUANTLET___STR "Error in quantlet  "

#define XMSG_WARNING 85
/* Modified by D-TEC */
#define XMSG_WARNING_STR "x"
//#define XMSG_WARNING_STR "Warning"

/* The following keywords (if --- endp) does not have to be translated */

#define XMSG_IF 86
#define XMSG_IF_STR "if"

#define XMSG_ELSE 87
#define XMSG_ELSE_STR "else"

#define XMSG_ENDIF 88
#define XMSG_ENDIF_STR "endif"

#define XMSG_WHILE 89
#define XMSG_WHILE_STR "while"

#define XMSG_ENDO 90
#define XMSG_ENDO_STR "endo"

#define XMSG_REPEAT 91
#define XMSG_REPEAT_STR "repeat"

#define XMSG_UNTIL 92
#define XMSG_UNTIL_STR "until"

#define XMSG_SWITCH 93
#define XMSG_SWITCH_STR "switch"

#define XMSG_CASE 94
#define XMSG_CASE_STR "case"

#define XMSG_DEFAULT 95
#define XMSG_DEFAULT_STR "default"

#define XMSG_BREAK 96
#define XMSG_BREAK_STR "break"

#define XMSG_ENDSW 97
#define XMSG_ENDSW_STR "endsw"

#define XMSG_PROC 98
#define XMSG_PROC_STR "proc"

#define XMSG_ENDP 99
#define XMSG_ENDP_STR "endp"

/* The preceeding keywords (if --- endp) does not have to be translated */

#define XMSG_ERROR 100
/* Modified by D-TEC */
#define XMSG_ERROR_STR "G["
//#define XMSG_ERROR_STR "Error"

#define XMSG_DISPLAY_WIN_CAPTION 101
/* Modified by D-TEC */
#define XMSG_DISPLAY_WIN_CAPTION_STR "\"
//#define XMSG_DISPLAY_WIN_CAPTION_STR "Display"

#define XMSG_PS_FILE_FILTER 102
/* Modified by D-TEC */
#define XMSG_PS_FILE_FILTER_STR "߽Ľ ̧ (*.PS)|*.ps|"
//#define XMSG_PS_FILE_FILTER_STR "Postscript Files (*.PS)|*.ps|"

#define XMSG_BITMAP_FILE_FILTER 103
/* Modified by D-TEC */
#define XMSG_BITMAP_FILE_FILTER_STR "ޯϯ ̧ (*.BMP)|*.bmp|"
//#define XMSG_BITMAP_FILE_FILTER_STR "Bitmap Files (*.BMP)|*.bmp|"

#define XMSG_SETELEMENT_ERROR 104
/* Modified by D-TEC */
#define XMSG_SETELEMENT_ERROR_STR "SetElementɂװ"
//#define XMSG_SETELEMENT_ERROR_STR "ERROR by SetElement"

#define XMSG_SETELEMENT_WRONG 105
/* Modified by D-TEC */
#define XMSG_SETELEMENT_WRONG_STR "SetElementɖ肪܂I"
//#define XMSG_SETELEMENT_WRONG_STR "Something is wrong by SetElement!"

/* 
 * This is the name of the font that is used for the axis description;
 * it must be an existing and everywhere available font!
 */
#define XMSG_AXIS_FONT_NAME 106
/* Modified by D-TEC */
#define XMSG_AXIS_FONT_NAME_STR "lr SVbN"
//#define XMSG_AXIS_FONT_NAME_STR "Times Roman"

/* 
 * This is the name of the font that is used for the graph headline;
 * it must be an existing and everywhere available font!
 */
#define XMSG_HEADLINE_FONT_NAME 107
/* Modified by D-TEC */
#define XMSG_HEADLINE_FONT_NAME_STR "lr SVbN"
//#define XMSG_HEADLINE_FONT_NAME_STR "Times Roman"

/* 
 * This is the name of the font that is used for the graph labels;
 * it must be an existing and everywhere available font!
 */
#define XMSG_LABELS_FONT_NAME 108
/* Modified by D-TEC */
#define XMSG_LABELS_FONT_NAME_STR "lr SVbN"
//#define XMSG_LABELS_FONT_NAME_STR "Times Roman"

/* 
 * This is the name of the font that is used for the text displays,
 * that is a part of the display used just for text output;
 * it must be an existing, everywhere available, and NONPROPORTIONAL font!
 */
#define XMSG_TEXT_FONT_NAME 109
/* Modified by D-TEC */
#define XMSG_TEXT_FONT_NAME_STR "lr SVbN"
//#define XMSG_TEXT_FONT_NAME_STR "Courier"

#define XMSG_NINETY_DAYS_LIMIT 110
/* Modified by D-TEC */
#define XMSG_NINETY_DAYS_LIMIT_STR "̃o[WXploRe\ngp90łłB\ngpɉ߂Ă܂I"
//#define XMSG_NINETY_DAYS_LIMIT_STR "This XploRe version is limited\nto 90 days only and it has\nalready expired!"

/*
 * Names for serif, sans-serif, and monospaced fonts; should be widely available
 * */

#define XMSG_DISP_FONT_SERIF  120
/* Modified by D-TEC */
#define XMSG_DISP_FONT_SERIF_STR "lr SVbN"
//#define XMSG_DISP_FONT_SERIF_STR "Times"

#define XMSG_DISP_FONT_SANSSERIF  121
/* Modified by D-TEC */
#define XMSG_DISP_FONT_SANSSERIF_STR "lr SVbN"
//#define XMSG_DISP_FONT_SANSSERIF_STR "Arial"

#define XMSG_DISP_FONT_MONOSPACE  122
/* Modified by D-TEC */
#define XMSG_DISP_FONT_MONOSPACE_STR "lr SVbN"
//#define XMSG_DISP_FONT_MONOSPACE_STR "Courier"

/* general window titles */

#define XMSG_XPLORE_ERROR 1000
/* Modified by D-TEC */
#define XMSG_XPLORE_ERROR_STR "XploRe - װ"
//#define XMSG_XPLORE_ERROR_STR "XploRe Error"

#define XMSG_XPLORE_SORRY 1001
/* Modified by D-TEC */
#define XMSG_XPLORE_SORRY_STR "XploRe - ߂Ȃ"
//#define XMSG_XPLORE_SORRY_STR "XploRe's sorry."

#define XMSG_XPLORE_QUESTION 1002
/* Modified by D-TEC */
#define XMSG_XPLORE_QUESTION_STR "XploRe - "
//#define XMSG_XPLORE_QUESTION_STR "XploRe's question."

#define XMSG_XPLORE_WARNING 1003
/* Modified by D-TEC */
#define XMSG_XPLORE_WARNING_STR "XploRe - x"
//#define XMSG_XPLORE_WARNING_STR "XploRe Warning"

#define XMSG_XPLORE_MESSAGE 1004
/* Modified by D-TEC */
#define XMSG_XPLORE_MESSAGE_STR "XploRe - ү"
//#define XMSG_XPLORE_MESSAGE_STR "XploRe Message"

/* popup menus */
#define XMSG_DISPPOP_PRINT 2001
/* Modified by D-TEC */
#define XMSG_DISPPOP_PRINT_STR "(&P)..."
//#define XMSG_DISPPOP_PRINT_STR "&Print..."

#define XMSG_DISPPOP_POSTSCRIPT 2002
/* Modified by D-TEC */
#define XMSG_DISPPOP_POSTSCRIPT_STR "߽Ļ̌(&P)..."
//#define XMSG_DISPPOP_POSTSCRIPT_STR "Save as &Postscript..."

#define XMSG_DISPPOP_BITMAP 2003
/* Modified by D-TEC */
#define XMSG_DISPPOP_BITMAP_STR "ޯϯ̧(&B)..."
//#define XMSG_DISPPOP_BITMAP_STR "Save as &Bitmap..."

#define XMSG_DISPPOP_TOOLTIP 2004
/* Modified by D-TEC */
#define XMSG_DISPPOP_TOOLTIP_STR "W̕\(&S)"
//#define XMSG_DISPPOP_TOOLTIP_STR "&Show coordinates"

#define XMSG_DISPPOP_COPYTOCLIP 2005
/* Modified by D-TEC */
#define XMSG_DISPPOP_COPYTOCLIP_STR "دް(&C)"
//#define XMSG_DISPPOP_COPYTOCLIP_STR "&Copy to clipboard"

#define XMSG_NULMEM 26  // Sk 020304 see global.h
/* Modified by D-TEC */
#define XMSG_NULMEM_STR "Fail to create a matrix with no entries"
#define XMSG_NULMEM_CONT_STR "Try to create a contour line with no entries"
//#define XMSG_NULMEM_STR "Fail to create a matrix with no entries"
//#define XMSG_NULMEM_CONT_STR "Try to create a contour line with no entries"

#define XMSG_READVALUE_DIALOGTITLE 3000
#define XMSG_READVALUE_DIALOGTITLE_STR "l̓ǂݍ"

#define XMSGW_OBJECT_LARGER_32K 3001
#define XMSGW_OBJECT_LARGER_32K_STR "\r\n޼ުĂɑ΂ݸނ32K𒴂Ă܂\r\n"

#define XMSGU_OBJECT_LARGER_32K 3001
#define XMSGU_OBJECT_LARGER_32K_STR "\n޼ުĂɑ΂ݸނ32K𒴂Ă܂\n"

#define XMSG_PARSER_ENTERQUANTLET 3003
#define XMSG_PARSER_ENTERQUANTLET_STR "گĂ̊Jn: %s"

#define XMSG_PARSER_LEAVEQUANTLET 3004
#define XMSG_PARSER_LEAVEQUANTLET_STR "گĂ̏I: %s"

#define XMSG_PARSER_PARSERROR 3005
#define XMSG_PARSER_PARSERROR_STR "@̓G["

#define XMSG_UNIXFONT_TIMES10 3100
#define XMSG_UNIXFONT_TIMES10_STR "-*-times-medium-r-*--10-*-*-*-*-*-iso8859-1"

#define XMSG_UNIXFONT_TIMES12 3101
#define XMSG_UNIXFONT_TIMES12_STR "-*-times-medium-r-*--12-*-*-*-*-*-iso8859-1"

#define XMSG_UNIXFONT_TIMES14 3102
#define XMSG_UNIXFONT_TIMES14_STR "-*-times-medium-r-*--14-*-*-*-*-*-iso8859-1"

#define XMSG_UNIXFONT_TIMES16 3103
#define XMSG_UNIXFONT_TIMES16_STR "-*-times-medium-r-*--16-*-*-*-*-*-iso8859-1"

#define XMSG_UNIXFONT_TIMES18 3104
#define XMSG_UNIXFONT_TIMES18_STR "-*-times-medium-r-*--18-*-*-*-*-*-iso8859-1"

#define XMSG_UNIXFONT_TIMES20 3105
#define XMSG_UNIXFONT_TIMES20_STR "-*-times-medium-r-*--20-*-*-*-*-*-iso8859-1"

#define XMSG_UNIXFONT_TIMES22 3106
#define XMSG_UNIXFONT_TIMES22_STR "-*-times-medium-r-*--22-*-*-*-*-*-iso8859-1"

#define XMSG_UNIXFONT_TIMES24 3107
#define XMSG_UNIXFONT_TIMES24_STR "-*-times-medium-r-*--24-*-*-*-*-*-iso8859-1"

#define XMSG_UNIXFONT_FL_COURIER18 3108
#define XMSG_UNIXFONT_FL_COURIER18_STR "Xplore*fontList:	-*-courier-medium-r-*--18-*-*-*-*-*-iso8859-1"

#define XMSG_FONTMASK_SERIF        "-*-times-medium-r-*--%d-*-*-*-*-*-iso8859-1"
#define XMSG_FONTMASK_SANSSERIF    "-*-helvetica-medium-r-*--%d-*-*-*-*-*-iso8859-1"
#define XMSG_FONTMASK_MONOSPACE    "-*-courier-medium-r-*--%d-*-*-*-*-*-iso8859-1"

#define XMSG_GLOBLIST_VARIABLE_FMTSTR 3200
#define XMSG_GLOBLIST_VARIABLE_FMTSTR_STR "ϐ %s "

#define XMSG_GLOBLIST_FUNCTION_FMTSTR 3201
#define XMSG_GLOBLIST_FUNCTION_FMTSTR_STR "֐ %s "

#define XMSG_GLOBLIST_MACRO_FMTSTR 3202
#define XMSG_GLOBLIST_MACRO_FMTSTR_STR "ϸ %s "

#define XMSG_GLOBLIST_UNKNOWN_FMTSTR 3203
#define XMSG_GLOBLIST_UNKNOWN_FMTSTR_STR "sȵ޼ު %s "

#define XMSG_INITTEXT_COMMANDLINE 3300
#define XMSG_INITTEXT_COMMANDLINE_STR "ײ"

#define XMSG_INITTEXT_OUTHEADLINE 3301
#define XMSG_INITTEXT_OUTHEADLINE_STR "\r\n%s ̓e\r\n\r\n"

#define XMSG_INITTEXT_DATESTRING 3302
#define XMSG_INITTEXT_DATESTRING_STR "%d/%d/%d"

#define XMSG_INITTEXT_EXPIRESTRING 3303
#define XMSG_INITTEXT_EXPIRESTRING_STR "CZX%sɏI܂B\r\n"

#define XMSG_INITTEXT_EXPIREDSTRING 3304
#define XMSG_INITTEXT_EXPIREDSTRING_STR "CZX%sɏI܂B\nVo[W_E[h܂H"

#define XMSG_INITTEXT_FATALERRORSTRING 3305
#define XMSG_INITTEXT_FATALERRORSTRING_STR "vIװ - XploReI܂B"
/* "vIG[܂B- XploReI܂B" */

#define XMSG_INITTEXT_NOTEMPSPACE 3306
#define XMSG_INITTEXT_NOTEMPSPACE_STR "ؗ̈悪%sɌ܂B - XploRe.iniĉB"

#define XMSG_INITTEXT_WARNNOSTARTUP 3307
#define XMSG_INITTEXT_WARNNOSTARTUP_STR "xF%s [hł܂B\n"

#endif

#ifndef XPLORE_STRINGS_DEFINED

/* English version */

#define XMSG_OUTPUT_TITLE_DONE 1
#define XMSG_OUTPUT_TITLE_DONE_STR " - done"

#define XMSG_OUTPUT_WIN_CAPTION 2
#define XMSG_OUTPUT_WIN_CAPTION_STR "Output"

#define XMSG_XPL_EDITOR_FILE_FILTER 3
#define XMSG_XPL_EDITOR_FILE_FILTER_STR "XploRe quantlet files (*.xpl)|*.xpl|Data files (*.dat)|*.dat|All files (*.*)|*.*|"

#define XMSG_NO_PRINTER_ACCESS 4
#define XMSG_NO_PRINTER_ACCESS_STR "Unable to access default printer"

#define XMSG_NO_TEXT_TO_PRINT 5
#define XMSG_NO_TEXT_TO_PRINT_STR "No text to print!"

#define XMSG_NO_MEMORY_TO_PRINT 6
#define XMSG_NO_MEMORY_TO_PRINT_STR "Not enough memory for printing!"

#define XMSG_TITLE_PRINT_WIN 7
#define XMSG_TITLE_PRINT_WIN_STR "XploRe Print"

#define XMSG_ERROR_CANNOT_WRITE_QUANTLET 8
#define XMSG_ERROR_CANNOT_WRITE_QUANTLET_STR "Cannot write quantlet file"

#define XMSG_ERROR_NO_QUANTLET_NAME 9
#define XMSG_ERROR_NO_QUANTLET_NAME_STR "No quantlet name found"

#define XMSG_ERROR_CANNOT_CREATE_HELP 10
#define XMSG_ERROR_CANNOT_CREATE_HELP_STR "Cannot create helpsystem"

#define XMSG_INCORRECT_QUANTLET_DEFINITION 11
#define XMSG_INCORRECT_QUANTLET_DEFINITION_STR "Found syntactically incorrect quantlet definition in line %i:\n\n%s"

#define XMSG_CLOSE_SELECT_ITEM 12
#define XMSG_CLOSE_SELECT_ITEM_STR "You must close selectitem"

#define XMSG_WANT_TO_QUIT 13
#define XMSG_WANT_TO_QUIT_STR "Do you really want to quit?"

#define XMSG_EDITOR_WIN_NAME 14 
#define XMSG_EDITOR_WIN_NAME_STR "Editor: "

#define XMSG_XPLLIB_EDITOR_FILE_FILTER 15
#define XMSG_XPLLIB_EDITOR_FILE_FILTER_STR "XploRe quantlet files (*.xpl)|*.xpl|XploRe library files (*.lib)|*.lib|Data files (*.dat)|*.dat|All files (*.*)|*.*"

#define XMSG_CANNOT_OPEN_FILE 16
#define XMSG_CANNOT_OPEN_FILE_STR "Cannot open file"

#define XMSG_CANNOT_GET_FILESIZE 17 
#define XMSG_CANNOT_GET_FILESIZE_STR "Cannot access filesize"

#define XMSG_FILE_TOO_LARGE 18 
#define XMSG_FILE_TOO_LARGE_STR "File larger than 32KB"

#define XMSG_DATA_FILE_FILTER 19
#define XMSG_DATA_FILE_FILTER_STR "Data file (*.DAT)|*.DAT|All files (*.*)|*.*"

#define XMSG_INPUT_WIN_CAPTION 20
#define XMSG_INPUT_WIN_CAPTION_STR "Input"

#define XMSG_ABOUT_WIN_CAPTION 21
#define XMSG_ABOUT_WIN_CAPTION_STR "About"

#define XMSG_XPLORE_WIN_CAPTION 22
#define XMSG_XPLORE_WIN_CAPTION_STR "XploRe"

#define XMSG_CANNOT_OPEN_HELP_FILE 23 
#define XMSG_CANNOT_OPEN_HELP_FILE_STR "Cannot open help file\t\n\n%s\n\nPlease check XPL4HELP path !!"

#define XMSG_OBJECT_DBLCLK_NAME 24
#define XMSG_OBJECT_DBLCLK_NAME_STR "Object %s"

#define XMSG_OBJECT_LIST_COMPONENTS 25 
#define XMSG_OBJECT_LIST_COMPONENTS_STR "a list with following components:\r\n "

#define XMSG_OBJECT_1MATRIX_LARGE 26 
#define XMSG_OBJECT_1MATRIX_LARGE_STR "Matrix is too large to view"

#define XMSG_OBJECT_2MATRIX_LARGE 27
#define XMSG_OBJECT_2MATRIX_LARGE_STR "Only first "

#define XMSG_OBJECT_3MATRIX_LARGE 28 
#define XMSG_OBJECT_3MATRIX_LARGE_STR " rows and "

#define XMSG_OBJECT_4MATRIX_LARGE 29 
#define XMSG_OBJECT_4MATRIX_LARGE_STR " columns are shown"

#define XMSG_OBJECT_TEXT_PLOT 30
#define XMSG_OBJECT_TEXT_PLOT_STR " TEXT"

#define XMSG_OBJECT_PLOT_PLOT 31
#define XMSG_OBJECT_PLOT_PLOT_STR " PLOT"

#define XMSG_OBJECT_DEFAULT_PLOT 32
#define XMSG_OBJECT_DEFAULT_PLOT_STR " DEFAULT"

#define XMSG_OBJECT_UNKNOWN 33
#define XMSG_OBJECT_UNKNOWN_STR " is an unknown type"

#define XMSG_1GLOBAL_ERROR_LINE 34
#define XMSG_1GLOBAL_ERROR_LINE_STR "\nin %s line: %ld\n%s"

#define XMSG_2GLOBAL_ERROR_LINE 35 
#define XMSG_2GLOBAL_ERROR_LINE_STR "\n%s line: %ld\n%s"

#define XMSG_3GLOBAL_ERROR_LINE 36 
#define XMSG_3GLOBAL_ERROR_LINE_STR "\nin %s line: %ld\n%s\n"

#define XMSG_4GLOBAL_ERROR_LINE 37
#define XMSG_4GLOBAL_ERROR_LINE_STR "\nin %s line: %ld\n"

#define XMSG_5GLOBAL_WARNING_LINE 38 
#define XMSG_5GLOBAL_WARNING_LINE_STR "\n%s line: %ld\n%s\n"

#define XMSG_FREE_NOT_ALLOWED_INSIDE 39
#define XMSG_FREE_NOT_ALLOWED_INSIDE_STR "free not allowed inside of procedures"

#define XMSG_NO_CONVERGENCE 40
#define XMSG_NO_CONVERGENCE_STR "No convergence"

#define XMSG_WARNING_IN_QUANTLET 41
#define XMSG_WARNING_IN_QUANTLET_STR "Warning in quantlet"

#define XMSG_DYNAMIC_LIBRARY_OPENED_AGAIN 42
#define XMSG_DYNAMIC_LIBRARY_OPENED_AGAIN_STR "dynamic library opened again"

#define XMSG_DYNAMIC_LIBRARY_NOT_FOUND 43
#define XMSG_DYNAMIC_LIBRARY_NOT_FOUND_STR "dynamic library not found"

#define XMSG_NO_OUTPUT_FILE_WAS_OPEN 44 
#define XMSG_NO_OUTPUT_FILE_WAS_OPEN_STR "no output file was open"

#define XMSG_IGNORE_SELECTION_DIMENSION_BY 45
#define XMSG_IGNORE_SELECTION_DIMENSION_BY_STR "ignore selection dimension by []"

#define XMSG_INVALID_CHARACTER 46
#define XMSG_INVALID_CHARACTER_STR "Invalid character"

#define XMSG_WRONG_NUMBER_OF_ARGUMENTS 47
#define XMSG_WRONG_NUMBER_OF_ARGUMENTS_STR "Wrong number of arguments"

#define XMSG_WRONG_DIMENSION 48
#define XMSG_WRONG_DIMENSION_STR "Wrong dimension"

#define XMSG_CAN_NOT_OPEN_FILE 49
#define XMSG_CAN_NOT_OPEN_FILE_STR "Can not open file"

#define XMSG_CAN_NOT_FIND_OBJECT 50
#define XMSG_CAN_NOT_FIND_OBJECT_STR "Can not find object"

#define XMSG_CAN_NOT_FIND_QUANTLET 51
#define XMSG_CAN_NOT_FIND_QUANTLET_STR "Can not find quantlet"

#define XMSG_WRONG_VALUE 52
#define XMSG_WRONG_VALUE_STR "Wrong value"

#define XMSG_EMPTY_OBJECT_ 53
#define XMSG_EMPTY_OBJECT__STR "Empty Object "

#define XMSG_WRONG_ARGUMENT_TYPE 54
#define XMSG_WRONG_ARGUMENT_TYPE_STR "Wrong argument type"

#define XMSG_WRONG_1ARGUMENT_TYPE 55
#define XMSG_WRONG_1ARGUMENT_TYPE_STR "Wrong argument type\nMust be numeric"

#define XMSG_WRONG_2ARGUMENT_TYPE 56
#define XMSG_WRONG_2ARGUMENT_TYPE_STR "Wrong argument type\nMust be text"

#define XMSG_WRONG_3ARGUMENT_TYPE 57
#define XMSG_WRONG_3ARGUMENT_TYPE_STR "Wrong argument type\n Must be plot"

#define XMSG_WRONG_4ARGUMENT_TYPE 58
#define XMSG_WRONG_4ARGUMENT_TYPE_STR "Wrong argument type\n Must be mask"

#define XMSG_WRONG_5ARGUMENT_TYPE 59
#define XMSG_WRONG_5ARGUMENT_TYPE_STR "Wrong argument type\n Must be time"

#define XMSG_UNKNOWN_VARIABLE 60
#define XMSG_UNKNOWN_VARIABLE_STR "Unknown variable"

#define XMSG_UNKNOWN_FUNCTION 61
#define XMSG_UNKNOWN_FUNCTION_STR "Unknown function"

#define XMSG_SYNTAX_ERROR 62
#define XMSG_SYNTAX_ERROR_STR "Syntax Error"

#define XMSG_ERROR_IN_ASSIGNMENT 63
#define XMSG_ERROR_IN_ASSIGNMENT_STR "Error in assignment"

#define XMSG_ERROR_IN_SELECTION 64
#define XMSG_ERROR_IN_SELECTION_STR "Error in selection"

#define XMSG_COMPONENT_NOT_FOUND 65
#define XMSG_COMPONENT_NOT_FOUND_STR "Component not found"

#define XMSG_VARIABLE_END_WITH_ 66
#define XMSG_VARIABLE_END_WITH__STR "Variable end with ."

#define XMSG_UNKNOWN_REFERENCE 67
#define XMSG_UNKNOWN_REFERENCE_STR "Unknown reference"

#define XMSG_WRONG_NUM_OF_ARGS 68
#define XMSG_WRONG_NUM_OF_ARGS_STR "Wrong number of arguments"

#define XMSG_MISSING_RETURN_ARGUMENT 69
#define XMSG_MISSING_RETURN_ARGUMENT_STR "Missing return argument"

#define XMSG_INTERNAL_ERROR 70
#define XMSG_INTERNAL_ERROR_STR "Internal Error"

#define XMSG_RUNTIME_ERROR 71
#define XMSG_RUNTIME_ERROR_STR "Runtime Error"

#define XMSG_NO_HELP_FOR_ 72
#define XMSG_NO_HELP_FOR__STR "No help for "

#define XMSG_INPUT_PARAMETER_ERROR 73
#define XMSG_INPUT_PARAMETER_ERROR_STR "Input Parameter Error"

#define XMSG_OUTPUT_PARAMETER_ERROR 74
#define XMSG_OUTPUT_PARAMETER_ERROR_STR "Output Parameter Error"

#define XMSG_EQUAL_NAME_FOR_IO 75
#define XMSG_EQUAL_NAME_FOR_IO_STR "Equal name for I/O parameter"

#define XMSG_TYPE_MISMATCH 76
#define XMSG_TYPE_MISMATCH_STR "Type mismatch"

#define XMSG_ERROR_IN_NELMIN 77
#define XMSG_ERROR_IN_NELMIN_STR "Error in Nelmin"

#define XMSG_ERROR_IN_GENAR 78
#define XMSG_ERROR_IN_GENAR_STR "Error in Genar"

#define XMSG_CANT_LOAD_DLL 79
#define XMSG_CANT_LOAD_DLL_STR "Can't load DLL"

#define XMSG_CLOSING_DLL 80
#define XMSG_CLOSING_DLL_STR "closing DLL"

#define XMSG_CANT_LOAD_SYMBOL 81
#define XMSG_CANT_LOAD_SYMBOL_STR "Can't load symbol"

#define XMSG_ERROR_IN_SIMPSON 82
#define XMSG_ERROR_IN_SIMPSON_STR "Error in Simpson"

#define XMSG_ERROR_IN_LOCPOL 83
#define XMSG_ERROR_IN_LOCPOL_STR "Error in LocPol"

#define XMSG_ERROR_IN_QUANTLET__ 84
#define XMSG_ERROR_IN_QUANTLET___STR "Error in quantlet  "

#define XMSG_WARNING 85
#define XMSG_WARNING_STR "Warning"

/* The following keywords (if --- endp) does not have to be translated */

#define XMSG_IF 86
#define XMSG_IF_STR "if"

#define XMSG_ELSE 87
#define XMSG_ELSE_STR "else"

#define XMSG_ENDIF 88
#define XMSG_ENDIF_STR "endif"

#define XMSG_WHILE 89
#define XMSG_WHILE_STR "while"

#define XMSG_ENDO 90
#define XMSG_ENDO_STR "endo"

#define XMSG_REPEAT 91
#define XMSG_REPEAT_STR "repeat"

#define XMSG_UNTIL 92
#define XMSG_UNTIL_STR "until"

#define XMSG_SWITCH 93
#define XMSG_SWITCH_STR "switch"

#define XMSG_CASE 94
#define XMSG_CASE_STR "case"

#define XMSG_DEFAULT 95
#define XMSG_DEFAULT_STR "default"

#define XMSG_BREAK 96
#define XMSG_BREAK_STR "break"

#define XMSG_ENDSW 97
#define XMSG_ENDSW_STR "endsw"

#define XMSG_PROC 98
#define XMSG_PROC_STR "proc"

#define XMSG_ENDP 99
#define XMSG_ENDP_STR "endp"

/* The preceeding keywords (if --- endp) does not have to be translated */

#define XMSG_ERROR 100
#define XMSG_ERROR_STR "Error"

#define XMSG_DISPLAY_WIN_CAPTION 101
#define XMSG_DISPLAY_WIN_CAPTION_STR "Display"

#define XMSG_PS_FILE_FILTER 102
#define XMSG_PS_FILE_FILTER_STR "Postscript Files (*.PS)|*.ps|"

#define XMSG_BITMAP_FILE_FILTER 103
#define XMSG_BITMAP_FILE_FILTER_STR "Bitmap Files (*.BMP)|*.bmp|"

#define XMSG_SETELEMENT_ERROR 104
#define XMSG_SETELEMENT_ERROR_STR "ERROR by SetElement"

#define XMSG_SETELEMENT_WRONG 105
#define XMSG_SETELEMENT_WRONG_STR "Something is wrong by SetElement!"

/* 
 * This is the name of the font that is used for the axis description;
 * it must be an existing and everywhere available font!
 */
#define XMSG_AXIS_FONT_NAME 106
#define XMSG_AXIS_FONT_NAME_STR "Times Roman"

/* 
 * This is the name of the font that is used for the graph headline;
 * it must be an existing and everywhere available font!
 */
#define XMSG_HEADLINE_FONT_NAME 107
#define XMSG_HEADLINE_FONT_NAME_STR "Times Roman"

/* 
 * This is the name of the font that is used for the graph labels;
 * it must be an existing and everywhere available font!
 */
#define XMSG_LABELS_FONT_NAME 108
#define XMSG_LABELS_FONT_NAME_STR "Times Roman"

/* 
 * This is the name of the font that is used for the text displays,
 * that is a part of the display used just for text output;
 * it must be an existing, everywhere available, and NONPROPORTIONAL font!
 */
#define XMSG_TEXT_FONT_NAME 109
#define XMSG_TEXT_FONT_NAME_STR "Courier"

#define XMSG_NINETY_DAYS_LIMIT 110
#define XMSG_NINETY_DAYS_LIMIT_STR "This XploRe version is limited\nto 30 days only and it has\nalready expired!" 

/*
 * Names for serif, sans-serif, and monospaced fonts; should be widely available
 * */

#define XMSG_DISP_FONT_SERIF  120
#define XMSG_DISP_FONT_SERIF_STR "Times"

#define XMSG_DISP_FONT_SANSSERIF  121
#define XMSG_DISP_FONT_SANSSERIF_STR "Arial"

#define XMSG_DISP_FONT_MONOSPACE  122
#define XMSG_DISP_FONT_MONOSPACE_STR "Courier"

/* general window titles */

#define XMSG_XPLORE_ERROR 1000
#define XMSG_XPLORE_ERROR_STR "XploRe Error"

#define XMSG_XPLORE_SORRY 1001
#define XMSG_XPLORE_SORRY_STR "XploRe's sorry."

#define XMSG_XPLORE_QUESTION 1002
#define XMSG_XPLORE_QUESTION_STR "XploRe's question."

#define XMSG_XPLORE_WARNING 1003
#define XMSG_XPLORE_WARNING_STR "XploRe Warning"

#define XMSG_XPLORE_MESSAGE 1004
#define XMSG_XPLORE_MESSAGE_STR "XploRe Message"

/* popup menus */
#define XMSG_DISPPOP_PRINT 2001
#define XMSG_DISPPOP_PRINT_STR "&Print..."

#define XMSG_DISPPOP_POSTSCRIPT 2002
#define XMSG_DISPPOP_POSTSCRIPT_STR "Save as &Postscript..."

#define XMSG_DISPPOP_BITMAP 2003
#define XMSG_DISPPOP_BITMAP_STR "Save as &Bitmap..."

#define XMSG_DISPPOP_TOOLTIP 2004
#define XMSG_DISPPOP_TOOLTIP_STR "&Show coordinates"

#define XMSG_DISPPOP_COPYTOCLIP 2005
#define XMSG_DISPPOP_COPYTOCLIP_STR "&Copy to clipboard"

#define XMSG_NULMEM 26  // Sk 020304 see global.h
#define XMSG_NULMEM_STR "Fail to create a matrix with no entries"
#define XMSG_NULMEM_CONT_STR "Try to create a contour line with no entries"

#define XMSG_READVALUE_DIALOGTITLE 3000
#define XMSG_READVALUE_DIALOGTITLE_STR "Read Value"

#define XMSGW_OBJECT_LARGER_32K 3001
#define XMSGW_OBJECT_LARGER_32K_STR "\r\nSorry, string for object exceeds 32K\r\n"

#define XMSGU_OBJECT_LARGER_32K 3002
#define XMSGU_OBJECT_LARGER_32K_STR "\nSorry, string for object exceeds 32K\n"

#define XMSG_PARSER_ENTERQUANTLET 3003
#define XMSG_PARSER_ENTERQUANTLET_STR "Entering quantlet: %s"

#define XMSG_PARSER_LEAVEQUANTLET 3004
#define XMSG_PARSER_LEAVEQUANTLET_STR "Leaving quantlet: %s"

#define XMSG_PARSER_PARSERROR 3005
#define XMSG_PARSER_PARSERROR_STR "Parse error"

#define XMSG_UNIXFONT_TIMES10 3100
#define XMSG_UNIXFONT_TIMES10_STR "-*-times-medium-r-*--10-*-*-*-*-*-*-*"

#define XMSG_UNIXFONT_TIMES12 3101
#define XMSG_UNIXFONT_TIMES12_STR "-*-times-medium-r-*--12-*-*-*-*-*-*-*"

#define XMSG_UNIXFONT_TIMES14 3102
#define XMSG_UNIXFONT_TIMES14_STR "-*-times-medium-r-*--14-*-*-*-*-*-*-*"

#define XMSG_UNIXFONT_TIMES16 3103
#define XMSG_UNIXFONT_TIMES16_STR "-*-times-medium-r-*--16-*-*-*-*-*-*-*"

#define XMSG_UNIXFONT_TIMES18 3104
#define XMSG_UNIXFONT_TIMES18_STR "-*-times-medium-r-*--18-*-*-*-*-*-*-*"

#define XMSG_UNIXFONT_TIMES20 3105
#define XMSG_UNIXFONT_TIMES20_STR "-*-times-medium-r-*--20-*-*-*-*-*-*-*"

#define XMSG_UNIXFONT_TIMES22 3106
#define XMSG_UNIXFONT_TIMES22_STR "-*-times-medium-r-*--22-*-*-*-*-*-*-*"

#define XMSG_UNIXFONT_TIMES24 3107
#define XMSG_UNIXFONT_TIMES24_STR "-*-times-medium-r-*--24-*-*-*-*-*-*-*"

#define XMSG_UNIXFONT_FL_COURIER18 3108
#define XMSG_UNIXFONT_FL_COURIER18_STR "Xplore*fontList:	-*-courier-medium-r-*--18-*-*-*-*-*-*-*"

#define XMSG_FONTMASK_SERIF        "-*-times-medium-r-*--%d-*-*-*-*-*-*-*"
#define XMSG_FONTMASK_SANSSERIF    "-*-helvetica-medium-r-*--%d-*-*-*-*-*-*-*"
#define XMSG_FONTMASK_MONOSPACE    "-*-courier-medium-r-*--%d-*-*-*-*-*-*-*"

#define XMSG_GLOBLIST_VARIABLE_FMTSTR 3200
#define XMSG_GLOBLIST_VARIABLE_FMTSTR_STR "Variable %s " 

#define XMSG_GLOBLIST_FUNCTION_FMTSTR 3201
#define XMSG_GLOBLIST_FUNCTION_FMTSTR_STR "Function %s " 

#define XMSG_GLOBLIST_MACRO_FMTSTR 3202
#define XMSG_GLOBLIST_MACRO_FMTSTR_STR "Quantlet %s " 

#define XMSG_GLOBLIST_UNKNOWN_FMTSTR 3203
#define XMSG_GLOBLIST_UNKNOWN_FMTSTR_STR "Unknown object %s " 

#define XMSG_INITTEXT_COMMANDLINE 3300
#define XMSG_INITTEXT_COMMANDLINE_STR "CommandLine"

#define XMSG_INITTEXT_OUTHEADLINE 3301
#define XMSG_INITTEXT_OUTHEADLINE_STR "\r\nContents of %s\r\n\r\n"

#define XMSG_INITTEXT_DATESTRING 3302
#define XMSG_INITTEXT_DATESTRING_STR "%d.%d.%d"

#define XMSG_INITTEXT_EXPIRESTRING 3303
#define XMSG_INITTEXT_EXPIRESTRING_STR "License will expire on %s\r\n"

#define XMSG_INITTEXT_EXPIREDSTRING 3304
#define XMSG_INITTEXT_EXPIREDSTRING_STR "License expired on %s\nDownload a new version ?"

#define XMSG_INITTEXT_FATALERRORSTRING 3305
#define XMSG_INITTEXT_FATALERRORSTRING_STR "Fatal error - XploRe will stop"

#define XMSG_INITTEXT_NOTEMPSPACE 3306
#define XMSG_INITTEXT_NOTEMPSPACE_STR "No temporary space found in %s - check XploRe.ini"

#define XMSG_INITTEXT_WARNNOSTARTUP 3307
#define XMSG_INITTEXT_WARNNOSTARTUP_STR "Warning: no %s loaded\n" 

#endif

#endif

