/* $Header: /home/xplore/cvs/xpl4gr/xselect.hpp,v 1.3 2002/08/16 12:32:03 sigbert Exp $ */

#ifndef XPLSELECTION
#define XPLSELECTION

#include "global.h"

class XplSelection
//L \section{XplSelection}
//L Class for selecting subarrays.
//L \begin{enumerate}
{ long *lptr;
  long length;

  public:

  XplSelection (void);

  XplSelection (long n);

  XplSelection (long n, long *ptr);

  ~XplSelection (void);

  long& operator[] (long nr);

  XplSelection& operator= (const XplSelection& xs);

  long len (void) const;

  long *ptr (void) const;
};
//L \end{enumerate}

#endif
