/* $Header: /home/xplore/cvs/xpl4gr/xsockio.h,v 1.3 2002/08/16 12:32:03 sigbert Exp $ */

#ifndef _XSOCKIO_H_
#define _XSOCKIO_H_

#ifdef SOCKETSERVER
#include <string.h>
#ifndef WIN32
#include <unistd.h>
#endif
#include "object.h"

extern int sock;
extern int oldClientVersion;      // flag to distinguish between old and new server

/*
    replaces the standard ostream class for the socket server.
    Purpose is to send the output through the socket.

    TTK, 2.5.97
*/

long readLineFromSocket (char *, long, int doExit = TRUE);

void sockin  (long &d);
void sockin  (double &d);
void sockin  (char *s);

void sockout (double d, const char *fmt = "%5.5lg");
void sockout (long d, const char *fmt = "%ld");
void sockout (unsigned long d, const char *fmt = "%lu");
void sockout (const char *d);
void sockout (const char c);
void sockout (XplDouble &x, const char *varstr, char *str = NULL);

#ifdef _XPLCDEF_
void sockout (XplChar &x, const char *varstr, char *fst = NULL);
#endif

#endif

#endif
