/* $Header: /home/xplore/cvs/xpl4gr/display.h,v 1.4 2002/10/31 18:23:24 cizek Exp $ */

#ifndef _DISPLAY_H
#define _DISPLAY_H

#include "main.h"
#include "xplmat.h"

class SubDisplay;

enum DispType {	DISPLAY, UDISPLAY, JDISPLAY, WDISPLAY};

class XplDisplay	{

protected:

	char *name;

	DispType type;
	
	XplMatrix vertical;	//z.b. {25, 25, 25, 25} fuer 4 spalten
	XplMatrix horizontal;	//z.b. {25, 25, 25, 25} fuer 4 zeilen

	int width;
	int height;

	int x;
	int y;

	SubDisplay * *content;	//was ist da drin???? 
				//vector zeigt auf zeigers. Nachdenken!
public:
	XplDisplay();
	XplDisplay(const XplDisplay &);
	XplDisplay(const XplDisplay *);
	XplDisplay(XplDouble hori, XplDouble veri);
	virtual ~XplDisplay();

	DispType WhatIs() const 	{	return(type);	}

	virtual SubDisplay* GetElement(int x=1, int y=1) const;
	virtual void SetElement(const Liste <XplObject *> * data_list,
		int x=1, int y=1);
	void Resize(int width, int height);
        // PC 20021031 - new for set/get/size/pos
	virtual void DoWinResize(int width, int height) {};
	virtual void DoWinPosition(int width, int height) {};
        virtual int GetWinWidth() { return width; };
        virtual int GetWinHeight() { return height; };
        virtual int GetWinTop() {};
        virtual int GetWinLeft() {};

	char * GetName() const;
	virtual void SetName(const char *);

	virtual void Print(const char * fname=NULL) const;

	int GetRows();
	int GetColumns();
	int GetWidth();
	int GetHeight();
	int GetElementWidth(int i, int j) const;	//	i,j=1....
	int GetElementHeight(int i, int j) const;	//	i,j=1....
	int GetElementTopPosition(int i, int j) const;	//	i,j=1....
	int GetElementBottomPosition(int i, int j) const;
	int GetElementLeftPosition(int i, int j) const;
	int GetElementRightPosition(int i, int j) const;

	void SetVertical(XplMatrix &v);		//noch nicht fertig!
	void SetHorizontal(XplMatrix &h);	//noch nicht fertig!

   void XUpdate(); 	//ein tritt in ....

			};	//end of class

#endif

