/* $Header: /home/xplore/cvs/xpl4gr/ed_axis.C,v 1.4 2003/05/23 15:36:39 cizek Exp $ */

#include "main.h"
#include "color.h"
#include "uplot.h"
#include "plot.h"
#include "xplore_strings.h"

#ifdef _GUIDO_
extern	int starttime;
extern	char *gformat;
extern char *gfname;
#endif

#ifdef _UNIX_

extern int which_font(int);
extern "C"	{

extern Liste <XplSymbol *> all_symbols;

extern BS_Glob_Variable bs_glob_variable;

extern GC every_gc;

//extern XFontStruct *every_font_info[];


struct Contr_AxisBord_Struct
		{	int axis_num;
			Widget x_col;
			Widget y_col;
			Widget axis_min;
			Widget axis_step;
			Widget m_wid;
			Widget k_wid;
			Widget current;
		};

extern void wrefresh(Widget);
extern void redraw_part(Widget , Dimension, Dimension, Dimension, Dimension);
extern void axisCB(Widget, XtPointer, XtPointer);

void clear_part(Widget , Dimension, Dimension, Dimension, Dimension);

void unmanage_itCB(Widget w, XtPointer p1, XtPointer p2)
{	XtPointer pp;
	XtVaGetValues(w, XmNuserData, &pp, NULL);
	if (pp==NULL)
		return;
	XtUnmanageChild( (Widget) pp);
}
void axis_change(Wid_Data *, Widget );
void axis_changeCB(Widget prodia, XtPointer p1, 
		XmSelectionBoxCallbackStruct* cbs);
void draw_axis(Widget draw);
extern Widget dialog;

void read_axis_numCB(Widget, XtPointer, XtPointer);

Widget init_axisborders_menu()
{	Widget lab, te, rc, kiste, pulldown, button, option;
	struct Contr_AxisBord_Struct *info;
	
	info= (Contr_AxisBord_Struct *)
			XtMalloc(sizeof(Contr_AxisBord_Struct));		
	XtUnmanageChild(XmSelectionBoxGetChild(
		dialog, XmDIALOG_SELECTION_LABEL));
	XtUnmanageChild(XmSelectionBoxGetChild(
		dialog, XmDIALOG_TEXT));
	
	kiste=XtVaCreateWidget("kiste", 
				xmRowColumnWidgetClass, dialog, NULL);
				
	pulldown= XmCreatePulldownMenu(kiste, "pulldown",
				(Arg *)NULL, 0);
	button=XtVaCreateManagedWidget("ax_1",
				xmPushButtonWidgetClass, pulldown, NULL);
	info->x_col=button;
	XtAddCallback(button, XmNactivateCallback, 
				read_axis_numCB, (XtPointer)info);

	button=XtVaCreateManagedWidget("ax_2",
				xmPushButtonWidgetClass, pulldown, NULL);
	info->y_col=button;
	XtAddCallback(button, XmNactivateCallback, 
				read_axis_numCB, (XtPointer)info);

	option=XmCreateOptionMenu(kiste, "axis_option",
				(Arg *) NULL, 0);
	XtVaSetValues(option, XmNsubMenuId, pulldown, NULL);
	XtManageChild(option);	
		
	rc=XtVaCreateWidget("rowcol", 
				xmRowColumnWidgetClass, kiste,
				XmNorientation, XmVERTICAL,
				XmNpacking, XmPACK_COLUMN,
				XmNnumColumns, 2,
				NULL);
//	create labels 

	lab=XtVaCreateManagedWidget("axis_lab_2", 
				xmLabelWidgetClass, rc, NULL);
	lab=XtVaCreateManagedWidget("axis_lab_3", 
				xmLabelWidgetClass, rc, NULL);
	lab=XtVaCreateManagedWidget("axis_lab_4", 
				xmLabelWidgetClass, rc, NULL);
	lab=XtVaCreateManagedWidget("axis_lab_5", 
				xmLabelWidgetClass, rc, NULL);
//	and text	

	info->axis_num=0;	//default

	te=XtVaCreateManagedWidget("te_field", 
				xmTextFieldWidgetClass, rc,
				NULL);
	info->axis_min=te;
	te=XtVaCreateManagedWidget("te_field", 
				xmTextFieldWidgetClass, rc,
				NULL);
	info->axis_step=te;
	te=XtVaCreateManagedWidget("te_field", 
				xmTextFieldWidgetClass, rc,
				NULL);
	info->m_wid=te;
	te=XtVaCreateManagedWidget("te_field", 
				xmTextFieldWidgetClass, rc,
				NULL);
	info->k_wid=te;
	info->current=NULL;	//welche draw???
			
	XtVaSetValues(rc, XmNuserData, info, NULL);
	XtVaSetValues(dialog, XmNuserData, info, NULL);
	XtAddCallback(dialog, XmNokCallback, axis_changeCB, 
				(XtPointer) info);  
	XtManageChild(rc);
	XtManageChild(kiste);
	return(rc);
}


void read_axis_numCB(Widget ax, XtPointer p1, XtPointer p2)
{	String nam;
	char str[32];
	int num;
	struct Contr_AxisBord_Struct *info=(Contr_AxisBord_Struct *)p1;
	Widget draw=info->current;
	Wid_Data *wi_da;
	
	XtVaGetValues(draw, XmNuserData, &wi_da, NULL);
	nam=XtName(ax);
	if (strcmp(nam, "ax_1"))
	{	if (strcmp(nam, "ax_2"))
		{	globalError.Set (ERR_INTERN, "axis_error");
		globalError.ShowError();
			return;
		}
		else
			info->axis_num=1;
	}
	else
		info->axis_num=0;
	num=info->axis_num;
		
	Vector <float> acontent;
	Achse ach=((Plot *)(wi_da->subdis))->GetAchse(num+1);
	acontent=ach.GetContent();
	
	sprintf(str, "%g", acontent[2]);
	XmTextFieldSetString(info->axis_min, str);

	sprintf(str, "%g", acontent[3]);
	XmTextFieldSetString(info->axis_step, str);

	sprintf(str, "%g", acontent[5]);
	XmTextFieldSetString(info->m_wid, str);

	sprintf(str, "%g",acontent[6]);
	XmTextFieldSetString(info->k_wid, str);
	return;
}
void axisborder_ausgeben(Widget push, XtPointer p1, XtPointer p2)
{ 	Widget draw=(Widget) p1;
	struct Contr_AxisBord_Struct *info;
	Wid_Data *wi_da;
	char str[12];
	int x, y, n, xx, yy, i, j, dim;
	Window dummyW;
	int dummyI;
	unsigned int dummyII;
	XmString xms;
	Achse a_da(0, 0, 0);
	XplMatrix rotpoint;
	
	XtVaGetValues(draw, XmNuserData, &wi_da, NULL);
	
	XtVaGetValues(dialog, XmNuserData, &info, NULL);
		
	rotpoint=((Plot *)(wi_da->subdis))->GetRotationCosinus();
	
	dim=rotpoint.rows();

#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	Plot * p=(Plot *)(wi_da->subdis);
	char name[64], line[64];;
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
		sprintf(line, "CLICK\tEditAxis");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif

#ifdef _BLABLA_
	for (i=0; i<dim; i++)
		((Plot *)(wi_da->subdis))->GetAchse(i+1).Out();
#endif	
	for (i=0; i<dim; i++)
		for (j=0; j<dim; j++)
		{	if (! (rotpoint(i,j)==0 || rotpoint(i,j)==1) )
				break;
			if ( rotpoint(i,j)==1 &&  j==0)
				xx=i;
			if ( rotpoint(i,j)==1 &&  j==1)
				yy=i;
		}
	if (! (i==dim && j==dim))
		// plot ist verdreht!	
		{	globalError.Set (ERR_INTERN, "Plot ist verdreht!");
		globalError.ShowError();
			return;
		}
		
	n=info->axis_num;
	if (n==0)
	 	a_da=((Plot *)(wi_da->subdis))->GetAchse(xx+1);
	 else
	 	a_da=((Plot *)(wi_da->subdis))->GetAchse(yy+1);

	sprintf(str, "X: %d. column", xx+1);
	xms=XmStringCreateSimple(str);
	XtVaSetValues(info->x_col, XmNlabelString, xms, NULL);

	sprintf(str, "Y: %d. column", yy+1);
	xms=XmStringCreateSimple(str);
	XtVaSetValues(info->y_col, XmNlabelString, xms, NULL);
	
	
	Vector <float> acontent=a_da.GetContent();
	sprintf(str, "%g", acontent[2]);
	XmTextFieldSetString(info->axis_min, str);

	sprintf(str, "%g", acontent[3]);
	XmTextFieldSetString(info->axis_step, str);

	sprintf(str, "%g", acontent[5]);
	XmTextFieldSetString(info->m_wid, str);

	sprintf(str, "%g",acontent[6] );
	XmTextFieldSetString(info->k_wid, str);

	info->current=draw;	//jetzt wissen wir, welche!
	
 	XQueryPointer(XtDisplay(push), XtWindow(push),
				&dummyW, &dummyW,
				&x, &y, &dummyI,
				&dummyI, &dummyII);
	XtVaSetValues(dialog, XmNx, (Position)x, 
				XmNy, (Position)y, NULL);
	
	XtManageChild(dialog);

#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "AxisW\tOPENED");
	fclose(gfile);
#endif
}

extern "C" void draw_text(Widget draw);
void head_ausgebenCB(Widget push, XtPointer p1, XtPointer p2)
{	
	Wid_Data *wi_da;
	XmString on, off;
	Widget draw=(Widget) p1;
	Dimension wi, he;
	
	XtVaGetValues(draw, XmNuserData, &wi_da, XmNwidth, &wi, 
				XmNheight, &he, NULL);
	Plot *p=(Plot *)(wi_da->subdis);
	
	on=XmStringCreateSimple("Headline on");
	off=XmStringCreateSimple("Headline off");
	p->head_on=! (p->head_on);
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];;
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	if (p->head_on)
		sprintf(line, "CLICK\tHeadlineOn");
	else
		sprintf(line, "CLICK\tHeadlineOff");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
	if (p->head_on)
	{	draw_text(draw);
		XtVaSetValues(push, XmNlabelString, off, NULL);
	}
	else
		XtVaSetValues(push, XmNlabelString, on, NULL);
	p->Refresh();
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	if (p->head_on)
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "HeadlineOn");
	 else
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "HeadlineOff");	 
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "REFRESH");
	fclose(gfile);
#endif
	XmStringFree(on);	//OK
	XmStringFree(off);	//OK
}
void set_headlineCB(Widget dialog, XtPointer p1, XtPointer p2)
{	//p1 ist leer!!!!
	XtPointer pp;
	XmString str;
	XtVaGetValues(dialog, XmNtextString, &str, 
			XmNuserData, &pp, NULL);
	Widget draw=(Widget) pp;
	
	//	cout<<XtName(draw)<<endl;
	
	char * tstr;
	Wid_Data *wi_da;
	XtVaGetValues(draw, XmNuserData, &wi_da, NULL);

	XmStringGetLtoR(str, XmSTRING_DEFAULT_CHARSET, &tstr);
	((Plot *)(wi_da->subdis))->SetHeadline(tstr);	
	draw_text(draw);
#ifdef _GUIDO_
		FILE *gfile;
	char *ndis;
	char name[64], line[64];
	Plot *p=(Plot *)(wi_da->subdis);
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "HeadW\tCLICK\tOK\t%s", tstr);
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	sprintf(line, "HeadW\tCLOSED");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, line);
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "REFRESH");
	fclose(gfile);
#endif
	delete tstr;
}	
void head_changeCB(Widget push, XtPointer p1, XtPointer p2)
{	
	Wid_Data *wi_da;
	XtPointer pp;

	Widget draw=(Widget) p1;
	static Widget head_dialog=NULL;
	XmString str;
	
	XtVaGetValues(draw, XmNuserData, &wi_da, NULL);
	if (head_dialog==NULL)
	{	head_dialog=XmCreatePromptDialog(bs_glob_variable.main_shell, "head_di",
				(Arg *) NULL, 0);
		XtAddCallback(head_dialog, XmNokCallback, 
				set_headlineCB, (XtPointer) NULL);
		XtVaSetValues(push, XmNuserData,
			(XtPointer) head_dialog, NULL);
	}	
	
	Plot *plot=(Plot *)(wi_da->subdis);
	char *hl=plot->GetHeadline();

#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];;
	XplDisplay *xpld=plot->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, plot->GetY(), plot->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "CLICK\tEditHeadline");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
	str=XmStringCreateSimple(hl);
	XtVaSetValues(head_dialog, 
		XmNtextString, str, XmNuserData, (XtPointer) draw, NULL);
	XmStringFree(str);	//OK
	delete hl;
	
	XtManageChild(head_dialog);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "HeadW\tOPENED");
 
	fclose(gfile);
#endif
}


Widget init_window_menu(Widget draw, Widget menu, Boolean on)
{	Widget win_menu, but, under_menu;
	XmString str;
	
	win_menu=XmCreatePulldownMenu(menu, "window_menu",
				(Arg *) NULL, 0);

	but=XtVaCreateManagedWidget("window_menu_1", 
				xmPushButtonWidgetClass, win_menu, NULL);
	XtAddCallback(but, XmNactivateCallback, 
				head_ausgebenCB, XtPointer(draw)); 

	str=on ? XmStringCreateSimple("Hide Axis") : 
		XmStringCreateSimple("Show Axis");
	but=XtVaCreateManagedWidget("window_menu_2", 
				xmPushButtonWidgetClass, win_menu, NULL);
	XtVaSetValues(but, XmNlabelString, str, NULL);
	XmStringFree(str);	//OK
		
	XtAddCallback(but, XmNactivateCallback, axisCB, XtPointer(draw)); 

	but=XtVaCreateManagedWidget("window_menu_3", 
				xmPushButtonWidgetClass, win_menu, NULL);
	XtAddCallback(but, XmNactivateCallback, 
				head_changeCB, XtPointer(draw)); 
	XtAddCallback(but, XmNdestroyCallback, 
				unmanage_itCB, XtPointer(NULL)); 
	XtVaSetValues(but, XmNuserData, (XtPointer) NULL, NULL);

	but=XtVaCreateManagedWidget("window_menu_4", 
				xmPushButtonWidgetClass, win_menu, NULL);
	XtAddCallback(but, XmNactivateCallback,
				axisborder_ausgeben, XtPointer(draw));

	//cout<<"it was init_window_menu"<<endl; 
	return(win_menu);
}

void axis_changeCB(Widget prodia, XtPointer p1, 
		XmSelectionBoxCallbackStruct* cbs)
{	String str;	
	float min, step, m, k;
	int n, xx, yy, i;
	Widget draw;
	Wid_Data * wi_da;
	struct Contr_AxisBord_Struct *info;

	if (! cbs->reason==XmCR_OK)
		return;

	info=(Contr_AxisBord_Struct *)p1;
	draw=info->current;
	XtVaGetValues(draw, XmNuserData, &wi_da, NULL);
	
	n=info->axis_num;

	XplMatrix rotpoint=((Plot *)(wi_da->subdis))->GetRotationCosinus();
	
	int dim=rotpoint.rows();
	
	for (i=0; i<dim; i++)
	{	if (rotpoint(i,0)==1)
		{	xx=i;
			break;
		}
	}
	if (i==dim)	//verdreht!
		return;
	for (i=0; i<dim; i++)
	{	if (rotpoint(i,1)==1)
		{	yy=i;
			break;
		}
	}
	if (i==dim)	//verdreht!
		return;

	if (n==0)
		n=xx;
	else
		n=yy;
	
	str=XmTextFieldGetString(info->axis_min);
	if (! sscanf(str, "%g", &min)==1)
	{	//cout<<"axis_change_error"<<endl;
		return;
	}

	str=XmTextFieldGetString(info->axis_step);
	if (! sscanf(str, "%g", &step)==1)
	{	//cout<<"axis_change_error"<<endl;
		return;
	}

	str=XmTextFieldGetString(info->m_wid);
	if (! sscanf(str, "%g", &m)==1)
	{	//cout<<"axis_change_error"<<endl;
		return;
	}

	str=XmTextFieldGetString(info->k_wid);
	if (! sscanf(str, "%g", &k)==1)
	{	//cout<<"axis_change_error"<<endl;
		return;
	}

#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];
	Plot *p=(Plot *)(wi_da->subdis);
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	sprintf(line, "AxisW\t%d\tCLICK\tOk\t%g\t%g", n, min, step);
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
	Achse ach=((Plot *)(wi_da->subdis))->GetAchse(n+1);
	ach.SetTicks(min, step, step/5);
	ach.SetValues(m, k);
	((Plot *)(wi_da->subdis))->SetAchse(ach);
	wrefresh(draw);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, line);
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "REFRESH");
	fclose(gfile);
#endif

}	
void DrawStringVertical(Display *dis, Window win, Pixmap pixy, 
			XFontStruct *font_info, GC gc, 
			Pixel background, Pixel foreground,
 			Dimension x, Dimension y, char *string)
{	XImage *vor,  *nach;
	Dimension text_wi, text_he;
	int le, i, j, depth;
	Pixmap little;
	XWindowAttributes wa;
	
	//cout<<"Vert: "<<string<<endl;


	if (XGetWindowAttributes(dis, win, &wa)==0)
	{	//cout<<"NULL!"<<endl;
		return;
	}
	
	switch (wa.map_state)
	{	case IsViewable: 
		//	//cout<<"IsViewable"<<endl;
			break;
		case IsUnmapped: 
		//	//cout<<"IsUnmapped"<<endl;
			return;
		case IsUnviewable: 
		//	//cout<<"IsUnviewable"<<endl;
			return;
	}	

	le=strlen(string);
	text_wi=XTextWidth(font_info, string, le);
	text_he=font_info->descent+font_info->ascent;

	depth=DefaultDepth(dis, DefaultScreen(dis));
	
	nach=XGetImage(dis, pixy, 0,0, text_he, text_wi, AllPlanes, XYPixmap);
	if (nach==NULL)
	{	//cout<<"NULL!"<<endl;
		return;
	}
	little=XCreatePixmap(dis,
			pixy,
			text_wi+1, text_he+1, depth);
	XSetForeground(dis, gc, background);
	XSetFunction(dis, gc, GXcopy);

	XFillRectangle(dis, little, gc, 0, 0, text_wi, text_he);	
	XSetForeground(dis, gc, BlackPixel(dis, DefaultScreen(dis)));
	XDrawString(dis, little, gc, 0, font_info->ascent, string, le);
	
	vor=XGetImage(dis, little, 0,0, text_wi, text_he, AllPlanes, XYPixmap);
	
	for (i=0; i<text_wi; i++)
		for (j=0; j<text_he; j++)
			XPutPixel(nach, j, text_wi-i-1, XGetPixel(vor, i, j));

	XSetFunction(dis, gc, GXcopy);

	XPutImage(dis, pixy,	gc, nach, 
			0, 0 ,x-text_he, y-text_wi/2, text_he, text_wi);
	XDestroyImage(vor);
	XDestroyImage(nach);
	//vor->data=NULL;
	//nach->data=NULL;
	XFreePixmap(dis, little);
	//XSetFunction(dis, gc, GXcopy);
}
inline int sqr_distanz(MyPoint &x, MyPoint &y)
{	
	int i, j;
	i=x.x-y.x;
	i*=i;
	j=x.y-y.y;
	j*=j;
	return(i+j);
}

extern Liste <XplColor *> all_colors;



void draw_axis(Widget draw)
{	Window win, root;
	Display *dis;
	Dimension wi, he;
	int i, dim, j, tm_count, text_wi;
	
	Pixel bg, fg;
	Wid_Data *wi_da;
	Achse ax_da(0, 0, 0), ay_da(0, 0, 0);
	Vector <float> xcontent, ycontent;
	Plot *plot;
	MyPoint von, bis, tima;
	XplMatrix do_von, do_bis, do_tima, rotcos, secsk;
	float origin, x_origin, y_origin, tm;
	char zahl[256];
	char * astring;
	XplMatrix xoffset, yoffset;
	char *axis_text;


#ifdef _BLABLA_
	cout<<"draw_axis fuer "<<XtName(draw)<<endl;
#endif

	win=XtWindow(draw);
	dis=XtDisplay(draw);
	
	XWindowAttributes wa;
	
	if (XGetWindowAttributes(dis, win, &wa)==0)
	{	//cout<<"NULL!"<<endl;
		return;
	}
	
	switch (wa.map_state)
	{	case IsViewable: 
			break;
		case IsUnmapped: 
			return;
		case IsUnviewable: 
			return;
	}	

	XtVaGetValues(draw, XmNuserData, &wi_da,
	 		XmNwidth, &wi, XmNheight, &he, 
	 		XmNforeground, &fg,
	 		XmNbackground, &bg, NULL);
	plot=(Plot *)(wi_da->subdis);
	if ( !(plot->axis_on) ) 
			return;

	
	XSetLineAttributes(dis, wi_da->bitmap_gc, 
				2, LineSolid, 
				CapRound, JoinRound);
	
	XSetForeground(dis, wi_da->bitmap_gc, 
				BlackPixel(dis, DefaultScreen(dis)));
	XSetBackground(dis, wi_da->bitmap_gc, 0);
	XSetFunction(dis, wi_da->bitmap_gc, GXcopy);
	
	plot=((Plot *)(wi_da->subdis));
	dim=plot->GetDimension();
	do_von=plot->GetRotationPoint();
	do_bis=plot->GetRotationPoint();
	do_tima=plot->GetRotationPoint();
		//nur wegen dimension???

	rotcos=plot->GetRotationCosinus();
	int which_x, which_y;
	XplMatrix timm;
	
	for (i=0; i<dim; i++)
	{	for (j=0; j<dim; j++)
		{	if (! (rotcos(i,j)==0 || rotcos(i,j)==1) )
			{	//cout<<"ist nicht 0 oder 1!"<<endl;
				break;
			}
			if ( rotcos(i,j)==1 &&  j==0)
				which_x=i;
			if ( rotcos(i,j)==1 &&  j==1)
				which_y=i;
		}
		if (j<dim)
			break;
	}

	XFontStruct *font_info=NULL;
	font_info=XLoadQueryFont(dis, XMSG_UNIXFONT_TIMES14_STR);
	XSetFont(dis, wi_da->bitmap_gc, font_info->fid);

	if (i==dim && j==dim)
		// plot ist nicht verdreht!
	{			
#ifdef _BLABLA_	
	cout<<"draw_axis::::OK!"<<endl;
#endif	
		ax_da=((Plot *)(wi_da->subdis))->GetAchse(which_x+1);
		ay_da=((Plot *)(wi_da->subdis))->GetAchse(which_y+1);

		xcontent=ax_da.GetContent();
		ycontent=ay_da.GetContent();
		
		do_von.fill(0.0);	//eine ecke

#ifdef _BLABLA
		cout<<"x: from-to: "<<xcontent[0]<<
		", "<<xcontent[1]<<endl;

		cout<<"y: from-to: "<<ycontent[0]<<
			", "<<ycontent[1]<<endl;
#endif
		do_von(0, which_x)=xcontent[0];
		do_von(0, which_y)=ycontent[0];
		
		do_bis.fill(0.0);
		do_bis(0, which_x)=xcontent[1];
		do_bis(0, which_y)=ycontent[1];
		
		von=plot->GetImage(do_von);
		bis=plot->GetImage(do_bis);
			
//	cout<<von.x<<", "<<von.y<<", "<<bis.x<<", "<<bis.y<<endl;
														
		xoffset=plot->GetHOffset();
		yoffset=plot->GetVOffset();


	clear_part(draw, 0, 0, wi, bis.y);
		clear_part(draw, 0, 0, von.x, he);
		clear_part(draw, 0,
				von.y, wi, he);
		clear_part(draw, bis.x,
				0, wi, he);

	XSetForeground(dis, wi_da->bitmap_gc,
				BlackPixel(dis, DefaultScreen(dis)));
	XSetBackground(dis, wi_da->bitmap_gc, 0);
	XSetFunction(dis, wi_da->bitmap_gc, GXcopy);
		//cout<<"Plot ist nicht verdreht!"<<endl;

//   if (plot->xaxisline || plot->yaxisline)	// PC 001206
//  	  XDrawRectangle(dis, wi_da->pixy, wi_da->bitmap_gc,
//	    	von.x, bis.y, bis.x-von.x, -bis.y+von.y);

// PC 001206 - plotting line by line
     if (plot->xaxisline)
     {
   	   XDrawLine(dis, wi_da->pixy, wi_da->bitmap_gc,
	    		von.x, von.y, bis.x, von.y);
   	   XDrawLine(dis, wi_da->pixy, wi_da->bitmap_gc,
	    		bis.x, bis.y, von.x, bis.y);
     }
     if (plot->yaxisline)
     {
   	   XDrawLine(dis, wi_da->pixy, wi_da->bitmap_gc,
	    		von.x, von.y, von.x, bis.y);
   	   XDrawLine(dis, wi_da->pixy, wi_da->bitmap_gc,
	    		bis.x, bis.y, bis.x, von.y);
     }

	if ((!plot->bottom_frame_visible()) &&
		(!plot->left_frame_visible()) )
			return;
		
		x_origin=xcontent[2];
		while (x_origin<do_von(0, which_x))
			x_origin=x_origin+xcontent[3];
			
#ifndef _SWETEST_
		while (x_origin>do_von(0, which_x)+xcontent[3])
			x_origin=x_origin-xcontent[3];
#endif		
		y_origin=ycontent[2];
		while (y_origin<do_von(0, which_y))
			y_origin=y_origin+ycontent[3];
#ifndef _SWETEST_
		while (y_origin>do_von(0, which_y)+ycontent[3])
			y_origin=y_origin-ycontent[3];
#endif		
	
		do_tima.fill(0.0);
		do_tima(0, which_x)=x_origin;

		
		char font_name[124];
		int which;
		
		which=-1;
				
		if ( 	plot->bottom_frame_visible() &&
			plot->left_frame_visible())
			//beide sichtbar!
		{	which=xoffset(0,0)*wi>yoffset(0,1)*he ? 
			(int)(yoffset(0,1)*he*TICK_STRING_HEIGHT/100.0+0.5) :
			(int)(xoffset(0,0)*wi*TICK_STRING_HEIGHT/100.0+0.5);
		}

		if (plot->bottom_frame_visible() && 
		 (!plot->left_frame_visible()))	//only bootom achse
		{	which=
			(int)(yoffset(0,1)*he*TICK_STRING_HEIGHT/100.0+0.5);
		}
		
		if ( (!plot->bottom_frame_visible()) && 
		 	plot->left_frame_visible())	//only bootom achse
		{	which=
			(int)(xoffset(0,0)*wi*TICK_STRING_HEIGHT/100.0+0.5);
		}

		//cout<<"fontgroesse="<<which<<endl;

			sprintf(font_name, 
			((UPlot *) plot)->GetUnixFontName(), // PC 20010703: "-*-times-medium-r-*--%d-*-*-*-*-*-*-*",
				which);
			XFreeFont(dis, font_info);
			font_info=XLoadQueryFont(dis, font_name);
			if (font_info== NULL)
			{	cerr<<" fonterror by "<<font_name<<endl;
				font_info=XLoadQueryFont(dis,
			 	DEFAULT_FONT);
			}
			//else
				//cout<<"font geholt: "<<font_name<<endl;
			XSetFont(dis, wi_da->bitmap_gc, font_info->fid);


		int right_end_of_mark=0;
		while(!( do_tima(0, which_x)>do_bis(0, which_x)) && plot->xtickmarks) // PC 001206
		{	tima=plot->GetImage(do_tima);				
			//tima.x+=AXIS_OFFSET;
			//tima.y-=AXIS_OFFSET;
			XDrawLine(dis, wi_da->pixy, wi_da->bitmap_gc,
				tima.x, von.y, tima.x, von.y+
			(int)(yoffset(0,1)*he*TICK_HEIGHT/100.0+0.5));
			XDrawLine(dis, wi_da->pixy, wi_da->bitmap_gc,
					tima.x, bis.y, 
					tima.x, bis.y-
			(int)(yoffset(0,0)*he*TICK_HEIGHT/100.0+0.5));
									
			tm=(do_tima(0,which_x)-xcontent[5])/
				xcontent[6];
			sprintf(zahl, AXIS_FORMAT, tm);
				prepare_string(zahl);
				text_wi=XTextWidth(font_info, 
				zahl, strlen(zahl));

			if (plot->bottom_frame_visible()
				&& right_end_of_mark<tima.x-text_wi/2)
			{					XDrawString(dis, wi_da->pixy, wi_da->bitmap_gc,
				tima.x-text_wi/2, 
				von.y+(int)(yoffset(0,1)*he/100.0*(TICK_STRING_HEIGHT+TICK_HEIGHT)+0.5), 
				zahl,
				strlen(zahl));
				right_end_of_mark=tima.x+text_wi/2;
			}
			do_tima(0, which_x)=do_tima(0, which_x)+
				xcontent[3];
			
		}

	//	string m+0.001*x
		if (plot->bottom_frame_visible() && plot->xtickmarks) // PC 001206
		{	
		/*	axis_text=ax_da.GetString();	
			if (!(xcontent[5]==0 && xcontent[6]==1))
				sprintf(zahl,"%g + %g * %s", xcontent[5],
					xcontent[6], axis_text);
				else
					sprintf(zahl, "%s", axis_text);
			delete axis_text;
		*/
			astring=axisstring(plot, 1);
			text_wi=XTextWidth(font_info, 
				zahl, strlen(astring));
			XDrawString(dis, wi_da->pixy, wi_da->bitmap_gc,
		 		wi/2-text_wi/2, 
				he-3,
				astring,
				strlen(astring));
			delete astring;	
		}

		do_tima.fill(0.0);
		do_tima(0, which_y)=y_origin;

		
		int top_end_of_mark=he;
					
		while(!( do_tima(0, which_y)>do_bis(0, which_y)) && plot->ytickmarks) // PC 001206
		{	tima=plot->GetImage(do_tima);
			//tima.x+=AXIS_OFFSET;
			XDrawLine(dis, wi_da->pixy, wi_da->bitmap_gc,
					von.x, tima.y, 
			von.x-(int)(xoffset(0,0)*wi*TICK_HEIGHT/100.0+0.5), 
					tima.y);
			XDrawLine(dis, wi_da->pixy, wi_da->bitmap_gc,
					bis.x, tima.y, 
		bis.x+(int)(xoffset(0,0)*wi*TICK_HEIGHT/100.0+0.5), 
					tima.y);
			tm=(do_tima(0,which_y)-ycontent[5])/
				ycontent[6];
			sprintf(zahl, AXIS_FORMAT, tm);
				prepare_string(zahl);
			text_wi=XTextWidth(font_info, 
				zahl, strlen(zahl));
			if (plot->left_frame_visible() &&
				top_end_of_mark>tima.y+text_wi/2)
			{	DrawStringVertical(dis, win, wi_da->pixy, 
					font_info, wi_da->bitmap_gc, 
					bg, fg, 
				//	von.x-marksize0, tima.y, 
					von.x-(int)(xoffset(0,0)*wi*TICK_HEIGHT/100.0+0.5), tima.y, 
					zahl);
				top_end_of_mark=tima.y-text_wi/2;
			}
			do_tima(0, which_y)=do_tima(0, which_y)+
				ycontent[3];
			
		}
		
		
	//	string m+0.001*x
		if (plot->left_frame_visible() && plot->ytickmarks) // PC 001206
		{	
		/*
			axis_text=ay_da.GetString();
			if (!(ycontent[5]==0 && ycontent[6]==1))
				sprintf(zahl,"%g + %g * %s", ycontent[5],
				ycontent[6], axis_text);
			else
				sprintf(zahl,"%s", axis_text);
			delete axis_text;
		*/
			astring=axisstring(plot, 2);	
			if (XTextWidth(font_info, zahl, strlen(astring))<he)
				DrawStringVertical(dis, win, wi_da->pixy, 
				font_info, wi_da->bitmap_gc, 
				bg, fg,
			//	font_info->ascent+font_info->descent+1,
				font_info->ascent+font_info->descent,
				he/2, astring);
			delete astring;
		}

#ifdef _BLABLA_	
	cout<<"draw_axis::::OK!"<<endl;
#endif	
		XFreeFont(dis, font_info);
		return;
	}
	for (i=0; i<dim; i++)
	{	ax_da=((Plot *)(wi_da->subdis))->GetAchse(1);	// NUR!
		xcontent=ax_da.GetContent();
		do_von=plot->GetRotationPoint();
		secsk=plot->GetFirstSkalierung();
		timm=plot->GetRotationPoint();
		timm.fill(0.0);
		timm(0, i)=xcontent[3]*secsk(0,0)/secsk(i,i);	
		do_bis=do_von+timm;		
		do_tima=do_bis+timm*0.2;		
	
		von=plot->GetImage(do_von);
		bis=plot->GetImage(do_bis);
		tima=plot->GetImage(do_tima);
//		cout<<von.x<<", "<<von.y<<endl;
//		cout<<bis.x<<", "<<bis.y<<endl;
		XDrawLine(dis, wi_da->pixy, wi_da->bitmap_gc, 
				von.x, von.y, bis.x, bis.y);
                // PC 20020320 - 3D axis should have description 1, 2, 3
		//astring=axisstring(plot, i+1);		
		sprintf(zahl, "%d", i+1);
		XDrawString(dis, wi_da->pixy, wi_da->bitmap_gc,
		 		tima.x, 
				tima.y,
				zahl, // astring,
				strlen(zahl)); // strlen(astring));
		//delete astring;			


	}
#ifdef _BLABLA_	
	cout<<"draw_axis::::OK!"<<endl;
#endif	
	XFreeFont(dis, font_info);
	return;
}
	}//ende der "extern C"
#endif
