/* $Header: /home/xplore/cvs/xpl4gr/fileinfo.h,v 1.3 2002/08/16 12:31:42 sigbert Exp $ */

#ifndef _FILEINFO_H_
#define _FILEINFO_H_

#include <string.h>
#include <time.h>

class FileInfo {
public:  FileInfo (const time_t t, const char *n) :
                  timestamp (t), fname (strdup(n)) {}
          ~FileInfo        ()                    { delete[] fname;      }
          const time_t GetTimeStamp (void) const { return (timestamp);  }
          const char*  Name         (void) const { return (fname);      }

          void  SetTimeStamp (const time_t t)    { timestamp = t;       }

          const int   operator< (const FileInfo &r)
	    {
	      return (strcmp (fname, r.fname) < 0);
	    }
          const int   operator> (const FileInfo &r)
	    {
	      return (strcmp (fname, r.fname) > 0);
	    }
 private: time_t timestamp;
          char   *fname;
};

#endif
