/* $Header: /home/xplore/cvs/xpl4gr/global.h,v 1.3 2002/08/16 12:31:42 sigbert Exp $ */

#ifndef XAGLOBAL

#define MAX_XARRAY 8

#define TYPE_UNKNOWN   0x00000000
#define TYPE_STRING    0x00000001
#define TYPE_INT       0x00000100
#define TYPE_LONG      0x00000101
#define TYPE_SHORT     0x00000102
#define TYPE_UINT      0x00000110
#define TYPE_ULONG     0x00000111
#define TYPE_USHORT    0x00000112
#define TYPE_DOUBLE    0x00000200
#define TYPE_LDOUBLE   0x00000201
#define TYPE_FLOAT     0x00000202
#define TYPE_MASK      0x00000300
#define TYPE_TIME      0x00000301

#define XAerror(no)        globalError.Set(no)
#define XAerrort(no, txt)  globalError.Set(no, txt)
#define XAwarning(no)      globalWarning.Set(no)
#define XAwarnt(no,txt)    globalWarning.Set(no, txt)

#define NOMEM       1
#define DIMBIG      2
#define DIMCON      3
#define NONSORT     4
#define DIMELEM     5
#define DIMNEG      6
#define STRBAD      7
#define NOCAST      8
#define NOCONV      9
#define RANGE      10
#define FUNCCALL   11
#define FORMAT     12
#define PARAMFALSE 13
#define STRINGBAD  14
#define ARRAYBAD   15
#define TIMEGRAN   16
#define NOUSE      17
#define NN         18
#define UNEXVAL    19
#define TIES       20
#define NNR        21
#define NOROW      20
#define OBSOLETE   22
#define NOSUPPORT  23
#define INTERN     24
#define LIST		 25
#define NULMEM     26
#define TIME       27

#define OPCON       2000

#define XAGLOBAL   1

#endif







