/* $Header: /home/xplore/cvs/xpl4gr/init1.C,v 1.4 2003/02/23 16:53:02 cizek Exp $ */

#ifdef _GRAPHICS_

#include "main.h"
#include "object.h"
#include "xplpp.h"
#include "plot.h"

/* PC MAC */
#ifndef __APPLE_CC__
#include <stream.h>
#endif

#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>

#include <X11/cursorfont.h>

#ifndef EOF
#define EOF (-1)
#endif

#define UNDO_COUNT 10
#define MAX_LINE_COUNT_TO_VIEW 10
/*extern char * xpl4prog;
extern char * xpl4home;
extern char * xpl4backup;
*/
extern int GenHTML (const char *);

#ifdef _GUIDO_
	extern char * gformat;
	extern int starttime;
	extern char *gfname;
#endif

extern "C" 	{

#include <Xm/List.h>
#include <Xm/Text.h>

extern BS_Glob_Variable bs_glob_variable;

extern	Widget com_wid; 
	
extern Liste<XplObject*> *objList;



Liste <char *> to_destroy;

struct Programm_Save_Struct{	Widget file_text;
				Widget file_name;
				};
struct Editor_Struct	{	Widget line_num;
				Liste <String> *undo_liste;
				};
				
void selected_to_parser(Widget com_hist, XtPointer p, XmListCallbackStruct *cbs)
{	Widget com_text=(Widget) p;
	int i;
	XmString *xms;
	String comstr;
	char com_all[1024];
	
	xms=cbs->selected_items;
	com_all[0]=0;
	if (cbs->selected_item_count==1)		//wie schoen!!
	{	XmStringGetLtoR(xms[0], XmSTRING_DEFAULT_CHARSET, &comstr);
		strcpy(com_all, comstr);
		//	cout<<"SELECTED: 1 Item: "<<com_all<<endl;
		XmTextSetString(com_text, com_all);
		XmListDeselectAllItems(com_text);
		return;
	}
		
	for (i=0; i<cbs->selected_item_count; i++)
	{	XmStringGetLtoR(xms[i], XmSTRING_DEFAULT_CHARSET, &comstr);
		strcat(com_all, comstr);
		strcat(com_all, "\n");
	}	
	//	cout<<"SELECTED:"<<com_all<<"!!!"<<endl;
	XmTextSetString(com_text, com_all);
	XmListDeselectAllItems(com_text);
	//	cout<<"OK?\n";
	return;
}

/*
extern void com_mod_ver(Widget w, XtPointer p1, XtPointer p2)
{	XmTextVerifyCallbackStruct *cbs=(XmTextVerifyCallbackStruct *) p2;	

	if (cbs->reason==XmCR_ACTIVATE)
	{	//cout<<"activate???"<<endl;
		return;
	}
	cout<<"com_mod_ve"<<endl;
	cout<<"count="<<cbs->text->length<<endl;     
	cout<<"Inserted:"<<" and (int)="
			<<(int)(cbs->text->ptr[0])<<endl;
}
*/


void undo_CB(Widget but, XtPointer p1, XtPointer p2)
{	Widget text_w=(Widget) p1;
	struct Editor_Struct * es; 
	
	XtVaGetValues(text_w, XmNuserData, &es, NULL);
	if (es->undo_liste->laenge()==1)
	{	globalError.Set (ERR_INTERN, "Undo is not possible");
		globalError.ShowError();
		return;
	}
	//cout<<"undo_CB vor:liste has "<<undo_liste->laenge()<<" elements\n";
	int pos=XmTextGetCursorPosition(text_w);
	XmTextSetString(text_w, (*(es->undo_liste))[0]);
	es->undo_liste->loesche(0);
	XmTextSetCursorPosition(text_w, pos);
	
	//cout<<"undo_CB mitten:liste has "<<
	//undo_liste->laenge()<<" elements\n";
	
	es->undo_liste->loesche(0);
	
	//cout<<"undo_CB nach:liste has "<<undo_liste->laenge()<<" elements\n";
}


void save_for_undoCB(Widget edit_text, XtPointer xtp1, 
			XmTextVerifyCallbackStruct *cbs)
{	char zei;
	if (cbs->text->length==1)
	{	zei=cbs->text->ptr[0];

#ifdef _BLABLA_
		cout<<"CHAR="<<zei<<", INT="<<(int)(zei)<<endl;
#endif
		if ( ((int)zei<32 || zei> 126) &&
			zei!='\n' && zei!='\t' )
		{	globalError.Set (ERR_INTERN, "Character not allowed!");
		globalError.ShowError();
			cbs->doit=False;
			return;
		}
		if (zei=='\t')
		{	cbs->text->length=2;
			XtFree(cbs->text->ptr);
			cbs->text->ptr=XtMalloc(sizeof(char)*(2+1));
			strcpy(cbs->text->ptr, "  ");
		}
	}
	struct Editor_Struct *es;
	XtVaGetValues(edit_text, XmNuserData, &es, NULL);

	char *str;
	
	str=XmTextGetString(edit_text);
	//cout<<"str by save:"<<str<<"ENDE"<<endl;
	//cout<<"save:liste has "<<es->undo_liste->laenge()<<" elements\n";
	es->undo_liste->fuegeEin(str, 0);
	//cout<<"save:liste has "<<es->undo_liste->laenge()<<" elements\n";
}

void updatelinenumber(Widget edit_text, XtPointer xtp1, 
			XmTextVerifyCallbackStruct *cbs)
{	if (cbs->reason!=XmCR_MOVING_INSERT_CURSOR)
		return;
	if (cbs->currInsert==cbs->newInsert)
		return;
	long i;
	long mini=cbs->currInsert<cbs->newInsert ? cbs->currInsert : 
		cbs->newInsert;
	long maxi=cbs->currInsert>cbs->newInsert ? cbs->currInsert :
		cbs->newInsert;
	struct Editor_Struct *es;
	XtVaGetValues(edit_text, XmNuserData, &es, NULL);
	char *text=XmTextGetString(edit_text);
	char * curr=text+mini;
	i=mini;
	while (i<maxi && curr[0]!='\n')
		curr++, i++;
	if (i==maxi)
	{	XtFree(text);
		return;
	}
	curr=text;
	i=0;
	int line_num=0;
	while (i<cbs->newInsert)
	{	if (curr[0]=='\n')
			line_num++;
		curr++;
		i++;
	}
	//cout<<"new line number: "<<line_num;
	char ln[4];
	sprintf(ln, "%d", line_num+1);
	XmTextSetString(es->line_num, ln);
	XtFree(text);
}
	
extern void text_to_parse(char *str);

void text_executeCB(Widget dialog, XtPointer p1, XtPointer p2)
{	Widget text_w=(Widget) p1;
	char *str;
	
	str=XmTextGetString(text_w);
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "EditW", "CLICK",
			"Execute");
	fprintf(gfile, "%s\n", str);
	fclose(gfile);
#endif	
	//cout<<"text_executeCB: "<<str<<endl;
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "XploRe", "TO PARSE",
			"");
	fprintf(gfile, "%s", str);
	fclose(gfile);
#endif	

	Cursor cursor;
	cursor=XCreateFontCursor(XtDisplay(text_w), XC_spider);
	XDefineCursor(XtDisplay(text_w), XtWindow(text_w), cursor);
	text_to_parse(str);

	cursor=XCreateFontCursor(XtDisplay(text_w), XC_top_left_arrow);
	XDefineCursor(XtDisplay(text_w), XtWindow(text_w), cursor);

#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "XploRe", "PARSED",
			"");
	fclose(gfile);
#endif	
	XtFree(str);
}

void make_helpCB(Widget dialog, XtPointer p1, XtPointer p2)
{	struct Programm_Save_Struct *psv=(Programm_Save_Struct *)p1;
	Widget text_w=psv->file_text;
	Widget file_name=psv->file_name;
	char *str, *file_name_str;
	
	file_name_str=XmTextGetString(file_name);
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "EditW", "CLICK",
			"Make Help");
	fprintf(gfile, "%s", file_name);
	fclose(gfile);
#endif	
	Boolean ja;
	ja=GenHTML(file_name_str);
#ifdef _BLABLA_
	if (ja)
	{	cout<<"help page created"<<endl;
#ifdef _GUIDO_
		FILE *gfile=fopen(gfname, "a+");
		fprintf(gfile, gformat, "S", time(NULL)-starttime, "XploRe", 
		"HELP SUCCEEDED", file_name);
		fclose(gfile);
#endif		
	}
	else
	{	cout<<"help page NOT created"<<endl;
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "XploRe", 
			"HELP FAILED", file_name);
	fclose(gfile);
#endif	
	}
#endif

}


void text_saveCB(Widget dialog, XtPointer p1, XtPointer p2)
{	struct Programm_Save_Struct *psv=(Programm_Save_Struct *)p1;
	Widget text_w=psv->file_text;
	Widget file_name=psv->file_name;
	char *str, *file_name_str, *fls, nfn[160];
	
	str=XmTextGetString(text_w);
	if (strlen(str)==0)
		return;
	file_name_str=XmTextGetString(file_name);
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "EditW", "CLICK",
			"SAVE");
	fprintf(gfile, "%s\n", str);
	fclose(gfile);
#endif	
/*	char *str1=str;
	while (str[0]==' ' || str[0]=='\n')
		if (strlen(str1)>0)
			str1++;
		else 
			break;
	if (strlen(str)==0)
		return;		
*/
	fls=strdup(file_name_str);
	
	int i=0;
	while (i<to_destroy.laenge() && strcmp(fls, to_destroy[i]))
		i++;
	if (i==to_destroy.laenge())
#ifdef _BLABLA_
		cerr<<fls<<" is not in destroy list"<<endl;
#else
		;
#endif
	else
		to_destroy.loesche(i);
	
	FILE *old_f, *bac_f;
//cout << "SK1: " << file_name_str << endl;
	old_f=fopen(file_name_str, "r");
	if ( !(old_f==NULL))
	//copy to bac-file
//	if (xpl4backup==NULL)
	{	sprintf(nfn, "%s", fls);
		fclose(old_f);
	}
/*	else	SK 24.06.98
	{	int la=strlen(fls);
		while ( (!(fls[la-1]=='.')) && (la>0)) 
			la--;
		if (la>0)	//it was  . in the name
			fls[la-1]=0;
			
		sprintf(nfn, "%s.bak", fls);
		la=strlen(nfn);
		while ( (!(nfn[la-1]=='/')) && (la>0)) 
			la--;
		//eigentlich faengt filename am nfn[la]...

		sprintf(nfn, "%s/%s", xpl4backup, nfn+la);
#ifdef _BLABLA_
		cout<<" new name for *.bak is "<<nfn<<endl;
#endif
		fclose(old_f);
		rename(file_name_str, nfn);
	}
*/
//cout << "SK1: " << file_name_str << endl;
	fstream f(file_name_str, ios::out);
	if ( f.bad() )
	{	globalError.Set (ERR_FILE, file_name_str);
		globalError.ShowError();
		XtFree(str);
		return;
	}
	f.write(str, strlen(str));
	f.close();
	//cout<<"text_saveCB: file_name: "<<file_name_str
	//		<<endl<<" Text:"<<str<<endl;

#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "XploRe", "SAVE",
			file_name_str);
	fclose(gfile);
#endif	
	XtFree(str);
	XtFree(fls);
	XtFree(file_name_str);
}
	
void quiteditprogCB(Widget but, XtPointer p1, XtPointer p2)
{	Widget file_text=(Widget) p1;
	struct Editor_Struct *es;
	XtVaGetValues(file_text, XmNuserData, &es, NULL);
#ifdef _BLABLA_
	cout<<"By quit: undo has "<<es->undo_liste->laenge()
	<<" elements"<<endl;
#endif	
	delete (Liste <String> *)(es->undo_liste);
	delete es;
	XtDestroyWidget(XtParent(XtParent(XtParent(file_text))));
	//man sollte auch undo_liste freigeben
}

void quit_shellCB(Widget but, XtPointer p1, XtPointer p2)
{	Widget file_text=(Widget) p1;
	XtDestroyWidget(file_text);
	//man sollte auch undo_liste freigeben
}

void gotoline(Widget but, XtPointer p1, XtPointer p2)
{	char * line=XmTextGetString(but);
	Widget wi=(Widget) p1;

	int line_num, i, from=0, to;
	if (sscanf(line, "%d", & line_num)!=1)
	{	globalError.Set (ERR_INTERN, "no such line!");
		globalError.ShowError();
		XtFree(line);
		return;
	}
	
	char *wo=XmTextGetString(wi);
	XmTextSetHighlight(wi, 
			0, strlen(wo), XmHIGHLIGHT_NORMAL);

	i=1;
	while (i<line_num && from<strlen(wo))
	{	if (wo[from]=='\n')
			i++;
		from++;
	}
	if (from==strlen(wo))
	{	globalError.Set (ERR_INTERN, "no such line!");
		globalError.ShowError();
		XtFree(line);
		XtFree(wo);
		return;
	}
	to=from+1;
	while ( wo[to]!='\n' && to<strlen(wo))
		to++;

#ifdef _BLABLA_
	cout<<line_num<<": from, to "<<(int)from<<", "<<(int)to<<endl;
#endif
	XmTextSetHighlight(wi, 
			from, to, 
			XmHIGHLIGHT_SELECTED);
	XmTextSetInsertionPosition(wi, from);
	XmTextShowPosition(wi, from);
	XtFree(line);
	XtFree(wo);

}

//extern void save_prgCB(Widget w, XtPointer p1, XtPointer p2);

void create_edit_window(const char *textstr, int lines, char *file_name)
{	Widget edit_shell, kiste, menu_line, but, file_text, file_na;
	XmString lst;

	struct Programm_Save_Struct *psv=(Programm_Save_Struct *) 
		XtMalloc (sizeof(Programm_Save_Struct));
	
	char ist[256];
	int ibeg=strlen(file_name);

	//cout<<"create_ed: "<<file_name<<endl;
	//cout<<ibeg<<endl;
	
	
	while (ibeg>-1 && file_name[ibeg]!='/')
		ibeg--;
	sprintf(ist, "%s", file_name+ibeg+1);
		
	//cout<<ist<<endl;

	edit_shell=XtCreatePopupShell(ist, topLevelShellWidgetClass,
				bs_glob_variable.main_shell, (Arg*) NULL, 0);
	kiste=	XtVaCreateManagedWidget("e_kiste", xmFormWidgetClass,
			edit_shell, NULL);				
	menu_line=XtVaCreateManagedWidget("menu_line", 	
				xmRowColumnWidgetClass, kiste,
			 	XmNtopAttachment,XmATTACH_FORM, 
				XmNleftAttachment, XmATTACH_FORM,
	//			XmNrightAttachment, XmATTACH_FORM,
				XmNorientation, XmHORIZONTAL, 
				NULL);
	file_na=XtVaCreateManagedWidget("file_line", 	
				xmTextFieldWidgetClass, kiste,
			 	XmNtopAttachment,XmATTACH_WIDGET, 
				XmNtopWidget, menu_line,
				XmNleftAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				XmNorientation, XmHORIZONTAL, 
				NULL);
	XmTextSetString(file_na, file_name);

        // PC 20010207 : argument for createscrolledtext
        Arg scrtextargs[10] = {
                                   { XmNeditMode, XmMULTI_LINE_EDIT },
                                   { XmNeditable, True },
                                   { XmNscrollingPolicy, XmAUTOMATIC },
                                   { XmNvisualPolicy, XmCONSTANT },
                                   { XmNscrollBarDisplayPolicy, XmSTATIC },
                                   { NULL }
                              };

        // PC 20010207
	file_text=XmCreateScrolledText(kiste, "prog_text", scrtextargs, 5);	
	// file_text=XmCreateScrolledText(kiste, "prog_text", (Arg *)NULL, 0);	
	struct Editor_Struct *es=(struct Editor_Struct*)
			new (struct Editor_Struct);
	es->undo_liste=new Liste <String>;

        /* PC 20010207: all options except for XmNuserData are set above
	XtVaSetValues(file_text, XmNeditMode, XmMULTI_LINE_EDIT,
				XmNeditable, True, 
				XmNuserData, (XtPointer) (es),
				NULL);
        */
	XtVaSetValues(file_text, XmNuserData, (XtPointer) (es), NULL);
	XtVaSetValues(XtParent(file_text), XmNtopAttachment,XmATTACH_WIDGET,
				XmNtopWidget, file_na, 
				XmNleftAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				XmNbottomAttachment, XmATTACH_FORM,
				NULL);
	XtAddCallback(file_text, XmNmodifyVerifyCallback, 
				save_for_undoCB, NULL);
	
	XtAddCallback(file_text, XmNmotionVerifyCallback, 
				updatelinenumber, NULL);
	
	lst=XmStringCreateSimple("Undo");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	XtAddCallback(but, XmNactivateCallback, undo_CB,
				(XtPointer) file_text);
	
	lst=XmStringCreateSimple("Line:");
	but=	XtVaCreateManagedWidget("e_but", xmLabelWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
				
	but=	XtVaCreateManagedWidget("e_but", xmTextWidgetClass,
			menu_line, XmNcolumns, 3, XmNeditable, False, NULL);
	XmTextSetString(but, " 1 ");

	es->line_num=but;

	lst=XmStringCreateSimple("Go to:");
	but=	XtVaCreateManagedWidget("e_but", xmLabelWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
				
	but=	XtVaCreateManagedWidget("e_but", xmTextWidgetClass,
			menu_line, NULL);
	XmTextSetString(but, " 1 ");
	XtVaSetValues(but, XmNcolumns, 3, NULL);
	XtAddCallback(but, XmNactivateCallback, gotoline,
				(XtPointer) file_text);
			
	lst=XmStringCreateSimple("Execute");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	XtAddCallback(but, XmNactivateCallback, text_executeCB,
				(XtPointer) file_text);

	lst=XmStringCreateSimple("Save");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	XtAddCallback(but, XmNactivateCallback, text_saveCB,
				(XtPointer) psv);

	lst=XmStringCreateSimple("Quit");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	XtAddCallback(but, XmNactivateCallback, quiteditprogCB,
				(XtPointer) file_text);			
				
	lst=XmStringCreateSimple("Make Help");
	but=	XtVaCreateManagedWidget("e_but", xmPushButtonWidgetClass,
			menu_line, XmNlabelString, lst, NULL);
	XmStringFree(lst);	//OK
	XtAddCallback(but, XmNactivateCallback, make_helpCB,
				(XtPointer) psv);

        // PC 20010108: parameter setting has to be done first
        //              XmNrows are set later
	int iii, jjj;
	iii=32500;
	jjj=1000;
	XtVaSetValues(file_text, XmNmaxLength, iii, /* PC 2001010207: XmNrows, jjj,*/ NULL);
	XtVaGetValues(file_text, XmNmaxLength, &iii,/* PC 2001010207: XmNrows, &jjj,*/ NULL);
	//cout<<(int)(iii)<<"=i, j="<<jjj<<endl;

        /* PC 20010207: does not make sense
	if (lines==0)
		lines=19;
	if (lines>10)
		XtVaSetValues(file_text, XmNrows, 10, NULL);
	else
		XtVaSetValues(file_text, XmNrows, lines, NULL);	
        */
        XtVaSetValues(file_text, XmNrows, 10, NULL);

        // PC 20010108: has to be done after parameter setting
	char *dummy;
	dummy=strdup(textstr);
	XmTextSetString(file_text, dummy);
	delete dummy;

	XtManageChild(file_text);
	psv->file_name=file_na;
	psv->file_text=file_text;
	XtPopup(edit_shell, XtGrabNone);

#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "EditW", "OPENED",
			file_name);
	fprintf(gfile, "%s", textstr);
	fclose(gfile);

#endif	
	
}


void show_fileCB(Widget fi_sel_dia, XtPointer p1, XtPointer p2)
{	char  str[256], *textstr;
	int n, lines;
	int c, c_past;
	char *dir;
	char * file_name;

	file_name=new char [256];
	textstr=new char [1520];
	
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
#endif	
	if ( strcmp(XtName(fi_sel_dia), "prog_box") )
	{	// cout<<"Neuer File heisst "<<endl;
		//new file load..
#ifdef _GUIDO_
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Program", "CLICK",
			"New");
	fclose(gfile);
#endif	
		Widget fsb=(Widget) p1;
		XmString xms;
		XtVaGetValues(fsb, XmNdirMask, &xms, NULL);
		XmStringGetLtoR(xms, XmSTRING_DEFAULT_CHARSET,
		 	&dir);	
		// z.b. /user/schmelzer/xplore4/prog/*.xpl
		n=strlen(dir);
		while ( dir[n-1]!='/' && n>0)
			n--;
		if (n==0)
		{	globalError.Set (ERR_INTERN, "filter is bad");
		globalError.ShowError();
			return;
		}
		dir[n-1]=0;				
	/*	dir=xpl4prog;
		if (dir==NULL)
			dir=xpl4home;
	*/
		Boolean found=False;
		static int num=1;
		FILE *nf;
		int mal=0;
		
		
		//cout<<" search for new in "<<dir<<endl;
		int eeof;
		while ( (! found ) && (mal<256))
		{	sprintf(file_name, "%s/new%d.xpl",dir, num); 
#ifdef _BLABLA_
			cout<<"ziel="<<file_name<<endl;
#endif
//cout << "SK3: " << file_name << endl;

			nf=fopen(file_name, "r");
			if (!(nf==NULL)) 
			  {	//cout<<"try to read "<<file_name<<endl;
                                eeof=fgetc(nf);
				fclose(nf);
				if (eeof==-1)
				  found=True;
				else
					num++;
				
			}
			else
			{	// cannot close when nf == NULL : fclose(nf);
			        nf=fopen(file_name, "w");
				if (!(nf==NULL))
				{	fclose(nf);
#ifdef _BLABLA_
			cout<<"hurra! "<<filename<<endl;
#endif				
					found=True;
				}
				else 
					num++;
			}
			mal++;
		}	
		if (mal==16)
		  {	globalError.Set (ERR_FILE, file_name);
		  globalError.ShowError();
			return;
		}		 
  		XtPopdown(XtParent(XtParent(fi_sel_dia)));
  		to_destroy.haengeAn(strdup(file_name));
	}
	else
	{	// file load...
#ifdef _GUIDO_
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Program", "CLICK",
			"OK");
	fclose(gfile);
#endif	
		char *ffile_name;
		XmFileSelectionBoxCallbackStruct *cbs=
				(XmFileSelectionBoxCallbackStruct *) p2;
		XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET,
		 	&ffile_name);
		sprintf(file_name, "%s", ffile_name);
		XtFree(ffile_name);
		XtUnmanageChild(fi_sel_dia);
	}
 	//cout<<"fstream with "<<file_name<<endl;
	fstream f(file_name, ios::in);
	if ( f.bad() ) //new file
	  {	lines=1;
	        textstr[0]='\0';
		textstr[1]=0;
	}
	else
	{       n=lines=0;
	        c=f.get();
		c_past='\n';
		while (	! (c==EOF)	)
		{	if (c_past!=c || c_past!='\n')
		{	textstr[n]=c;
			n++;
			if (c=='\n')
				lines++;
		}
		c_past=c;
		c=f.get();
	//cout<<"n="<<n<<", c="<<c<<endl;
		if (n>0 && n%1520==0)
		{
#ifdef _BLABLA_
	cerr<<"Ist das ein groesser file!"<<endl;
#endif
			textstr=(char *)realloc(textstr, sizeof(char)*(n+1520));
		}
		}
		textstr[n]=0;
	}
	create_edit_window(textstr, lines, file_name);
	delete file_name;
	delete textstr;
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Program", "CLOSED", "");
	fclose(gfile);
#endif	
}
extern void unmanageCB(Widget w, XtPointer p1, XtPointer p2);
extern void prog_cancelCB(Widget w, XtPointer p1, XtPointer p2);
void say_it(Widget w, XtPointer p1, XtPointer p2)
{	char *fn=XmTextGetString(w);
	char * textstr;
	int n, lines;
	int c, c_past;
	textstr=new char [1520];
	
	fstream f(fn, ios::in);
	if ( f.bad() )	// kann ja mal passieren....
	{	delete fn;
		return;
	}
	n=lines=0;
	c=f.get();
	c_past='\n';
	while (	! (c==EOF)	)
	{	if (c_past!=c || c_past!='\n')
		{	textstr[n]=c;
			n++;
			if (c=='\n')
				lines++;
		}
		c_past=c;
		c=f.get();
	//cout<<"n="<<n<<", c="<<c<<endl;
		if (n>0 && n%1520==0)
			textstr=(char *)realloc(textstr, sizeof(char)*(n+1520));
		
	}
	textstr[n]=0;
	
	XmTextSetString( (Widget) p1, textstr);
	delete textstr;
	delete fn;
		
}
void show_prog_box(Widget w, XtPointer p1, XtPointer p2)
{	static Widget prog_box=NULL;
	Widget new_pr, pr_text;
	XmString xms;
	
#ifdef _GUIDO_
	FILE *gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Command", "CLICK",
			"Program");
	fclose(gfile);
#endif	
	if (prog_box==NULL)
	{	prog_box=XmCreateFileSelectionDialog(
			bs_glob_variable.main_shell, "prog_box", 
				NULL, 0);
		
		xms=XmStringCreateSimple(NULL);
		XtVaSetValues(prog_box, XmNdirectory, xms, NULL);
		XmStringFree(xms); 	//OK
		XtAddCallback(prog_box, XmNokCallback, show_fileCB, 
					XtPointer(NULL));
		XtAddCallback(prog_box, XmNcancelCallback, prog_cancelCB, 
					XtPointer(NULL));
		pr_text=XmCreateScrolledText(prog_box, "prog_browser",
				(Arg*)NULL, 0);
		XtManageChild(pr_text);
		XtVaSetValues( XmFileSelectionBoxGetChild(prog_box, 
					XmDIALOG_FILTER_LABEL),
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, pr_text, NULL);
		XtVaSetValues(pr_text,
				XmNeditMode, XmMULTI_LINE_EDIT,
				XmNeditable, False, 
				XmNrows, 5, NULL);
		XmTextSetString(pr_text, "   \n \n \n \n    ");
		new_pr=XtVaCreateManagedWidget("New",
				xmPushButtonWidgetClass, prog_box, NULL);
		
		XtAddCallback(new_pr, XmNactivateCallback, show_fileCB, 
					XtPointer(prog_box));
		XtAddCallback(XmFileSelectionBoxGetChild(prog_box, 
					XmDIALOG_TEXT),
					XmNvalueChangedCallback, say_it, 
					XtPointer(pr_text));
	}
	XtManageChild(prog_box);
	XtPopup(XtParent(prog_box), XtGrabNone);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Program", "OPENED", "");
	fclose(gfile);
#endif	
}

void save_log(char *str)
{	Widget file_list=XmCommandGetChild(com_wid, XmDIALOG_HISTORY_LIST);
	XmString *strtable;
	char msg[256];
	int n, count;
	
	if (strchr(str, '.')==NULL)
		str=strcat(str, ".out");
	fstream f(str, ios::out);
	if ( f.bad() )
	{	globalError.Set (ERR_FILE, str);
		globalError.ShowError();
		return;
	}
	
	XtVaGetValues(file_list, XmNitemCount, &count, 
				XmNitems, &strtable, NULL);
	for (n=0; n<count; n++)
	{	XmStringGetLtoR(strtable[n], XmSTRING_DEFAULT_CHARSET, &str);	
		f<<str<<endl;
	}
	
	
	return;
}


	
	}
#endif
