/* $Header: /home/xplore/cvs/xpl4gr/initxa.hpp,v 1.3 2002/08/16 12:31:44 sigbert Exp $ */



#include "xnew.hpp"

#include "xstring.hpp"

#include "xplmask.hpp"



extern double randomval, nrand, iszero;

extern int nset;

extern char filename[2048], xpl4datatok[4096];

// *xpl4data, *outheadline, *outlineno, *outlayerline;

// extern long outmaxdata;

// extern XplStringDatabase xplorebase;  TTK, 28.12.98

extern char *Smonth[12];

extern char *Sday[7]; 

// extern XMemory xmem;   TTK, 19.12.98



void SetNaN (double *X);

void SetNaN (float  *X);

void SetNaN (xplmask *X);

void SetNaN (xplstring *X);

void SetNaN (long *X);

void SetNaN (int *X);



int  isNaN  (double X);

int  isNaN  (float  X);

int  isNaN  (long   X);

int  isNaN  (int    X);

int  isNaN  (short  X);

int  isNaN  (unsigned long  X);

int  isNaN  (unsigned int   X);

int  isNaN  (unsigned short X);

int  isNaN  (xplmask    X);

int  isNaN  (xplstring  X);



void x4sprintf (char *buf, const char*fmt, double X);  

void x4sprintf (char *buf, const char*fmt, float  X);  

void x4sprintf (char *buf, const char*fmt, long   X);        

void x4sprintf (char *buf, const char*fmt, int    X);        

void x4sprintf (char *buf, const char*fmt, short  X);        

void x4sprintf (char *buf, const char*fmt, unsigned long  X);

void x4sprintf (char *buf, const char*fmt, unsigned int   X);

void x4sprintf (char *buf, const char*fmt, unsigned short X);

void x4sprintf (char *buf, const char*fmt, xplmask    X);    

void x4sprintf (char *buf, const char*fmt, xplstring  X);    

void x4fprintf (FILE *buf, const char*fmt, double X);  

void x4fprintf (FILE *buf, const char*fmt, float  X);  

void x4fprintf (FILE *buf, const char*fmt, long   X);        

void x4fprintf (FILE *buf, const char*fmt, int    X);        

void x4fprintf (FILE *buf, const char*fmt, short  X);        

void x4fprintf (FILE *buf, const char*fmt, unsigned long  X);

void x4fprintf (FILE *buf, const char*fmt, unsigned int   X);

void x4fprintf (FILE *buf, const char*fmt, unsigned short X);

void x4fprintf (FILE *buf, const char*fmt, xplmask    X);    

void x4fprintf (FILE *buf, const char*fmt, xplstring  X);    



int  isZero  (double X);

int  isZero  (float  X);

void SetZero (double X);

double GetZero (void);



void SetMin (double *X);

void SetMin (float  *X);

void SetMin (long   *X);

void SetMin (int    *X);

void SetMin (short  *X);

void SetMin (unsigned long   *X);

void SetMin (unsigned int    *X);

void SetMin (unsigned short  *X);



void SetMax (double *X);

void SetMax (float  *X);

void SetMax (long   *X);

void SetMax (int    *X);

void SetMax (short  *X);

void SetMax (unsigned long   *X);

void SetMax (unsigned int    *X);

void SetMax (unsigned short  *X);



long memcopy (xplstring*, xplstring*, long);

long memcopy (long*, long*, long);

long memcopy (double*, double*, long);

long memcopy (int*, int*, long);

long memcopy (char*, char*, long);

long memcopy (xplmask*, xplmask*, long);



// template <class T> xpltypeid (T* x);

long xpltypeid (double *X);

long xpltypeid (float  *X);

long xpltypeid (long   *X);

long xpltypeid (int    *X);

long xpltypeid (short  *X);

long xpltypeid (unsigned long   *X);

long xpltypeid (unsigned int    *X);

long xpltypeid (unsigned short  *X);

long xpltypeid (xplmask    *X);

long xpltypeid (xplstring  *X);



FILE *opendatafile (const char *datei, const char *how);

int removedatafile (const char *datei);



double x4atof (char *tok);



char* format (double *X);  

char* format (float  *X);  

char* format (long   *X);        

char* format (int    *X);        

char* format (short  *X);        

char* format (unsigned long  *X);

char* format (unsigned int   *X);

char* format (unsigned short *X);

char* format (xplmask    *X);    

char* format (xplstring  *X);    



void makefmtstring (char *fmt);

char *maketxtstring (char *separator);

