/* $Header: /home/xplore/cvs/xpl4gr/logfile.C,v 1.3 2002/08/16 12:31:45 sigbert Exp $ */

#include <stdlib.h>
#include <stdio.h>

#include "property.h"
#include "directory.h"
#include "xplio.h"

FILE *xpllog =NULL;
char *logname=NULL;
int firstlog = 1, canopenlog;

void SetLogfileName (const char *ln)       
{ property.setProperty ("logfile", ln); }

int write_to_log(char *parsetext)
{  int canopenlog = 1;
   char text[128], *ln;

   logname = property.getProperty("logfile");
   if ((logname!=NULL) && (strlen(logname)>0))
   { ln = openfile (PROG, logname, (firstlog ? "w+" : "a+"));
     xpllog = fopen (ln, (firstlog ? "w+" : "a+"));
     if (xpllog)
     { fprintf(xpllog, "%s\n", parsetext);
       fclose(xpllog);
     }
     else if (firstlog)
     { sprintf (text, "Warning: Can not open logfile '%s'\r\n", logname); // SK 03.08.98
       xplmessage(text);
     }
     firstlog = 0;
   }
   return (0);
}

void getlogfilename (char *buf)
{ char *ln;
  logname = property.getProperty("logfile");
  if ((logname!=NULL) && (strlen(logname)>0))
  { ln = openfile (PROG, logname, (firstlog ? "w+" : "a+"));
    strcpy (buf, ln);
  }
}
