/* $Header: /home/xplore/cvs/xpl4gr/nnet.hpp,v 1.3 2002/08/16 12:31:47 sigbert Exp $ */



#define N    100              /* Max number of units allowed in net */

#define NWTS N*N/3

#define EPS 1.0E-80



#define errmsg(s) globalError.Set(NNR, s)



void set_net(long *n, long *nconn, long *conn, long *nsunits, long *entropy, 

             long *softmax, double *decay);



void set_train(long *ntr, double *train, double *weights);



void nntest(long *ntest, double *test, double *result, double *inwts);



void Build_Net (long ninputs, long nhidden, long noutputs);



static double sigmoid(double sum);



static double E(double y, double t);



static void fpass (double *input, double *goal, double wx);



static double sigmoid_prime(double value);



static double sigmoid_prime_prime(double  value);



static void bpass (double *goal, double wx);



void dfunc(double *p, double *df, double *fp);



static double fminfn(double  *p);



static void fmingr(double *p, double *df);



static double *vect(long n);

 

static void free_vect(double *v);



static double **matrix(long nrh, long nch);



static void free_matrix(double **m, long nrh, long nch);



static double **Lmatrix(long n);



static void free_Lmatrix(double **m, long n);



void dovm(long *Nweights, double *wts, double *Fmin, long *maxit, long *trace);



typedef unsigned char booleanr;



#define false 0



#define stepredn	0.2

#define acctol		0.0001

#define reltest		10.0

#define abstol 		1.0e-4

#define reltol 		1.0e-8

#define REPORT		10



static void vmmin(long n, double *b, double *Fmin, long maxit, long trace);



static void pHessian(double *input, double *goal, double wx);



#define max(a,b) a>b?a:b

#define min(a,b) a<b?a:b



void Hessian(double *inwts, double *Hess);



#define Calloc(n,T)  new T[n]

#define Free(p)      delete[] p
