/* $Header: /home/xplore/cvs/xpl4gr/plot.C,v 1.5 2003/02/23 17:02:39 cizek Exp $ */

#include <stdio.h>
#include <math.h>
#include "directory.h"
#include "plot.h"
#include "x4math2.h"

// PC 20010705, PC MAC
#if defined(__BORLANDC__) || defined(__APPLE_CC__)
double rint(double x);
#endif
#ifdef __MINGW32__
double rint(double x);
#endif

char * axisstring(const Plot *plot, int i)
{	Achse ach(0,0,0);
	char *axis_text;
	char * zahl = new char [128];

	char m[16];
	char k[16];
	int pok;

	ach=plot->GetAchse(i);
	axis_text=ach.GetString();
	Vector <float> xcontent=ach.GetContent();


	m[0]='\0';
	k[0]='\0';
	if (xcontent[6]>10)
		sprintf(k, "%s%s%d",
			 "*", "E", (int)rint(x4log10(xcontent[6]))); 	// PC 20010705 - added rint
	if (xcontent[6]<0.1)
		sprintf(k, "%s%s%d",
			 "*", "E", (int)rint(x4log10(xcontent[6]))); 	// PC 20010705 - added rint
	if (xcontent[6]!=1 && k[0]=='\0')
		sprintf(k, "%s%g",
			 "*", xcontent[6]);
	if (xcontent[5]!=0)
		sprintf(m, "%g%s", xcontent[5], "+");

	sprintf(zahl, "%s%s%s", m, axis_text, k);
	delete axis_text;
	return(zahl);


	if (xcontent[6]<999 && xcontent[6]>0.01)
	{	if ( xcontent[5]==0 && xcontent[6]==1)
			sprintf(zahl, "%s", axis_text);
		if ( xcontent[5]==0 && xcontent[6]!=1)
			sprintf(zahl,"%g * %s",
				xcontent[6], axis_text);
		if ( xcontent[5]!=0 && xcontent[6]==1)
			sprintf(zahl,"%g + %s", xcontent[5],
				axis_text);
		if ( xcontent[5]!=0 && xcontent[6]!=1)
			sprintf(zahl,"%g + %g * %s", xcontent[5],
			xcontent[6], axis_text);
	}
	else
	{	if ( xcontent[5]==0 )
			sprintf(zahl,"%E * %s",
				xcontent[6], axis_text);
		if ( xcontent[5]!=0 )
			sprintf(zahl,"%E + %E * %s", xcontent[5],
			xcontent[6], axis_text);
	}

	delete axis_text;
	return(zahl);
}

#ifndef __BORLANDC__ //LOOK!
#include <unistd.h>
#else
#include <process.h>
#endif

#include "color.h"


/* WOT TAK! I ne fig tut!
int which_font(int size)
{	int ret=(size-MIN_FONT-1)/2;
	if (ret>7) ret=7;
	if (ret<0) ret=0;
	return(ret);
}
*/

#ifndef CONVEX
#define CONVEX 15
#endif

#ifndef ASK
#define ASK 15
#endif


#ifdef _UNIX_
#include "main.h"
#endif

// ???	#include "psstr.h"

extern void parse (const char *line);

void ZoomPlot(Plot *plot, int x1, int y1, int x2, int y2)
{	MyPoint mp1, mp2;
	int wi, he, xx, yy;
	wi=plot->GetWidth();
	he=plot->GetHeight();
	Achse ach;
	Vector <float> conti;
	mp1.x=x1<x2 ? x1 : x2;
	mp1.y=y1<y2 ? he-y1 : he-y2;
	mp2.x=x1<x2 ? x2 : x1;
	mp2.y=y1<y2 ? he-y2 : he-y1;

	xx= x1>x2 ? x1-x2 : x2-x1;
	yy= y1>y2 ? y1-y2 : y2-y1;
	int dim, i;
	XplMatrix rc, xm1, xm2, fsk, sk;

	dim=plot->GetDimension();
	rc=plot->GetRotationCosinus();
	for (i=0; i<dim; i++)
		if (rc(i, i)!=1)
			break;
	if (i==dim)
	// plot ist nicht verdreht!
	{	plot->MakeBackup();
		xm1=plot->GetOrigin(mp1);
		xm2=plot->GetOrigin(mp2);
		if (xm2(0,0)-xm1(0,0)<0.00001 || xm2(0,1)-xm1(0,1)<0.00001)
		{	cerr<<"Zoom is not possible!"<<endl;
			return;
		}
		fsk=plot->GetFirstSkalierung();	
		sk=plot->GetSecondSkalierung();	

		ach=plot->GetAchse(1);
		conti=ach.GetContent();
		
		/* Alle gute Dinge sind drei!	Oder 4?*/
		if (conti[3]*fsk(0,0)*sk(0,0)>xx/2)
			conti[3]=conti[3]/2;
		if (conti[3]*fsk(0,0)*sk(0,0)>xx/2)
			conti[3]=conti[3]/2;
		if (conti[3]*fsk(0,0)*sk(0,0)>xx/2)
			conti[3]=conti[3]/2;
		if (conti[3]*fsk(0,0)*sk(0,0)>xx/2)
			conti[3]=conti[3]/2;

		ach.SetTicks(conti[2], conti[3], 0);
		ach.SetPosition(xm1(0, 0), xm2(0, 0));
		plot->SetAchse(ach);
		
		ach=plot->GetAchse(2);
		conti=ach.GetContent();

		/* Alle gute Dinge sind drei!	*/
		if (conti[3]*fsk(1,1)*sk(1,1)>yy/2)
			conti[3]=conti[3]/2;
		if (conti[3]*fsk(1,1)*sk(1,1)>yy/2)
			conti[3]=conti[3]/2;
		if (conti[3]*fsk(1,1)*sk(1,1)>yy/2)
			conti[3]=conti[3]/2;
		if (conti[3]*fsk(1,1)*sk(1,1)>yy/2)
			conti[3]=conti[3]/2;
		ach.SetTicks(conti[2], conti[3], 0);
		ach.SetPosition(xm1(0, 1), xm2(0, 1));
		plot->SetAchse(ach);
	}
}



void Plot::Out(int data_num) const
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Plot::out: error!");
		globalError.ShowError();
		return;	
	}
	vis_data[data_num-1]->out();
}
void Plot::Out() const
{	int i;
	for (i=0; i<vis_data.laenge(); i++)
		vis_data[i]->out();
	return;
}

void Plot::MakeBackup() 	//before you zoom, you must backup the axis
				//and all the Transformation!
{	if (BackupAxis.laenge()>0)
		return;
		
#ifdef _BLABLA_
	cout<<"Plot::MakeBackup()"<<endl;
#endif
	BackupRotationPoint=RotationPoint;	

	BackupRotationCosinus=RotationCosinus;	
					
	BackupFirstSkalierung=FirstSkalierung;	

	BackupSecondSkalierung=SecondSkalierung;	
					
	BackupTranslation=Translation;
	
	int cols=BackupRotationPoint.cols();

	int i;
	for (i=0; i<cols; i++)
			BackupAxis.haengeAn(Axis[i]);
	UpdateDeformations();

}

void Plot::GetBackup()	//by Reset or smth else
{	if (BackupAxis.laenge()==0)
	{	cerr<<"backup is empty!"<<endl;
		return;
	}
#ifdef _BLABLA_
	cout<<"Plot::GetBackup()"<<endl;
#endif
	RotationPoint=BackupRotationPoint;	

	RotationCosinus=BackupRotationCosinus;	
					
	FirstSkalierung=BackupFirstSkalierung;	
	SecondSkalierung=BackupSecondSkalierung;	
					
	Translation=BackupTranslation;
	
	int cols=BackupRotationPoint.cols();
		
	int i;
	for (i=0; i<cols; i++)
			Axis[i]=BackupAxis[i];
	UpdateDeformations();

/* BEGIN jetzt die offsets abgleichen!	15.1.97*/
/*	int left, right;
	bool hequal= (hoffset[0]==hoffset[1]);
	if (hequal==True)
	{	left = (int)(voffset[1]*height/(double)width+0.5);
		if (hequal)
			right=left;
		SetHOffset(left, right);
	}
*/
/* END jetzt die offsets abgleichen!	15.1.97*/

	BackupAxis.remove();
}		



void Plot::ConstructTransformations(int cols)
{	int j;
	
	XplMatrix *dobby=new XplMatrix (1, cols); 
	RotationPoint=(*dobby);

	XplMatrix  *rc=new XplMatrix (cols, cols);
	rc->fill(0.0);
	for (j=0; j<cols; j++)
		(*rc)(j,j)= 1 ;
	

	RotationCosinus=(*rc);
	
	XplMatrix  *sk=new XplMatrix (cols, cols);
	sk->fill(0.0);
	for (j=0; j<cols; j++)
		(*sk)(j,j)= 1 ;
	
//	//cout<<"	ConstructDeformations: sk"<<endl;
//	sk->out();
	FirstSkalierung=(*sk);
	SecondSkalierung=(*sk);
	
	XplMatrix  *tr=new XplMatrix (1, cols);
	tr->fill(0.0);
//	//cout<<"	ConstructDeformations: tr"<<endl;
//	tr->out();
	Translation=(*tr);
	
	Deformation[0]=FirstSkalierung*RotationCosinus*SecondSkalierung;
	XplMatrix *null=new XplMatrix(Translation);
	null->fill(0.0);
	Deformation[1]=(*null)-RotationPoint*(Deformation[0])-Translation;
	(*sk)=sk->inv();
	(*rc)=rc->transpose();
	BackDeformation[0]=(*sk)*(*rc);
	BackDeformation[1]=Translation*(BackDeformation[0])+RotationPoint;
	delete sk;
	delete rc;
	delete null;
	delete dobby;
	delete tr;

	
}
extern int matrix_count;

void Plot::UpdateDeformations()
{

	Deformation[0]=FirstSkalierung*RotationCosinus*SecondSkalierung;
	
	XplMatrix null(Translation);
	null.fill(0.0);
	Deformation[1]=null-RotationPoint*(Deformation[0])-Translation;

	XplMatrix  sk1=FirstSkalierung.inv();
	XplMatrix  sk2=SecondSkalierung.inv();

	XplMatrix  rc=RotationCosinus.transpose();

	BackDeformation[0]=sk2*rc*sk1;

	BackDeformation[1]=Translation*(BackDeformation[0])
			+RotationPoint;
	
	if (PointKoord==NULL)
	{	//cout<<"PointKoord==NULL!!!"<<endl;
		return;
	}	
	int i, j;
//	//cout<<"Just a moment..,"<<endl;

//	//cout<<"HERE by UPDATE: matrix_count="<<matrix_count<<endl;
	
/*------------------------------------------------*/
	
	MyPoint *mp=PointKoord;
	int lae=vis_data.laenge();
	int co, all_co=0;
	XplMatrix  res;
	VisMatrix *vm;
	for (i=0; i<lae; i++)
	{	vm=vis_data[i];
		res=vm->GetContent();
		co=vm->GetPointCount();
		Compute(res, Deformation[0], Deformation[1], mp);
		mp+=co;
		all_co+=co;
	}
	mp=PointKoord;
	for (i=0; i<all_co; i++, mp++)
		mp->y=height-mp->y;

#ifdef _BLABLA_
	cout<<"UPDATE:"<<endl;
	mp=PointKoord;
	for (i=0; i<all_co; i++, mp++)
		cout<<i+1<<": x="<<mp->x<<", y="<<mp->y<<endl;
#endif

	return;
}	
	
void Plot::SetTransformation(	XplMatrix  *RP, XplMatrix *FSk,
				XplMatrix  *R, 
				XplMatrix  *Sk, XplMatrix  *Tr)
	//es soll moeglich sein nur manche davon zu aendern, indem
	//andere Pointer auf NULL zeigen. Anschliesslich wird Update
	//gefuehrt
{	
#ifdef _BLABLA_
cout<<"Vor dem SetTransformation:"<<endl;
cout<<"RotationsPoint:"<<endl;
RotationPoint.out();
cout<<"RotationsCos"<<endl;
RotationCosinus.out();
cout<<"FirstSkalierung:"<<endl;
FirstSkalierung.out();
cout<<"SecondSkalierung:"<<endl;
SecondSkalierung.out();
cout<<"Translation:"<<endl;
Translation.out();
cout<<"NEU: RotationsPoint:"<<endl;
if (RP!=NULL)
	RP->out();
cout<<"NEU: RotationsCos"<<endl;
if (R!=NULL)
	R->out();
cout<<"NEU: FirstSkalierung:"<<endl;
if (FSk!=NULL)
	FSk->out();
cout<<"NEU: SecondSkalierung:"<<endl;
if (Sk!=NULL)
	Sk->out();
cout<<"NEU: Translation:"<<endl;
if (Tr!=NULL)
	Tr->out();
#endif

	if (! (RP==NULL))
	{	RotationPoint=(*RP);

	/*	Translation=Translation+
		(RotationPoint-(*RP))*(RotationCosinus)*(Skalierung);
		RotationPoint=(*RP);
	*/
	}
	if (! (R==NULL))
		RotationCosinus=(*R);
	if (! (Sk==NULL))
		SecondSkalierung=(*Sk);
	if (! (FSk==NULL))
		FirstSkalierung=(*FSk);
	if (! (Tr==NULL))
		Translation=(*Tr);
	
//	//cout<<"HERE vor UPDATE: matrix_count="<<matrix_count<<endl;
	UpdateDeformations();
//	//cout<<"UND HERE nach UPDATE: matrix_count="<<matrix_count<<endl;
		
#ifdef _BLABLA_
cout<<"Nach dem SetTransformation:"<<endl;
cout<<"RotationsPoint:"<<endl;
RotationPoint.out();
cout<<"RotationsCos"<<endl;
RotationCosinus.out();
cout<<"FirstSkalierung:"<<endl;
FirstSkalierung.out();
cout<<"SecondSkalierung:"<<endl;
SecondSkalierung.out();
cout<<"Translation:"<<endl;
Translation.out();
#endif
	return;
}
			
XplMatrix  Plot::GetRotationPoint() const	
{	return(RotationPoint);
}

XplMatrix  Plot::GetRotationCosinus()	const
{	return(RotationCosinus);
}

XplMatrix  Plot::GetFirstSkalierung() const	
{	return(FirstSkalierung);
}	

XplMatrix  Plot::GetSecondSkalierung() const	
{	return(SecondSkalierung);
}

XplMatrix  Plot::GetTranslation() const
{	return(Translation);
}	

XplMatrix	Plot::GetHOffset() 	const
{	XplMatrix ret(1, 2);
	ret(0, 0)=hoffset[0];
	ret(0, 1)=hoffset[1];
	return(ret);
}

XplMatrix	Plot::GetVOffset() 	const
{	XplMatrix ret(1, 2);
	ret(0, 0)=voffset[0];
	ret(0, 1)=voffset[1];
	return(ret);
}


	
MyPoint Plot::GetImage(XplMatrix  &x) const
{	MyPoint mp;

	Compute(x, Deformation[0], Deformation[1], &mp);
	mp.y=height-mp.y;
	return(mp);


/*	//cout<<"GetImageTo:\n";
	x.out();
	//cout<<"Def0=\n";
	Deformation[0].out();
	//cout<<"Def1=\n";
	Deformation[1].out();
*/
//	y=x*(Deformation[0])+Deformation[1];
/*	//cout<<"Resultat:n";
	y.out();
*/
/*	MyPoint mp;
	mp.x=(short) (y(0,0)+0.5);
	mp.y=(short) (height-y(0,1)+0.5);
//	//cout<<"GetImage:"<<mp->x<<", "<<mp->y<<endl;
	return(mp);
*/
}

XplMatrix Plot::GetOrigin(MyPoint &x) const
{	XplMatrix  xd(1, RotationPoint.cols());
	xd(0,0)=(double) x.x;
	xd(0,1)=(double) (height-x.y);
	return(xd*(BackDeformation[0])+BackDeformation[1]);
}

MyPoint *Plot::GetPointKoord() const
{	return(PointKoord);	//Aufpassen! Nucht aendern!
}


void Plot::Replace(int ttop, int bbottom, int lleft, int rright)
{	SubDisplay::Replace(ttop, bbottom, lleft, rright);
}

/*
void Plot::Resize(int wi, int he)
{	if (wi==width && he==height)
		return;

	XplMatrix  *skal1, *trans1;
	int dim, i;
	
	if (vis_data.laenge()==0)
	{	width=wi;
		height=he;
		return;
	}
	
	dim=RotationPoint.cols();
	skal1=new XplMatrix (dim, dim);
	skal1->fill(0.0);


(*skal1)(0,0)=(double)(wi-wi*(hoffset[0]+hoffset[1])/100.0-2*SYMBOL_SIZE)/
			(width-width*(hoffset[0]+hoffset[1])/100.0-2*SYMBOL_SIZE);
	(*skal1)(1,1)=(double)(he-he*(voffset[0]+voffset[1])/100.0-2*SYMBOL_SIZE)/
			(height-height*(voffset[0]+voffset[1])/100.0-2*SYMBOL_SIZE);
	
	for (i=2; i<dim; i++)
		(*skal1)(i,i)=1;

	trans1=new XplMatrix (1, dim);;
	trans1->fill(0.0);
	(*trans1)(0,0)=hoffset[0]*wi/100.0+SYMBOL_SIZE-
				(hoffset[0]*width/100.0+SYMBOL_SIZE)*
					(*skal1)(0,0);
	(*trans1)(0,1)=voffset[0]*he/100.0+SYMBOL_SIZE-
				(voffset[0]*height/100.0+SYMBOL_SIZE)*
				(*skal1)(1,1);

	Skalierung=Skalierung*(*skal1);				

	Translation=Translation*(*skal1);
	Translation=Translation-(*trans1);
		
			
	delete skal1;
	delete trans1;
				
	width=wi;
	height=he;
	UpdateDeformations();
	
	Refresh();
	
}
*/

void Plot::Resize(int wi, int he)
{	if (wi==width && he==height)
		return;

	XplMatrix  *skal1, *trans1;
	int dim, i;

	if (vis_data.laenge()==0)
	{	width=wi;
		height=he;
		return;
	}
	
#ifdef _BLABLA_
	cout<<"Plott::Resize from ("<<width<<", "<<height<<") to ("<<wi<<", "<< he<<")\n";
#endif
//cout<<"RESIZE 1;VBORDER="<<voffset[0]*height/100<<endl;
//cout<<"RESIZE 1;HBORDER="<<hoffset[0]*width/100<<endl;

	dim=RotationPoint.cols();
	skal1=new XplMatrix (dim, dim);
	skal1->fill(0.0);

	int ss=SYMBOL_SIZE;
	ss=0;
	
	(*skal1)(0,0)=(double)(wi-wi*(hoffset[0]+hoffset[1])/100.0-2*ss)/
			(width-width*(hoffset[0]+hoffset[1])/100.0-2*ss);
	(*skal1)(1,1)=(double)(he-he*(voffset[0]+voffset[1])/100.0-2*ss)/
			(height-height*(voffset[0]+voffset[1])/100.0-2*ss);
	
	for (i=2; i<dim; i++)
		(*skal1)(i,i)=1;

	trans1=new XplMatrix (1, dim);;
	trans1->fill(0.0);
	(*trans1)(0,0)=hoffset[0]*wi/100.0-
				(hoffset[0]*width/100.0)*
					(*skal1)(0,0);
	(*trans1)(0,1)=voffset[0]*he/100.0-
				(voffset[0]*height/100.0)*
				(*skal1)(1,1);
				
	SecondSkalierung=SecondSkalierung*(*skal1);				
	if (BackupAxis.laenge()>0)
		BackupSecondSkalierung=BackupSecondSkalierung*(*skal1);				
	
	Translation=Translation*(*skal1);
	Translation=Translation-(*trans1);
	if (BackupAxis.laenge()>0)
	{	BackupTranslation=BackupTranslation*(*skal1);
		BackupTranslation=BackupTranslation-(*trans1);
	}	
			
	delete skal1;
	delete trans1;
				
	width=wi;
	height=he;
	UpdateDeformations();
	
//cout<<"RESIZE 2;VBORDER="<<voffset[0]*height/100<<", VOFFSET="<<voffset[0]<<endl;
//cout<<"RESIZE 2;HBORDER="<<hoffset[0]*width/100<<", HOFFSET="<<hoffset[0]<<endl;

/* jetzt die offsets angleichen		SWS 20.11.97	*/
		//SWS 29.4.98!!!
		
	int top, bottom, left, right;

	if (offset_equal)
	{	double result;
		int maxwihe= wi>he ? wi : he;
		result=AXIS_OFFSET*maxwihe;
		if (result<100*MIN_BORDER)
			result=100*MIN_BORDER;		
		while (result*3/100.0>he || result*3/100.0>he)
					// if plot is too small...	
			result=result*0.75;
		top=bottom=(int)(result/he+0.5);
		left=right=(int)(result/wi+0.5);
		/* because of natural numbers...*/

		if ( 	(int)(left*width/100.0+0.5)>=MIN_BORDER
			&&
			(int)(bottom*height/100.0+0.5)<MIN_BORDER ) 
			bottom++,top++;
		if ( 	(int)(left*width/100.0+0.5)<MIN_BORDER
			&&
			(int)(bottom*height/100.0+0.5)>=MIN_BORDER ) 
			left++,right++;
		SetHOffset(left, right);
		SetVOffset(bottom, top);
	}
		
		


//cout<<"RESIZE 3;VBORDER="<<voffset[0]*height/100.0<<", VOFFSET="<<voffset[0]<<endl;
//cout<<"RESIZE 3;HBORDER="<<hoffset[0]*width/100.0<<", HOFFSET="<<hoffset[0]<<endl;


	UpdateDeformations();
	Refresh();


	
}


void Plot::SetHOffset(int left, int right)
{	XplMatrix  *skal1, *trans1;
	int xoffs[2];
	int dim, i;
	xoffs[0]=left;
	xoffs[1]=right;
	
	
	//cout<<"PlotResize\n";

	//cout<<"SetXOffset:\n";
	//cout<<"Skalierung vor:"<<endl;
	//SecondSkalierung.out();

	if (vis_data.laenge()==0)
	{	hoffset[0]=xoffs[0];
		hoffset[1]=xoffs[1];	
		return;
	}
	
	dim=RotationPoint.cols();
	skal1=new XplMatrix (dim, dim);
	skal1->fill(0.0);

	int ss=SYMBOL_SIZE;
	ss=0;
		(*skal1)(0,0)=(double)(width-width*(xoffs[0]+xoffs[1])/100.0-
				2*ss)/
			(width-width*(hoffset[0]+hoffset[1])/100.0-
				2*ss);
	
	for (i=1; i<dim; i++)
		(*skal1)(i,i)=1;

	SecondSkalierung=SecondSkalierung*(*skal1);				

	//cout<<"Skalierung nach:"<<endl;
	//SecondSkalierung.out();


/*	trans1=new XplMatrix (1, dim);;
	trans1->fill(0.0);
	(*trans1)(0,0)=xoffs[0]*width/100.0+SYMBOL_SIZE-
				(hoffset[0]*width/100.0+SYMBOL_SIZE)*
					(*skal1)(0,0);
	(*trans1)(0,1)=(*skal1)(1,1);
				
	Translation=Translation*(*skal1);
	Translation=Translation-(*trans1);
	delete trans1;
*/
	Translation(0, 0)=-(xoffs[0]*width/100+
		(width-(xoffs[0]+xoffs[1])*width/100)/2);		
			
	delete skal1;
				
	hoffset[0]=xoffs[0];
	hoffset[1]=xoffs[1];	
	UpdateDeformations();


/*	XplMatrix mfrom, mto;

//cout<<"wi="<<width<<", height="<<height<<endl;

	MyPoint from;
	from.x=hoffset[0]*width/100;
	from.y=voffset[1]*height/100;
//cout<<"from "<<from.x<<", "<<from.y<<endl;
	mfrom=GetOrigin(from);	//left down corner

	from.x=width-hoffset[1]*width/100;
	from.y=height-voffset[0]*height/100;
//cout<<"to "<<from.x<<", "<<from.y<<endl;
	mto=GetOrigin(from); 	//right up corner

	Axis[0].SetPosition(mfrom(0, 0), mto(0, 0));

*/
//cout<<"SETHOFFS;VBORDER="<<voffset[0]*height/100<<endl;
//cout<<"SETHOFFS;HBORDER="<<hoffset[0]*width/100<<endl;



}

void Plot::SetVOffset(int top, int bottom)
{	XplMatrix  *skal1, *trans1;
	int dim, i;
	int yoffs[2];
	yoffs[0]=top;
	yoffs[1]=bottom;
	
	//cout<<"PlotResize\n";

	if (vis_data.laenge()==0)
	{	voffset[0]=yoffs[0];
		voffset[1]=yoffs[1];	
		return;
	}
	
	dim=RotationPoint.cols();
	skal1=new XplMatrix (dim, dim);
	skal1->fill(0.0);
	
	int ss=SYMBOL_SIZE;
	ss=0;

	(*skal1)(0, 0)=1;
	(*skal1)(1,1)=(double)(height-height*(yoffs[0]+yoffs[1])/100.0-
			2*ss)/
			(height-height*(voffset[0]+voffset[1])/100.0-
			2*ss);

	for (i=2; i<dim; i++)
		(*skal1)(i,i)=1;

	SecondSkalierung=SecondSkalierung*(*skal1);				

/*	trans1=new XplMatrix (1, dim);;
	trans1->fill(0.0);
	(*trans1)(0,1)=yoffs[0]*height/100.0+SYMBOL_SIZE-
				(voffset[0]*height/100.0+SYMBOL_SIZE)*
					(*skal1)(1,1);
	(*trans1)(0,0)=(*skal1)(0, 0);
				
	Translation=Translation*(*skal1);
	Translation=Translation-(*trans1);
	delete trans1;
*/
	/*
	Translation(0,1)=-(yoffs[0]*height/100+
		(height-(yoffs[0]+yoffs[1])*height/100)/2);		
	*/
			
	Translation(0,1)=-(yoffs[1]*height/100+
		(height-(yoffs[0]+yoffs[1])*height/100)/2);			delete skal1;
				
	voffset[0]=yoffs[0];
	voffset[1]=yoffs[1];	
	UpdateDeformations();

/*
	XplMatrix mfrom, mto;


	MyPoint from;
	from.x=hoffset[0]*width/100;
	from.y=voffset[0]*height/100;
	mfrom=GetOrigin(from);	//left down corner
	from.x=width-hoffset[1]*width/100;
//	from.y=height-voffset[1]*height/100;
	from.y=height-voffset[1]*height/100;
	mto=GetOrigin(from); 	//right up corner
	Axis[1].SetPosition(mto(0, 1), mfrom(0, 1));
*/
//cout<<"SETVOFFS;VBORDER="<<voffset[0]*height/100<<endl;
//cout<<"SETVOFFS;HBORDER="<<hoffset[0]*width/100<<endl;

}

/*-----------------------------------------------------------------------*/

// PC 20010702: functions for getting / setting fonttype

void Plot::SetFontType(char *type)
{
     if ((strcmp(type, "monospace") == 0) || (strcmp(type, "monospaced") == 0) || (strcmp(type, "m") == 0))
          desc_font_type = FT_MONOSPACE;
     else if ((strcmp(type, "sansserif") == 0) || (strcmp(type, "ss") == 0))
          desc_font_type = FT_SANSSERIF;
     else desc_font_type = FT_SERIF;
}

void Plot::SetFontType(enum FontType type)
{
     if ((type == FT_SERIF) || (type == FT_SANSSERIF) || (type == FT_MONOSPACE))
          desc_font_type = type;
     else desc_font_type = FT_SERIF;
}

const char *Plot::GetFontTypeA(void) const
{
     if (desc_font_type == FT_MONOSPACE)
          return "monospaced";
     else if (desc_font_type == FT_SANSSERIF)
          return "sansserif";
     else return "serif";
}

enum FontType Plot::GetFontTypeI(void) const
{
     return desc_font_type;
}

/*-----------------------------------------------------------------------*/
int Plot::GetDimension() const
{
	return(RotationCosinus.cols());
}
/*-----------------------------------------------------------------------*/

	Achse Plot::GetAchse(int i) const
{	//i ist 1 .. .. dimension
	if (i<1 || i>GetDimension())
	{	Achse ach(0, 0, 0);
		globalError.Set (ERR_INTERN, "Error by Plot::GetAchse");
		globalError.ShowError();
		cerr<<"Error by Plot::GetAchse"<<endl;
		return(ach);
	}
//	cout<<"Plot::GetAchse(int i) "<<i<<endl;
	Achse ach(Axis[i-1]);
	return(ach);
}	

	int Plot::SetAchse(const Achse & ach) 
{	int i=ach.GetDimension();
	if (i<1 || i>GetDimension())
	{	globalError.Set (ERR_INTERN, "Error by Plot::SetAchse");
		globalError.ShowError();
		return(-1);
	}

//	cout<<"Plot::SetAchse(int i) "<<i<<endl;
	
	XplMatrix skal=GetSecondSkalierung();		
	
	Vector <float> alt=Axis[i-1].GetContent();
	Vector <float> neu=ach.GetContent();


	if (alt[0]==neu[0] && alt[1]==neu[1])	//NICHT umskalieren!!!
	{	Axis[i-1]=ach;
		return(0);
#ifdef _BLABLA_
cout<<"HURRA!"<<endl;
#endif
	}

	skal(i-1,i-1)= skal(i-1,i-1)*(alt[1] -alt[0])/(neu[1]-neu[0]);

	XplMatrix rp=GetRotationPoint();
#ifdef _BLABLA_
	cout<<"rp:"<<endl;
	rp.out();
#endif
	rp(0, i-1)=(neu[0]+neu[1])/2.0;
#ifdef _BLABLA_
	cout<<"rp:"<<endl;
	rp.out();
#endif
	//XplMatrix r=GetRotationCosinus();

	XplMatrix tr=GetTranslation();
	switch(i)
	{	case 1:
		tr(0,0)=-(width-(hoffset[0]+hoffset[1])*width/100.0)/2-
				hoffset[0]*width/100.0;
		break;
		
		case 2:
	//	tr(0,1)=-(height-(voffset[0]+voffset[1])*height/100.0)/2
	//			-voffset[0]*height/100.0;
		tr(0,1)=-(height-(voffset[0]+voffset[1])*height/100.0)/2
				-voffset[1]*height/100.0;
	}
	//SetTransformation(&rp, &r, &skal, &tr);
	SetTransformation(&rp, NULL, NULL, &skal, &tr);
	Axis[i-1]=ach;
		
	return(0);
}	

/*-----------------------------------------------------------------------*/

	XplMatrix  Plot::PlotMinToDimension()  const
{	XplMatrix  d, dd;
	int i, j, lae, co;

	lae=vis_data.laenge();
	
	/*	//cout<<"PlotMinToDimension mit"<<endl;
		vm.out();
		//cout<<"dabei visdata[0] ist"<<endl;
		vis_data[0].out();
	*/
	d= vis_data[0]->MinCol(); 
	co=d.cols();
	for (i=1; i<lae; i++)
	{	dd= vis_data[i]->MinCol();
		for (j=0; j<co; j++)
			if (dd(0,j)<d(0,j))
				d(0,j)=dd(0,j);
	}
	//	//cout<<"Resultat:"<<endl;
	//	d.out();
	return(d);
	
}

/*-----------------------------------------------------------------------*/

	XplMatrix  Plot::PlotMaxToDimension() const
{	XplMatrix  d, dd;
	int i, j, lae, co;
		
	d= vis_data[0]->MaxCol(); 
	co=d.cols();
	lae=vis_data.laenge();
	for (i=1; i<lae; i++)
	{	dd= vis_data[i]->MaxCol();
		for (j=0; j<co; j++)
			if (dd(0,j)>d(0,j))
				d(0,j)=dd(0,j);

	}
	return(d);
	
}
/*-----------------------------------------------------------------------*/




/*-----------------------------------------------------------------------*/

	void Plot::DeleteAll()
{	
	while (vis_data.laenge()>0)
	{	delete vis_data[0];
		vis_data.loesche(0);
	}
}
/*-----------------------------------------------------------------------*/

	int Plot::DeleteData(int j)	//	j=1,...vis_data.laenge()
//           
{	if (j<1 || j>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "no such data!");
		globalError.ShowError();
		return(0);
	}
	
	int p_co=0, i, p_vor=0, p_nach=0;
		
	for (i=0; i<j-1; i++)
		p_co+=vis_data[i]->GetPointCount();
	p_vor=p_co;

	int p_j=vis_data[j-1]->GetPointCount();

	for (i=j; i<vis_data.laenge(); i++)
		p_nach+=vis_data[i]->GetPointCount();

	p_co=p_vor+p_j+p_nach;
		
	MyPoint *nmp=new MyPoint [p_vor+p_nach];
	memcpy(nmp, PointKoord, sizeof(MyPoint)*p_vor);
	memcpy(nmp+p_vor, PointKoord+p_vor+p_j, sizeof(MyPoint)*p_nach);
	
	delete PointKoord;
	
	PointKoord=nmp;
	
	delete vis_data[j-1];
	vis_data.loesche(j-1);
	

  return(0);	}

/*-----------------------------------------------------------------------*/

int Plot::AddData(XplObject * mo)
{	int cols1, cols2;
	
#ifdef _BLABLA_ 
		cout<<"Plot::AddData"<<endl;
#endif

	XplDouble *xpld=mo->DefaultXplDouble();
	cols1=xpld->dimension(1);
	cols2=RotationPoint.cols();

	if ( 	(vis_data.laenge()>0) &&
		!( cols1==cols2 ) )
	{	globalError.Set (ERR_INTERN, "Error: AddData: different columncount");
		globalError.ShowError();
		return(-1);
	}
	
	XplMatrix  oldmini=PlotMinToDimension();		//SWSW 30.1
	XplMatrix  oldmaxi=PlotMaxToDimension();
	
	VisMatrix* v=new VisMatrix( mo );
	
	vis_data.haengeAn(v);
	int p_co=0, i;
	for (i=0; i<vis_data.laenge(); i++)
		p_co+=vis_data[i]->GetPointCount();
	int alt_p_co=p_co-v->GetPointCount();
		
	MyPoint *nmp=new MyPoint [p_co];
	MyPoint *curr;
	memcpy(nmp, PointKoord, sizeof(MyPoint)*alt_p_co);
	
	curr=nmp+alt_p_co;
	Compute(v->GetContent(), Deformation[0], Deformation[1], curr);
	 
	for (i=alt_p_co; i<p_co; i++, curr++)
		curr->y=height-curr->y;

	delete PointKoord;
	
	PointKoord=nmp;



	XplMatrix  newmini=PlotMinToDimension();		//SWSW 30.1
	XplMatrix  newmaxi=PlotMaxToDimension();
	XplMatrix  newspread=newmaxi-newmini;
		
	Achse ach(Axis[1]);
	Vector <float> oldvf, newvf;

//	ach=GetAchse(2);
	oldvf=ach.GetContent();
	newvf=ach.GetContent();
	

	// set new borders ? 	
	if ( oldvf[0]>newmini(0,1))
		newvf[0]=newmini(0,1)-0.05*newspread(0,1);
	if ( oldvf[1]<newmaxi(0,1))
		newvf[1]=newmaxi(0,1)+0.05*newspread(0,1);


	// and now...
	if (oldvf[0]!=newvf[0] || oldvf[1]!=newvf[1])
	{	ach.SetPosition(newvf[0], newvf[1]);
		// set new major?	
		if ( newvf[1]-newvf[0]>2*(oldvf[1]-oldvf[0]))
			ach.SetTicks(0, 0);
		SetAchse(ach); 
	}
		

	ach=GetAchse(1);
	oldvf=ach.GetContent();
	newvf=ach.GetContent();
	
	// set new borders ? 	
	if ( oldvf[0]>newmini(0,0))
		newvf[0]=newmini(0,0)-0.05*newspread(0,0);
	if ( oldvf[1]<newmaxi(0,0))
		newvf[1]=newmaxi(0,0)+0.05*newspread(0,0);

	// and now...

	if (oldvf[0]!=newvf[0] || oldvf[1]!=newvf[1])
	{	ach.SetPosition(newvf[0], newvf[1]);
		// set new major?	
		if ( newvf[1]-newvf[0]>2*(oldvf[1]-oldvf[0]))
			ach.SetTicks(0, 0);
		SetAchse(ach); 
	}	



	
	//man sollte noch data_menu erweitern!!??? Also...


//cout<<"ADDDATA;VBORDER="<<voffset[0]*height/100<<endl;
//cout<<"ADDDATA;HBORDER="<<hoffset[0]*width/100<<endl;


	return(vis_data.laenge());

}

XplObject * Plot::GetXplObject(int data_num) const
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by Plot::GetXplObject");
		globalError.ShowError();
		return(NULL);
	}
	return(vis_data[data_num-1]->GetXplObject());
}

/*-----------------------------------------------------------------------*/

int Plot::GetPointCount(int data_num) const
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by GetPointCount");
		globalError.ShowError();
		return(0);
	}
	return(vis_data[data_num-1]->GetPointCount());
}

void Plot::SetPointColor(int color, int data_num, int which_point)
{	int i;
	if (data_num<0 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by SetPointColor");
		globalError.ShowError();
		return;
	}
	if (data_num==-0)
	{	for (i=0; i<vis_data.laenge(); i++)
	 		vis_data[i]->SetPointColor(color);	
	 	return;
	 }
	 vis_data[data_num-1]->SetPointColor(color, which_point);	
}

void Plot::SetPointColor(int color, int data_num, const XplMatrix which_point)
{	int i;
	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by SetPointColor");
		globalError.ShowError();
		return;
	}
	 vis_data[data_num-1]->SetPointColor(color, which_point);	
}

int Plot::GetPointColor(int data_num, int which_point) const
{	int i;
	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by Plot::GetPointColor");
		globalError.ShowError();
		return(0);
	}
	return(vis_data[data_num-1]->GetPointColor(which_point));	
}

void Plot::SetPointLayout(Outfit out, int data_num, int which_point)
{	int i;
	if (data_num<0 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by SetAllPointsOutfit");
		globalError.ShowError();
		return;
	}
	if (data_num==0)
	{	for (i=0; i<vis_data.laenge(); i++)
	 		vis_data[i]->SetPointLayout(out, which_point);	
	 	return;
	 }
	 vis_data[data_num-1]->SetPointLayout(out, which_point);		
}
	
void Plot::SetPointLayout(int lay, int data_num, const XplMatrix which_point)
{	int i;
	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by SetPointColor");
		globalError.ShowError();
		return;
	}
	 vis_data[data_num-1]->SetPointLayout(lay, which_point);	
}

int Plot::GetPointLayout(int data_num, int which_point) const
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by ");
		globalError.ShowError();
		return(NOPOINT);
	}
	 return(vis_data[data_num-1]->GetPointLayout(which_point));		
}

/*-----------------------------------------------------------------------*/

Liste <MyPolygon *> Plot::GetPolygons() const	//gets all polygons!
{	int i, k, j;
	Liste <MyPolygon*> result;
	Liste <MyPolygon*> curr;
	j=0;
	MyPoint *mp=PointKoord;
	
	for (i=0; i<vis_data.laenge(); i++)
	{	curr=vis_data[i]->GetPolygons();
		for (k=0; k<curr.laenge(); k++,j++)
		{	result.haengeAn(curr[k]);
			result[j]->ComputePoints(mp);
		}
		mp+=vis_data[i]->GetPointCount();
	}
	return(result);
}
		
void Plot::SetPolygonColor(int color, int data_num, int line_num)
{	int i;
	if (data_num<0 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by SetPolygonColor: no such data");
		globalError.ShowError();
		return;
	}
	if (data_num==0)
	{	for (i=0; i<vis_data.laenge(); i++)
	 		vis_data[i]->SetPolygonColor(color, line_num);	
	 	return;
	}
	
	vis_data[data_num-1]->SetPolygonColor(color, line_num);	
}

void Plot::SetPolygonLayout(int li, int data_num, int line_num)
{	int i;
	if (data_num<0 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by SetPolygonLayout: no such data");
		globalError.ShowError();
		return;
	}
	if (data_num==0)
	{	for (i=0; i<vis_data.laenge(); i++)
	 		vis_data[i]->SetPolygonLayout(li, line_num);	
	 	return;
	}
	
	vis_data[data_num-1]->SetPolygonLayout(li, line_num);	
}
	
void Plot::SetPolygonThick(int th, int data_num, int line_num)
{	int i;
	if (data_num<0 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by SetPolygonThick: no such data");
		globalError.ShowError();
		return;
	}
	if (data_num==0)
	{	for (i=0; i<vis_data.laenge(); i++)
	 		vis_data[i]->SetPolygonThick(th, line_num);	
	 	return;
	}
	
	vis_data[data_num-1]->SetPolygonThick(th, line_num);	
}

int Plot::GetPolygonColor(int data_num, int line_num) const
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by GetPolygonColor: no such data");
		globalError.ShowError();
		return(0);
	}
	
	return(vis_data[data_num-1]->GetPolygonColor(line_num));	
}

int Plot::GetPolygonLayout(int data_num, int line_num) const
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by GetPolygonLayout: no such data");
		globalError.ShowError();
		return(0);
	}
	
	return(vis_data[data_num-1]->GetPolygonLayout(line_num));	
}


int Plot::GetPolygonThick(int data_num, int line_num) const
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error by GetPolygonThick: no such data");
		globalError.ShowError();
		return(0);
	}
	
	return(vis_data[data_num-1]->GetPolygonThick(line_num));	
}

MyPoint* Plot::GetPointsToPolygon(int dat_num, int polli_num) const

{	int i, count, offset, index, ii;
	MyPoint *res;
	MyPoint ima;
	XplMatrix  xpl;
	int *indy;
	
	if (dat_num<1 || dat_num> vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error: Plot::GetPointsToPolygon");
		globalError.ShowError();
		return(NULL);
	}
	
	offset=0;
	for (i=0; i<dat_num-1; i++)
		offset+=vis_data[i]->GetPointCount();
	//da sind die (x,y) zu suchen...
	
	count=GetPolygonSize(dat_num, polli_num);
	indy=vis_data[dat_num-1]->GetPolygonIndex(polli_num);
	res= new MyPoint [count];
	for (i=0; i<count; i++, res++, indy++)
	{	res[0].x=(PointKoord+offset+indy[0])[0].x;	//SUPER!
		res[0].y=(PointKoord+offset+indy[0])[0].y;	//SUPER!
	}
	delete (indy-count);
	return(res-count);
}
	
int Plot::GetPolygonSize(int data_num, int line_num) const
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error:Plot:: GetPolygonSize");
		globalError.ShowError();
		return(0);
	}
	return(vis_data[data_num-1]->GetPolygonSize(line_num));
}

int Plot::GetPolygonCount(int data_num) const
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set (ERR_INTERN, "Error: Plot::GetPolygonCount");
		globalError.ShowError();
		return(0);
	}
	return(vis_data[data_num-1]->GetPolygonCount());
}
	

/*-----------------------------------------------------------------------*/

void Plot::AddPolygon(int data_num, int how_much, int *some, 
				int color, int line_outfit)
{	int i;
	if (data_num>vis_data.laenge() || data_num<1)
	{	globalError.Set (ERR_INTERN, "Error by ConnectPoints: no such data");
		globalError.ShowError();
		return;
	}
	vis_data[data_num-1]->AddPolygon(how_much, some, color, line_outfit);		 
}
	
void Plot::DeletePolygon(int data_num, int line_num)
{	int i;
	if (data_num>vis_data.laenge() || data_num<0)
	{	globalError.Set (ERR_INTERN, "Error by DeletePolygon: no such data");
		globalError.ShowError();
		return;
	}
	if (data_num==0)
	{	for (i=0; i<vis_data.laenge(); i++)
			vis_data[i]->DeletePolygon();
		return;
	}
	vis_data[data_num-1]->DeletePolygon(line_num);		
}	


char* Plot::GetDataName(int i) const
{	if (i<vis_data.laenge()+1 && i>0)
		return(vis_data[i-1]->GetName());
	globalError.Set (ERR_INTERN, "Error bei SetDataOutfit(int)\n");
		globalError.ShowError();
	return(NULL);
}
				
void Plot::SetDataName(int i, const char *na)	
{	if (i<vis_data.laenge()+1 && i>0)
		vis_data[i-1]->SetName(na);
	else
	{	globalError.Set (ERR_INTERN, "Error bei SetDataName(int)\n");
		globalError.ShowError();
	}
}
void Plot::Refresh() const
{	
	if (! refresh_automatic)
		return;
#ifdef _BLABLA_
	cout<<"refresh..."<<endl;
#endif
}
		
int Plot::redraw_points(int data_num, XplMatrix & only_these)
{	if (data_num<1 || data_num>vis_data.laenge())
	{	globalError.Set(ERR_INTERN, "Error by link");
		globalError.ShowError();
		return(-1);
	}
	if (	vis_data[data_num-1]->GetPointCount()!=
		only_these.rows()	)
	{	globalError.Set(ERR_INTERN, "Error by link");
		globalError.ShowError();
		return(-1);
	}		
	return(0);
}


int Plot::repaint_part(int part_x, int part_y, 
		int part_width, int part_height) const
{	 return(0);	
}

inline int sqr_distanz(MyPoint &x, MyPoint &y)
{	
	int i, j;
	i=x.x-y.x;
	i*=i;
	j=x.y-y.y;
	j*=j;
	return(i+j);
}
int Plot::NearestPointTo(MyPoint &x) const
{	int i, ii, ind, rows, data_count;
	double di, curr_di;
	MyPoint mp, *pk;
	
	rows=0;
	pk=PointKoord;

	int first_response=0;
	int resp_number;
	Liste <int> respi;

	for (i=0; i<vis_data.laenge(); i++)
	{	if (first_response==0 && vis_data[i]->SomeRespPoints())
		{	first_response=i+1;
			resp_number=rows;
		}
		rows+=vis_data[i]->GetPointCount();
	}
		
	if (rows==0)
	{	globalError.Set (ERR_INTERN, "keine Punkte da");
		globalError.ShowError();
		return(-1);
	}
	
	ind=0;

	if (first_response==0)	// no responding points
	{	di=sqr_distanz(x, *pk);
	//cout<<"NearestPointTo: "<<rows<<endl;
		for (i=1; i<rows; i++)
		{	pk++;
			curr_di=sqr_distanz(x, *pk);
			if (curr_di<di)
			{	ind=i;
				di=curr_di;
			}
		}
		return(ind);
	}
	else
	{	respi=vis_data[first_response-1]->GetRespIndex();
		di=sqr_distanz(x, *(pk+resp_number+respi[0]));
		ind=resp_number+respi[0];
		for (i=1; i<respi.laenge(); i++)
		{	curr_di=sqr_distanz(x, *(pk+resp_number+respi[i]));
			if (curr_di<di)
			{	ind=resp_number+respi[i];
				di=curr_di;
			}
		}
		resp_number+=vis_data[first_response-1]->GetPointCount();
		for (ii=first_response; ii<vis_data.laenge(); ii++)
		if (vis_data[ii]->SomeRespPoints())
		{	
#ifdef _BLABLA_
	cout<<"search by data="<<ii+1<<endl;
#endif
			respi=vis_data[ii]->GetRespIndex();
			for (i=0; i<respi.laenge(); i++)
			{	curr_di=sqr_distanz(x,
				 *(pk+resp_number+respi[i]));
				if (curr_di<di)
				{	ind=resp_number+respi[i];
					di=curr_di;
#ifdef _BLABLA_
					cout<<"naeher dran, data="<<
					ii+1<<", punkt nr. "<<respi[i]<<endl;
#endif
				}
			}
			resp_number+=vis_data[ii]->GetPointCount();
		}
		else
		{
			resp_number+=vis_data[ii]->GetPointCount();
#ifdef _BLABLA_
			cout<<"NO search by data="<<ii+1<<endl;
#endif
		}
		return(ind);
	}

}	

XplMatrix &  Plot::RealPoint(int data_num, int i) const
{	XplMatrix *xplm = new XplMatrix(RotationCosinus.cols());
	xplm->fill(0.0); 
	if (data_num>vis_data.laenge() || data_num<1)
	{	globalError.Set (ERR_INTERN, "Error by RealPoint: no such data");
		globalError.ShowError();
		return(*xplm);
	}
	delete xplm;
	return(vis_data[data_num-1]->RealPoint(i));
}

bool Plot::IsHomogen(int data_num) const	
{	if (data_num>vis_data.laenge()-1 || data_num<0)
	{	globalError.Set (ERR_INTERN, "Error by Plot::IsHomogen: no such data");
		globalError.ShowError();
		return((0==1));
	}
	return(vis_data[data_num]->IsHomogen());
}

int checkup(Liste <XplObject*> vars)
{	int i, cols, rescols;
	rescols=vars[0]->DefaultXplDouble ()->dimension(1);
	
	if (rescols<2)
	{	char meld[32];
		sprintf(meld, "Warning: Matrice %s has 1 collumn",
				vars[0]->Name());
		globalError.Set (ERR_INTERN, meld);
		globalError.ShowError();
	}
	cols=rescols;
	for (i=1; i<vars.laenge(); i++)
	{	cols=vars[i]->DefaultXplDouble()->dimension(1);	
		if (cols<2)
		{	char meld[32];
			sprintf(meld, "ERROR: Matrice %s has 1 collumn",
				vars[i]->Name());
			globalError.Set (ERR_INTERN, meld);
			globalError.ShowError();
		}
		if ( ! rescols==cols )
		{	char meld[32];
			sprintf(meld, 
			"ERROR: Matrices have different dimension");
			globalError.Set (ERR_INTERN, meld);
			globalError.ShowError();
			if (cols<rescols)
				rescols=cols;
		}
	}
	char meld[32];
	sprintf(meld, "CHECKUP results with %d columns\n", rescols);
	//cout<<meld;
	return(rescols);
}

char * Plot::GetHeadline() const
{	return(strdup(head_line));
}

void Plot::SetHeadline(const char* hl)
{	delete head_line;
	head_line=strdup(hl);
}


void SetXYtoPlot(Plot &p, int x, int y)
{	//x und y sollen 0...dim(p)-1 sein!!!
	XplMatrix rotcos=p.GetRotationCosinus();
	if (x<0 || y<0 || x>rotcos.cols()-1 || y>rotcos.cols()-1)
	{	char meld[124];
		sprintf(meld, "x und y sollen 0...%d sein", rotcos.cols()-1);
		globalError.Set (ERR_INTERN, meld);
		globalError.ShowError();
		return;
	}
	rotcos.fill(0.0);
	rotcos(x,0)=1;
	rotcos(y,1)=1;
	
	p.SetTransformation(	NULL, NULL, &rotcos, NULL, NULL);
}	

void Plot::SetBrushBoard(MyPoint from, MyPoint to)
{	cursor_from.x= from.x>to.x ? to.x : from.x;
	cursor_from.y= from.y>to.y ? to.y : from.y;
	cursor_to.x= from.x>to.x ? from.x : to.x;
	cursor_to.y= from.y>to.y ? from.y : to.y;
#ifdef _BLABLA_
	cout<<"FROM: ("<<from.x<<", "<<from.y<<"), TO: ("
		<<to.x<<", "<<to.y<<")\n";
#endif
}

	
XplMatrix Plot::GetBrushed(int data_num)	//liefert index_vector,
 						//data_num=0,....
{	int i, co=vis_data[data_num]->GetPointCount();
	XplMatrix new_sel(co, 1);
	new_sel.fill(0.0);
	if (data_num <0 || data_num>vis_data.laenge()-1)
		return(new_sel);
	MyPoint *myp=PointKoord;
	for (i=0; i<data_num; i++)
		myp+=vis_data[i]->GetPointCount();

	for (i=0; i<co; i++, myp++)
		new_sel(i, 0)= (myp->x<cursor_to.x && myp->x>cursor_from.x &&
				myp->y<cursor_to.y && myp->y>cursor_from.y ) ?
				1 : 0;
#ifdef _BLABLA_
	cout<<"was selected:"<<endl;
	vis_data[data_num]->selected.out();
	cout<<"from ("<<cursor_from.x<<", "<<cursor_from.y<<
		") to ("<<cursor_to.x<<", "<<cursor_to.y<<endl;  
	cout<<"new_sel :"<<endl;
	new_sel.out();
#endif
	XplMatrix old_sel=vis_data[data_num]->selected;
	XplMatrix res_sel(co, old_sel.cols()+1);
	int j;
	res_sel.fill(0.0);
	for (i=0; i<co; i++)
	for (j=0; j<res_sel.cols()-2; j++)
		res_sel(i, j)=old_sel(i, j);
	for (i=0; i<co; i++)
	{	res_sel(i, res_sel.cols()-2)=new_sel(i, 0);
		res_sel(i, res_sel.cols()-1)=new_sel(i, 0); 
		// hier spaeter verschiedene sequencen einbauen!
	}
	vis_data[data_num]->selected=res_sel;	
#ifdef _BLABLA_
	cout<<"jetzt selected:"<<endl;
	vis_data[data_num]->selected.out();
#endif
/*	if (after_brush!=NULL && strlen(after_brush)!=0)
		parse(after_brush);
*/	
	return(new_sel);
}
	
void Plot::MakeAfterBrush()
{	if (after_brush!=NULL && strlen(after_brush)!=0)
		parse(after_brush);
}
	
void Plot::SetBrushFunction(const char *sbf)
{	if (after_brush!=NULL && strlen(after_brush)!=0)
		delete after_brush;
	after_brush=strdup(sbf);
}

XplMatrix Plot::SetBrushOutfit(Outfit ou)
{	cout<<"noch nicht fertig\n";
	XplMatrix ret;
	return(ret);
}
XplMatrix Plot::SetBrushColor(int color)
{	cout<<"noch nicht fertig\n";
	XplMatrix ret;
	return(ret);
}	
void Plot::SetBrushed(int data_num, XplMatrix ind_vec)
{	cout<<"noch nicht fertig\n";
}

void Plot::AddButton(const char *, const char*)
{	;
}
void Plot::DeleteButton(const char *)
{	;
}

void Plot::InFocus()
{	;
}

#define PS_POINT_RADIUS 1
#define PAPER_OFFSET 0 //Abstand von papierrand unten und links

#ifdef __BORLANDC__ //LOOK!
#define POINT POINT1
#endif

extern Liste <XplColor *> all_colors;
extern Liste <XplSymbol *> all_symbols;


extern int ADashOfPolygon(int);
extern int BDashOfPolygon(int);
extern int which_font(int);

void prepare_string(char * str)
{	char *where_point=strchr(str, '.');
	if (where_point==NULL)
		return;
	while ( str[ strlen(str)-1]=='0' )
		str[ strlen(str)-1]=0;
	if ( str[ strlen(str)-1]=='.' )
		str[ strlen(str)-1]=0;
}

/*char *psnametosym[]={	"NOPOINT", "POINT", "RECTANGLE", "CIRCLE", "TRIANGLE",
			 "XSYM", "RHOMBUS", "FLD_RECTANGLE", "FLD_CIRCLE",
			 "FLD_ROMB", "FLD_TRIANGLE", "CROSS", "STAR", "GRID",
			  "GRID_RHOMBUS", "POINT"};
*/
char *psnametosym[]={	"NOPOINT", "P", "R", "C", "T",
			 "X", "RH", "FR", "FC",
			 "FRH", "FT", "CR", "S", "G",
			  "GR", "P"};

#define LAB_FONT 10
void Plot::Print(FILE * ps_file) const
{	int i, j, k, p_co, count;
	MyPoint *my_p;
	int gemalt, homogen, homo_color, poli_count, color, line_num;
	Outfit homo_outfit;
	int homo_size;
	char fname[124];
	char line[256];
	float red, green, blue;
	XplColor *col_num;
	char * astring;

#ifdef _BLABLA_
	cout<<"PRINT PLOT width="<<width<<", height="<<height<<endl;
#endif
	MyPoint *points=GetPointKoord();
	Lines_Outfit fi;

	//fprintf(ps_file, "%d %d translate\n", PAPER_OFFSET, PAPER_OFFSET);

	if (head_on==(0==0) && top_frame_visible())
	{	int x_head=(int)(width/2.0+0.5);
		int y_head=(int)
			(height-
		voffset[0]*height*HEAD_HEIGHT/100.0+0.5);
		fprintf(ps_file, "0.0 0.0 0.0 setrgbcolor\n");
		fprintf(ps_file, 
		// PC 20010703: "/Times-Roman findfont\n [%d 0 0 %d 0 0]\n makefont setfont\n",
		"/%s findfont\n [%d 0 0 %d 0 0]\n makefont setfont\n",
                GetPSFontName(),
		(int)(voffset[0]*height*HEAD_HEIGHT*PSFONT_PROP/100.0+0.5),
		(int)(voffset[0]*height*HEAD_HEIGHT*PSFONT_PROP/100.0+0.5));		
		//wf, wf); 
		fprintf(ps_file, "(%s) %d %d XplShow\n", head_line,
			x_head, y_head);
		//cout<<y_head<<", "<<height-voffset[0]*height/100.0<<endl;
	}

	
	fprintf(ps_file, "gsave\n");
	fprintf(ps_file, "stroke\n");	//sicherheithalbe...
	fprintf(ps_file, "%d %d div %d %d div scale\n", 
	display->GetElementWidth(di_x, di_y), width,
	display->GetElementHeight(di_x, di_y), -height);
	
	fprintf(ps_file, "0 -%d translate\n", height);

	/* CLIP!*/
/*	gsave
	newpath
	0 0 moveto 
	0 500 lineto
	500 500 lineto 
	500 0 lineto
	500 0 lineto
	gsave
	closepath
	eoclip
	newpath
*/

	int lefto, righto, bottomo, topo;
	bool rotated;
	XplMatrix rotpoint;
	int which_x, which_y;
	
	int dim=GetDimension();
	rotpoint=GetRotationCosinus();
	for (i=0; i<dim; i++)
		for (j=0; j<dim; j++)
		{	if (! (rotpoint(i,j)==0 || rotpoint(i,j)==1) )
				break;
			if ( rotpoint(i,j)==1 &&  j==0)
				which_x=i;
			if ( rotpoint(i,j)==1 &&  j==1)
				which_y=i;
		}
	if (i==dim && j==dim) 
		rotated=(1==0);
	else
		rotated=(0==0);
			
	if (axis_on && !rotated)		//clear frame!
	{	topo=height-(int)(voffset[1]*height/100.0+0.5);
		bottomo=(int)(voffset[0]*height/100.0+0.5);
		//lefto=(int)(hoffset[1]*width/100.0+0.5);
		//righto=width-(int)(hoffset[0]*width/100.0+0.5);
		lefto=(int)(hoffset[0]*width/100.0+0.5);
		righto=width-(int)(hoffset[1]*width/100.0+0.5);
	}
	else
	{	topo=height-1;
		bottomo=1;
		lefto=1;
		righto=width-1;
	}
		
	fprintf(ps_file, "gsave newpath %d %d moveto %d %d lineto\n",
			lefto, bottomo, lefto, topo);
	
	fprintf(ps_file, "%d %d lineto\n %d %d lineto %d %d lineto\n",
	 	righto, topo, righto, bottomo, lefto, bottomo);
	 fprintf(ps_file, 
	 	"closepath eoclip newpath\n");

	fprintf(ps_file, "1 setlinewidth\n");
	fprintf(ps_file, "[] 0 setdash\n");
	


/*	fprintf(ps_file, 
"0 0 moveto\n%d 0 lineto\n%d %d lineto\n0 %d lineto \n0 0 lineto stroke\n",
		width, width, height, height);
*/
	for (j=0; j<vis_data.laenge(); j++)
	{	p_co=vis_data[j]->GetPointCount();
		gemalt=0;

		while (gemalt < p_co)
		{	homogen=1;
			homo_outfit=vis_data[j]->GetPointLayout(gemalt+1);
			homo_color=vis_data[j]->GetPointColor(gemalt+1);

			while 
				(	(homogen+gemalt < p_co) &&
		(vis_data[j]->GetPointColor(gemalt+homogen+1)==
			homo_color) &&
		(vis_data[j]->GetPointLayout(gemalt+homogen+1)==
			homo_outfit) )
				homogen++;
			if (homo_color>-1 && homo_color<all_colors.laenge())
			{	col_num=all_colors[homo_color];
				red=col_num->red/(float)(256);
				green=col_num->green/(float)(256);
				blue=col_num->blue/(float)(256);
			}
			else
			//	z.b. bei PSGEN
				red=green=blue=0.0;

// PC 20020204 - fixed, all non-unix versions have to be divided by 256 once more
#ifndef _UNIX_
				red=red/(float)(256);
				green=green/(float)(256);
				blue=blue/(float)(256);
#endif
		sprintf(line, "%1.3f %1.3f %1.3f setrgbcolor",
			red, green, blue);
			fprintf(ps_file, "%s \n", line);
			switch(homo_outfit)
			{	case NOPOINT:
				points=points+homogen;
				break;

				case POINT:
				for (i=0; i<homogen; i++, points++)
					fprintf(ps_file, "%d %d POINT\n", 
					points->x,
					points->y );
				break;

				default:
#ifdef _BLABLA_
				cout<<"symbol nummer "<<homo_outfit<<endl;
				cout<<" heisst "<<
				psnametosym[all_symbols[homo_outfit-2]->symbol]<<endl;
				cout<<"Symbols : "<<all_symbols.laenge()<<endl;
#endif
				if (all_symbols[homo_outfit-2]->symbol!=ASK)
				{
				homo_size=all_symbols[homo_outfit-2]->size;
				for (i=0; i<homogen; i++, points++)
					
				if (homo_size==SYMBOL_SIZE)	
					fprintf(ps_file, "%d %d %s\n", 
					points->x,
					points->y,
			psnametosym[all_symbols[homo_outfit-2]->symbol]);
				else
/*
					fprintf(ps_file, 
	"gsave %d %d %d translate %d div  dup scale\n %d %d %s\n grestore\n", 
			homo_size, 
			points->x, points->y,
			SYMBOL_SIZE, 0, 0,  
			psnametosym[all_symbols[homo_outfit-2]->symbol]);
*/				
					fprintf(ps_file, 
				"(%s) %d %d %d %d XAS\n",
			psnametosym[all_symbols[homo_outfit-2]->symbol],
			homo_size, 
			SYMBOL_SIZE, 
			points->x, points->y);  
				}
				else
					points=points+homogen;			
				break;

				
			}
		gemalt+=homogen; 
		}
	}
	int a, b;
	for (j=0; j<vis_data.laenge(); j++)
	{	poli_count=vis_data[j]->GetPolygonCount();
#ifdef _BLABLA_
	cout<<"Data "<<j<<" hat "<<poli_count<<" Polygons"<<endl;
#endif
		for (i=0; i<poli_count; i++)
		{ 	count=vis_data[j]->GetPolygonSize(i+1);
			points=GetPointsToPolygon(j+1, i+1);	
			color=vis_data[j]->GetPolygonColor(i+1);
			fi=vis_data[j]->GetPolygonLayout(i+1);
			if (fi!=NOLINE  )
			{	col_num=all_colors[color];
				red=col_num->red/(float)(256);
				green=col_num->green/(float)(256);
				blue=col_num->blue/(float)(256);
// PC 20020204 - fixed, all non-unix versions have to be divided by 256 once more
#ifndef _UNIX_
				red=red/(float)(256);
				green=green/(float)(256);
				blue=blue/(float)(256);
#endif
				
				sprintf(line, "%1.3f %1.3f %1.3f setrgbcolor", 
				red, green, blue);
				fprintf(ps_file, "%s \n", line);
			
				if (vis_data[j]->GetPolygonThick(i+1)!=CONVEX)
				{	fprintf(ps_file, "%d setlinewidth\n",
					vis_data[j]->GetPolygonThick(i+1));
					if ( fi!=SOLID)
					{	a=ADashOfPolygon(fi);
						b=BDashOfPolygon(fi);
						fprintf(ps_file, 
						"[%d %d] 0 setdash\n", a, b);
					}
					else
					fprintf(ps_file, 
					"[] 0 setdash\n");	
				}
				
				fprintf(ps_file, "%d %d moveto\n",
				(points)->x, (points)->y);
				
				for (line_num=1; line_num<count; line_num++)
				{	if (line_num%100==0)
						fprintf(ps_file, 
					"%d %d lineto stroke %d %d moveto\n",
						(points+line_num)->x, 
						(points+line_num)->y,
						(points+line_num)->x, 
						(points+line_num)->y);
					if 
				(!((points+line_num)->x==(points+line_num-1)->x
					&&
				(points+line_num)->y==(points+line_num-1)->y))
					fprintf(ps_file, "%d %d lineto\n",
				(points+line_num)->x, (points+line_num)->y);
#ifdef _BLABLA_
				else
					cout<<line_num<<" line length 0"<<endl;
#endif
				}
				if (vis_data[j]->GetPolygonThick(i+1)!=CONVEX)
					fprintf(ps_file, "stroke\n");	
				else
				fprintf(ps_file, "fill\n");
#ifdef _BLABLA_
		printf("[%d %d] 0 setdash stroke\n", a, b);
#endif
			}
			delete points;
		}
	}		

	/*
	if (Axis.laenge()==0)
	{	fprintf(ps_file, "grestore\ngrestore\n");
	//	fprintf(ps_file, "grestore\n0 +%d translate\n", height);
	//	fprintf(ps_file, "1 -1 scale\n");
		return;
	}
	*/
	int tm_count;
	char zahl[256];
	char* zahl_beg;
	XplMatrix do_von, do_bis, do_tima, secsk;

	MyPoint von, bis, tima;
	float origin, tm;

	Achse ax_da(0, 0, 0), ay_da(0, 0, 0);
	Vector <float> xcontent, ycontent;
	//char *axis_string;

	XplMatrix timm;

#ifdef _BLABLA_
	if (axis_on)
		cout<<"print axen draw..1."<<endl;
	else
		cout<<"print no axen draw..."<<endl;
#endif
		if (axis_on)
	{	//cout<<"print axen..."<<endl;
#ifdef _BLABLA_
		cout<<"print axen draw..2."<<endl;
		cout<<all_colors.laenge()<<" colors"<<endl;
#endif
	
		red=all_colors[0]->red/(float)(65536);
		green=all_colors[0]->green/(float)(65536);
		blue=all_colors[0]->blue/(float)(65536);

#ifdef _BLABLA_
		cout<<"print axen draw...3"<<endl;
#endif

		fprintf(ps_file, "%1.3f %1.3f %1.3f setrgbcolor\n", 
			red, green, blue);
		fprintf(ps_file, "1 setlinewidth\n"); 
		fprintf(ps_file, "[] 0 setdash\n");
		
		dim=GetDimension();
		do_von=GetRotationPoint();
		do_bis=GetRotationPoint();
		do_tima=GetRotationPoint();
		rotpoint=GetRotationCosinus();
		//nur wegen dimension???
		
		which_x=which_y=-1;
		for (i=0; i<dim; i++)
			for (j=0; j<dim; j++)
		{	if (! (rotpoint(i,j)==0 || rotpoint(i,j)==1) )
				break;
			if ( rotpoint(i,j)==1 &&  j==0)
				which_x=i;
			if ( rotpoint(i,j)==1 &&  j==1)
				which_y=i;
		}
		if (which_x>-1 && which_y>-1)
		// plot ist nicht verdreht!
		{	float x_origin, y_origin;


			ax_da=GetAchse(which_x+1);
			ay_da=GetAchse(which_y+1);

			xcontent=ax_da.GetContent();
			ycontent=ay_da.GetContent();
			
			do_von.fill(0.0);	//eine ecke
			do_von(0, which_x)=xcontent[0];
			do_von(0, which_y)=ycontent[0];
		
			do_bis.fill(0.0);
			do_bis(0, which_x)=xcontent[1];
			do_bis(0, which_y)=ycontent[1];
		
			von=GetImage(do_von);
			bis=GetImage(do_bis);
		
	/*		von.x=von.x-AXIS_OFFSET;
			von.y=von.y+AXIS_OFFSET;
			bis.x=bis.x+AXIS_OFFSET;
			bis.y=bis.y-AXIS_OFFSET;
	*/	
			topo=height-1;
			bottomo=1;
			lefto=1;
			righto=width-1;
		
	fprintf(ps_file, "0 0 moveto\ngrestore\ngsave newpath %d %d moveto %d %d lineto\n",
			lefto, bottomo, lefto, topo);
	
	fprintf(ps_file, "%d %d lineto\n %d %d lineto %d %d lineto\n",
	 	righto, topo, righto, bottomo, lefto, bottomo);
	 fprintf(ps_file, 
	 	"closepath eoclip newpath\n");

	fprintf(ps_file, "1 setlinewidth\n");
	fprintf(ps_file, "[] 0 setdash\n");

   if (xaxisline)	// PC 001206
		fprintf(ps_file, "%d %d %d %d XplLine\n",
				von.x, von.y, bis.x, von.y);

   if (yaxisline)	// PC 001206
		fprintf(ps_file, "%d %d %d %d XplLine\n",
				von.x, von.y, von.x, bis.y);

   if (yaxisline)	// PC 001206
		fprintf(ps_file, "%d %d %d %d XplLine\n",
				bis.x, bis.y, bis.x, von.y);

   if (xaxisline)	// PC 001206
  		fprintf(ps_file, "%d %d %d %d XplLine\n",
				bis.x, bis.y, von.x, bis.y);
	
		if ((bottom_frame_visible()) || 
			(left_frame_visible()) )
		{
			//do_von=GetOrigin(von);
			//do_bis=GetOrigin(bis);
		
			x_origin=xcontent[2];
			while (x_origin<do_von(0, which_x))
				x_origin=x_origin+xcontent[3];
#ifndef _SWETEST_
			while (x_origin>do_von(0, which_x)+
					xcontent[3])
				x_origin=x_origin-xcontent[3];
#endif		
			
			y_origin=ycontent[2];
			while (y_origin<do_von(0, which_y))
				y_origin=y_origin+ycontent[3];
#ifndef _SWETEST_
			while (y_origin>do_von(0, which_y)+
					ycontent[3])
				y_origin=y_origin-ycontent[3];
#endif		
		
			do_tima.fill(0.0);
			do_tima(0, which_x)=x_origin;

		int which=-1;
	XplMatrix xoffset, yoffset;
		xoffset=GetHOffset();
		yoffset=GetVOffset();


//cout<<"PRINT;VBORDER="<<(int)(voffset[0]*height/100.0+0.5)<<endl;
//cout<<"PRINT;HBORDER="<<(int)(hoffset[0]*width/100.0+0.5)<<endl;

		if ( 	bottom_frame_visible() &&
			left_frame_visible())
			//beide sichtbar!
		{	which=xoffset(0,0)*width>yoffset(0,1)*height ? 
			(int)(yoffset(0,1)*height*TICK_STRING_HEIGHT/100.0+0.5) :
			(int)(xoffset(0,0)*width*TICK_STRING_HEIGHT/100.0+0.5);
		}

		if (bottom_frame_visible() && 
		 (!left_frame_visible()))	//only bootom achse
		{	which=
			(int)(yoffset(0,1)*height*TICK_STRING_HEIGHT/100.0+0.5);
		}
		
		if ( (!bottom_frame_visible()) && 
		 	left_frame_visible())	//only bootom achse
		{	which=
			(int)(xoffset(0,0)*width*TICK_STRING_HEIGHT/100.0+0.5);
		}

		//cout<<"fontgroesse="<<which<<endl;

		// PC 20010702: fprintf(ps_file, "/Times-Roman findfont\n");
		fprintf(ps_file, "/%s findfont\n", GetPSFontName());
		fprintf(ps_file, "[%d 0 0 -%d 0 0] makefont \n",
		(int)(0.5+which*PSFONT_PROP), (int)(0.5+which*PSFONT_PROP));
		fprintf(ps_file, "setfont \n");

			while( !(do_tima(0, which_x)>do_bis(0, which_x)) && xtickmarks) // PC 001206
			{	tima=GetImage(do_tima);
				fprintf(ps_file, "%d %d %d %d XplLine\n",
					tima.x, 
					von.y+(int)(voffset[1]*height*TICK_HEIGHT/100.0+0.5), 
					tima.x, von.y);
				
				fprintf(ps_file, "%d %d %d %d XplLine\n",
					tima.x, bis.y, 
					tima.x, bis.y-
					(int)(voffset[0]*height*TICK_HEIGHT/100.0+0.5));
				
				tm=(do_tima(0,which_x)-xcontent[5])/
						xcontent[6];
				sprintf(zahl, AXIS_FORMAT, tm);
				prepare_string(zahl);

				if (bottom_frame_visible())
				{	fprintf(ps_file, 
					"(%s) %d %d XplShow\n", zahl,
					tima.x,
					von.y+
	+(int)(voffset[1]*height*(TICK_STRING_HEIGHT+TICK_HEIGHT)/100.0+0.5));
//voffset[1]*height/100/2);
				}										
				do_tima(0, which_x)=do_tima(0, which_x)+
				xcontent[3];
			
			}
	//	string m+0.001*x
			if (bottom_frame_visible() && xtickmarks) // PC 001206
			{	astring=axisstring(this, which_x+1);		
				fprintf(ps_file, "(%s) %d %d XplShow\n",
				 astring, width/2, 
			height-(int)(voffset[1]*height*TICK_HEIGHT/100.0+0.5));	
				delete astring;
			}
			
			do_tima.fill(0.0);
			do_tima(0, which_y)=y_origin;

			while( !(do_tima(0, which_y)>do_bis(0, which_y)) && ytickmarks) // PC 001206
			{	tima=GetImage(do_tima);
				fprintf(ps_file, "%d %d %d %d XplLine\n",
					von.x-(int)(hoffset[0]*width*TICK_HEIGHT/100.0+0.5), 
					tima.y, 
					von.x, tima.y);
				
				fprintf(ps_file, "%d %d %d %d XplLine\n",
					bis.x, tima.y, 
					bis.x+(int)(hoffset[1]*width*TICK_HEIGHT/100.0+0.5), 
					tima.y);
			tm=(do_tima(0,which_y)-ycontent[5])/
				ycontent[6];

				if (left_frame_visible())
				{	sprintf(zahl, AXIS_FORMAT, tm);
					prepare_string(zahl);
					fprintf(ps_file, 
					"(%s) %d %d XplRotShow\n", zahl,
					von.x-1-(int)(hoffset[0]*width*(TICK_HEIGHT)/100.0+0.5), 
					tima.y);
				}	
				//	30=10+40/2!!
				do_tima(0, which_y)=do_tima(0, which_y)+
				ycontent[3];
			
			}
	//	string m+0.001*y
		
			if (left_frame_visible() && ytickmarks) // PC 001206
			{	astring=axisstring(this, which_y+1);
				fprintf(ps_file, "(%s) %d %d XplRotShow\n",
				 astring,
			(int)(hoffset[0]*width*TICK_STRING_HEIGHT/100.0+0.5), 
					height/2);
				delete astring;
			}
	
		//	kein AXIS_STRING_OFFSET+ noetig!
		}
		else
			;		//only frame is visible...
		}
		else
		{	fprintf(ps_file, "/Times-Roman findfont\n");
				fprintf(ps_file,
				"[16 0 0 -16 0 0] makefont \nsetfont \n");
			do_von=GetRotationPoint();
			von=GetImage(do_von);
			if (von.x>0 && von.x<width && von.y>0 && von.y<height)
			for (i=0; i<dim; i++)
			{	ax_da=GetAchse(1);	// NUR!
				xcontent=ax_da.GetContent();
				timm=GetRotationPoint();
				timm.fill(0.0);
				secsk=GetFirstSkalierung();
				timm(0, i)=xcontent[3]*secsk(0,0)/secsk(i,i);

				do_bis=do_von+timm;
				do_tima=do_bis+timm*0.2;

				bis=GetImage(do_bis);
				//if (bis.x>0 && bis.x<width
				//	&& bis.y>0 && bis.y<height)
				{	fprintf(ps_file, "%d %d moveto\n",
						von.x, von.y);
					fprintf(ps_file,
						"%d %d lineto stroke\n",
						bis.x, bis.y);
				}

				tima=GetImage(do_tima);
				//if (tima.x>0 && tima.x<width
				//	&& tima.y>0 && tima.y<height)
 				{  // PC 20020320 - axis should be described 1, 2, 3
               //astring=axisstring(this, i+1);
					sprintf(zahl, "%d", i+1);
					fprintf(ps_file,
						"(%s) %d %d XplShow\n", zahl, // astring,
						tima.x, tima.y);
					//delete astring;
				}
			}
		}


	}	
	char *labsi;
	Liste <XplLabel> labs;
	int which_current;
	int which=LAB_FONT;
	
	points=GetPointKoord();
	int last_color=0;
	for (j=0; j<GetDataCount(); j++)
	if (SomeLabels(j+1))
	{	fprintf(ps_file, "/Times-Roman findfont\n");
		fprintf(ps_file, "[%d 0 0 -%d 0 0] makefont \n",
			(int)(0.5+which*FONT_PROP),
			(int)(0.5+which*FONT_PROP));
		fprintf(ps_file, "setfont \n");
		p_co=GetPointCount(j+1);
		labs=GetLabels(j+1);
		last_color=0;
		sprintf(line, 
			"%1.3f %1.3f %1.3f setrgbcolor", 
			0.0, 0.0, 0.0);
		fprintf(ps_file, "%s \n", line);
		for (i=0; i<p_co; i++,points++)
		{	labsi=labs[i].GetText();
#ifdef _BLABLA_
		cout<<"LAbel: "<<labsi<<", direction="<<
				labs[i].direction<<
				", color="<<labs[i].color<<endl;
#endif
			if (labs[i].color!=last_color)
			{	col_num=all_colors[labs[i].color];
				red=col_num->red/(float)(256);
				green=col_num->green/(float)(256);
				blue=col_num->blue/(float)(256);
// PC 20020204 - fixed, all non-unix versions have to be divided by 256 once more
#ifndef _UNIX_
				red=red/(float)(256);
				green=green/(float)(256);
				blue=blue/(float)(256);
#endif

				sprintf(line,
					"%1.3f %1.3f %1.3f setrgbcolor",
				red, green, blue);
				fprintf(ps_file, "%s \n", line);
				last_color=labs[i].color;

			}
			which_current=labs[i].size;
			if (!(which==which_current) && labs[i].direction!=-1)
			{	fprintf(ps_file, "/Times-Roman findfont\n");
				fprintf(ps_file, "[%d 0 0 -%d 0 0] makefont \n",
					(int)(0.5+which_current*FONT_PROP), 
					(int)(0.5+which_current*FONT_PROP));
				fprintf(ps_file, "setfont \n");
				which=which_current;
			}
			switch(labs[i].direction)
			{	case -1:
				break;
				
				case 0: 
				fprintf(ps_file, 
				"(%s) %d %d XplShow\n", labsi,
				points->x, points->y+(int)(which_current/2));
				break;	
				
				case 3: 
				fprintf(ps_file, 
				"(%s) %d %d XplShow3\n", labsi,
				points->x+(int)(which_current/2), 
				points->y+(int)(which_current/2));
				break;					

				case 6: 
				fprintf(ps_file, 
				"(%s) %d %d XplShow6\n", labsi,
				points->x, 
				points->y+3*(int)(which_current/2));
				break;		
								
				case 9:
				fprintf(ps_file, 
				"(%s) %d %d XplShow9\n", labsi,
				points->x-(int)(which_current/2),
				points->y+(int)(which_current/2));
				break;					

				case 12:
				fprintf(ps_file, 
				"(%s) %d %d XplShow12\n", labsi,
				points->x, 
				points->y-(int)(which_current/2));
				break;	
				
				default:
				cout<<"sorry, not implemented"<<endl;
				break;
			}
			delete labsi;
			
		}
	}
	else
		points+=GetPointCount(j+1);

/*
	fprintf(ps_file, "grestore\n0 +%d translate\n", height);
	fprintf(ps_file, "1 -1 scale\n");
*/
	fprintf(ps_file, "grestore\ngrestore\n");

}
void Plot::Print(const char * file_name) const
{	FILE *ps_file;
	char line[256];
	char fname[16];
	
	static int n=1;
//	cout<<"PRINT!!!"<<endl;
//	cout<<"width="<<width<<", height="<<height<<endl;
	if (file_name==NULL)
		sprintf(fname, "%s%d.ps", "subd", n);
	else
		sprintf(fname, "%s", file_name);
	//	cout<<"filename: "<<fname<<endl;
	ps_file=fopen(fname, "w");  // SK 23.06.98
	if ( ps_file==NULL )
	{	globalError.Set (ERR_FILE, fname);
		globalError.ShowError();
		return;
	}
	fprintf(ps_file, "%s\n",
		"%!PS-Adobe-2.0 EPSF-1.2");
	fprintf(ps_file, "%s 0 0 %d %d\n",
		"%%BoundingBox:",
		width+PAPER_OFFSET, height+PAPER_OFFSET);
		
	fprintf(ps_file, "%s\n",
		"/POINT {2 0 360 arc stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/RECTANGLE {moveto 4 4  rmoveto -4 4 rlineto -4 -4 rlineto 4 -4 rlineto 4 4 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/CIRCLE {4 0 360 arc stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/TRIANGLE {moveto 0 4  rmoveto -4 -4 rlineto 4 -4 rlineto 0 4 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/XSYM {moveto 4 4 rmoveto -4 -4 rlineto -4 4 rmoveto 4 -4 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/RHOMBUS {moveto 0 4  rmoveto -4 0 rlineto 0 -4 rlineto 4 0 rlineto 0 4 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/FLD_RECTANGLE {moveto 4 4  rmoveto -4 4 rlineto -4 -4 rlineto 4 -4 rlineto 4 4 rlineto closepath gsave fill grestore stroke} def" );

	fprintf(ps_file, "%s\n",
		"/FLD_CIRCLE {4 0 360 arc fill} def" 	);
		
	fprintf(ps_file, "%s\n",
		"/FLD_ROMB {moveto 0 4  rmoveto -4 0 rlineto 0 -4 rlineto 4 0 rlineto 0 4 rlineto closepath gsave fill grestore stroke} def" 	);

	fprintf(ps_file, "%s\n",
		"/FLD_TRIANGLE {moveto 0 4  rmoveto -4 -4 rlineto 4 -4 rlineto 0 4 rlineto closepath gsave fill grestore stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/CROSS {moveto -4 0 rmoveto 4 0 rlineto 0 -4 rmoveto 0 4 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/STAR {moveto -4 0 rmoveto 4 0 rlineto 0 -4 rmoveto 0 4 rlineto 4 4 rmoveto -4 -4 rlineto -4 4 rmoveto 4 -4 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/GRID {moveto -4 0 rmoveto 4 0 rlineto 0 -4 rmoveto 0 4 rlineto 4 4  rmoveto -4 4 rlineto -4 -4 rlineto 4 -4 rlineto 4 4 rlineto stroke} def" 	);

	fprintf(ps_file, "%s\n",
"/GRID_RHOMBUS {moveto 4 4 rmoveto -4 -4 rlineto -4 4 rmoveto 4 -4 rlineto -4 0 rmoveto 4 0 rlineto 0 -4 rmoveto 0 4 rlineto stroke} def" 	);



	fprintf(ps_file, 
	"/XplShow {moveto dup stringwidth pop 2 div neg 0 rmoveto show} def\n");
		
	fprintf(ps_file, 
"/XplShow3 {moveto show} def\n");
	
	fprintf(ps_file, 
"/XplShow6 {moveto dup stringwidth exch 2 div neg exch rmoveto show} def\n");
	
	fprintf(ps_file, 
"/XplShow9 {moveto dup stringwidth pop neg 0 rmoveto show} def\n");
	
	fprintf(ps_file, 
"/XplShow12 {moveto dup stringwidth neg exch 2 div exch rmoveto show} def\n");
	
	fprintf(ps_file, 
	"/XplRotShow {moveto -90 rotate dup stringwidth pop 2 div neg 0 rmoveto show 90 rotate} def\n");

	fprintf(ps_file, 
	"/XplClip {/h exch def /w exch def w 0 rlineto 0 h rlineto w neg 0 rlineto gsave fill grestore newpath} def\n");

	fprintf(ps_file, 
	"/XplLine {moveto lineto stroke} def\n");
	
	fprintf(ps_file, 
	"/XplPointAs {gsave 0 0 7 1 roll 7 1 roll translate div  dup scale cvx cvn exec grestore} def\n");
	
	fprintf(ps_file, "/XAS {XplPointAs} def\n");	
	fprintf(ps_file, "/P {POINT} def\n");	
	fprintf(ps_file, "/R {RECTANGLE} def\n");	
	fprintf(ps_file, "/C {CIRCLE} def\n");	
	fprintf(ps_file, "/T {TRIANGLE} def\n");	
	fprintf(ps_file, "/X {XSYM} def\n");	
	fprintf(ps_file, "/RH {RHOMBUS} def\n");	
	fprintf(ps_file, "/FR {FLD_RECTANGLE} def\n");	
	fprintf(ps_file, "/FC {FLD_CIRCLE} def\n");	
	fprintf(ps_file, "/FRH {FLD_ROMB} def\n");	
	fprintf(ps_file, "/FT {FLD_TRIANGLE} def\n");	
	fprintf(ps_file, "/CR {CROSS} def\n");	
	fprintf(ps_file, "/S {STAR} def\n");	
	fprintf(ps_file, "/G {GRID} def\n");	
	fprintf(ps_file, "/GR {GRID_RHOMBUS} def\n");	

	Print(ps_file);

	// Sehr wichtig!!!	
	fprintf(ps_file, "showpage");
	fclose(ps_file);
	n++;
	
}
	
Boolean Plot::SomeLabels(int data_num) const
{	return(vis_data[data_num-1]->SomeLabels());
}

Liste <XplLabel > Plot::GetLabels(int data_num, int point_number) const
{	return(vis_data[data_num-1]->GetLabels(point_number));
}

int Plot::SetLabels(int data_num, const Liste <int> co, 
		const Liste <XplLabel> & labs )
{	return(vis_data[data_num-1]->SetLabels(co, labs));	}
	
//	data_num=1, ..., vis_data.laenge()
//	point_number=1, ..., number of points in this dataset
//	line_number=1, ..., number of lines in this dataset

	
int Plot::QuadrDistToPoint(MyPoint & mouse_pointer,
				int data_number,
				int point_number)
{	if (data_number<1 || data_number>vis_data.laenge())
	{	cerr<<"Error by Plot::QuadrDistToPoint by data_number="<<
			data_number<<endl;
		return(-1);
	}
	int point_count=vis_data[data_number-1]->GetPointCount();
	if (point_number<1 || point_number>point_count)
	{	cerr<<"Error by Plot::QuadrDistToPoint by point_number="<<
			point_number<<endl;
		return(-1);
	}

	MyPoint *mp=PointKoord;
	int i;
	for (i=1; i<data_number; i++)
		mp+=vis_data[i-1]->GetPointCount();
	mp+=point_number;
	return((mouse_pointer.x-mp->x)*(mouse_pointer.x-mp->x)+(mouse_pointer.y-mp->y)*(mouse_pointer.y-mp->y));
}
	
int Plot::QuadrDistToLine(MyPoint & mouse_pointer,
				int data_number,
				int line_number)
/* 	return the quadrat from disatance in window geometry	*/
{return(0);}
	
int Plot::NearestLineTo(MyPoint &x) const	//get the line index (1, ..., n)
{return(0);}

Boolean Plot::IsThisPoint(	MyPoint & mouse_pointer, 
				int data_number,
				int point_number)
	/* 	uses the pointsize and QuadrDistToPoint*/
{	int qd=QuadrDistToPoint(mouse_pointer, data_number, point_number);
	int hout=vis_data[data_number-1]->GetPointLayout(point_number);
	int size=all_symbols[hout-2]->size;
	Boolean ret;
	ret=(qd<=size*size);
	return(ret);
}
	

MyPoint Plot::CenterOfPolygon(int data_number,
				int line_number)
{	MyPoint ret;
	ret.x=0;
	ret.y=0;
	int count=GetPolygonSize(data_number, line_number);	// 1 zu viel?
	int * indy=vis_data[data_number-1]->GetPolygonIndex(line_number);
	if ( (*indy)==(*(indy+count-1)) )
		count--;   
	delete indy;

	MyPoint * ptop=GetPointsToPolygon(data_number, line_number);

	if (count==0 || count==1)
	{	ret.x=ptop->x;
		ret.y=ptop->y;
		delete (ptop-count);
		return(ret);
	}
		
	int i;
	for (i=0; i<count; i++, ptop++)
	{	ret.x+=ptop->x;
		ret.y+=ptop->y;
	}
	ret.x=ret.x/count;
	ret.y=ret.y/count;
	
	delete (ptop-count);
	return(ret);
}
	
Boolean Plot::InThisLine(	MyPoint & mouse_pointer, 
				int data_number,
				int line_number)
	/* 	for lines: uses the linewidth and QuadrDistToLine	*/
{return(0==0);}
Boolean Plot::InThisPolygon(	MyPoint & mouse_pointer, 
				int data_number,
				int line_number)
	/* 	for polygons: uses the linewidth;			*/
	/*	is ==True if the point belongs the polygon or the border*/
{	Boolean ret=False;
#ifdef _UNIX_
	int count=GetPolygonSize(data_number, line_number);	// 1 zu viel?
	MyPoint * ptop=GetPointsToPolygon(data_number, line_number);
	Region regi=XPolygonRegion((XPoint *)ptop, count, WindingRule);
	ret=XPointInRegion(regi, mouse_pointer.x, mouse_pointer.y);
#endif 
	return(0==1);
}

bool Plot::top_frame_visible() const
{	return( (int)(voffset[0]*height/100.0+0.5)>=MIN_BORDER);
}
bool Plot::bottom_frame_visible() const
{	return( (int)(voffset[1]*height/100.0+0.5)>=MIN_BORDER);
}
bool Plot::left_frame_visible() const
{	return( (int)(hoffset[0]*width/100.0+0.5)>=MIN_BORDER);
}
bool Plot::right_frame_visible() const
{	return( (int)(hoffset[1]*width/100.0+0.5)>=MIN_BORDER);
}

const char *Plot::GetPSFontName(void) const
{
     if (desc_font_type == FT_MONOSPACE)
          return PSFN_MONOSPACE;
     else if (desc_font_type == FT_SANSSERIF)
          return PSFN_SANSSERIF;
     else return PSFN_SERIF;
}

