/* $Header: /home/xplore/cvs/xpl4gr/swefun4.C,v 1.3 2002/08/16 12:31:51 sigbert Exp $ */

// Erweiterung of SWS_Interpreter
//  SWS 26.2.95

#pragma implementation "liste.h"

#include <math.h>
#include <new.h>
#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif
#include <signal.h>

#include "liste.h"
#include "init.h"
#include "function.h"
#include "macro.h"
#include "xplfun.h"
#include "xplfun2.h"
#include "xplfun3.h"
#include "xplbasefun.h"
#include "plot.h"

#ifdef _GRAPHICS_
#include "motif.h"

BS_Glob_Variable bs_glob_variable;

struct 	D_S	{	Widget text_w;
			XplObject *wohin;
		};

Boolean fertig;
	
void dialog_ok(Widget w, XtPointer p1, XtPointer p2)
{	struct 	D_S *ds=(struct D_S*) p1;
	Widget te=ds->text_w;
	XplObject *o=ds->wohin;
	char *st=XmTextGetString(te);
	float d;
	cout<<"DIALOG : "<< st<<endl;
	cout<<"und XplDouble:"<<endl;
	o->Print();

	switch(o->Type())
	{	case O_XPLDOUBLE:
			if (! (sscanf(st, "%g", &d)==1))
			{	xplmessage("it is not a double!");
				return;
			}
			//cout<<"DOUBLE : soll:"<<d<<endl;  
			//o->DefaultXplDouble()->mdump("%g");			
			(*(o->DefaultXplDouble()))(0)=(double)d;
			//o->DefaultXplDouble()->mdump("%g");			
			break;
		case O_XPLCHAR:
			cout<<"XPLCHAR"<<endl;
			break;
		default:	
			cout<<"UNKNOWN TYPE"<<endl;
			break;
	}	
	XtFree(st);
	fertig=True;
}

XplObject* dialogbox(Liste<XplObject*> *argl)
{	static Widget d_dialog=NULL;

	char *str="DEFAULT";
	float f=0.0;
	
	if (argl->laenge()==2)
	{			
	
	if (! ((*argl)[0]->Type()==O_XPLCHAR))
	{	globalError.Set (ERR_INTERN, "Error by dialogbox: first parameter must be a XplChar!");
		return(NULL);
	}
	XplChar * xplc=(*argl)[0]->DefaultComponent()->Content().xplchar;
	str=(*xplc)(0).tostr();	//OK!
#ifdef _BLABLA_
	cout<<"str="<<str<<endl;
#endif	
	if (! ((*argl)[1]->Type()==O_XPLDOUBLE))
	{	globalError.Set (ERR_INTERN, "Error by dialogbox: second parameter must be a XplDouble!");
		return(NULL);
	}
	XplDouble * xd=(*argl)[1]->DefaultXplDouble();
	f=(*xd)[0];
	}
#ifdef _BLABLA_
	cout<<"xd="<<f<<endl;	
#endif	
	static struct D_S *ds;
		
	Widget ok;
	if (d_dialog==NULL)
	{	d_dialog=XmCreatePromptDialog(bs_glob_variable.main_shell, 
			"XploRe_dialog", (Arg *)NULL, 0);
		ok=XmSelectionBoxGetChild(d_dialog, XmDIALOG_OK_BUTTON);
		 ds=(struct D_S *)(new (struct D_S) [1]);
		XtAddCallback(ok,  XmNactivateCallback, dialog_ok, 
			(XtPointer) ds);
	}
	Widget lab, text;
	lab=XmSelectionBoxGetChild(d_dialog, XmDIALOG_SELECTION_LABEL);
	XmString xms=XmStringCreateSimple(str);
	XtVaSetValues(lab, XmNlabelString, xms, NULL);
	XmStringFree(xms);	//OK
	delete str;
	
	str=new char [16];
	sprintf(str, "%f", f);
	text=XmSelectionBoxGetChild(d_dialog, XmDIALOG_TEXT);
	XmTextSetString(text, str);
	delete str;
	

  	XplObject *o  = new XplObject (new XplDouble (1), "uhu");
	(*(o->DefaultXplDouble()))(0)=f;
  	ds->text_w=text;
  	ds->wohin=o;
	o->Print();

	XtManageChild(d_dialog);
	
	fertig=False;
	while (!fertig)
		XtAppProcessEvent(bs_glob_variable.kontext, XtIMAll);
	
	
	
	return(o);
}

Widget colorwindow;
XColor color;
#include <Xm/Scale.h>

#define DoColor 111
#define DoLight 222
#define DoSatur 333


double val(double n1, double n2, double hue)
{	if (hue>360)
		hue=hue-360;
	else if (hue<0)
		hue=hue+360;
	if (hue<60)
		return(n1+(n2-n1)*hue/60);
	if (hue<180)
		return(n2);
	if (hue<240)
		return(n1+(n2-n1)*(240-hue)/60);
	return(n1);
}

void new_value(Widget scale_w, XtPointer p1, XmScaleCallbackStruct *cbs)
{	int *rgbp=(int *)p1;
	int rgb;
	rgb=(*rgbp);
	XplDouble *rgbd;
	XtVaGetValues(scale_w, XmNuserData, &rgbd, NULL);
	
	static double l=0.5, s=0.5, h=359, delta;
	//und jetzt wahrnehmen....
	Colormap cmap=DefaultColormapOfScreen(XtScreen(scale_w));
	cout<<rgb<<endl;
	switch(rgb)
	{	case DoColor:
		h=cbs->value;
		cout<<"DOCOLOR!"<<endl;
		break;
		case DoLight:
		cout<<"DOCLIGHT!"<<endl;
		l=(cbs->value)/(double)100;
		break;
		case DoSatur:
		cout<<"DOSATUR!"<<endl;
		s=(cbs->value)/(double)100;
		break;
	}
	//und jetzt zurueck...
	double m2, m1;
	if (l<=0.5)
		m2=l*(1+s);
	else
		m2=l+s-l*s;
	m1=2*l-m2;
	if (s==0)
		rgbd->fill(l);
	else
	{	(*rgbd)(0)=val(m1, m2, h+120);
		(*rgbd)(1)=val(m1, m2, h);
		(*rgbd)(2)=val(m1, m2, h-120);
	}
	color.red=(int)(0.5+(*rgbd)(0)*65536);
	color.green=(int)(0.5+(*rgbd)(1)*65536);
	color.blue=(int)(0.5+(*rgbd)(2)*65536);	
	XFreeColors(XtDisplay(scale_w), cmap, &color.pixel, 1, 0);
	if (!XAllocColor(XtDisplay(scale_w), cmap, &color))
	{	cerr<<"OH NEIN!"<<endl;
		exit(1);
	}
	XtVaSetValues(colorwindow, XmNbackground, color.pixel, NULL);
}		
	
XplObject* colordialogbox(Liste<XplObject*> *argl)
{	static 	Widget sh=NULL;
	int *DC=new (int);
	(*DC)=DoColor;
	int *DL=new (int);
	(*DL)=DoLight;
	int *DS=new (int);
	(*DS)=DoSatur;
	
	cout<<(*DC)<<(*DL)<<(*DS)<<endl;
	
	if (! (sh==NULL))
	{	XtPopup(sh, XtGrabNone);
		return(NULL);
	}
	Widget main_shell=bs_glob_variable.main_shell;
	
	Widget rowcol, scale;
		
	XplDouble *rgb=new XplDouble(3);
	rgb->fill(1.0);
	color.flags=DoRed|DoGreen|DoBlue;
	color.red=65535;
	color.blue=color.green=0;
	XAllocColor(XtDisplay(main_shell),
	 		DefaultColormapOfScreen(XtScreen(main_shell)),
	 		&color);
	sh=XtCreatePopupShell("XploRe_color", topLevelShellWidgetClass,
			main_shell, (Arg*)NULL, 0);
	rowcol=XtVaCreateManagedWidget("rc", xmFormWidgetClass, 
			sh, NULL);
	colorwindow=XtVaCreateManagedWidget("cw",
	 		widgetClass, rowcol,
	 		XmNheight, 100,
	 		XmNtopAttachment, XmATTACH_FORM,
	 		XmNleftAttachment, XmATTACH_FORM,
	 		XmNrightAttachment, XmATTACH_FORM,
	 		XmNbackground, color.pixel, NULL);
	rowcol=XtVaCreateWidget("rowcol", xmRowColumnWidgetClass, 
	 		rowcol, XmNorientation, XmHORIZONTAL, 
	 		XmNtopAttachment, XmATTACH_WIDGET,
	 		XmNtopWidget, colorwindow,
	 		XmNbottomAttachment, XmATTACH_FORM,
	 		NULL);
	 	
	scale=XtVaCreateManagedWidget("Color", xmScaleWidgetClass, rowcol,
	 	XmNshowValue, True,
	 	XmNmaximum, 359,
	 	XmNvalue, 1,
	 	XmNminimum, 1,
	 	//XmNscaleMultiple, 5,
	 	XmNuserData, rgb, 
	 	XtVaTypedArg, XmNtitleString, XmRString, "Color", 6, NULL);
	XtAddCallback(scale, XmNdragCallback, new_value, (XtPointer)DC);
	XtAddCallback(scale, 
		XmNvalueChangedCallback, new_value, (XtPointer)DC);
	 	
	scale=XtVaCreateManagedWidget("Light", xmScaleWidgetClass, rowcol,
	 	XmNshowValue, True,
	 	XmNmaximum, 99,
	 	XmNvalue, 50, 
	 	XmNminimum, 1,
	 	//XmNscaleMultiple, 1,
	 	XmNuserData, rgb, 
	 	XtVaTypedArg, XmNtitleString, XmRString, "Light", 5,NULL);
	XtAddCallback(scale, XmNdragCallback, new_value, (XtPointer)DL);
	XtAddCallback(scale, 
		XmNvalueChangedCallback, new_value, (XtPointer)DL);
	 	
	scale=XtVaCreateManagedWidget("Satur", xmScaleWidgetClass, rowcol,
	 	XmNshowValue, True,
	 	XmNmaximum, 99,
	 	XmNminimum, 1,
	 	XmNvalue, 50, 
	 	//XmNscaleMultiple, 1,
	 	XmNuserData, rgb, 
	 	XtVaTypedArg, XmNtitleString, XmRString, "Satur", 6, NULL);
	XtAddCallback(scale, XmNdragCallback, new_value, (XtPointer)DS);
	XtAddCallback(scale, 
		XmNvalueChangedCallback, new_value, (XtPointer)DS);

	XtManageChild(rowcol);
	XtPopup(sh, XtGrabNone);
	return(NULL);
}	 	
	
#endif
