/* $Header: /home/xplore/cvs/xpl4gr/uplot1.C,v 1.4 2003/05/23 16:43:21 cizek Exp $ */

#ifdef _UNIX_

#ifndef __BORLANDC__
#include <unistd.h>
#else
#include <process.h>
#endif
#include <iostream.h>

#include "liste.h"
#include "main.h"
#include "uplot.h"
#include "udisp.h"
#include "xplio.h"
#include "color.h"

#define GREY 8
#define BRUSH_OUT 85
#define BRUSH_COLOR 0

#define CONVEX 15
#define DASH_MAL 1

#ifndef MENUE_HEIGHT
#define MENUE_HEIGHT 50			// sieh udisp.C!
#endif

#ifdef _GUIDO_
extern	int starttime;
extern	char *gformat;
extern char *gfname;
#endif

extern Liste <XplColor *> all_colors;
extern Liste <XplSymbol *> all_symbols;

extern Colormap cmap;			//OK


extern void ZoomPlot(Plot *plot, int x1, int y1, int x2, int y2);

extern "C" int rpc_xfer_brush_to_xgobi(char *, int);

extern char *xplfont_vorname[];
extern char *xplfont_name[];
extern XplObject *FreeColor(Liste <XplObject*>  *);
//extern int which_font(int);
			
#define HEAD_FONT XMSG_FONTMASK_SERIF

extern double  distanz(XplMatrix &x, XplMatrix &y);

extern int ADashOfPolygon(int);
extern int BDashOfPolygon(int);

#ifdef _GRAPHICS_
#include <X11/keysymdef.h>
#include <X11/keysym.h>

extern "C" void	wrefresh(Widget);

Plot * plot_for_user=NULL;
XplDouble xym(2);

extern Boolean ready;

extern "C"	{

/*	Globale Variablen						*/

extern BS_Glob_Variable bs_glob_variable;

extern GC every_gc;
// NE FIG TUT! extern XFontStruct *every_font_info[];

#define JUST 500
#define RP_SIZE 4
#define MAL 32

void show_rotation_point(Widget draw)
{	Wid_Data *wid_data;
	Pixel color;
	MyPoint mp;
	XplMatrix rp;

	Window win;
	Display *dis;

	
	win=XtWindow(draw);
	dis=XtDisplay(draw);

/*	XWindowAttributes wa;
	if (XGetWindowAttributes(dis, win, &wa)==0)
	{	//cout<<"NULL!"<<endl;
		return;
	}
	
	switch (wa.map_state)
	{	case IsViewable: 
		//	//cout<<"IsViewable"<<endl;
			break;
		case IsUnmapped: 
		//	//cout<<"IsUnmapped"<<endl;
			return;
		case IsUnviewable: 
		//	//cout<<"IsUnviewable"<<endl;
			return;
	}	
*/
/*	XtVaGetValues(draw,XmNbackground, &color, XmNuserData, &wid_data,
				NULL);
	XSetBackground(XtDisplay(draw),
				every_gc, color);
	XSetForeground(XtDisplay(draw),
				every_gc, 
				BlackPixel(dis, DefaultScreen(dis)));
	Plot *pl=(Plot *)(wid_data->subdis);
	rp=pl->GetRotationPoint();
	mp=pl->GetImage(rp);
	XCopyPlane(dis, 
		bs_glob_variable.bitmap[3],
		win, every_gc,
		0,0,7,7, 
		mp.x-3,
		mp.y-3, 1);
*/
}




void redraw_some_points(Widget draw, int data_num, XplMatrix & which_points)
{	int j,i,  p_co, gemalt;
	Window win;
	Display *dis;
	Wid_Data *wid_data;
	Plot *plot;
	Dimension wi, he;
	Pixel color;
	Outfit outfit;
	long unsigned int pixel;
	int sym_size, size2;

	wrefresh(draw);
	
/*	win=XtWindow(draw);
	dis=XtDisplay(draw);

#ifdef _BLABLA_
	cout<<"redraw_some_points..."<<endl;
#endif
	XtVaGetValues(draw,XmNbackground, &color, XmNuserData, &wid_data,
			XmNwidth, &wi, XmNheight, &he,
				NULL);
	XSetBackground(XtDisplay(draw),
				wid_data->bitmap_gc, color);
	plot=(Plot *)(wid_data->subdis);
		
	XSetFunction(dis, wid_data->bitmap_gc, GXcopy);
	MyPoint *mp=plot->GetPointKoord();

	for (j=0; (j<data_num-1 && j<plot->GetDataCount()); j++)
	{	mp+=plot->GetPointCount(j+1);
	}
	if (j==plot->GetDataCount())
		return;
	gemalt=0;
	p_co=which_points.rows();
	while ( gemalt<p_co)
	{	while (gemalt<p_co && which_points(gemalt, 0)==0 )
			gemalt++, mp++;
		if (gemalt==p_co)
			return;
		
		outfit=plot->GetPointLayout(data_num, gemalt+1);
		pixel=all_colors[plot->GetPointColor(data_num,
				 gemalt+1)]->pixel;
		XSetForeground(XtDisplay(draw),
				wid_data->bitmap_gc, pixel);

		switch(outfit)
		{	case POINT:
			XSetClipMask(XtDisplay(draw),
					wid_data->bitmap_gc, None);
			XDrawPoint(dis, wid_data->pixy,
				wid_data->bitmap_gc,
				mp->x, mp->y);
			break;

			case NOPOINT:
			break;
				
			default:
				
			if (outfit-2<0 ||
					outfit-2>all_symbols.laenge())
			{	cerr<<"error by show_points!"<<endl;
				return;
			}
			XSetClipMask(XtDisplay(draw),
					wid_data->bitmap_gc,
					all_symbols[outfit-2]->pixy);
			sym_size=all_symbols[outfit-2]->size;
			size2=sym_size/2;
			if (	which_points(gemalt, 0)==1 &&
				mp->x>-1 && mp->x<wi+1 
				&& mp->y>-1 && mp->y>-1 )
			{
					XSetClipOrigin(XtDisplay(draw),
					wid_data->bitmap_gc, mp->x-size2,
					mp->y-size2);
					XFillRectangle(dis,
					wid_data->pixy, wid_data->bitmap_gc,
					mp->x-size2, mp->y-size2, 
					sym_size, sym_size);

			}


		}
		mp++;
		gemalt++; 
	}

	XSetClipMask(XtDisplay(draw),
					wid_data->bitmap_gc, None);
	XtVaGetValues(draw, XmNbackground, &color, NULL);
	XSetBackground(dis, every_gc, color);
	XSetFunction(dis, every_gc, GXcopy);
	XCopyArea(dis, wid_data->pixy, XtWindow(draw), every_gc, 0, 0, wi, he,
	 	0, 0);
*/
}	





void show_point(Widget draw)
{	int i, j, k, p_co, count;
	//Window win;
	Display *dis;
	Pixel color;
	Wid_Data *wid_data;
	int gemalt, homogen, homo_color, points_drawn;
	Outfit homo_outfit;
	Plot *plot;
	long unsigned int pixel;
	Dimension wi, he;
	Liste <XplObject *> li;	
	
	//win=XtWindow(draw);
	dis=XtDisplay(draw);
	
	XtVaGetValues(draw,XmNbackground, &color, XmNuserData, &wid_data,
			XmNwidth, &wi, XmNheight, &he,
				NULL);

	XSetBackground(XtDisplay(draw),
				wid_data->bitmap_gc, color);
	//cout<<"hier"<<endl;
	
	plot=(Plot *)(wid_data->subdis);
		
	XSetFunction(dis, wid_data->bitmap_gc, GXcopy);
	//	XSetPlaneMask(dis, wid_data->bitmap_gc, 1);
	MyPoint *mp=plot->GetPointKoord();
	
	int sym_size, size2;
	
	//cout<<"es gibt "<<all_symbols.laenge()<<endl;
	
	XSetWindowColormap(dis, XtWindow(draw), cmap);	//OK
	for (j=0; j<plot->GetDataCount(); j++)
	{	p_co=plot->GetPointCount(j+1);
		gemalt=0;	

		
		while (gemalt < p_co)
		{	homogen=1;
			homo_outfit=plot->GetPointLayout(j+1, gemalt+1);
			homo_color=plot->GetPointColor(j+1, gemalt+1);
			while 
				(	homogen+gemalt < p_co &&
		plot->GetPointColor(j+1, gemalt+homogen+1)==
			homo_color &&
		plot->GetPointLayout(j+1, gemalt+homogen+1)==
			homo_outfit	
				)
				homogen++;
								
			pixel=all_colors[homo_color]->pixel;
			XSetForeground(XtDisplay(draw),
					wid_data->bitmap_gc, pixel);
					
			XSetBackground(XtDisplay(draw),
				wid_data->bitmap_gc, 0);
			switch(homo_outfit)
			{	case POINT:
				XSetClipMask(XtDisplay(draw),
					wid_data->bitmap_gc, None);
				points_drawn=0;
				while (points_drawn+JUST<homogen)
				{	XDrawPoints(dis, wid_data->pixy,
						wid_data->bitmap_gc,
						(XPoint *)mp, JUST,
						CoordModeOrigin);
					mp=mp+JUST;
					points_drawn+=JUST;
				}	
				XDrawPoints(dis, wid_data->pixy,
						wid_data->bitmap_gc,
						(XPoint *)mp,
						homogen-points_drawn, 
						CoordModeOrigin);
					mp=mp+(homogen-points_drawn);
				break;

				case NOPOINT:
			//	//cout<<"NOPOINT"<<endl;
				mp=mp+homogen;
				break;
				
				default:
				
				if (homo_outfit-2<0 ||
					 homo_outfit-2>all_symbols.laenge())
				{	cerr<<"error by show_points!"<<endl;
					return;
				}
				XSetClipMask(XtDisplay(draw),
					wid_data->bitmap_gc,
					all_symbols[homo_outfit-2]->pixy);
				sym_size=all_symbols[homo_outfit-2]->size;
				size2=sym_size/2;
				for (i=0; i<homogen; i++, mp++)
				{	if (	mp->x>-1 && mp->x<wi+1 
						&& mp->y>-1 && mp->y>-1)
					{
					XSetClipOrigin(XtDisplay(draw),
					wid_data->bitmap_gc, mp->x-size2,
					mp->y-size2);
					XFillRectangle(dis,
					wid_data->pixy, wid_data->bitmap_gc,
					mp->x-size2, mp->y-size2, 
					sym_size, sym_size);

#ifdef _BLABLA_
				cout<<" visible ";
#endif

					}
#ifdef _BLABLA_
					else
				cout<<" invisible ";
#endif
					
					
		//cout<<"Gemalt bei("<<
		//	mp->x<<", "<<mp->y<<")\n";
				}


			}
		gemalt+=homogen; 
		}

	}
	XSetFunction(dis, wid_data->bitmap_gc, GXcopy);
	XSetClipMask(XtDisplay(draw),
					wid_data->bitmap_gc, None);
}
void draw_lines(Widget draw)
{	int j, color, count;
	Lines_Outfit fi;
	Display *dis;
	Wid_Data *wid_data;
	Dimension wi, he;
	Plot *plot;
	char dash_list[2];	
	MyPoint *points;

	/*
	int j, color, count, poli_count;
	Lines_Outfit fi;
	Display *dis;
	Wid_Data *wid_data;
	Dimension wi, he;
	MyPoint *points;
	Plot *plot;
	char dash_list[2];		
	*/
	
	dis=XtDisplay(draw);
	XtVaGetValues(draw,XmNbackground, &color, XmNuserData, &wid_data,
				XmNwidth, &wi, XmNheight, &he, NULL);
	plot=(Plot *)(wid_data->subdis);

	int adash, bdash;
	int line_thickness;

	Liste <MyPolygon *> polis;
	polis=plot->GetPolygons();
	for (j=0; j<polis.laenge(); j++)
	if (polis[j]->layout!=NOLINE)
	{	points=polis[j]->GetPoints();
		count=polis[j]->GetPointCount();
		fi=polis[j]->layout;
		color=polis[j]->color;
		line_thickness=polis[j]->thick;
		XSetForeground(dis, wid_data->bitmap_gc,
			 	all_colors[color]->pixel);
		if ( fi==SOLID)
			XSetLineAttributes(dis, wid_data->bitmap_gc, 
				line_thickness, LineSolid, 
				CapRound, JoinRound);
			else 
			if (line_thickness!=CONVEX)
			{	adash=ADashOfPolygon(fi);
				bdash=BDashOfPolygon(fi);
#ifdef _BLABLA_
	cout<<fi<<" ergibt adash="<<adash<<" und bdash="<<bdash<<endl;
#endif			
				dash_list[0]=(char)(2*adash+2*line_thickness);
				dash_list[1]=(char)(2*bdash+2*line_thickness);

				XSetLineAttributes(dis, wid_data->bitmap_gc, 
				line_thickness, LineOnOffDash, 
				CapRound, JoinRound);
				XSetDashes(dis, wid_data->bitmap_gc, 
						0, dash_list, 2);
			}
			if (line_thickness!=CONVEX)
			{XDrawLines(dis, wid_data->pixy, wid_data->bitmap_gc,
				(XPoint *)points, count, CoordModeOrigin);
				
			/*	for (int kk=0; kk<count; kk++)
					cout<<points[kk].x<<", "<<points[kk].y<<endl;	*/
			}
			else
			{	XFillPolygon(dis, wid_data->pixy, 
				wid_data->bitmap_gc,
				(XPoint *)points, count, Convex, 
				CoordModeOrigin);			
				XSetLineAttributes(dis, wid_data->bitmap_gc, 
				0, LineSolid, 
				CapRound, JoinRound);
				XDrawLines(dis, wid_data->pixy, wid_data->bitmap_gc,
				(XPoint *)points, count, CoordModeOrigin);
			}
		delete points;
	}
	/*	for (j=0; j<plot->GetDataCount(); j++)
	{	poli_count=plot->GetPolygonCount(j+1);
	//	cout<<"Data "<<j<<" hat "<<poli_count<<" Polygons"<<endl;
		for (i=0; i<poli_count; i++)
		{ 	count=plot->GetPolygonSize(j+1, i+1);
			points=plot->GetPointsToPolygon(j+1, i+1);
			fi=plot->GetPolygonLayout(j+1, i+1);
			if (fi==NOLINE  )
				delete points;
			else
			{
			color=plot->GetPolygonColor(j+1, i+1);
	//		cout<<"Data "<<j<<", Polygon "<<i<<", Farbe:"
	//			<<color<<endl;
			XSetForeground(dis, wid_data->bitmap_gc,
			 	all_colors[color]->pixel);

			line_thickness=plot->GetPolygonThick(j+1, i+1);
			
			if ( fi==SOLID)
				XSetLineAttributes(dis, wid_data->bitmap_gc, 
				line_thickness, LineSolid, 
				CapRound, JoinRound);
			else 
			if (line_thickness!=CONVEX)
			{	adash=ADashOfPolygon(fi);
				bdash=BDashOfPolygon(fi);
#ifdef _BLABLA_
	cout<<fi<<" ergibt adash="<<adash<<" und bdash="<<bdash<<endl;
#endif			
				dash_list[0]=(char)(DASH_MAL*adash);
				dash_list[1]=(char)(DASH_MAL*bdash);

				XSetLineAttributes(dis, wid_data->bitmap_gc, 
				line_thickness, LineOnOffDash, 
				CapRound, JoinRound);
				XSetDashes(dis, wid_data->bitmap_gc, 0, dash_list, 2);
			}

			if (line_thickness!=CONVEX)
			XDrawLines(dis, wid_data->pixy, wid_data->bitmap_gc,
				(XPoint *)points, count, CoordModeOrigin);
			else
			{	XFillPolygon(dis, wid_data->pixy, 
				wid_data->bitmap_gc,
				(XPoint *)points, count, Convex, 
				CoordModeOrigin);			
				XSetLineAttributes(dis, wid_data->bitmap_gc, 
				0, LineSolid, 
				CapRound, JoinRound);
				XDrawLines(dis, wid_data->pixy, wid_data->bitmap_gc,
				(XPoint *)points, count, CoordModeOrigin);
			}
			delete points;
			}
		}
	}
*/






	XSetLineAttributes(dis, wid_data->bitmap_gc, 
		0, LineSolid, CapRound, JoinRound);
	
	return;
}

void clear_part(Widget draw,  Dimension x, Dimension y,
 		Dimension w, Dimension h)
{	
	Pixel color;
	XRectangle rec;
	Region regi;	
	Dimension wi, he;
	Wid_Data *wid_data;
	Display *dis=XtDisplay(draw);

	XtVaGetValues(draw, XmNbackground, &color, 
			XmNwidth, &wi, XmNheight, &he, 
			XmNuserData, &wid_data, NULL);
	rec.x=(short) x;
	rec.y=(short) y;
	rec.width=(short)w;
	rec.height=(short)h;
	regi=XCreateRegion();
	XUnionRectWithRegion(&rec, regi, regi);
	// ??XSetRegion(dis, wid_data->bitmap_gc, regi);	
	XSetForeground(dis, wid_data->bitmap_gc, color);
	XSetFunction(dis, wid_data->bitmap_gc, GXcopy);

	XDestroyRegion(regi);
	
	XFillRectangle(dis, wid_data->pixy, wid_data->bitmap_gc, 
		x, y, w, h);
	rec.x=(short) 0;
	rec.y=(short) 0;
	rec.width=(short)wi;
	rec.height=(short)he;
	regi=XCreateRegion();
	XUnionRectWithRegion(&rec, regi, regi);
	// ??XSetRegion(dis, wid_data->bitmap_gc, regi);	
	XDestroyRegion(regi);

}

void draw_text(Widget draw)
{	Wid_Data *wid_data;
	int i, head_size, which, which_current;
	Text_Data *text_data;
	MyPoint where;
	XplMatrix ori;
	Plot *plot;
	Window win;
	Display *dis;
	Dimension wi, he;
	int te_wi, te_he;

	win=XtWindow(draw);
	dis=XtDisplay(draw);

	XtVaGetValues(draw,XmNuserData, &wid_data,
			XmNwidth, &wi, XmNheight, &he, NULL);
	XSetWindowColormap(dis, XtWindow(draw), cmap);	//OK

	plot=(Plot *)(wid_data->subdis);
	XplMatrix yoffset;
		
	int j, k, p_co, count;
	Pixel color;
	char *labsi;
	int labels_drawn;
	long unsigned int pixel;
	Liste <XplObject *> li;	
	
	XtVaGetValues(draw,XmNbackground, &color, XmNuserData, &wid_data,
			XmNwidth, &wi, XmNheight, &he,
				NULL);
	
	XSetBackground(XtDisplay(draw),
				wid_data->bitmap_gc, color);
	XSetFunction(dis, wid_data->bitmap_gc, GXcopy);
	
	MyPoint *mp=plot->GetPointKoord();
		
	//cout<<"es gibt "<<all_symbols.laenge()<<endl;
	
	Liste <XplLabel> labs;
	int last_color;
	
	char *newline;
	int longest;
	int curr_length;
	int ijk, ii, jj;
	int lines_count;
	char line[256];
	char oneline[256];
	
	
	XSetWindowColormap(dis, XtWindow(draw), cmap);	//OK
	last_color=0;

//	which=which_font(DEFAULT_LABEL_FONT);
//	XSetFont(dis, wid_data->bitmap_gc, (every_font_info[which])->fid);
	char font_name[124];

	XFontStruct *font_info=XLoadQueryFont(dis, DEFAULT_FONT);
		
	XSetFont(dis, wid_data->bitmap_gc, (font_info)->fid);

	XSetForeground(dis, wid_data->bitmap_gc,
			 	BlackPixel(dis, DefaultScreen(dis)));

	for (j=0; j<plot->GetDataCount(); j++)
	if (plot->SomeLabels(j+1))
	{	p_co=plot->GetPointCount(j+1);
		labs=plot->GetLabels(j+1);
		for (i=0; i<p_co; i++,mp++)
		{	labsi=labs[i].GetText();
#ifdef _BLABLA_
	//	cout<<"LAbel: "<<labsi<<", direction="<<
	//			labs[i].direction<<
	//			", color="<<labs[i].color<<endl;
#endif
			/********/
			// newline?
			if (labsi!=NULL && strlen(labsi)!=0 && 
				strlen(labsi)<256) 
			{	for (ii=0,jj=0; ii<strlen(labsi); ii++,jj++)
				if (int(labsi[ii])==92 && 
					ii<strlen(labsi) && 
					labsi[ii+1]=='n')
				{	line[jj]='\n';
					ii++;
				}
				else 			
					line[jj]=labsi[ii];
				line[jj]=0;
				newline=line;
				longest=0;
				curr_length=0;
				lines_count=1;
			//cout<<labsi<<endl;
				while (newline[0]!='\0')
			{	if (newline[0]=='\n')
				{	if (curr_length>longest)
						longest=curr_length;
					curr_length=0;
					lines_count++;
				}
				else
					curr_length++;
				newline++;
			}
				if (curr_length>longest)
					longest=curr_length;
			//cout<<lines_count<<", "<<longest<<endl;			
			/********/
			
			which_current=labs[i].size;
			sprintf(font_name, 
			"-*-times-medium-r-*--%d-*-*-*-*-*-*-*",
				which_current);
			XFreeFont(dis, font_info);
			font_info=XLoadQueryFont(dis, font_name);
			if (font_info== NULL)
			{	cerr<<" fonterror by "<<font_name<<endl;
				font_info=XLoadQueryFont(dis,
			 	DEFAULT_FONT);
			}
		//	else
		//		cout<<"font geholt: "<<font_name<<endl;
			XSetFont(dis, wid_data->bitmap_gc, font_info->fid);
			{	te_wi=XTextWidth(font_info,
				labsi, strlen(labsi));
				te_wi=te_wi*longest/strlen(labsi);
			/********/
				te_he=font_info->ascent;
			//	+font_info->descent;
			if (!(which==which_current))
			{	XFreeFont(dis, font_info);
				sprintf(font_name, 
				"-*-times-medium-r-*--%d-*-*-*-*-*-*-*",
					which_current);
				font_info=XLoadQueryFont(dis, font_name);
				if (font_info== NULL)
				{	cerr<<" fonterror by "<<font_name<<endl;
					font_info=XLoadQueryFont(dis,
			 		DEFAULT_FONT);
				}
			//else
			//	cout<<"font geholt: "<<font_name<<endl;
				XSetFont(dis, wid_data->bitmap_gc, 
				font_info->fid);
			}
			if (labs[i].color!=last_color)
			{	XSetForeground(dis, wid_data->bitmap_gc,
				 	all_colors[labs[i].color]->pixel);
				 	last_color=labs[i].color;
			}
				switch(labs[i].direction)
				{	case -1:
				break;
				
				case 0:
			/********/
				newline=line;
				if (lines_count>1)
				for (ijk=0; ijk<lines_count; ijk++)
				{	sprintf(oneline, "%s", newline);
					ii=0;
					while (oneline[ii]!='\n' &&
						ii<strlen(oneline))
						ii++;
					oneline[ii]='\0';
					XDrawString(dis, wid_data->pixy, 
						wid_data->bitmap_gc, 
					mp->x-te_wi/2, 
					mp->y+te_he/2*(1-lines_count+2*ijk),
					oneline,
					strlen( oneline));
					newline+=strlen(oneline);
					newline++;
				}
				else
			/********/
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc, 
				mp->x-te_wi/2, 
				mp->y+te_he/2,
				labsi,
				strlen( labsi));
				break;
				
				case 3:
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc, 
				mp->x+te_he/2, 
				mp->y+te_he/2,
				labsi,
				strlen( labsi));
				break;
				
				case 6:
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc, 
				mp->x-te_wi/2, 
				mp->y+3*te_he/2,
				labsi,
				strlen( labsi));
				break;
				
				case 9:
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc, 
				mp->x-te_wi-te_he/2, 
				mp->y+te_he/2,
				labsi,
				strlen( labsi));
				break;
					
				case 12:
				XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc, 
				mp->x-te_wi/2, 
				mp->y-te_he/2,
				labsi,
				strlen( labsi));
				break;				
				
				default:
				cout<<"sorry, not implemented"<<endl;
				break;
				}
			}
			delete labsi;
			}
		}
	}
	else
		mp+=plot->GetPointCount(j+1);
		
	XSetFunction(dis, wid_data->bitmap_gc, GXcopy);
	XFreeFont(dis, font_info);
}
void draw_headline(Widget draw)
{	Wid_Data *wid_data;
	int i, head_size, which, which_current;
	Text_Data *text_data;
	MyPoint where;
	XplMatrix ori;
	Plot *plot;
	Window win;
	Display *dis;
	Dimension wi, he;
	int te_wi, te_he;

	win=XtWindow(draw);
	dis=XtDisplay(draw);

	XtVaGetValues(draw,XmNuserData, &wid_data,
			XmNwidth, &wi, XmNheight, &he, NULL);
	XSetWindowColormap(dis, XtWindow(draw), cmap);	//OK

	plot=(Plot *)(wid_data->subdis);
	XplMatrix yoffset;
	
	if (plot->head_on==True && plot->top_frame_visible())
	{	yoffset=plot->GetVOffset();
		head_size=(int)( yoffset(0,0)*he/100/2+0.5);
		clear_part(draw, 0,0, wi, (int)(he*(yoffset(0,0))*HEAD_HEIGHT/100+0.5));
//		which=which_font(head_size);
		which=head_size;

		XFontStruct *font_info;
		char font_name[124];
		sprintf(font_name, 
			((UPlot *) plot)->GetUnixFontName(), // PC 20010703: "-*-times-medium-r-*--%d-*-*-*-*-*-*-*",
				which);
		font_info=XLoadQueryFont(dis, font_name);
		if (font_info== NULL)
		{	cerr<<" fonterror by "<<font_name<<endl;
			font_info=XLoadQueryFont(dis,
			 DEFAULT_FONT);
		}
		//else
		//	cout<<"font geholt: "<<font_name<<endl;
		XSetFont(dis, wid_data->bitmap_gc, font_info->fid);
		
		/*
		XSetFont(dis, wid_data->bitmap_gc, 
			(every_font_info[which])->fid);
		*/
		XSetForeground(dis, wid_data->bitmap_gc,
			 	BlackPixel(dis, DefaultScreen(dis)));

		char *hl=plot->GetHeadline();
		te_wi=XTextWidth(font_info, hl,
			strlen(hl));
	
		XDrawString(dis, wid_data->pixy, wid_data->bitmap_gc, 
			wi/2-te_wi/2, 
			(int)(he*(yoffset(0,0))*HEAD_HEIGHT/100+0.5),
			hl,
			strlen( hl));
		XFreeFont(dis, font_info);
		
		delete hl;
	}	
	
		
	XSetFunction(dis, wid_data->bitmap_gc, GXcopy);
}

extern void draw_axis(Widget draw);


void axisCB(Widget w, XtPointer p1, XtPointer p2)
{	Widget draw=(Widget) p1;
	XmString drawstr;
	Wid_Data *wi_da;
	XRectangle rec;
	Region regi;
	Dimension wi, he;
	Display *dis;	

	XtVaGetValues(draw, XmNuserData, &wi_da, XmNwidth, &wi, 
			XmNheight, &he, NULL);
	/*
	rec.x=(short) 0;
	rec.y=(short) 0;
	rec.width=(short)wi;
	rec.height=(short)he;
	regi=XCreateRegion();
	XUnionRectWithRegion(&rec, regi, regi);
	dis=XtDisplay(draw);
	//XSetRegion(dis, every_gc, regi);	
	XDestroyRegion(regi);
	*/

	Plot *plot=(Plot *)(wi_da->subdis);
	plot->axis_on=!(plot->axis_on);
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];;
	XplDisplay *xpld=plot->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, plot->GetY(), plot->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	if (plot->axis_on)
		sprintf(line, "CLICK\tAxisOn");
	else
		sprintf(line, "CLICK\tAxisOff");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
	if (plot->axis_on==False)
		drawstr=XmStringCreateSimple("Show Axis");
	else 
		drawstr=XmStringCreateSimple("Hide Axis");
	XtVaSetValues(w, XmNlabelString, drawstr, NULL);
	XmStringFree(drawstr);	//OK
/*	if (plot->axis_on==True)
	{	draw_axis(draw);
		draw_text(draw);
	}
	else 
*/
		wrefresh(draw);
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	if (plot->head_on)
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "AxisOn");
	 else
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "AxisOff");	 
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "REFRESH");
	fclose(gfile);
#endif
}

void clear(Widget draw)
{	Pixel color;
	Dimension wi, he;
	Wid_Data *wid_data;

	XtVaGetValues(draw,XmNuserData, &wid_data, XmNbackground, &color,
	 			XmNwidth, &wi, XmNheight, &he, NULL);
	
	XSetForeground(XtDisplay(draw),
				wid_data->bitmap_gc, color);
	XSetFunction(XtDisplay(draw), wid_data->bitmap_gc, GXcopy);
	
	XFillRectangle(XtDisplay(draw), wid_data->pixy, wid_data->bitmap_gc, 
		0, 0, wi, he);

}


void wrefresh(Widget draw)
{	Wid_Data *wid_data;
	Dimension wi, he;
	Pixel color;
	Display *dis;
	XGCValues gcv;
	Window win;
	
	XRectangle rec;
	Region regi;	

	if (!XtIsRealized(draw))
	{
#ifdef _BLABLA_
	cout<<"noch nicht da!"<<endl;
#endif
		return;
	}
//	cout<<"schon da!"<<endl;
	win=XtWindow(draw);
	dis=XtDisplay(draw);


	XWindowAttributes wa;
		
	if (XGetWindowAttributes(dis, win, &wa)==0)
	{	//cout<<"NULL!"<<endl;
		return;
	}
	
	switch (wa.map_state)
	{	case IsViewable: 
		//	cout<<"IsViewable"<<endl;
			break;
		case IsUnmapped: 
		//	cout<<"IsUnmapped"<<endl;
			return;
		case IsUnviewable: 
		//	cout<<"IsUnviewable"<<endl;
			return;
		default:	cout<<"default"<<endl;
			break;
	}
	XtVaGetValues(draw,XmNuserData, &wid_data, 
		 	XmNwidth, &wi, XmNheight, &he, 
		 	XmNbackground, &color, NULL);
#ifdef _BLABLA_
	cout<<"refresh... fuer "<<XtName(draw)<<" mit color="<<color<<endl;	
#endif
	Plot *plot=(Plot *)(wid_data->subdis);
	if (plot->GetDataCount()==0)
	{	clear(draw);
		return;
	}

/*	rec.x=(short) 0;
	rec.y=(short) 0;
	rec.width=(short)wi;
	rec.height=(short)he;
	regi=XCreateRegion();
	XUnionRectWithRegion(&rec, regi, regi);
	XSetRegion(dis, every_gc, regi);	
	XDestroyRegion(regi);
	XSetFillRule(dis, every_gc, WindingRule);
*/
/*	gcv.background=color;
	XChangeGC(XtDisplay(draw), every_gc,
		GCBackground, &gcv);	
*/
	
	// 6->7.5->8.4 MB return;
	
	clear(draw);	
	draw_lines(draw);
	show_point(draw);
	if (plot->rotation_point_on)
		show_rotation_point(draw);
	draw_text(draw);

	if (plot->axis_on)
		draw_axis(draw);
		
	draw_headline(draw);	
	
	
	XtVaGetValues(draw, XmNbackground, &color, NULL);
	XSetBackground(dis, every_gc, color);
	XSetFunction(dis, every_gc, GXcopy);
	XCopyArea(dis, wid_data->pixy, XtWindow(draw), every_gc, 0, 0, wi, he,
	 	0, 0);

} 

void redraw_part(Widget draw,  Dimension x, Dimension y,
 		Dimension part_wi, Dimension part_he)
{	Wid_Data *wid_data;
	Dimension wi, he;
	XRectangle rec;
	Region regi;
	Display *dis;
	Window win;
	
	win=XtWindow(draw);
	dis=XtDisplay(draw);
	Pixel color;

	if (!XtIsRealized(draw))
	{
#ifdef _BLABLA_
	cout<<"noch nicht da!"<<endl;
#endif
		return;
	}
	
//	//cout<<"refresh...part with x, y, wi, he:"<<x<<", "<<y<<", "<<part_wi<<
//		", "<<part_he<<endl;
		
	XWindowAttributes wa;
		
	if (XGetWindowAttributes(dis, win, &wa)==0)
	{	//cout<<"NULL!"<<endl;
		return;
	}
	
	switch (wa.map_state)
	{	case IsViewable: 
		//	cout<<"IsViewable"<<endl;
			break;
		case IsUnmapped: 
		//	cout<<"IsUnmapped"<<endl;
			return;
		case IsUnviewable: 
		//	cout<<"IsUnviewable"<<endl;
			return;
		default:	cout<<"default"<<endl;
			break;
	}
	XtVaGetValues(draw,XmNuserData, &wid_data,
			XmNwidth, &wi, XmNheight, &he, NULL);
	Plot *plot=(Plot *)(wid_data->subdis);

	if (plot->GetDataCount()==0)
	{	clear(draw);
		return;
	}

	rec.x=(short) x;
	rec.y=(short) y;
	rec.width=(short)part_wi;
	rec.height=(short)part_he;
	regi=XCreateRegion();
	XUnionRectWithRegion(&rec, regi, regi);
	// ??XSetRegion(dis, wid_data->bitmap_gc, regi);	
	
	clear(draw);
	show_point(draw);
	draw_lines(draw);
	if (plot->rotation_point_on)
		show_rotation_point(draw);
	if (plot->axis_on)
		draw_axis(draw);
	draw_text(draw);
	
	XtVaGetValues(draw, XmNbackground, &color, NULL);
	XSetBackground(dis, every_gc, color);
	XSetFunction(dis, every_gc, GXcopy);
	XCopyArea(dis, wid_data->pixy, XtWindow(draw), every_gc, 0, 0, wi, he,
	 	0, 0);

	XDestroyRegion(regi);
	regi=XCreateRegion();
	rec.x=(short) 0;
	rec.y=(short) 0;
	rec.width=(short) wi;
	rec.height=(short) he;
	XUnionRectWithRegion(&rec, regi, regi);
	// ??XSetRegion(dis, wid_data->bitmap_gc, regi);
	XDestroyRegion(regi);	
}	


int maxint(int a, int b)
{	
	int n;
	n=( a>b ) ? a : b;
	return(n);
}	
int minint(int a, int b)
{	
	int n;
	n=( a<b ) ? a : b;
	return(n);
}	
int mod(int a)
{	
	int n;
	n=(a>0) ? (a) : (-a);
	return n;
}
	
#define L_OFFSET 0
void popit(Widget draw, XEvent *cbs, MouseFunction mf)
{	Widget *lab;
	int x, y, satz_num, ind, count, i, j;
	XplMatrix curr_point, point, ori;
	XplMatrix m;	
	MyPoint mp;
	char line[256];
	XmString old_str;
	Wid_Data *wid_data;
	XmString xmline;
	Display *dis;
	Pixel color;
	Dimension wi, he, x_ev, y_ev, shell_wi, shell_he;
	Text_Data *te_da;
	Plot *plot;
	
	char gline[256];

	dis=XtDisplay(draw);
	XtVaGetValues(draw, XmNuserData, &wid_data,
	 		XmNwidth, &wi, XmNheight, &he, NULL);
	XtVaGetValues(wid_data->ind_label, XmNchildren, &lab, NULL);
	if ( !(cbs->type==ButtonPress || cbs->type==MotionNotify))
		return;
	x= cbs->type==ButtonPress ? 
		cbs->xbutton.x : 
			cbs->xmotion.x ;
	y= cbs->type==ButtonPress ?
		cbs->xbutton.y :
			cbs->xmotion.y;
	plot=(Plot *)(wid_data->subdis);
//	//cout<<"x="<<x<<", y="<<y<<endl;

	Liste <XplLabel> labs;
	char *lt=NULL;
	
	switch (mf)
	{	case INDEX:
		if (plot->GetDataCount()==0)
		{	//cerr<<"Plot hat keine datensaetze"<<endl;
			return;
		} 	

		mp.x=x;
		mp.y=y;
		ind=plot->NearestPointTo(mp);
/*
#ifdef _BLABLA_
	cout<<".NearestPointTo:"<<ind<<endl;
#endif		
*/		count=plot->GetDataCount();

		for (satz_num=0; satz_num<count; satz_num++)
		{	ind-=plot->GetPointCount(satz_num+1);
			if (ind<0)
				break;
		}
		ind+=plot->GetPointCount(satz_num+1);
		// so etwa???
		m=plot->RealPoint(satz_num+1, ind); 
		
		if (plot->SomeLabels(satz_num+1))
		{	labs=plot->GetLabels(satz_num+1);
			if (labs[ind].direction==-1)
				lt=labs[ind].GetText();
		}
				
		if (lt!=NULL && strlen(lt)!=0 && strlen(lt)<256) 
		{	for (i=0,j=0; i<strlen(lt); i++,j++)
			if (int(lt[i])==92 && i<strlen(lt) && lt[i+1]=='n')
			{	line[j]='\n';
				i++;
			}
			else 			
				line[j]=lt[i];
			delete lt;
			line[j]=0;
		}
		else
		{	switch(m.cols())
			{	case 1:
			sprintf(line,"(%g)\ni=%4d\ndata_num=%2d",
			m(0,0), ind+1, satz_num+1);
			sprintf(gline,"(%g)\ti=%4d\tdata_num=%2d",
			m(0,0), ind+1, satz_num+1);
				break;
				case 2:
			sprintf(line,"(%g, %g)\ni=%d\ndata_num=%d",
			m(0,0), m(0,1), ind+1, satz_num+1);
			sprintf(gline,"(%g, %g)\ti=%d\tdata_num=%d",
			m(0,0), m(0,1), ind+1, satz_num+1);
				break;
				default:
			sprintf(line,"(%g, %g, %g)\ni=%d\ndata_num=%d",
			m(0,0), m(0,1), m(0,2), ind+1, satz_num+1);
			sprintf(gline,"(%g, %g %g)\ti=%d\tdata_num=%d",
			m(0,0), m(0,1), m(0,2), ind+1, satz_num+1);
			}
		}

		xmline=XmStringCreateLtoR(line, XmSTRING_DEFAULT_CHARSET);
		XtVaSetValues(lab[0], 
			XmNforeground, all_colors[0]->pixel, NULL);
		mp=plot->GetImage(m);
		x=mp.x;
		y=mp.y;
		break;
		
		case STRING:
		count=plot->text_liste.laenge();
		te_da=(plot->text_liste)[count-1];
		xmline=XmStringCreate(te_da->text,
			 xplfont_name[te_da->font_number]);
		XtVaSetValues(lab[0],
		XmNforeground, all_colors[te_da->color_number]->pixel, NULL);
		x=y=0;
		break;
		
		default:
		xplmessage("sorry, no such function yet");
		return;
		break;
	}
	XtVaGetValues(lab[0], XmNlabelString, &old_str, NULL);
	if ( ! XmStringCompare(xmline, old_str))
		XtVaSetValues(lab[0], XmNlabelString, xmline, NULL);  
	XmStringFree(xmline);	//OK

	switch(mf)
	{	case STRING:	
		XtVaGetValues(XtParent(wid_data->ind_label), 
				XmNwidth, &shell_wi,
				XmNheight, &shell_he, NULL);
		XtVaSetValues(XtParent(wid_data->ind_label), 
				XmNx, cbs->xbutton.x_root-shell_wi/2,
				XmNy, cbs->xbutton.y_root-shell_he/2, NULL);
		break;
			
		case INDEX:
		XtVaSetValues(XtParent(wid_data->ind_label), 
				XmNx, cbs->xbutton.x_root+x-cbs->xbutton.x+L_OFFSET,
				XmNy, cbs->xbutton.y_root+y-cbs->xbutton.y+L_OFFSET,
				NULL);
		break;
			
		default:
		xplmessage("sorry, no such function yet");
		return;
		break;
	}
	if (cbs->type==ButtonPress)
		XtPopup(XtParent(wid_data->ind_label), XtGrabNone);
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64];
	XplDisplay *xpld=plot->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d\tINDEX", ndis, plot->GetY(), plot->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, gline);
	fclose(gfile);
#endif
}

//extern void set_automatic_axis_position(Wid_Data *wi_da, int wi, int he);
extern void set_automatic_axis_tickmark(Wid_Data *wi_da);

extern int matrix_count;

inline void prepare_gc(Display *dis, GC gc)
{	XSetFunction(dis, gc, GXxor);
	//XSetForeground(dis, gc, 1);
	XSetForeground(dis, gc, all_colors[GREY]->pixel);
	XSetLineAttributes(dis, gc, 
				DEFAULT_LINE_WIDTH, LineSolid, 
				CapRound, JoinRound);
}


extern unsigned long xpl_server_number;
	
extern void pophandler(Widget w, XtPointer p, XEvent *cbs, char *ch)
{	Widget draw=(Widget) p;
	Wid_Data *wid_data;
	int x, y, i, j, ic, jc, t, count;
	int minx, maxx, miny, maxy, dim, step_wi, step_he;
	static int ecke[ZWEI];
	static int curr_ecke[ZWEI];
	static int last_mouse_xy[ZWEI];
	static int brushs[4];
	Display *dis;
	Pixel color, bg, fg;
	Pixmap draw_pix_new;
	char * frage;
	Dimension xd, yd, wi, he;
	Text_Data *te_da;
	MyPoint mp, mp_old, mp1, mp2;
	XplMatrix ori, skal, trans, skal1, trans1, rp, br, xm2, xm1, tr, tr1, sk, sk1, rc, rc1;
	Dimension ra_wi, ra_he, d_wi, d_he;
	Plot *plot, *plot_to_link;
	double achoff;
	XplMatrix xoffset, yoffset;
	int which_button;
	MyPoint from, to;
	MyPoint fromp, top;
	static Boolean redraw_frame=False;
	static Boolean popit_was=False;

	dis=XtDisplay(draw);
	XtVaGetValues(draw, XmNuserData, &wid_data,
			XmNwidth, &wi, XmNheight, &he, NULL);
	if (wid_data==NULL)
	{	//cout<<"Hilfe! Ein Zombie!"<<endl;
		return;
	}
	if (wid_data->subdis==NULL)
	{	cout<<"subdis=0!!!"<<endl;
		return;
	}
	plot=(Plot *)(wid_data->subdis);
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64];
	XplDisplay *xpld=plot->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, plot->GetY(), plot->GetX());
	delete ndis;
	char line[64];
#endif
	
	if (plot==plot_for_user && ! ready)
	{	xym(0)=cbs->xbutton.x;
		xym(1)=cbs->xbutton.y;
		xym.mdump("%f");
		ready=True;
		return;
	}
			
	if (plot->GetDataCount()==0)
		return;
			
	xoffset=plot->GetHOffset();
	yoffset=plot->GetVOffset();
	
	prepare_gc(dis, every_gc);	//?????			
		

/*
#ifdef _BLABLA_
	switch(cbs->xany.type)
	{	case ColormapNotify:
		cout<<"ColormapNotify"<<endl;
		break;
		
		case EnterNotify:
		cout<<"EnterNotify"<<endl;
		break;
		
		case LeaveNotify:
		cout<<"LeaveNotify"<<endl;
		break;
		
		case KeyPress:
		cout<<"KeyPress"<<endl;
		break;
		
		case MotionNotify:
		cout<<"MotionNotify"<<endl;
		break;

		default:
		cout<<"SmthElse"<<endl;
		break;
	}
#endif
*/
	if (cbs->xany.type==ColormapNotify)
	{	
			XSetWindowColormap(dis, XtWindow(draw), cmap);	//OK
			return;	
	}	
	XSetWindowColormap(dis, XtWindow(draw), cmap);	//OK
	Achse ach(0, 0, 0);
	switch(cbs->xany.type)
	{	
		case EnterNotify:
/*
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, "ENTER");
	fclose(gfile);
#endif		
*/
		if (popit_was)
		{	popit_was=False;
		//	cout<<"return by EnterNotify..."<<endl;
			return;
		}
		if (plot->pointer_function==PREPARE_BRUSH && redraw_frame)
		{	prepare_gc(dis, every_gc);
			XDrawRectangle(dis, XtWindow(draw), every_gc,
			(int)(last_mouse_xy[0]-brushs[3]),
			(int)(last_mouse_xy[1]-brushs[2]),
			brushs[1]+brushs[3],
			brushs[0]+brushs[2]);
			redraw_frame=False;
			XSetFunction(dis, every_gc, GXcopy);
		}
		if (plot->pointer_function==PREPARE_BRUSH)
		{	prepare_gc(dis, every_gc);
			last_mouse_xy[0]=cbs->xcrossing.x;
			last_mouse_xy[1]=cbs->xcrossing.y;
			brushs[0]=minint(he-last_mouse_xy[1], 
				(int)(plot->brush_size[0]*he/100.0));
			brushs[1]=minint(wi-last_mouse_xy[0],
				(int)(plot->brush_size[1]*wi/100.0));
			brushs[2]=minint(last_mouse_xy[1], 	
				(int)(plot->brush_size[2]*he/100.0));
			brushs[3]=minint(last_mouse_xy[0],
				(int)(plot->brush_size[3]*wi/100.0));
			XDrawRectangle(dis, XtWindow(draw), every_gc,
			last_mouse_xy[0]-brushs[3],
			last_mouse_xy[1]-brushs[2],
			brushs[1]+brushs[3],
			brushs[0]+brushs[2]);
			redraw_frame=True;
			XSetFunction(dis, every_gc, GXcopy);

		}
		break;

		case LeaveNotify:
/*
ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, "LEAVE");
	fclose(gfile);
#endif
*/
		if (popit_was)
			return;
		
		if (plot->pointer_function==PREPARE_BRUSH && redraw_frame)
		{	prepare_gc(dis, every_gc);
			XDrawRectangle(dis, XtWindow(draw), every_gc,
			(int)(last_mouse_xy[0]-brushs[3]),
			(int)(last_mouse_xy[1]-brushs[2]),
			brushs[1]+brushs[3],
			brushs[0]+brushs[2]);
			redraw_frame=False;
			XSetFunction(dis, every_gc, GXcopy);
		}
		break;	//LeaveNotify

		case KeyPress:
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	sprintf(line, "KEYPRESS\t%d", cbs->xkey.keycode);
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
		step_wi=wi/100;
		step_he=he/100;
		rp=plot->GetRotationPoint();
		if (rp.cols()<3)
			break;
	/*	//cout<<"KeyPress:"<<cbs->xkey.keycode<<endl;
		//cout<<"Before move rotpoint:"<<endl;
		rp.out();
	*/
		mp=plot->GetImage(rp);
		mp_old=mp;
	//	//cout<<"image for rp: "<<mp.x<<","<<mp.y<<endl;
		if (plot->rotation_point_move_mode)
		{	switch(cbs->xkey.keycode)
			{	case XK_Left:	//Left Arrow
				mp.x=mp.x-step_wi;
				break;
				case XK_Right:	//Right Arrow
				mp.x=mp.x+step_wi;
				break;
				case XK_Up:	//Arrow Up
				mp.y=mp.y-step_he;
				break;
				case XK_Down:	//Arrow Down
				mp.y=mp.y+step_wi;
				break;
				case 96: //Enter
				plot->rotation_point_move_mode=False;
				break;
			}
	//		//cout<<"image for rp: "<<mp.x<<","<<mp.y<<endl;

			ori=plot->GetOrigin(mp);
	
	/*		//cout<<"After move rotpoint:"<<endl;
			ori.out();
	*/
			if (plot->GetDimension()>2)
				ori(0,2)=rp(0,2);
			
	//		//cout<<"HERE: matrix_count="<<matrix_count<<endl;
			
			plot->MakeBackup();
			plot->SetTransformation(&ori, NULL, NULL, NULL, NULL);
	//		//cout<<"UND HERE: matrix_count="<<matrix_count<<endl;
			
			
			
			
			plot->repaint_part(mp_old.x-RP_SIZE, mp_old.y-RP_SIZE,
					RP_SIZE*2, RP_SIZE*2);
			plot->repaint_part(mp.x-RP_SIZE, mp.y-RP_SIZE,
					RP_SIZE*2, RP_SIZE*2);
	//		//cout<<"JETZT: matrix_count="<<matrix_count<<endl;
		}
		else
		{	int dim;
			XplMatrix RC(plot->GetRotationCosinus());
			dim=RC.rows();	// oder 1, ist egal
			double pi=3.14156;
			double angle=2*pi/MAL;
			double cosi=cos(angle);
			double sini=sin(angle);
		
			XplMatrix NRC(dim, dim);
			NRC.fill(0.0);
			for (i=0; i<dim; i++)
				NRC(i,i)=1.0;
			if (dim==2)
			{	//cout<<
				"Leider ist plot nur 2-dimensional...\n";
					NRC(0,0)=cos(angle);
					NRC(1,1)=cos(angle);
					NRC(0,1)=-sin(angle);
					NRC(1,0)=sin(angle);
					RC=RC*(NRC);
					plot->MakeBackup();
					plot->SetTransformation(
						NULL, NULL, &RC, NULL, NULL),
					plot->Refresh();

			}
			else		//mind 3 dim
			{	char buf[1];
				KeySym keysym;
				XComposeStatus compose;
				XLookupString(&(cbs->xkey), buf, 1, &keysym, &compose); 
				switch(keysym)
				{	case XK_Left:	//Left Arrow
					NRC(0,0)=cos(angle);
					NRC(2,2)=cos(angle);
					NRC(0,2)=-sin(angle);
					NRC(2,0)=sin(angle);
					NRC(1,1)=1.0;
					break;
					
					case XK_Right:	//Right Arrow
					NRC(0,0)=cos(angle);
					NRC(2,2)=cos(angle);
					NRC(0,2)=sin(angle);
					NRC(2,0)=-sin(angle);
					NRC(1,1)=1.0;
					break;
				
					case XK_Up:	//Arrow Up
					NRC(1,1)=cos(angle);
					NRC(2,2)=cos(angle);
					NRC(1,2)=-sin(angle);
					NRC(2,1)=+sin(angle);
					NRC(0,0)=1.0;
					break;
				
					case XK_Down:	//Arrow Down
					NRC(1,1)=cos(angle);
					NRC(2,2)=cos(angle);
					NRC(1,2)=sin(angle);
					NRC(2,1)=-sin(angle);
					NRC(0,0)=1.0;
					break;
					
					/*	case 96:
					plot->rotation_point_move_mode=True;
					break;
					*/
				}
				RC=RC*(NRC);
				plot->MakeBackup();
				plot->SetTransformation(
						NULL, NULL, &RC, NULL, NULL),
				plot->Refresh();
				wrefresh(draw);
				if (wid_data->ret_button!=NULL)
					XtManageChild(wid_data->ret_button);
			}		
		}
		break;	//from KeyPress

		
		case Expose:
		if (cbs->xexpose.count>0)
		{	
#ifdef _BLABLA_
	cout<<"count>0\n";
#endif
			break;
		}


#ifdef _BLABLA_	
	cout<<"redraw_part by expose for "<<XtName(draw)<<
			"from "<<cbs->xexpose.x<<","<<cbs->xexpose.y<<
			" to "<<cbs->xexpose.x+cbs->xexpose.width<<
			","<<cbs->xexpose.y+cbs->xexpose.height<<endl;
#endif
/*		redraw_part(draw, cbs->xexpose.x, cbs->xexpose.y, 
			cbs->xexpose.width, cbs->xexpose.height);
*/		

	//	if (XQLength(dis)==0)
		{	wrefresh(draw);
		}
		break;	//from Expose
		
/*		case ConfigureNotify:
#ifdef _BLABLA_	
		cout<<"confi_noti eventhandler"<<endl;
#endif	
		((UPlot *)(wid_data->subdis))->Resize(wi, he);
	
		if (XQLength(dis)==0)
		//	Ich sehe keine andere Moeglichkeit zu erfahren, ob
		//	danach ein Expose Event folgt
		//
			wrefresh(draw);
		
		//wrefresh(draw);
		break;	//from ConfigureNotify
*/		
	
	
		case ButtonPress:
	//	cout<<"ButtonPress..."<<endl;		
		which_button=cbs->xbutton.button;
#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	sprintf(line, "BUTTONPRESS\t%d\t%d\t%d", which_button, 
	cbs->xcrossing.x, cbs->xcrossing.y);
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
		((UPlot *)(wid_data->subdis))->InFocus();	

	int glyph, xgobisize, xlay, xsym, xsize, xerase;
	
		switch(plot->mouse_function[which_button-1])
		{	case SINGLE_BRUSH:
			prepare_gc(dis, every_gc);
			
			if (redraw_frame)
			{	XDrawRectangle(dis, XtWindow(draw), every_gc,
				last_mouse_xy[0]-brushs[3],
				last_mouse_xy[1]-brushs[2],
				brushs[1]+brushs[3],
				brushs[0]+brushs[2]);
				redraw_frame=False;
			}
			last_mouse_xy[0]=cbs->xcrossing.x;
			last_mouse_xy[1]=cbs->xcrossing.y;
			brushs[0]=minint(he-last_mouse_xy[1], 
				(int)(plot->brush_size[0]*he/100.0));
			brushs[1]=minint(wi-last_mouse_xy[0],
				(int)(plot->brush_size[1]*wi/100.0));
			brushs[2]=minint(last_mouse_xy[1], 	
				(int)(plot->brush_size[2]*he/100.0));
			brushs[3]=minint(last_mouse_xy[0],
				(int)(plot->brush_size[3]*wi/100.0));
				

/*	cout<<"By ButtonPress:  "<<
	(int)(last_mouse_xy[0]-plot->brush_size[0]*wi/100.0)<<", "<<
		(int)(last_mouse_xy[1]-plot->brush_size[1]*he/100.0)<<", "<<
		(int)(plot->brush_size[1]*he/50.0)<<", "<< 
		(int)(plot->brush_size[1]*he/50.0)<<endl;
*/
			fromp.x=cbs->xbutton.x-brushs[3];
			top.x=cbs->xbutton.x+brushs[1];
			fromp.y=cbs->xbutton.y-brushs[2];
			top.y=cbs->xbutton.y+brushs[0];
				
			plot->SetBrushBoard(fromp, top);
			
			/* Extra Wurst fuer 1. Data wegen ev. xgobi	*/
#ifdef _RPCXGOBI_
			if (plot->is_linked)
			{	br=plot->GetBrushed(0);
				// br.out();
				
				char *RequStr = (char *) XtMalloc ((unsigned int) (512 + br.rows()*20));
				char temp[80];
				sprintf(RequStr, "%x ", xpl_server_number);

				for (j=0; j<br.rows(); j++)
				if ( 	br(j, 0)==1 )
				{
					xlay=plot->GetPointLayout(1, j+1);
					if (xlay==0)
					{	xsize=0;
						xsym=0;
					}
					else if (xlay==1)
					{	xsize=0;
						xsym=1;
					}
					else
					{	xsize=all_symbols[xlay-2]->size;
						xsym=all_symbols[xlay-2]->symbol;
					}
					
					xgobisize=(int)((xsize-2)/3.0+0.5);
					xerase = 0;
					
					switch(xsym)
					{	case 0: xerase=1;
					                break;
						case 1: glyph=6;
							xgobisize=0;
							break;
						case 2:	glyph=2;
							break;
						case 3: glyph=4;
							break;
						case 5: glyph=1;
							break;
						case 7: glyph=3;
							break;
						case 8: glyph=5;
							break;
						case 11: glyph=0;
							break;
						default: glyph=1;
							xgobisize=2;
							break;
					}
					
					sprintf(temp, "%d:%d ", j, 1000 * xgobisize + 100 * glyph + xerase * 11 + 10);
					strcat(RequStr, temp);
				}
				rpc_xfer_brush_to_xgobi(RequStr, plot->linked_to);
				XtFree ((char *) RequStr);
			}
#endif	
			/* Extra Wurst fuer i. Data wegen ev. link_list	*/

			int lds, pln;
			for (i=0; i<plot->GetDataCount(); i++)
			{	br=plot->GetBrushed(i);
				plot->SetPointColor(BRUSH_COLOR, i+1, br);
				//cout<<"OHOHO!"<<endl;
				//br.out();
				for (pln=0; pln<plot->link_liste.laenge();
						pln++)
				if (plot->link_liste[pln]->my_data==i+1)
				{	lds=plot->link_liste[pln]->data;
					plot->link_liste[pln]->plot->
						SetPointColor(
							BRUSH_COLOR, lds, br);
					(UPlot *)(plot->link_liste[pln]->plot)
						->redraw_points(1, br);
				}
			}
			plot->MakeAfterBrush();
			redraw_part(draw, fromp.x-1, fromp.y-1, 
				top.x-fromp.x+2, top.y-fromp.y+2);

			redraw_frame=False;			
			break;	// from SINGLE_BRUSH
			
			case BRUSH: case ZOOM:
			x=cbs->xbutton.x;
			y=cbs->xbutton.y;
			curr_ecke[0]=ecke[0]=x;
			curr_ecke[1]=ecke[1]=y;
			plot->last_click_x=x;
			plot->last_click_y=y;
			break;	// end from  case BRUSH: case ZOOM:
						
			case INDEX: case STRING:
			popit(draw, cbs, plot->mouse_function[which_button-1]);
			popit_was=True;
			break;
			
			case NOTHING:
			//	cout<<"ButtonPress by NOTHING!"<<endl;
			break;
			
			case SINGLE_ZOOM:
			cout<<"Sorry, not ready"<<endl;
			break;
		}
		break;	// end of ButtonPress

		case MotionNotify:

//		wid_data->subdis->InFocus();	
		switch(cbs->xmotion.state)
		{	case Button1Mask:
			which_button=1;
			break;
			
			case Button2Mask:
			which_button=2;
			break;
			
			case Button3Mask:
			which_button=3;
			break;
			
			default:	//no button at all
			which_button=0;
			if (plot->pointer_function!=PREPARE_BRUSH)
			{	last_mouse_xy[0]=0;
				last_mouse_xy[1]=0;
				XSetFunction(dis, every_gc, GXcopy);
				return;
			}
			break;
		}
		if (	which_button>0 && 			
			(plot->mouse_function[which_button-1]==INDEX ||
			plot->mouse_function[which_button-1]==STRING))
		{	popit(draw, cbs, plot->mouse_function[which_button-1]);
			return;
		}

			if (plot->pointer_function==PREPARE_BRUSH &&
				redraw_frame )
			{	prepare_gc(dis, every_gc);
				XDrawRectangle(dis, XtWindow(draw), every_gc,
				(int)(last_mouse_xy[0]-brushs[3]),
				(int)(last_mouse_xy[1]-brushs[2]),
				brushs[1]+brushs[3],
				brushs[0]+brushs[2]);
				redraw_frame=False;
			}


			if (plot->pointer_function==PREPARE_BRUSH)
			{	prepare_gc(dis, every_gc);
				last_mouse_xy[0]=cbs->xbutton.x;
				last_mouse_xy[1]=cbs->xbutton.y;
				brushs[0]=minint(he-last_mouse_xy[1], 
					(int)(plot->brush_size[0]*he/100.0));
				brushs[1]=minint(wi-last_mouse_xy[0],
					(int)(plot->brush_size[1]*wi/100.0));
				brushs[2]=minint(last_mouse_xy[1], 	
					(int)(plot->brush_size[2]*he/100.0));
				brushs[3]=minint(last_mouse_xy[0],
					(int)(plot->brush_size[3]*wi/100.0));
				XDrawRectangle(dis, XtWindow(draw), every_gc,
				(int)(last_mouse_xy[0]-brushs[3]),
				(int)(last_mouse_xy[1]-brushs[2]),
				brushs[1]+brushs[3],
				brushs[0]+brushs[2]);
				redraw_frame=True;
			}

		if (	cbs->xmotion.state==Button1Mask ||
			cbs->xmotion.state==Button2Mask ||
			cbs->xmotion.state==Button3Mask )
		switch(plot->mouse_function[which_button-1])
		{	case BRUSH: case ZOOM:	
			x=cbs->xmotion.x;
			y=cbs->xmotion.y;
			prepare_gc(dis, every_gc);
			if ( mod(curr_ecke[0]-x) > 5 ||
				mod(curr_ecke[1]-y) >5	)
			{	XDrawRectangle(dis, XtWindow(draw), every_gc,
				minint(curr_ecke[0], ecke[0]),
				minint(curr_ecke[1], ecke[1]),
				mod(curr_ecke[0]-ecke[0]), 
				mod(ecke[1]-curr_ecke[1]));	
					
				XDrawRectangle(dis, XtWindow(draw), every_gc,
				minint(ecke[0],x),
				minint(ecke[1], y),
				mod(ecke[0]-x), 
				mod(y-ecke[1]));
			
				curr_ecke[0]=x;
				curr_ecke[1]=y;
				from.x=minint(ecke[0],x);
				from.y=minint(ecke[1], y);			
				to.x=maxint(ecke[0],x);
				to.y=maxint(ecke[1], y);
				//plot->SetBrushBoard(from, to);
			}
			return;
			
			case INDEX: case STRING:
			popit(draw, cbs, plot->mouse_function[which_button-1]);
			popit_was=True;
			break;
			
			case SINGLE_BRUSH:
			fromp.x=cbs->xbutton.x-brushs[3];
			top.x=cbs->xbutton.x+brushs[1];
			fromp.y=cbs->xbutton.y-brushs[2];
			top.y=cbs->xbutton.y+brushs[0];
				
			prepare_gc(dis, every_gc);			
			if (redraw_frame)
			{	XDrawRectangle(dis, XtWindow(draw), every_gc,
				last_mouse_xy[0]-brushs[3],
				last_mouse_xy[1]-brushs[2],
				brushs[1]+brushs[3],
				brushs[0]+brushs[2]);
				redraw_frame=False;
			}

#ifdef _BLABLA_
	cout<<"By ButtonPressMotify:  "<<
	(int)(last_mouse_xy[0]-plot->brush_size[0]*wi/100.0)<<", "<<
		(int)(last_mouse_xy[1]-plot->brush_size[1]*he/100.0)<<", "<<
		(int)(plot->brush_size[1]*he/50.0)<<", "<< 
		(int)(plot->brush_size[1]*he/50.0)<<endl;
#endif
			plot->SetBrushBoard(fromp, top);
			for (i=0; i<plot->GetDataCount(); i++)
				{	br=plot->GetBrushed(i);
					for (j=0; j<br.cols(); j++)
					if ( 	br(0, j)==1 )
					{
						plot->SetPointColor(BRUSH_COLOR,
						 i+1, j+1);
					}
				}
			redraw_part(draw, cbs->xbutton.x-
					plot->brush_size[0]*wi/100-1,
					cbs->xbutton.y-
					plot->brush_size[1]*he/100-1,
					plot->brush_size[0]*wi/50+2, 
					plot->brush_size[1]*he/50+2);

			redraw_frame=False;			
					
			break;
		}

		break;	//for MotionNotify
		
		case ButtonRelease:
		((UPlot*)(wid_data->subdis))->InFocus();	
		
		which_button=cbs->xbutton.button;
#ifdef _GUIDO_
		gfile=fopen(gfname, "a+");
		sprintf(line, "BUTTONRELEASE\t%d\t%d\t%d", which_button, 
			cbs->xbutton.x, cbs->xbutton.y);
		fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
			fclose(gfile);
#endif
		switch(plot->mouse_function[which_button-1])
		{	case ZOOM:	
			prepare_gc(dis, every_gc);
			if ( mod(curr_ecke[0]-ecke[0])>0 &&
				mod(ecke[1]-curr_ecke[1])>0)
			XDrawRectangle(dis, XtWindow(draw), every_gc,
					minint(curr_ecke[0], ecke[0]),
					minint(curr_ecke[1], ecke[1]),
					mod(curr_ecke[0]-ecke[0]), 
					mod(ecke[1]-curr_ecke[1]));
				
			XSetFunction(dis, every_gc, GXcopy);
			
			minx=minint(ecke[0],curr_ecke[0]);
			miny=minint(ecke[1], curr_ecke[1]);
			maxx=maxint(ecke[0],curr_ecke[0]);
			maxy=maxint(ecke[1], curr_ecke[1]);

			if  (	(maxx-minx<10)||
		 	     		(maxy-miny<10) )
					break;
			t=miny;
			miny=he-maxy;
			maxy=he-t;
			
			dim=plot->GetDimension();
			rc=plot->GetRotationCosinus();	
			plot->MakeBackup();
			for (i=0; i<dim; i++)
			{	if (rc(i, i)!=1)
					break;
			}
			if (i==dim)
			// plot ist nicht verdreht!
			{	
				ZoomPlot(plot, 
				plot->last_click_x, he-plot->last_click_y,
				cbs->xbutton.x, he-cbs->xbutton.y);
			/*
				mp1.x=minx;
				mp1.y=he-maxy;
				mp2.x=maxx;
				mp2.y=he-miny;
				xm1=plot->GetOrigin(mp1);
				xm2=plot->GetOrigin(mp2);
				if (xm2(0,0)-xm1(0,0)<0.00001)
				{	cerr<<"Zoom is not possible!"<<endl;
					break;
				}
				ach=plot->GetAchse(1);

			achoff=SYMBOL_SIZE*(xm1(0, 0)-xm2(0, 0))/
		(wi-(xoffset(0,0)+xoffset(0,1))*wi/100.0-2*SYMBOL_SIZE);
		//	ach.SetPosition(xm1(0, 0)-achoff, xm2(0, 0))+achoff;
			ach.SetPosition(xm1(0, 0), xm2(0, 0));
			plot->SetAchse(ach);
				
				mp1.x=minx;
				mp1.y=he-maxy;
				mp2.x=minx;
				mp2.y=he-miny;
				xm1=plot->GetOrigin(mp1);
				xm2=plot->GetOrigin(mp2);
				if (xm1(0,1)-xm2(0,1)<0.00001)
				{	cerr<<"Zoom is not possible!"<<endl;
					break;
				}
				ach=plot->GetAchse(2);
				achoff=SYMBOL_SIZE*(xm2(0, 1)-xm1(0, 1))/
		(he-(yoffset(0,0)+yoffset(0,1))*he/100.0-2*SYMBOL_SIZE);
				
				
				mp1.x=minx;
				mp1.y=he-maxy;
				mp2.x=minx;
				mp2.y=he-miny;
				ach=plot->GetAchse(2);
		//		ach.SetPosition(xm2(0, 1)-achoff, xm1(0, 1)+achoff);
				ach.SetPosition(xm2(0, 1), xm1(0, 1));
				plot->SetAchse(ach);
				*/	
			}				
			else
			{	sk=plot->GetSecondSkalierung();
				tr=plot->GetTranslation();
				sk1=sk;
				sk1(0,0)=wi*(100-xoffset(0,0)-xoffset(0,1))/
						100.0/(maxx-minx);
				sk1(1,1)=he*(100-yoffset(0,0)-yoffset(0,1))/
						100.0/(maxy-miny);
				for (i=2; i<dim; i++)
					sk1(i,i)=1;
#ifdef _BLABLA_
				cout<<"sk1:"<<endl;
				sk1.out();
				cout<<"sk*sk1:"<<endl;
				(sk*sk1).out();
#endif
				sk=sk*sk1;	
				xm1=tr;
				xm1.fill(0.0);
				xm1(0,0)=minx;
				xm1(0,1)=miny;
				xm2=xm1;
				xm2(0,0)=xoffset(0,1)*wi/100.0;
				xm2(0,1)=yoffset(0,1)*he/100.0;
				
				tr=tr*sk1+xm1*sk1-xm2;
			
				plot->SetTransformation(NULL, NULL, NULL, &sk, &tr);
			}
			
			wrefresh(draw);
			if (wid_data->ret_button!=NULL)
					XtManageChild(wid_data->ret_button);
#ifdef _GUIDO_
		gfile=fopen(gfname, "a+");
		fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "ZOOM");
		fclose(gfile);
#endif
			break;

			case BRUSH:
			if ( mod(curr_ecke[0]-ecke[0])>0 &&
				mod(ecke[1]-curr_ecke[1])>0)
			XDrawRectangle(dis, XtWindow(draw), every_gc,
					minint(curr_ecke[0], ecke[0]),
					minint(curr_ecke[1], ecke[1]),
					mod(curr_ecke[0]-ecke[0]), 
					mod(ecke[1]-curr_ecke[1]));
				
			XSetFunction(dis, every_gc, GXcopy);
			
			minx=minint(ecke[0],curr_ecke[0]);
			miny=minint(ecke[1], curr_ecke[1]);
			maxx=maxint(ecke[0],curr_ecke[0]);
			maxy=maxint(ecke[1], curr_ecke[1]);
	for (i=0; i<plot->GetDataCount(); i++)
				{	br=plot->GetBrushed(i);
					for (j=0; j<br.cols(); j++)
					if ( 	br(0, j)==1 )
					{
/*
#ifdef _BLABLA_
						cout<<j+1<<" selected"<<endl;
#endif
*/					plot->SetPointLayout(BRUSH_COLOR,
						i, j+1);
					}
				}
			break;
				
			
			case INDEX:
			XtPopdown(XtParent(wid_data->ind_label));
			return;

			case STRING:
			int x, y;
			count=plot->text_liste.laenge();
			te_da=plot->text_liste[count-1];
			
			mp.x=cbs->xbutton.x;
//			mp.y=he-cbs->xbutton.y;
			mp.y=cbs->xbutton.y;
			//cout<<"Attention! image=("<<mp.x<<","<<mp.y<<")\n";
			ori=((Plot *)(wid_data->subdis))->GetOrigin(mp);		
			//ori.out();
			//cout<<"Release:"<<endl;
			te_da->where=ori;
			break;
			
			case NOTHING:
			//cout<<"ButtonRelease for NOTHING!"<<endl;
			break;
			
			default:	//SINGLE_BRUSH ?
		//	last_mouse_xy[0]=0;
		//	last_mouse_xy[0]=1;
			//cout<<"ButtonRelease for DEFAULT!"<<endl;
			redraw_frame=False;			
				break;;
		}	//end of switch(plot->mouse_function...
		break;	//from ButtonRelease
	}	// from EventType
}

void destroyCB(Widget push, XtPointer p1, XtPointer p2)
{	if (! (p1==NULL))
	{	XtDestroyWidget((Widget) p1);
		return;
	}
	XtPointer pp;
	XtVaGetValues(push, XmNuserData, &pp, NULL);
	XtDestroyWidget((Widget) pp);
}
void popupCB(Widget push, XtPointer p1, XtPointer p2)
{	Widget shell=(Widget) p1;
	int x, y, i;
	Window dummyW;
	int dummyI;
	unsigned int li; 	
	
	XQueryPointer(XtDisplay(push), XtWindow(push),
				&dummyW, &dummyW,
				&x, &y, &dummyI,
				&dummyI, &li);
	XtVaSetValues(shell, XmNx, (Position)x, 
				XmNy, (Position)y, NULL);
	XtPopup(shell, XtGrabNone);
}


static Boolean Demo=False;

void DemoTimer(Plot *plot, XtIntervalId *idPtr)
{	if (! Demo)
		return;
		
	static int already=0;
	int n;

	XplMatrix RC;
	int dim, i;
	double angle, pi, cosi, sini;
	pi=3.14156;
	RC=plot->GetRotationCosinus();
	dim=RC.rows();	// oder cols, ist egal
	
#ifdef _BLABLA_
	cout<<"Demo:: RotCos was :"<<endl;
	RC.out();
#endif
/*	if (already==MAL && dim==2)
	{	already=0;
		XplMatrix mini=plot->PlotMinToDimension();
		XplMatrix rp2=plot->GetRotationPoint();
		rp2=rp2-(rp2-mini)/2.0;
		plot->SetTransformation(&rp2, NULL, NULL, NULL, NULL);
	//		plot->GetRotationPoint().out();
	for (n=0; n<10; n++)
	{	if (! Demo)
			return;
		sleep(1);
	}
	XtAppAddTimeOut(bs_glob_variable.kontext, 0, DemoTimer, 
				(caddr_t) plot);
		return;
	}		
*/
	XplMatrix NRC(dim, dim);
	NRC.fill(0.0);
	angle=2*pi/MAL;
	cosi=cos(angle);
	sini=sin(angle);
	NRC(0,0)=cosi;
	NRC(1,1)=cos(angle);
	NRC(0,1)=-sini;
	NRC(1,0)=sini;
	for (i=2; i<dim; i++)
			NRC(i,i)=1;

	RC=RC*(NRC);
	if (dim > 2)
	{	NRC.fill(0.0);
		NRC(0,0)=1;
		NRC(1,1)=cosi;
		NRC(2,2)=cosi;
		NRC(1,2)=-sini;
		NRC(2,1)=sini;
		for (i=3; i<dim; i++)
			NRC(i,i)=1;
		RC=RC*(NRC);
	}
	
	
#ifdef _BLABLA_
	cout<<"Demo::RC nach matmult"<<endl;
	RC.out();
#endif	
	plot->MakeBackup();
	plot->SetTransformation(NULL, NULL, &RC, NULL, NULL);
	plot->Refresh();
	
//	//cout<<"hopla...\n";

	Display *dpy=XtDisplay(bs_glob_variable.main_shell);

//	//cout<<"aufgepasst.."<<endl;
	XFlush(dpy);
	XmUpdateDisplay(bs_glob_variable.main_shell);
	if (! Demo)
		return;
//	//cout<<"weiter...";
	XtAppAddTimeOut(bs_glob_variable.kontext, 5, DemoTimer, 
				(caddr_t) plot);
	already++;
	return;
}

void demoCB(Widget draw, XtPointer p1, XtPointer p2)
{	XFlush(XtDisplay(bs_glob_variable.main_shell));
	Demo=!Demo;
	if (Demo)
	XtAppAddTimeOut(bs_glob_variable.kontext, 50, DemoTimer, (caddr_t) p1);
}
void exposeCB(Widget draw, XtPointer p1, XmDrawingAreaCallbackStruct *cbs)
{	Pixel fg, bg;
	Display *dis;
			
	//cout<<"expose"<<endl;
	if (cbs->event->xexpose.count>0)
	{	//cout<<"count>0\n";
		return;
	}
	redraw_part(draw, cbs->event->xexpose.x, cbs->event->xexpose.y, 
	cbs->event->xexpose.width, cbs->event->xexpose.height);
	
}
/*
void resizeCB(Widget draw, XtPointer p1, XmDrawingAreaCallbackStruct *cbs)
{	Dimension wi, he;
	int depth, j;
	Wid_Data *wid_data;
	
	XtVaGetValues(draw, XmNwidth, &wi, XmNheight, &he,
			XmNuserData, &wid_data, NULL);
#ifdef _BLABLA_
	cout<<XtName(draw)<<" resize:::wi:"<<wi<<", he:"<<he<<endl;
#endif	
	if (wid_data->subdis==NULL)
		return;	// nur atrappe...
	
	((UPlot *)(wid_data->subdis))->Resize(wi, he);
	//	((UPlot *)(wid_data->subdis))->Refresh();
	//	soll lieber waehrend expose passieren...
	
	
	
	return;
}
*/
extern Widget init_data_menu(Widget, Widget, Plot*, Wid_Data*);
extern Widget init_text_menu(Widget, Widget, Plot*, Wid_Data*);
extern Widget init_window_menu(Widget, Widget, Boolean);

Widget init_index_label(Widget draw)
{	Widget index_shell, index_label, lab;
	Boolean ja;
	
	index_shell=XtCreatePopupShell("index_shell", overrideShellWidgetClass,
				draw,(Arg*) NULL, 0);

	XtVaSetValues(index_shell, XmNallowShellResize, True, NULL);

	index_label=XtVaCreateManagedWidget("index_label",
				 xmRowColumnWidgetClass,
				index_shell, NULL);

	lab=XtVaCreateManagedWidget("lab", xmLabelWidgetClass,
				index_label, NULL);
	XmString xm=XmStringCreateLtoR("lab", XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues(lab, XmNlabelString, xm, NULL);
	XmStringFree(xm);
	return(index_label);
	
}

void pseudo_destroy(Widget w, XtPointer p1, XtPointer p2)
{	//cout<<"Pseudo_destroy!"<<endl;
	XtPopdown(w);
}

void draw_destroy(Widget w, XtPointer p1, XtPointer p2)
{	//cout<<"draw_destroy!"<<endl;
	w=NULL;
}
	
void swscloseCB(Widget w, XtPointer p1, XtPointer p2)
{	Wid_Data *wid_data;
	Widget draw=(Widget) p1;
		
	XtVaGetValues(draw, XmNuserData, &wid_data, NULL);
	Plot *p =(Plot *)(wid_data->subdis);
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];;
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, "CLICK\tClose");
	fclose(gfile);
#endif
	XFlush(XtDisplay(bs_glob_variable.main_shell));
	Demo=False;
	XFlush(XtDisplay(bs_glob_variable.main_shell));
	//cout<<"na ja..."<<endl;
	XtVaGetValues(draw, XmNuserData, &wid_data, NULL);
		
	XIconifyWindow(XtDisplay(bs_glob_variable.main_shell),
		XtWindow(XtParent(XtParent(XtParent(draw)))),
		DefaultScreen(XtDisplay(bs_glob_variable.main_shell)));

#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	if (p->head_on)
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "CLOSED");
	fclose(gfile);
#endif

}

void originCB(Widget w, XtPointer p1, XmPushButtonCallbackStruct* p2 )
{	Widget draw=(Widget) p1;
	Dimension wi, he;
	Wid_Data *wid_data;
	int i, dim, j, xx, yy;
	double von[2];
	double bis[2];
				
	XtVaGetValues(draw, XmNuserData, &wid_data,
			XmNheight, &he,
			XmNwidth, &wi, NULL);
			
	if (((Plot *)(wid_data->subdis))->GetDataCount()==0)
		return;
		
	Plot *p=(Plot *)(wid_data->subdis);
#ifdef _GUIDO_
	FILE *gfile;
	char *ndis;
	char name[64], line[64];;
	XplDisplay *xpld=p->GetDisplay();
	ndis=xpld->GetName();
	sprintf(name, "%s\t%d\t%d", ndis, p->GetY(), p->GetX());
	delete ndis;
	gfile=fopen(gfname, "a+");
		sprintf(line, "CLICK\tReset");
	fprintf(gfile, gformat, "U", time(NULL)-starttime, "Display",
	 		name, line);
	fclose(gfile);
#endif
	p->GetBackup();
/*
	XplMatrix mini=p->PlotMinToDimension();
	XplMatrix maxi=p->PlotMaxToDimension();
	dim=p->GetDimension();

	int offset=0;
	Achse ach(0, 0, 0);
	float from, to, achoff;
	int *xoffset, *yoffset;
	xoffset=p->GetHOffset();
	yoffset=p->GetVOffset();
	for (i=0; i<dim; i++)
	{	ach=p->GetAchse(i+1);
		from=maxi(0, i)-mini(0, i) > 0.0 ?
			mini(0,i) : mini(0, i)-1;
		to=maxi(0, i)-mini(0, i) > 0.0 ?
			maxi(0,i) : maxi(0, i)+1;
		
		switch(i)
		{	case 0:	achoff=SYMBOL_SIZE*(to-from)/
		(wi-(xoffset(0,0)+xoffset(0,1))*wi/100.0-2*SYMBOL_SIZE);
				break;
			case 1:	achoff=SYMBOL_SIZE*(to-from)/
		(he-(yoffset(0,0)+yoffset(0,1))*he/100.0-2*SYMBOL_SIZE);
				break;
			
			default: achoff=0;
				break;
		}
		
		ach.SetPosition(from-achoff, to+achoff);
		((Plot *)(wid_data->subdis))->SetAchse(ach);
	}
	delete xoffset;
	delete yoffset;
*/
	wrefresh(draw);
	XtUnmanageChild(wid_data->ret_button);

#ifdef _GUIDO_
	gfile=fopen(gfname, "a+");
	fprintf(gfile, gformat, "S", time(NULL)-starttime, "Display",
	 		name, "RESETED");
	fclose(gfile);
#endif
}


Widget CreateMenuToPlot(Widget draw, Plot *pplot, 
		Wid_Data *wid_data, XplDisplay *ddixi)

{	Widget menu, kas1, kas2, kas3, kas4, kas5, kas6;
	Widget data_menu, window_menu, string_menu;
	Widget dis_menu;
	int c_c, i;
	Widget *chi;
	UPlot *plot=(UPlot *)pplot;
	UDisplay *dixi=(UDisplay *)ddixi;
	
	dis_menu=dixi->GetMenu();	
//	cout<<"menu heisst "<<XtName(dis_menu)<<endl;
/*	menu=XtVaCreateWidget("PLOT_MENU",
				xmPushButtonWidgetClass,
				dixi->GetMenu(), 
	   			XmNleftAttachment, XmATTACH_FORM, 
	   			XmNtopAttachment, XmATTACH_FORM, 
	   			XmNbottomAttachment, XmATTACH_FORM, 
	   			XmNrightAttachment, XmATTACH_FORM, 
				NULL);
*/
	menu=	XmCreateMenuBar(dis_menu, "plot_menue",
				(Arg *) NULL, 0);

	XtVaSetValues(menu, XmNtopAttachment,XmATTACH_FORM, 
				XmNleftAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				XmNbottomAttachment, XmATTACH_FORM,
				NULL);
	kas1=	XtVaCreateManagedWidget("data_but",
				xmCascadeButtonWidgetClass, menu, 
				NULL);
	
	kas2=XtVaCreateManagedWidget("win_but", 
				xmCascadeButtonWidgetClass, menu, 
				NULL);
	kas3=XtVaCreateWidget("reset_but", 
				xmCascadeButtonWidgetClass, menu, 
				NULL);
/*	kas5=XtVaCreateManagedWidget("dr_st_but", 
				xmCascadeButtonWidgetClass, menu, 
				NULL);
*/
	kas4=XtVaCreateManagedWidget("quit_but", 
				xmCascadeButtonWidgetClass, menu, 
				NULL);
/*	kas6=XtVaCreateManagedWidget("Demo_but", 
				xmCascadeButtonWidgetClass, menu, 
				NULL);
*/
	XtAddCallback(kas4, XmNactivateCallback, swscloseCB, 
				(XtPointer) draw);
/*	XtAddCallback(kas6, XmNactivateCallback, demoCB, 
				(XtPointer) plot);
*/
	XtAddCallback(kas3, XmNactivateCallback,originCB,	
				 (XtPointer) draw);		
	
	data_menu=init_data_menu(draw, menu, plot, wid_data);
//	cout<<"init_data_menu"<<endl;
	//dabei wird auch wid_data->contr_pan initialisiert
	XtVaSetValues(kas1, XmNsubMenuId, data_menu, NULL);
	
	window_menu=init_window_menu(draw, menu, plot->axis_on);
	XtVaSetValues(kas2, XmNsubMenuId, window_menu, NULL);
	wid_data->ret_button=kas3;
	wid_data->ind_label=init_index_label(draw);
	wid_data->data_menu=data_menu;
	
/*	string_menu=init_text_menu(draw, menu, plot, wid_data);
	XtAddCallback(kas5, XmNactivateCallback, popupCB,	
				 (XtPointer) string_menu);
	XtAddCallback(kas5, XmNdestroyCallback, destroyCB,	
				 (XtPointer) string_menu);
*/	
	XtManageChild(menu);
	XtRealizeWidget(menu);
	XtRealizeWidget(XtParent(menu));
	XtVaSetValues(XtParent(menu), XmNheight, MENUE_HEIGHT, NULL);
	return(menu);
}
					
void userCB(Widget w, XtPointer p1, XtPointer p2)
{	char * com=(char *)p1;
#ifdef _BLABLA_
	cout<<com<<endl;
#endif
	parse(com);	
}
	}	//ende von extern "C"
#endif

	
#endif
