/* $Header: /home/xplore/cvs/xpl4gr/utext.C,v 1.3 2002/08/16 12:31:52 sigbert Exp $ */

#ifdef _UNIX_

#include "utext.h"
#include "udisp.h"
	
UText::UText(const char *ct,
		XplDisplay* dixi, 
		const int di_x, const int di_y):
			VisText(ct, dixi, di_x, di_y)
{	Widget kiste, menu_parent;
	char *brumbrum;
	brumbrum=strdup(ct);
	type=UTEXT;

#ifdef _BLABLA_
	cout<<"UText::UText(const char *ct,
		XplDisplay* dixi, 
		const int di_x, const int di_y)"<<endl;
#endif
	kiste=((UDisplay *)(dixi))->GetKiste();
	menu_parent=((UDisplay *)(dixi))->GetMenu();
	char na[32];
	//sprintf(na, "plotdef(%d, %d)", di_x, di_y);
	sprintf(na, "utext");
	text_w=XtVaCreateWidget(na,
				xmTextWidgetClass,
				kiste,
	   			XmNleftAttachment, XmATTACH_POSITION, 
	   			XmNleftPosition, left, 
	   			XmNtopAttachment, XmATTACH_POSITION, 
	   			XmNtopPosition, top,	
	   			XmNbottomAttachment, XmATTACH_POSITION, 
	   			XmNbottomPosition, bottom, 
	   			XmNrightAttachment, XmATTACH_POSITION, 
	   			XmNrightPosition, right, 
	   			NULL);

	XtManageChild(text_w);
	XmTextSetString(text_w, brumbrum);
	delete(brumbrum);
	Refresh();

}

UText::~UText()
{	XtDestroyWidget(text_w);
}

void UText::Refresh() const
{	char *te=VisTextGetText();
	XmTextSetString(text_w, te);
	delete te;
	XtManageChild(text_w);
}

void UText::VisTextSetText(const char *te)
{	VisText::VisTextSetText(te);
	char *brumbrum=strdup(te);
	XmTextSetString(text_w, brumbrum);
	XtManageChild(text_w);
	delete brumbrum;
}

char * UText::VisTextGetSelectedText()const
{	return(NULL);
}

#endif		//of UNIX
