/* $Header: /home/xplore/cvs/xpl4gr/wavelet.h,v 1.3 2002/08/16 12:31:53 sigbert Exp $ */

 void filter_mirror(double *data,
						  int    length);
 void filter_TI(double *data,
					 double *T0_vector,
					 double *T1_vector,
					 int length);
  void fwt_TI(double *data,
				  double **TI_table, /*TI_table contains all wavelet
										  tramsform of shifted data*/
				  int   length, /*number of rows in TI_table */
				  int   depth);  /*number of colloms in TI_table */

/* fast wavelet transform*/
void fwt(double *data,
			int    length, /*length of the input vector; must be a power of 2 */
			int    level);  /*number of father wavelets coeff.
								  must be a power of 2 */

 void filter_mother_father(double *x,
									 int   length);

 void filter_father_father(double *x,
									  int   length);

void invert_TI(double** TI,
					int length,
					int depth,
					double* vec);

void retrieve(double **TI,  //extracts fwt from TI_table
				 int shift,    // shift of the data in time domain
				 int length,
				 int depth,
				 double *vec);
int get_level(int length, //returns number of father coefficients
				  int  depth);

int get_depth(int length, //returns number of rows in TI_table
				  int  level);

 double  **wvmatrix(int nrow, int ncol);

void  delete_matrix(double **m, int nrow);

void show(double* vector, int length);
void setwc (int newrange, double *newh);

void filter_mirror2(double** data,
                    long    length,
                    long asm_index);

void invert_filter_mirror(double* data, long block_length);
void invert_filter_mirror2(double** data,
                    long    length,
                    long asm_index);
void invert_fwt2(double** data,
          long   length,
          long   level,
          long   asm_index);
void fwt2(double** data,
          long   length,
          long   level,
          long   asm_index);




