/* $Header: /home/xplore/cvs/xpl4gr/wplot.h,v 1.3 2002/08/16 12:31:54 sigbert Exp $ */

#ifndef _WPLOT_H
#define _WPLOT_H

#include <owl\dc.h>
#include <owl\framewin.h>
#include <owl\mdichild.h>
#include <owl\chooseco.h>
#include <owl\profile.h>
//#include "xplwin.h"
#include "display.h"
#include "wdisp.h"
#include "plot.h"
#include "text.h"
#include "xplore.rh"


class WDisplay;
class WPlot: public Plot {

	TProfile *PlotProfile;
	WDisplay *Wdixi;
	void PaintAxis();


public:

	int delX; // the upper left corner of the plot in display
	int delY; // use setDelX(int, int, int, int) getDelX setDelY get DelY
   bool selected;
   bool mousedown;	// PC 20010418: LMB is pressed
   TPoint lastpoint; // PC 20010418: last mouse point if mousedown = true

   WPlot(const WPlot * wplot=NULL, WDisplay* dixi=NULL,                        // SVEN
   	const int di_x=1, const di_y=1);

	WPlot(const Liste <XplObject *> * data_list,
		WDisplay* wdixi=NULL,
		const int di_x=1, const di_y=1);
	/* 	the constructor needed by show(d, 1, 1, x)	*/

	WPlot(WDisplay* wdixi=NULL,
		const int di_x=1, const di_y=1);
	/* 	the constructor needed by createdsiplay(1, 1)	*/

   


/*-----------------------------------------------------------------------*/

	~WPlot()	;
/*-----------------------------------------------------------------------*/

		void paint(int mitgrafik) const;
/*-----------------------------------------------------------------------*/

	virtual void Refresh() const;	// the most important thing here!
	virtual void Resize(int, int);
	void RotateUp();
	void RotateDown();
	void RotateLeft();
	void RotateRight();

/*-----------------------------------------------------------------------*/

	void InFocus();

/*-----------------------------------------------------------------------*/

	void AddButton(const char *, const char*);
	/*	you can make it later....			*/

	void DeleteButton(const char *);
	/*	you can make it later....			*/

/*-----------------------------------------------------------------------*/



	virtual int redraw_points(int data_num, XplMatrix & only_these);
/* 	to use only after color_brush	!!!!!			*/
	/*	you can make it later....			*/

   virtual int repaint_part(int part_x, int part_y,
		int part_width, int part_height, TDC *tdc=NULL) const;
	/*	you can make it later....			*/

   int getWidth() {return width;}
   int getHeight() {return height;}

        const char *GetWinFontName(void);    // PC 20010702

	};


class WText: 	public VisText {

	WDisplay *Wdixi;
   int delX, delY;

public:

	WText(const char *c=NULL, XplDisplay *d=NULL,
			const int di_x=1, const di_y=1);
	~WText();

	void Refresh(TDC *tdc=NULL) const;

	void VisTextSetText(const char *);
	char * VisTextGetSelectedText() const;
};


#endif


