/* $Header: /home/xplore/cvs/xpl4gr/xinteger.hpp,v 1.3 2002/08/16 12:31:55 sigbert Exp $ */

#include "xnumber.hpp"

#ifndef XPLINTEGER
#define XPLINTEGER

template <class T> static T and (T l, T r);
template <class T> static T or  (T l, T r); 

template<class T> class XplInteger : public XplNumber<T> {

  public:
  
  XplInteger (XplIndex newdim); 
  XplInteger (long d0=1, long d1=1, long d2=1, long d3=1, 
              long d4=1, long d5=1, long d6=1, long d7=1);
  ~XplInteger ();

  XplInteger (XplNumber<T> &x); 
  XplInteger (const XplArray<T> &x);
  XplInteger (XplInteger<T> *x);
  XplInteger (XplInteger<T> & x);

  XplInteger<T>& operator= (const XplNumber<T>& x);		
  XplInteger<T>& operator= (const XplArray<T>& x);		

  XplInteger<T> operator&&(XplInteger<T> &right);
  XplInteger<T> operator||(XplInteger<T> &right);

};

#endif
