/* $Header: /home/xplore/cvs/xpl4gr/xnan.h,v 1.3 2002/08/16 12:31:56 sigbert Exp $ */

/* NaN Handling of XploRe

   tested for

     Solaris 2 / Sparc
     Linux 2   / Intel
     HP UX 10  / A 9000


   by TTK, 23.4.97

*/

#ifndef  _XNAN_H_
#define  _XNAN_H_


#define TRUE   1
#define FALSE  0

int  XisNaN    (double x);
// delivers TRUE, if x is NaN otherwise FALSE

int  XisInf    (double x);
// delivers TRUE, if x is Inf otherwise FALSE

int  XisPosInf (double x);
// delivers TRUE, if x is +Inf otherwise FALSE

int  XisNegInf (double x);
// delivers TRUE, if x is -Inf otherwise FALSE

int  XisNumber (double x);
// delivers TRUE, if x is neither Inf nor NaN

#endif
