/* $Header: /home/xplore/cvs/xpl4gr/xplfun.h,v 1.5 2003/07/28 17:26:18 cizek Exp $ */

#ifndef _XPLFUN_H_
#define _XPLFUN_H_

#ifdef __BORLANDC__ //LOOK!
double rint(double);  //SWS 4.11.97
#endif

XplObject*      testExec  (Liste<XplObject*> *argl);
XplObject*      testIntervall  (Liste<XplObject*> *argl);
XplObject*      testNelmin     (Liste<XplObject*> *argl);
XplObject*      testBFGS       (Liste<XplObject*> *argl);
XplObject*      testSimpson    (Liste<XplObject*> *argl);

XplObject*      print         (Liste<XplObject*> *argl);
XplObject*      saveMacroText (Liste<XplObject*> *argl);
XplObject*      printMacroText(Liste<XplObject*> *argl);
XplObject*      printMacroTL  (Liste<XplObject*> *argl);
XplObject*	runif         (Liste<XplObject*> *argl);
XplObject*	rnorm         (Liste<XplObject*> *argl);
XplObject*	transpose     (Liste<XplObject*> *argl);
XplObject*	execFile      (Liste<XplObject*> *argl);
XplObject*	readMac       (Liste<XplObject*> *argl);
XplObject*	X4LoadLibrary   (Liste<XplObject*> *argl);
XplObject*	ExecCommand   (Liste<XplObject*> *argl);
XplObject*	inverse       (Liste<XplObject*> *argl);
XplObject*	diag          (Liste<XplObject*> *argl);
XplObject*	matabs        (Liste<XplObject*> *argl);
XplObject*	matfloor      (Liste<XplObject*> *argl);
XplObject*	matsqrt       (Liste<XplObject*> *argl);
XplObject*	matsin        (Liste<XplObject*> *argl);
XplObject*      bmatrix       (Liste<XplObject*> *argl);
XplObject*	matrows       (Liste<XplObject*> *argl);
XplObject*	matcols       (Liste<XplObject*> *argl);
XplObject*	paf           (Liste<XplObject*> *argl);
XplObject*	diag          (Liste<XplObject*> *argl);
XplObject*	eye          (Liste<XplObject*> *argl);	  //MS 20030713
XplObject*	readVar       (Liste<XplObject*> *argl);
#ifndef MATRIX
XplObject*	writeVar  (Liste<XplObject*> *argl);
XplObject*	writeappendVar  (Liste<XplObject*> *argl);
#endif

XplObject*	knn       (Liste<XplObject*> *argl);

#ifdef MATRIX
XplObject*	minc      (Liste<XplObject*> *argl);
XplObject*	maxc      (Liste<XplObject*> *argl);
XplObject*	sumc      (Liste<XplObject*> *argl);
XplObject*	prodc     (Liste<XplObject*> *argl);
XplObject*	eigen     (Liste<XplObject*> *argl);
XplObject*	sort      (Liste<XplObject*> *argl);

#else

XplObject*      InitRandom   (Liste<XplObject*> *argl);
XplObject*      bmatrixnew   (Liste<XplObject*> *argl);
XplObject*      bzeromatrixnew   (Liste<XplObject*> *argl);
XplObject*      dim          (Liste<XplObject*> *argl);
XplObject*      reshape      (Liste<XplObject*> *argl);
XplObject*      xaMKnn       (Liste<XplObject*> *argl);
XplObject*      xaSknn       (Liste<XplObject*> *argl);
XplObject*      xaBinData    (Liste<XplObject*> *argl);
XplObject*      xaIndex      (Liste<XplObject*> *argl);
XplObject*      xaMin        (Liste<XplObject*> *argl);
XplObject*      xaMax        (Liste<XplObject*> *argl);
XplObject*      xaSort       (Liste<XplObject*> *argl);
XplObject*      xaFFT        (Liste<XplObject*> *argl);
XplObject*      xaInvFFT     (Liste<XplObject*> *argl);
XplObject*      xaFWT        (Liste<XplObject*> *argl);
XplObject*      xaInvFWT     (Liste<XplObject*> *argl);
XplObject*      xaFWTin      (Liste<XplObject*> *argl);
XplObject*      xaInvFWTin   (Liste<XplObject*> *argl);
XplObject*      xaFWTinShift (Liste<XplObject*> *argl);

XplObject*      xaNNrsetnet   (Liste<XplObject*> *argl);
XplObject*      xaNNrsettrain (Liste<XplObject*> *argl);
XplObject*      xaNNrdovm     (Liste<XplObject*> *argl);
XplObject*      xaNNrtest     (Liste<XplObject*> *argl);

XplObject*      xaEigsm      (Liste<XplObject*> *argl);
XplObject*      xaDet        (Liste<XplObject*> *argl);
XplObject*      xaLU         (Liste<XplObject*> *argl);
XplObject*      xaDistance   (Liste<XplObject*> *argl);

#ifndef SKBUG
XplObject*      xaConv       (Liste<XplObject*> *argl);
XplObject*      xaGrid       (Liste<XplObject*> *argl);
XplObject*      xaSumR       (Liste<XplObject*> *argl);
XplObject*      xaSumC       (Liste<XplObject*> *argl);
XplObject*      xaSum        (Liste<XplObject*> *argl);
XplObject*      xaSumNaN     (Liste<XplObject*> *argl);
XplObject*      xaMulR       (Liste<XplObject*> *argl);
XplObject*      xaMulC       (Liste<XplObject*> *argl);
XplObject*      xaMul        (Liste<XplObject*> *argl);
XplObject*      xaMulNaN     (Liste<XplObject*> *argl);
XplObject*      xaMax        (Liste<XplObject*> *argl);
XplObject*      xaMaxR       (Liste<XplObject*> *argl);
XplObject*      xaMaxC       (Liste<XplObject*> *argl);
XplObject*      xaMin        (Liste<XplObject*> *argl);
XplObject*      xaMinR       (Liste<XplObject*> *argl);
XplObject*      xaMinC       (Liste<XplObject*> *argl);
XplObject*      xaCumsum     (Liste<XplObject*> *argl);
XplObject*      xaCumsumNaN  (Liste<XplObject*> *argl);
XplObject*      xaCumsumR    (Liste<XplObject*> *argl);
XplObject*      xaCumsumC    (Liste<XplObject*> *argl);
XplObject*      xaCummul     (Liste<XplObject*> *argl);
XplObject*      xaCummulNaN  (Liste<XplObject*> *argl);
XplObject*      xaCummulR    (Liste<XplObject*> *argl);
XplObject*      xaCummulC    (Liste<XplObject*> *argl);
XplObject*      xaMean       (Liste<XplObject*> *argl);
XplObject*      xaMeanNaN    (Liste<XplObject*> *argl);
XplObject*      xaMeanR      (Liste<XplObject*> *argl);
XplObject*      xaMeanC      (Liste<XplObject*> *argl);
XplObject*      xaVar        (Liste<XplObject*> *argl);
XplObject*      xaVarNaN     (Liste<XplObject*> *argl);
XplObject*      xaVarR       (Liste<XplObject*> *argl);
XplObject*      xaVarC       (Liste<XplObject*> *argl);
XplObject*      xaCov        (Liste<XplObject*> *argl);
XplObject*      xaCovNaN     (Liste<XplObject*> *argl);
XplObject*      xaMinInd     (Liste<XplObject*> *argl);
XplObject*      xaMaxInd     (Liste<XplObject*> *argl);
XplObject*	xaMedian     (Liste<XplObject*> *argl);     // PC 20010221
XplObject*	xaMedianNaN  (Liste<XplObject*> *argl);     // PC 20010221
XplObject*      xaMseq (Liste<XplObject*> *argl);           // PC 20010222
XplObject*      xaAseq (Liste<XplObject*> *argl);           // PC 20010222
XplObject*      xaInfo (Liste<XplObject*> *argl);           // SK 20020204
#endif

#endif


#ifdef _GRAPHICS_  
XplObject*      editMacroText   (Liste<XplObject*> *argl);
XplObject*      editXplDouble   (Liste<XplObject*> *argl);
#endif

#ifdef __BORLANDC__
XplObject*      BorlandDummy   (Liste<XplObject*> *argl);
#endif

int    PowOf2          (const long n);
int    LoadMacro       (const char *fname, int reload = FALSE);
char * FindDir         (const char *name, const char *dirs, int env = TRUE);
int    alreadyReadFile (const char *macfile, int delBuffer = FALSE);

#endif

void BeginXploReCommand (char *cmd);
void EndXploReCommand ();
void SendNumericMatrix (char *name, XplDouble *x);
XplDouble *GetNumericMatrix ();
void SendTextMatrix (char *name, XplChar *x);





