/* $Header: /home/xplore/cvs/xpl4gr/xplwinap.h,v 1.4 2003/05/23 18:01:20 cizek Exp $ */

//
// XploRe Accessuar Windows
//
#ifndef _XPLWINAP_H_
#define _XPLWINAP_H_

//#include <owl\framewin.h>
#include <owl\listbox.h>
#include <owl\mdichild.h>
#include <owl\validate.h>
#include <owl\color.h>
#include <owl\button.h>
#include "xplore.rh"
#include "xplore.h"

#include <owl\updown.h> // DS: 15.12.99

#define WIN_EDIT    0
#define WIN_LIB     1
#define WIN_INPUT   2
#define WIN_OUTPUT  3
#define WIN_MACRO   4
#define WIN_FUNC    5
#define WIN_OBJ     6

#ifdef JAPANESE
#define OBJ_TITLE  "޼ު"
#define FUN_TITLE  "֐"
#define MAC_TITLE  "گ"
#else
#define OBJ_TITLE  "Objects"
#define FUN_TITLE  "Functions"
#define MAC_TITLE  "Quantlets"
#endif

#define MAXEDWINDOWSPOS		10
class WinPosManager
{ int width, height;
  long k;
  long windowpos[MAXEDWINDOWSPOS];  	// PC 20011211: window positions

  public:

  WinPosManager();
  int getwin (int type, TRect* viewable);
  int getedwinid(void);		// PC 20011211: finds the position that will be next used by getwin
  void removeedwinid(int winid);	// PC 20011211: clears blocked position
};

extern WinPosManager wpm;

#define MAX_INFO_LENGTH 8190
#define MAX_TEXT_LENGTH 32560

void something2dos (char *txt, int maxlen);

class TXploreClient;

//template<class T> class TFuncWin : public TMDIChild {
//could be template, but we don't need it yet.

class TFuncWin : public TMDIChild {
  public:
	 TFuncWin(TXploreClient& parent, const char far* title = 0);
	 ~TFuncWin();

  int ListLength();
  void UpdateLists();

  protected:
  void EvSize(uint sizeType, TSize& size);
  void SetupWindow();

  private:
  TXploreClient *Parent;
  TListBox *objects;
  TEdit *info;

  char Title[30]; //"Functions", "Objects" or "Macros"

  void EvItemDblClk(); // main click response function
//  void EvSetFocus();   // SK 13.11.98
  void EvClose();
  void ObjDblClk(char* SelItem);
  void FunDblClk(char* SelItem);
  void MacDblClk(char* SelItem);

  DECLARE_RESPONSE_TABLE(TFuncWin);
};

typedef char* Strp;

class AutosaveDlg : public TDialog // DS 15.12.99
{
	public:
   int autosaveTime;
   bool isAutosave;

	AutosaveDlg (TWindow* parent, TResId resId = IDD_AUTOSAVEDIALOG, TModule* module=0);
   virtual ~AutosaveDlg();
   int Execute( bool asenable, int astime );

	private:
   bool CanClose();
	void evAsEnable();
   void SetupWindow();
   TCheckBox* asenable;
   TEdit* astimer;
   TUpDown* asadjust;
   DECLARE_RESPONSE_TABLE(AutosaveDlg);
};

class InfoDialog : public TDialog
{ TEdit *xpl4data, *xpl4lib, *xpl4dll, *xpl4help, *xpl4prog,
        *xpl4temp, *xpl4outdata, *xpl4outlib, *xpl4outdll,
        *xpl4outhelp, *xpl4outprog, *xpl4outtemp, *xpl4log;

  public:

/*  InfoDialog (TWindow* parent, char *caption) :
    (parent, caption) {};
*/
  InfoDialog (TWindow* parent, TResId resId, TModule* module = 0);

  void SetupWindow();

  DECLARE_RESPONSE_TABLE(InfoDialog);

};

#endif

