/* $Header: /home/xplore/cvs/xpl4gr/xselect.C,v 1.3 2002/08/16 12:32:03 sigbert Exp $ */

#include <string.h>

#include "xselect.hpp"

  XplSelection::XplSelection (void)
  { lptr = new long[length = 1];
    *lptr = 0;
  }

  XplSelection::XplSelection (long n)
  { long i;
    lptr = new long[length = n];
    for (i=0; i<n; i++) *(lptr+i) = i;
  }

  XplSelection::XplSelection (long n, long *ptr)
  { long i;
    lptr = new long[length = n];
    for (i=0; i<n; i++) *(lptr+i) = *(ptr+i);
  }

  XplSelection::~XplSelection (void)
  { delete[] lptr; }

  long& XplSelection::operator[] (long nr)
  { return (*(lptr+nr)); }

  XplSelection& XplSelection::operator= (const XplSelection& xs)
  { delete[] lptr;
    lptr = new long[length = xs.length];
    memcpy (lptr, xs.lptr, length*sizeof(long));
    return (*this);
  }

  long XplSelection::len (void) const
  { return length; }

  long* XplSelection::ptr (void) const
  { return lptr; }

