/* $Header: /home/xplore/cvs/xpl4gr/xsort.hpp,v 1.3 2002/08/16 12:32:04 sigbert Exp $ */

#ifndef XPLSORT
#define XPLSORT

template<class T> class XplSort
{ long *feld; 
  T *sv; 

#ifdef HAS_STDSORT
  long (XplSort<T>::*proc) (long, long);
#else
  typedef long (XplSort<T>::*FP)(long, long);
  FP proc;
#endif

  long qsgreater (long a, long b);
  long qssmaller (long a, long b);
  void bubble (long l, long r);
  void quicki (long l, long r);
  void heapsort (long n);

  public:

  XplSort();
  void sortvec (T *ptr);
  void quicksort (long *base, long n, int type);
};

#endif
